*****************************************************************************
* Name:		FILER48
* Type:		Library
* Platform:	HP48G/G+/GX
* Language:	50% System RPL / 50% Assembly Language
* Author:	Raul del cid Lopez, Guatemala C.A.
* Email:	Raoolio@yahoo.com
* Copyright:
*	(c) 2000-2004 by Raul del Cid Lopez. ALL rights reserved.
*
* Description:
*	Complete Memory Browser to manage all files inside the HP48.
*	It replaces the built-in MEMORY browser and has full support
*	for Port:0: Object Handling.
*
* Introduced Features:
*	v2.0:	Library Protection Shell.
*	v1.92:	Memory Counter for Selected Files.
*	v1.9:	4 New Flavors are Compiled now.
*	v1.8:	Can Explore Covered Ports!!! (2-32). Port 1 also.
*	v1.7:	100% customizable via MetaKernel's Filer Extensions.
*
* Uses:
*	- Library  163: Right-Shift Key Plane
*	- Library  257: UFL Font Lev. 1
*	- Library 1698: USND 3.0
*****************************************************************************



*****************************************
DEFINE xFILER48		ROMPTR 1BC 00
DEFINE xVIEW		ROMPTR 1BC 01
*****************************************
DEFINE $>miniFont	ROMPTR 1BC 02
DEFINE F48IndexDraw	ROMPTR 1BC 03
DEFINE F48FilesDraw	ROMPTR 1BC 04
*****************************************
DEFINE F48Tree		ROMPTR 1BC 05
DEFINE F48DirIndxDrw	ROMPTR 1BC 06
DEFINE F48DirsDraw	ROMPTR 1BC 07
*****************************************
DEFINE F48SliderCalc	ROMPTR 1BC 08
DEFINE F48Slider	ROMPTR 1BC 09
DEFINE F48StatusDraw	ROMPTR 1BC 0A
DEFINE F48MenuDraw	ROMPTR 1BC 0B
*****************************************
DEFINE F48$Index@	ROMPTR 1BC 0C
DEFINE F48$Checks@	ROMPTR 1BC 0D
*****************************************
DEFINE F48HiddenDir@	ROMPTR 1BC 0E
DEFINE F48Copy/Move	ROMPTR 1BC 0F
*****************************************
DEFINE F48ParseName	ROMPTR 1BC 10
DEFINE F48AskUser	ROMPTR 1BC 11
DEFINE F48Input		ROMPTR 1BC 12
DEFINE F48KeyRepeat	ROMPTR 1BC 13
*****************************************
DEFINE F48Choose	ROMPTR 1BC 14
DEFINE F48ChsCurDrw	ROMPTR 1BC 15
DEFINE F48CheckDraw	ROMPTR 1BC 16
DEFINE F48CustomMenu	ROMPTR 1BC 17
*****************************************
DEFINE F48UP		ROMPTR 1BC 18
DEFINE F48DOWN		ROMPTR 1BC 19
DEFINE F48GetKey	ROMPTR 1BC 1A
DEFINE F48PageUpSetup	ROMPTR 1BC 1B
DEFINE F48PageDnSetup	ROMPTR 1BC 1C
DEFINE F48MaxUpSetup	ROMPTR 1BC 1D
DEFINE F48MaxDnSetup	ROMPTR 1BC 1E
*****************************************
DEFINE F48ObView	ROMPTR 1BC 1F
DEFINE F48Sort!		ROMPTR 1BC 20
DEFINE F48Select!	ROMPTR 1BC 21
DEFINE F48GetIO		ROMPTR 1BC 22


************** PROTECTION ***************
DEFINE stackDepth@	20GETLAM
DEFINE quit?		19GETLAM
DEFINE quit!		19PUTLAM
DEFINE downEnter?	18GETLAM
DEFINE downEnter!	18PUTLAM
************* SAVED VARS ****************
DEFINE sortBy@		17GETLAM
DEFINE sortBy!		17PUTLAM
DEFINE props?		16GETLAM
DEFINE props!		16PUTLAM
DEFINE mainStatus?	15GETLAM
DEFINE mainStatus!	15PUTLAM
**************** FILER ******************
DEFINE mainMenu?	14GETLAM
DEFINE mainMenu!	14PUTLAM
DEFINE context@		13GETLAM
DEFINE context!		13PUTLAM
DEFINE $vars@		12GETLAM
DEFINE $vars!		12PUTLAM
*****************************************
DEFINE $path@		11GETLAM
DEFINE $path!		11PUTLAM
DEFINE updir?		10GETLAM
DEFINE updir!		10PUTLAM
DEFINE miniFont@	9GETLAM
*********** TREE Compatible *************
DEFINE max@		8GETLAM
DEFINE max!		8PUTLAM
DEFINE index@		7GETLAM
DEFINE index!		7PUTLAM
DEFINE min@		6GETLAM
DEFINE min!		6PUTLAM
DEFINE n@		5GETLAM
DEFINE n!		5PUTLAM
************* SCROLL BAR ****************
DEFINE dy@		4GETLAM
DEFINE dy!		4PUTLAM
DEFINE barHeight@	3GETLAM
DEFINE barHeight!	3PUTLAM
************ STATUS FLAGS ***************
DEFINE refresh?		2GETLAM
DEFINE refresh!		2PUTLAM
DEFINE reload?		1GETLAM
DEFINE reload!		1PUTLAM
DEFINE TRUEreload!	TRUE1PUTLAM
*********** COPY/MOVE FLAGS *************
DEFINE moveMode?	12GETLAM
DEFINE moveMode!	12PUTLAM
DEFINE all?		8GETLAM
DEFINE all!		8PUTLAM
DEFINE delMode?		7GETLAM
DEFINE delMode!		7PUTLAM
DEFINE dest@		6GETLAM
DEFINE dest!		6PUTLAM
*****************************************
DEFINE prevContext@	6GETLAM
DEFINE prevContext!	6PUTLAM
************* TREE VARS *****************
DEFINE Tmax@		8GETLAM
DEFINE Tmax!		8PUTLAM
DEFINE Tindex@		7GETLAM
DEFINE Tindex!		7PUTLAM
DEFINE Tmin@		6GETLAM
DEFINE Tmin!		6PUTLAM
DEFINE Tn@		5GETLAM
DEFINE Tn!		5PUTLAM
DEFINE Tdy@		4GETLAM
DEFINE Tdy!		4PUTLAM
DEFINE TbarHeight@	3GETLAM
DEFINE TbarHeight!	3PUTLAM
DEFINE T$dirs@		2GETLAM
DEFINE T$dirs!		2PUTLAM
DEFINE TminiFont@	1GETLAM
*************** EDIT ********************
DEFINE arch@		2GETLAM
DEFINE tipo@		1GETLAM
************** CHOOSE *******************
DEFINE CsortMode?	7GETLAM
DEFINE Cn@		6GETLAM
DEFINE Cn!		6PUTLAM
DEFINE Cinvert?		5GETLAM
DEFINE Cinvert!		5PUTLAM
DEFINE Cindex@		4GETLAM
DEFINE Cindex!		4PUTLAM
DEFINE CXoff@		3GETLAM
DEFINE CXoff!		3PUTLAM
DEFINE CYoff@		2GETLAM
DEFINE CYoff!		2PUTLAM
DEFINE CbarSize@	1GETLAM
DEFINE CbarSize!	1PUTLAM
*****************************************



ASSEMBLE
		TITLE Filer48 2.41 Ultra-Lite

MaxChrs		EQU 10	Maximum Label #Chars

check		EQU 8	Display the Check Field Only?
Card1_128K	EQU 7	Card 1 is 128K?
Card1		EQU 6	Card 1 Plugged?
HighPort	EQU 5	Covered Port?
PortMode	EQU 4	Port Mode?

LIBTYPE		EQU 19	Library Object #Type

invFont		EQU 3	Invert Font data?
Wide		EQU 0	Full screen width?
RomId		EQU 444


		CON(5)	=DOLIB		* Library Prologue
		REL(5)	->LibEnd	* Size Field

		CON(2)	(($end)-($beg))/2
$beg		NIBASC	\FILER48-U 2.41\n\
		NIBASC	\Raul del Cid Lopez\n\
		NIBASC	\raoolio@yahoo.com\n\
		NIBASC	\Aug 2005\
$end		CON(2)	(($end)-($beg))/2

		CON(3)	RomId		* Library#

		REL(5)	FilerHash	* ->Hash Table Offset
		REL(5)	FilerMsg	* ->Message Table Offset
		REL(5)	FilerLink	* ->Link Table Offset
		REL(5)	FilerCfg	* ->Config PRG Offset


*****************************************
* LINK TABLE:
*****************************************
FilerLink	CON(5)	=DOHSTR		* Link Table Prologue
		REL(5)	->LinkEnd	* Size Field

		REL(5)	_xFILER48
		REL(5)	_xVIEW
		REL(5)	_$>miniFont
		REL(5)	_F48IndexDraw
		REL(5)	_F48FilesDraw
		REL(5)	_F48Tree
		REL(5)	_F48DirIndxDrw
		REL(5)	_F48DirsDraw
		REL(5)	_F48SliderCalc
		REL(5)	_F48Slider
		REL(5)	_F48StatusDraw
		REL(5)	_F48MenuDraw
		REL(5)	_F48$Index@
		REL(5)	_F48$Checks@
		REL(5)	_F48HiddenDir@
		REL(5)	_F48Copy/Move
		REL(5)	_F48ParseName
		REL(5)	_F48AskUser
		REL(5)	_F48Input
		REL(5)	_F48KeyRepeat
		REL(5)	_F48Choose
		REL(5)	_F48ChsCurDrw
		REL(5)	_F48CheckDraw
		REL(5)	_F48CustomMenu
		REL(5)	_F48UP
		REL(5)	_F48DOWN
		REL(5)	_F48GetKey
		REL(5)	_F48PageUpSetup
		REL(5)	_F48PageDnSetup
		REL(5)	_F48MaxUpSetup
		REL(5)	_F48MaxDnSetup
		REL(5)	_F48ObView
		REL(5)	_F48Sort!
		REL(5)	_F48Select!
		REL(5)	_F48GetIO
->LinkEnd


*****************************************
* HASH TABLE:
*****************************************
FilerHash	CON(5)	=DOHSTR		* Hash Table Prologue
		REL(5)	->HashEnd	* Size Field

		CON(5)	0		* ->Len 1 offset
		CON(5)	0		* ->Len 2
		CON(5)	0		* ->Len 3
		REL(5)	->L4N1		* ->Len 4
		CON(5)	0		* ->Len 5
		CON(5)	0		* ->Len 6
		REL(5)	->L7N1		* ->Len 7
		CON(5)	0		* ->Len 8
		CON(5)	0		* ->Len 9
		CON(5)	0		* ->Len 10
		CON(5)	0		* ->Len 11
		CON(5)	0		* ->Len 12
		CON(5)	0		* ->Len 13
		CON(5)	0		* ->Len 14
		CON(5)	0		* ->Len 15
		CON(5)	0		* ->Len 16

		REL(5)	->NamesEnd	* Names Area Size Field
->L4N1		CON(2)	4
		NIBASC	\VIEW\
		CON(3)	1
->L7N1		CON(2)	7
		NIBASC	\FILER48\
		CON(3)	0

->NamesEnd	CON(5)	(->NamesEnd)-(->L7N1)
O2		CON(5)	(O2)-(->L4N1)
->HashEnd



		CON(1)	8
		CON(3)	RomId
		CON(3)	1
_xVIEW
RPL
::
  CK1
  CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		GOSUB	F48GetObType
		A=C	A
		GOVLNG	=PUSH#ALOOP
  ENDCODE
  F48ObView
  DROP
 ;



ASSEMBLE
		CON(1)	8
		CON(3)	RomId
		CON(3)	0
_xFILER48
RPL
::
  CK0

  ( Library 257: UFL present? )
  # 1BC01
  ' ROMPTR 101 000
  ROMPTRDECOMP
  NOTcase ERROROUT
  ' ID FNT
  EQUALNOTcase ERROROUT
  DROP

  PATHDIR ' LAM Pth ONE DOBIND
  ERRSET
  ::
    DEPTH		( stackDepth )
    FalseTrue		( quit?, downEnter? )

    ' ID F48L RclHiddenVar
    ITE
    INCOMPDROP
    :: TWO TrueTrue ;	( sortBy, props?, mainStatus? )

    TRUE		( mainMenu? )
    CONTEXT@		( context@ )
    ZEROZERO		( $vars, $path )
    FALSE 		( updir? )
    ROMPTR 101 3	( Font )
    ZEROZEROZERO	( max, index, min )
    ZEROZEROZERO	( n, dy, barHeight )
    FalseTrue		( refresh?, reload? )
    ' NULLLAM TWENTY NDUPN DOBIND

    TOADISP	( To Text Disp )
    REDISPHBUFF	( Window -> #0 #0 )
    RSZVDISP	( Set Std Size )

  BEGIN
    reload? IT
    ::
      ::
	context@ HOMEDIR? case "HOME"
	NULL$
	context@
	BEGIN
	  DUP RAM-WORDNAME
	  ID>$ CHR \\ >T$
	  ROT &$SWAP
	  GETUPDIR
	NOT_UNTIL
	CDR$
       ;

      $path!

      TrueFalse reload! refresh!
      NULL$ $vars!
      GARBAGE

      context@
******** LIST DIR/Port0/LIB Vars ********
*
* 3:	context@
* 1:	libOb?		-> $vars #obs
********** $vars Structure: *************
* "ooooo sssss sssss mmmmm xxxxx NameAddr1 ObjectAddr1 ..."
*    5     5     5     5     5       5	       5
*
* 5:	# Objects
* 5:	# Selected Objects
* 5:	Selection Size (Nibbs)
* 5:	Free RAM (Nibbs)
* 5:	Sel_Field
* 5:	->Name
* 5:	->Object
*****************************************
*	CPU Use:
* R0.A=	->$vars		B.A= free RAM
* R3.A=	#obs		D.A= ob count
* D1	->$vars
*****************************************
CODE

NullNames	EQU 5	Show Null Names?

		GOSBVL	=SAVPTR
		GOSBVL	=DisableIntr	* Interruptions OFF!

* Fetch User Status Flag #6

		C=0	A
		LC(1)	6
		A=C	A
		ST=1	0
		GOSBVL	=TestFlag
		C=C&A	XS
		ST=0	NullNames
		?C=0	XS
		GOYES	+
		ST=1	NullNames
+		C=DAT1	A
		R1=C			* Save current DIR/LIB
		GOSBVL	=ROOM
		A=C	A		* A.A= Free RAM
		C=0	A
		LC(2)	200		* Leave 200 Nibbles Free
		C=A-C	A
		GOC	MemErr
		GOSBVL	=MAKE$N
		B=A	A		* B.A= Free Memory
		C=0	A
		LC(2)	5*4		* Reserve Trackin Fields
		B=B-C	A
		GONC	+
MemErr		GOVLNG	=GPMEMERR
+		CD0EX
		D1=C			* D1 ->$

* Prepare $vars Fields

		C=0	W
		DAT1=C	W		* Clear All 4 Fields!
		D1=D1+	16
		DAT1=C	4
		D1=D1+	4
		D=0	A		* D.A= Object Counter
		A=R1			* Recover DIR/LIB

*****************************************
		STITLE	Dir Vars Search Engine
*****************************************
DirEngine	GOSBVL	=D0->LastRamWrd
		C=DAT0	A
		C=-C	A		* C.A= Last object's offset
nextVarLup	?C=0	A		* Empty Dir? (Link=0)
		GOYES	VarsDone
		AD0EX
		A=A-C	A
		R1=A.F	A		* Save ->Name
		D0=A			* D1 ->Name
		C=0	A
		C=DAT0	B
		?C#0	B		* NULLID?
		GOYES	+		* yep, just skip 2 Nibbles
		?ST=0	NullNames
		GOYES	VarsDone
+		GOSBVL	(=TRAVERSE+)+5
		B=B-CON A,15		* Reserve Name & Object's address
		GOC	MemErr
		C=0	A
		DAT1=C	A		* Write blank space for check mark!
		D1=D1+	5
		C=R1.F	A
		DAT1=C	A		* Write Name's address!
		D1=D1+	5
		AD0EX
		DAT1=A	A		* Write Object's address!
		D1=D1+	5
*****************************************
		D=D+1	A
		D0=C			* ->Name
		D0=D0-	5
		C=DAT0	A		* C.A= next Link
		GOTO	nextVarLup
*****************************************
VarsDone	C=D	A
		R3=C			* Save #obs
'VarsDone	A=R0
		AD1EX			* D1 ->$
		D0=A			* Ensure D0 ->$end
		D1=D1+	10
		DAT1=C	A		* Write #obs in $
		GOSBVL	=Shrink$

		GOSBVL	=ROOM		* C.A= Free RAM
		A=R1
		D1=A			* ->$vars+5 (done by Shrink$)
		D1=D1+	20		* ->Mem_Field
		DAT1=C	A		* Write Free Mem!

		GOSBVL	=AllowIntr	* Interruptios ON!
		GOSBVL	=GETPTR
		C=R0
		DAT1=C	A
		A=R3
		GOVLNG	=PUSH#ALOOP
ENDCODE
*****************************************

      n!		( Save #Files )

************** SORT-ENGINE **************
* Hoare's Quick-Sort Algorithm.
* Written by Tamir Demri for Reals.
* Optimized for Filer48 by Raul.
*
* 1:	$vars -> $vars' (sorted)
*
* R0.W= Save A.W
* R1.W= Save C.W
* R2.W= Save B.W
* R3.A= ->Last_Ob
* R4.A= ->$stack (Current Recursion Level)
*****************************************
CODE

typeSrt		EQU 0	Sort by Type?
nameSrt		EQU 1	Sort by Name?
carry		EQU 2	Carry Set?
reverse		EQU 3	Reverse Order?
LAMsortBy	EQU 17

		STITLE	Quick-Sort Engine

* Check if we have more than 1 File

ML-Sort!	C=DAT1	A
		CD1EX			* ->$vars
		D1=D1+	10
		A=DAT1	A		* A.A= #files
		D1=C			* Restore D1
		C=0	A
		LC(1)	1
		?A>C	A		* More than 1 File?
		GOYES	+
		GOVLNG	=Loop		* Nope, Quit here!

* Prepare the Sorting Engine!

+		GOSBVL	=DisableIntr
		GOSBVL	=SAVPTR
		D0=(5)	=TEMPENV
		A=DAT0	A
		C=0	A
		LC(2)	(LAMsortBy)*10+5
		A=A+C	A
		D0=A			* -> &LAMsortBy
		A=DAT0	A
		D0=A			* -> bint
		D0=D0+	5
		A=DAT0	A		* A.A= #sortBy
****************************************
		CLRST
		LC(1)	4
		?A<C	P
		GOYES	+
		ST=1	reverse
		A=A-CON	A,4
+		?A#0	P
		GOYES	+
		GOTO	QSReverse
+		A=A-1	A
		?A#0	P
		GOYES	+
		ST=1	nameSrt
		GONC	Make$stack
+		A=A-1	A
		?A#0	P
		GOYES	Make$stack
		ST=1	typeSrt
*****************************************
* Reserve 2/3 of $vars for the $Stack,
* used to save the RTN addresses
*****************************************
Make$stack	A=DAT1	A
		D1=A
		D1=D1+	10		* ->#obs_Field
		A=DAT1	A
		C=A	A
		C=C+C	A
		C=C+C	A
		C=C+A	A
		GOSBVL	=MAKE$		* Alloc #n*10 Nibbs= 2/3 of $vars
		A=DAT1	A
		R1=A			* R1.A= ->$vars (for QSWipe)
*****************************************
		?ST=1	nameSrt		* Sort by Name?
		GOYES	QSInit
*****************************************
		D1=A
		D1=D1+	10
		C=DAT1	A
		D1=D1+	5
		A=0	W
		DAT1=A	10		* Clear #sel and SelSize Fields!
		D1=D1+	15		* D1 ->First_Ob
		D=C	A		* D= Loop Counter
		D=D-1	A
		?ST=1	typeSrt
		GOYES	TypeLoop
*****************************************
SizeLoop	CD1EX
		D1=C
		D0=C
		D0=D0+	10
		A=DAT0	A
SizeCode	B=A	A		* B= Start Address
		D0=A
		GOSBVL	=SKIPOB
		CD0EX
		C=C-B	A		* C= Object Size
		DAT1=C	A
		D1=D1+	15
		D=D-1	A
		GONC	SizeLoop
		GOC	QSInit
*****************************************
TypeLoop	CD1EX
		D1=C
		D0=C
		D0=D0+	10
		A=DAT0	A
		D0=A			* D0 ->Object
TypeCode	GOSUB	F48GetObType	* Get Object Type!
		DAT1=C	A
		D1=D1+	15
		D=D-1   A
		GONC	TypeLoop
*****************************************
QSInit		C=R0
		D1=C
		D1=D1+	10		* ->Return_Addresses save
		A=R1
		A=A+CON	A,5
		D0=A			* D1 ->Size_field of $vars
		C=DAT0	A
		A=A+C	A		* A.A= ->$vars_End after Last_Ob
		D0=D0+	25		* D0 ->First_Ob
		GOSUB	QuickSort
		?ST=1	nameSrt
		GOYES	QSReverse
*****************************************
QSWipe		A=R1
		D1=A			* D1 ->$vars
		D1=D1+	10
		C=DAT1	A		* C[A]= #Obs
		C=C-1	A
		A=0	A
		D1=D1+	5		* ->#Sel_Field
QSWipeLp	D1=D1+	15		* ->nxt Selection_Field
		DAT1=A	A
		C=C-1	A
		GONC	QSWipeLp
*****************************************
QSReverse	?ST=0	reverse
		GOYES	QSEnd!
		GOSBVL	=D0=DSKTOP
		A=DAT0	A		* A.A= ->$vars
		A=A+CON	A,5
		D0=A			* D0 ->sizeField of $vars
		C=DAT0	A
		C=C+A	A
		D1=C			* D1 ->$vars_End after LastOb
		D0=D0+	5
		C=DAT0	A		* C.A= #files
		B=C	A
		BSRB.F	A
		B=B-1	A
		D0=D0+	5		* ->#Sel_Field
*****************************************
* Swap Objects from both Sides until middle
*****************************************
QSReverseLp	D0=D0+	15
		A=DAT0	15
		D1=D1-	15
		C=DAT1	15
		DAT1=A	15
		DAT0=C	15
		B=B-1	A
		GONC	QSReverseLp
QSEnd!		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP
*****************************************
* Check if Program is User or System RPL
*****************************************
PrgCheck	D0=D0+	5
		A=DAT0	A
		LC(5)	=x<<
		?A=C	A		* User RPL program?
		GOYES	+
		C=0	A
		LC(2)	24		* C= System RPL Type
		RTN
+		C=0	A
		LC(2)	28		* C= User RPL Type
		RTN
*****************************************
* Check if "String" is a "BZ.." File
*****************************************
StrCheck	D0=D0+	10
		A=DAT0	4
		LCSTR	'BZ'
		P=	3
		?A=C	WP		*  $BZ ?
		GOYES	+
		P=	0
		C=0	A
		LC(2)	25
		RTN
+		P=	0
		C=0	A
		LC(2)	30
		RTN
*****************************************
* Gets Object Type
* In:	D0 ->Obj
* Out:	C[B]= #Type
* Uses:	A, C, D, D0, 2 RSTK
*****************************************
F48GetObType	A=DAT0	X
		LC(3)	=DOCOL
		?A=C	X		* Program?
		GOYES	PrgCheck
		LC(3)	=DOCSTR
		?A=C	X		* String?
		GOYES	StrCheck
		LC(2)	26-1
		CDEX	A
		RSTK=C			* Save Object Counter
		GOSUB	PrologTable
		CON(3)	=DORRP
		CON(2)	0
		CON(3)	=DOLIST
		CON(2)	20
		CON(3)	=DOREAL
		CON(2)	23
		CON(3)	=DOCMP
		CON(2)	9
		CON(3)	=DOARRY
		CON(2)	22
		CON(3)	=DOSYMB
		CON(2)	2
		CON(3)	=DOHSTR
		CON(2)	5
		CON(3)	=DOGROB
		CON(2)	16
		CON(3)	=DOLIB
		CON(2)	19
		CON(3)	=DOEXT0
		CON(2)	18
		CON(3)	=DOCODE
		CON(2)	8
		CON(3)	=DOIDNT
		CON(2)	15
		CON(3)	=DOROMP
		CON(2)	29
		CON(3)	=DOBINT
		CON(2)	6
		CON(3)	=DOLNKARRY
		CON(2)	17
		CON(3)	=DOTAG
		CON(2)	26
		CON(3)	=DOLAM
		CON(2)	21
		CON(3)	=DOEXT
		CON(2)	27
		CON(3)	=DOBAK
		CON(2)	4
		CON(3)	=DOCHAR
		CON(2)	7
		CON(3)	=DOEREL
		CON(2)	11
		CON(3)	=DOECMP
		CON(2)	10
		CON(3)	=DOACPTR
		CON(2)	1
		CON(3)	=DOEXT3
		CON(2)	3
		CON(3)	=DOEXT2
		CON(2)	14
		CON(3)	=DOEXT4
		CON(2)	12
		CON(2)	13		* External [?]
PrologTable	C=RSTK
		D0=C			* D0= PrologTable  C=D0
PrologLup	C=DAT0	X
		D0=D0+	3
		?A=C	X
		GOYES	ReadType
		D0=D0+	2
		D=D-1	B
		GONC	PrologLup
ReadType	C=RSTK
		D=C	A		* Restore D
		C=0	A
		C=DAT0	B		* Read Object Type
		RTN
*****************************************
* Sorts the Objects between the start
* and End addresses.
* Arguments:
* A.A= ->Slot after Last_Ob	(End address)
* D0 ->First_Ob			(start address)
*****************************************
QuickSort	C=RSTK
		DAT1=C	A		* Save RETURN Address in $stack
		D1=D1+	5
		CD0EX
		D0=C
		DAT1=C	A		* Save ->First_Ob Addr in $stack
		D1=D1+	5
*****************************************
		C=A-C	A		* C.A= Nibbs between: Last-First
		R3=A.F	A		* R3.A= ->Last_Ob
		AD1EX			* D1 ->Last_Ob
		R4=A.F	A		* R4.A= ->$stack
*****************************************
		A=C	A
		C=0	A
		LC(1)	15
		GOSBVL	=IntDiv		* C=A/15 :#Obs between to sort
		C=C-1	A		* N-1
		D=C	A
		A=A+1	A		* A.A= 1
		?C>A	A		* More than 2 Objects?
		GOYES	QS#Obs>2
*****************************************
* We have only 2 Objects,
* compare them swap? and Return
*****************************************
		?C=0	A		* Only 1 Object?
		GOYES	QSPopStkRTN
		A=DAT0	15		* A[W]= First_Ob
		D1=D1-	15
		C=DAT1	15		* C[W]= Last_Ob
		GOSUB	A<=C?
		GOC	QSPopStkRTN
		DAT0=C	15		* Swap Objects
		DAT1=A	15
QSPopStkRTN	GOSUB	QSPopStk	* Pop address into C.A
		D0=C			* Restore D0->First_Ob
		GOTO	QSReturn
*****************************************
* Set Partition Element as
* arbitrary midpoint of First & End
*****************************************
QS#Obs>2	CSRB.F	A		* C.A= (#obs-1)/2
		A=C	A
		ASL	A
		A=A-C	A		* A.A= 15*(#obs-1)/2
		CD0EX
		A=A+C	A		* First_Ob address + Middle_Ob
		D0=A			* D0 ->Middle_Ob
		A=DAT0	10		* A.A= Partition Element
		D0=C			* Restore D0 ->First_Ob
		GOTO	QSReadOb
*****************************************
* Find first Element >= Partition Element,
* starting from Left->
*****************************************
QSLeft->Lup	D=D-1	A
		GOC	QSContinue
		D0=D0+	15
QSReadOb	C=DAT0	15		* C[W]= First_Ob
		GOSUB	A<=C?		* Middle_Ob <= First_Ob?
		GONC	QSLeft->Lup
*****************************************
* Find first Element <= Partition Element, starting from <-Right
*****************************************
		B=C	W		* B[W]= First_Ob
		C=A	W		* C.A= Middle_Ob
QS<-RightLup	D=D-1	A
		GOC	++
		D1=D1-	15
		A=DAT1	15		* A[W]= Last_Ob
		GOSUB	A<=C?		* Last_Ob <= Middle_Ob?
		GONC	QS<-RightLup
		CAEX	W		* A[W]= Middle_Ob
		DAT0=C	15		* Swap Objects
		C=B	W
		DAT1=C	15
		GOC	QSLeft->Lup
*****************************************
QSContinue	D0=D0+	15
++		A=R3.F	A		* Restore A.A= ->Last_Ob
		C=R4.F	A
		D1=C			* Restore D1->RTNaddress
		GOSUB	QuickSort
		AD0EX
		GOSUB	QSPopStk
		D0=C			* Restore D0 ->First_Ob
		GOSUB	QuickSort
QSReturn	GOSUB	QSPopStk	* Pop address into C.A
		PC=C			* Return there...
*****************************************
QSPopStk	C=R4.F	A		* Get ->$stack
		C=C-CON	A,5
		R4=C.F	A		* update ->$stack
		D1=C			* D1= ->$stack
		C=DAT1	A		* Pop Address
		RTN
*****************************************
A<=C?		?ST=1	nameSrt
		GOYES	D0<=D1?
		?A<=C	A
		RTNYES
		RTN
*****************************************
* Name at D0 <= than Name at D1?
* Uses:	A,B,C,D,D0,D1 & 3 Stack Levels
*****************************************
D0<=D1?		R0=A			* Save A.W
		GOSBVL	=ASRW5
		R1=C			* Save C.W
		GOSBVL	=CSRW5
		CD1EX			* D1 ->Name2
		RSTK=C			* Save D1
		CD0EX
		RSTK=C			* Save D0
		C=D	A
		RSTK=C			* Save D.A
		C=B	W
		R2=C			* Save B.W
*****************************************
		D0=A			* D0 ->Name1
		A=DAT0	B
		A=A-1	B
		GOC	CmpOk
		B=A	B		* B[B]= Name1 Counter
		C=DAT1	B
		C=C-1	B
		GOC	CmpFail
		D=C	B		* D[B]= Name2 Counter
nxtChar		D0=D0+	2
		D1=D1+	2
		A=DAT0	B
		C=DAT1	B
		?A<C	B
		GOYES	CmpOk
		?A>C	B
		GOYES	CmpFail
		B=B-1	B
		GONC	+
*****************************************
CmpOk		ST=1	carry
		GOC	GetPtrRTN
*****************************************
+		D=D-1	B
		GONC	nxtChar
CmpFail		ST=0	carry
*****************************************
GetPtrRTN	C=RSTK
		D=C	A		* Restore D.A
		C=RSTK
		D0=C			* Restore D0
		C=RSTK
		D1=C			* Restore D1
		C=R2
		B=C	W		* Restore B.W
		C=R1			* Restore C.W
		A=R0			* Restore A.W
		?ST=1	carry		* Carry Set?
		RTNYES
		RTN
ENDCODE
************ SORT-ENGINE END ************
      $vars!
      ::
	updir? case
	::
	  FALSE updir!
	  $vars@
	  prevContext@

***************************************
*	UPDIR POSITION FINDER
*
* 2: $vars@
* 1: prevContext@  ->  #pos
***************************************
	  CODE
		STITLE	UpDir-Pos Finder
		C=DAT1	A
		RSTK=C			* Save ->DIR/LIB to found
		D=D+1	A
		D1=D1+	5
		GOSBVL	=PopASavptr
		D1=A
		D1=D1+	10
		C=DAT1	A
		D=C	A		* D[A]= #obs
		D1=D1+	15		* ->MEM_Field
		C=RSTK			* Restore ->DIR/LIB
		B=C	A
		A=0	A		* init offset Counter
nxtDirptr	D=D-1	A
		GOC	push#1
		A=A+1	A
		D1=D1+	15
		C=DAT1	A
		?C#B	A
		GOYES	nxtDirptr
		GONC	push#
push#1		A=0	A		* Not found!
		A=A+1	A
push#		GOVLNG	=PUSH#ALOOP	* Push DIR/LIB offset
	  ENDCODE

	  index!
	  ONE min!
	  n@ EIGHT #>ITE :: EIGHT index@ #MAX DUP SEVEN #- min! ;
			 n@
	  max!
	 ;

	ONEONE min! index!
	EIGHT n@ #MIN max!
       ;
     ;	( Fin-Reload )

    refresh?
    IT
    ::
      F48StatusDraw
      F48FilesDraw

ASSEMBLE
_F48SliderCalc
RPL
      ::
	n@ NINE #< ?SEMI

	n@ UNCOERCE % 46 DUP3PICK %8 %T %OF
	%2 %MAX
	DUP COERCE barHeight!
	%- SWAP %8 %- %/ dy!

ASSEMBLE
_F48Slider
RPL
	::
	  dy@ min@ #1- UNCOERCE %* COERCE   ( Y Pos )
	  barHeight@			    ( Bar Height )
	  CODE
		STITLE	Slider Display Engine
		GOSBVL	=POP2#
		R0=A			* R0.A= Y pos
		R1=C			* R1.A= vertHeight
		GOSBVL	=SAVPTR

* Bug Fix for n=32

		C=0	A
		LC(2)	48-1
		D=C	A		* B.A= vertHeight Safe Counter

* Prepare D1 ->offset in Screen (fast version)

+		D1=(5)	#8068D
		A=DAT1	A
		LC(5)	9*34-2
		A=A+C	A		* advance 9 Rows - 2 nibbs
		D1=A			* ->Disp, just for Slider!

* Start drawing:  frame, blank space and bar!

		GOSUB	1Black		* Write Top Line
		A=R0
		B=A	A		* B.A= Y pos
		?A=0	A		* Bar at Top?
		GOYES	+		* yep, no leading space
		A=A-1	A
		GOSUB	White		* Write leading blank space
+		A=R1
		A=A-1	A
		GOSUB	Black		* Write Bar

* Now compute & draw final white space

		C=0	A
		LC(2)	46-1		* BarSize
		C=C-B	A
		A=R1
		C=C-A	A		* Final=BarSize-Y-vertHeight
		GOC	+		* just in case of underflow...
		A=C	A
		GOSUB	White		* Write final blank space
+		GOSUB	1Black		* Write bottom Line
SlideQuit	GOVLNG	=GETPTRLOOP
*********************************
* #5= 0101 pixels
* #7= 0111 pixels
*********************************
White		LCHEX	5
		GONC	BarLp
1Black		A=0	A
Black		LCHEX	7
BarLp		DAT1=C	P
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2		* D1 ->nextLine

		D=D-1	A		* If Bar Limit Exeeded?
		GOC	BadLimit	* Quit!

		A=A-1	A
		GONC	BarLp
		RTNCC

* Bugfix when Bar Limit Exceeded (n=32)

BadLimit	C=RSTK			* Pop Return Address
		GOC	SlideQuit	* and Quit!
	  ENDCODE
	 ;
       ;
      F48MenuDraw
      FALSE refresh!
     ;

ASSEMBLE
_F48GetKey
RPL
    ::
      GETKEY* ?SKIP DROP#131d

      BINT80h #=casedrop	( ALPHA )
      ::
	# 100
	SetAlphaAnn
	GETKEY* NOTcasedrop DROP#131d

	BINT40h
	OVER#=case
	::
	  #+
	  SetLeftAnn
	  GETKEY* NOTcasedrop DROP#131d
	  #+
	  ClrLeftAnn
	  ClrAlphaAnn
	 ;

	BINTC0h
	OVER#=case
	::
	  #+
	  SetRightAnn
	  GETKEY* NOTcasedrop DROP#131d
	  #+
	  ClrRightAnn
	  ClrAlphaAnn
	 ;

	#+
	ClrAlphaAnn
       ;

      BINT40h			( LEFT SHIFT )
      OVER#=case
      ::
	SetLeftAnn
	GETKEY* NOTcasedrop DROP#131d
	#+
	ClrLeftAnn
       ;

      BINTC0h			( RIGHT SHIFT )
      OVER#=case
      ::
	SetRightAnn
	GETKEY* NOTcasedrop DROP#131d
	#+
	ClrRightAnn
       ;
     ;
    mainMenu?

    ERRSET
*****************************************
* KEY HANDLER:
* 1:	#KeyCode ->
* Dispatches the given #KeyCode, we have
* an Offset for each available Shortkey.
*****************************************
    CODE

MainMenu	EQU 0	* Main Menu?

		CLRST
*		ST=0	MainMenu
		GOSBVL	=popflag
		GONC	+
		ST=1	MainMenu
+		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		?ST=1	MainMenu
		GOYES	++
		C=0	A
		LC(1)	6
		?A>C	A
		GOYES	++
		LC(2)	50
		A=A+C	A
++		GOSUB	->KeyTable
KeyStart	CON(3)	11
		REL(4)	_F48KeyUp
		CON(3)	17
		REL(4)	_F48KeyDown
		CON(3)	25
		REL(4)	_F48KeyEnter
		CON(3)	18
		REL(4)	_F48DOWNDIR
		CON(3)	16
		REL(4)	_F48UPDIR
		CON(3)	12
		REL(4)	_F48NXTMENU
		CON(3)	#C9
		REL(4)	_F48SWAPHEADER
		CON(3)	10
		REL(4)	_F48LIST
		CON(3)	#CB
		REL(4)	_F48MAXUP
		CON(3)	#D1
		REL(4)	_F48MAXDOWN
		CON(3)	#4B
		REL(4)	_F48PAGEUP
		CON(3)	#51
		REL(4)	_F48PAGEDOWN

		CON(3)	1
		REL(4)	_F48VIEW
		CON(3)	2
		REL(4)	_F48EDIT
		CON(3)	3
		REL(4)	_F48RENAME
		CON(3)	4
		REL(4)	_F48NEW
		CON(3)	5
		REL(4)	_F48TREE
		CON(3)	6
		REL(4)	_F48SORT
		CON(3)	51
		REL(4)	_F48SELECT
		CON(3)	52
		REL(4)	_F48COPY
		CON(3)	53
		REL(4)	_F48MOVE
		CON(3)	54
		REL(4)	_F48ORDER
		CON(3)	55
		REL(4)	_F48ZIP
		CON(3)	56
		REL(4)	_F48LINK

		CON(3)	#D0
		REL(4)	_F48TREE
		CON(3)	28
		REL(4)	_F48PURGE
		CON(3)	15
		REL(4)	_F48EVAL
		CON(3)	#CE
		REL(4)	_F48RCL
		CON(3)	#5A
		REL(4)	_F48EDIT
		CON(3)	#ED
		REL(4)	_F48Off
		CON(3)	45
		REL(4)	_F48QUIT
		CON(3)	#1D
		REL(4)	_F48QuitHere
* SORT - Shortcuts
		CON(3)	#D		* [']
		REL(4)	_F48Hidden
		CON(3)	#E		* N
		REL(4)	_F48NameSort
		CON(3)	#13		* S
		REL(4)	_F48SizeSort
		CON(3)	#14		* T
		REL(4)	_F48TypeSort
		CON(3)	#15		* U
		REL(4)	_F48Original
		CON(3)	#4E		* LS+N
		REL(4)	_F48NameRev
		CON(3)	#53		* LS+S
		REL(4)	_F48SizeRev
		CON(3)	#54		* LS+T
		REL(4)	_F48TypeRev
		CON(3)	#55		* LS+U
		REL(4)	_F48OrigRev
* SELECT - Shotcuts
		CON(3)	#101		* [Alpha]+A
		REL(4)	_F48SelAll
		CON(3)	#109		* [Alpha]+I
		REL(4)	_F48SelInv
		CON(3)	#10E		* [Alpha]+N
		REL(4)	_F48SelNone
* I/O - Shortcuts
		CON(3)	#E9		* [RS]+1
		REL(4)	_F48LINK
		CON(3)	#112		* [Alpha]+R
		REL(4)	_F48RECV
		CON(3)	#113		* [Alpha]+S
		REL(4)	_F48SEND
* Misc - Shortcuts
		CON(3)	#103		* [Alpha]+C
		REL(4)	_F48COPY
		CON(3)	#10D		* [Alpha]+M
		REL(4)	_F48MOVE
		CON(3)	#11B		* [Alpha]+Z
		REL(4)	_F48ZIP
		CON(3)	#50		* [LS]+PICTURE
		REL(4)	_F48PrintDisp
		CON(3)	#83		* Alarm/Slepp Event!
		REL(4)	_F48QUIT
->KeyTable	C=RSTK
		D0=C
		C=0	A
		LC(2)	((->KeyTable)-(KeyStart))/7
		B=C	A
KeyLup		B=B-1	A
		GOC	KeyLpQuit
		C=DAT0	X
		?A=C	X
		GOYES	KeyEval
		D0=D0+	7
		GONC	KeyLup

KeyLpQuit	GOVLNG	=GETPTRLOOP

KeyEval		D0=D0+	3
		C=DAT0	4
		AD0EX
		C=C+A	A
		GOVLNG	=GETPTREVALC
*		A=A+C	A
*		GOVLNG	=GPPushALp
    ENDCODE
    ERRTRAP
    ::
      TOADISP
      stackDepth@ RESETDEPTH
      ERROR@ DUP#0=csDROP
      JstGETTHEMSG

      ZEROZERO FOURTEEN BLANKIT
      TWELVE LineGrob XYGROBDISP
      ERRBEEP
      ZEROZEROZERO "Error:" $>miniFont XYGROBDISP
      SIX ROT $>miniFont XYGROBDISP
      TRUEreload!
      ClrDA1IsStat
      WaitForKey 2DROP
     ;
  quit?
  UNTIL

  ( Save Options )
    sortBy@
    props?
    mainStatus?
    THREE ::N
    ' ID F48L StoHiddenVar
    ABND
   ;
  ERRTRAP
  ::
    'REVAL
    ERRJMP
   ;
  ::
    1GETLAM DEPTH 1PUTLAM
    COMPEVAL
    1GETABND #1- RESETDEPTH
    ClrDAsOK
   ;
 ;

ASSEMBLE
_F48Hidden
RPL
****************************
* Show/Hide Null-Named Vars
****************************
::
  SIX DUP
  TestUserFlag
  ITE ClrUserFlag
      SetUserFlag
  TRUEreload!
 ;

ASSEMBLE
_F48Original
RPL
:: ZERO F48Sort! ;

ASSEMBLE
_F48NameSort
RPL
:: ONE F48Sort! ;

ASSEMBLE
_F48TypeSort
RPL
:: TWO F48Sort! ;

ASSEMBLE
_F48SizeSort
RPL
:: THREE F48Sort! ;

ASSEMBLE
_F48OrigRev
RPL
:: FOUR F48Sort! ;

ASSEMBLE
_F48NameRev
RPL
:: FIVE F48Sort! ;

ASSEMBLE
_F48TypeRev
RPL
:: SIX F48Sort! ;

ASSEMBLE
_F48SizeRev
RPL
:: SEVEN F48Sort! ;


ASSEMBLE
_F48SelAll
RPL
:: ZERO F48Select! ;

ASSEMBLE
_F48SelInv
RPL
:: ONE F48Select! ;

ASSEMBLE
_F48SelNone
RPL
:: TWO F48Select! ;

ASSEMBLE
_F48PrintDisp
RPL
:: DOLCD> ;


ASSEMBLE
_F48Off
RPL
::
  TurnOff
 ;



ASSEMBLE
_F48QUIT
RPL
::
  TRUE quit!
 ;



ASSEMBLE
_F48QuitHere
RPL
::
  PATHDIR ' LAM Pth STOLAM
  TRUE quit!
 ;



ASSEMBLE
_F48RCL
RPL
::
  F48$Checks@
  INCOMPDROP
 ;



ASSEMBLE
_F48SWAPHEADER
RPL
::
  mainStatus? NOT mainStatus!
  F48StatusDraw
 ;



ASSEMBLE
_F48NXTMENU
RPL
::
  mainMenu? NOT mainMenu!
  F48MenuDraw
 ;



ASSEMBLE
_F48LIST
RPL
::
  props? NOT props!
  F48FilesDraw
 ;



ASSEMBLE
_F48EVAL
RPL
::
  F48$Index@
  DROPDUP prevContext!
  TrueTrue updir! reload!
  COLA_EVAL
 ;



ASSEMBLE
_F48COPY
RPL
::
  F48$Checks@
  FALSE		( COPY Mode! )
  F48Copy/Move
 ;



ASSEMBLE
_F48MOVE
RPL
::
  F48$Checks@
  TRUE		( MOVE Mode! )
  F48Copy/Move
 ;



ASSEMBLE
_F48TREE
RPL
::
  TRUE F48Tree NOT?SEMI
  DUP CONTEXT! context!
  TRUEreload!
 ;



ASSEMBLE
_F48ORDER
RPL
::
  F48$Checks@
  TRUEreload!
  INNERCOMP
  ZERO_DO
    >LASTRAM-WOR
  LOOP
  ZERO sortBy!
 ;



ASSEMBLE
_F48PURGE
RPL
::
  F48$Checks@

  TRUEreload!
  FALSETRUE delMode! all!
  INNERCOMP
  ZERO_DO
    F48AskUser
    ITE OBPURGE!
	DROP
  LOOP
 ;



ASSEMBLE
_F48SORT
RPL
::
  "Size"
  "Type"
  "Name"
  "Original"
  FOUR sortBy@ TRUE
  F48Choose NOT?SEMI

ASSEMBLE
_F48Sort!
RPL
  ::
    sortBy@ OVER#=case DROP

    DUP#0=
    SWAPDUP sortBy!
    FOUR #= ORcase TRUEreload!

    $vars@
    CODE
		GOLONG	ML-Sort!
    ENDCODE
    DROPTRUE refresh!
   ;
 ;



ASSEMBLE
_F48MAXUP
RPL
::

ASSEMBLE
_F48MaxUpSetup
RPL
  ::
    ONEONE index! min!
    n@ EIGHT #MIN max!
    F48SliderCalc
   ;

  F48FilesDraw
 ;



ASSEMBLE
_F48MAXDOWN
RPL
::

ASSEMBLE
_F48MaxDnSetup
RPL
  ::
    n@ NINE OVER#> case index!

    DUPDUP index! max!
    SEVEN #- min!
    F48SliderCalc
   ;

  F48FilesDraw
 ;



ASSEMBLE
_F48PAGEUP
RPL
::

ASSEMBLE
_F48PageUpSetup
RPL
  ::
    min@ #1- EIGHT #MIN
    min@ OVER#- min!
    max@ OVER#- max!
    index@ SWAP#- index!
    F48SliderCalc
   ;

  F48FilesDraw
 ;



ASSEMBLE
_F48PAGEDOWN
RPL
::

ASSEMBLE
_F48PageDnSetup
RPL
  ::
    n@ max@ #- EIGHT #MIN
    min@ OVER#+ min!
    max@ OVER#+ max!
    index@ #+ index!
    F48SliderCalc
   ;

  F48FilesDraw
 ;



ASSEMBLE
_F48UPDIR
RPL
::
  TRUEreload!
  context@ DUP prevContext!

  HOMEDIR?
  case
  ::
    TrueTrue F48Tree
    NOTcase quit!
    SWAPDROPDUP CONTEXT! context!
   ;

  TRUE updir!
  context@
  ZERO context!		( free-up the Ob )

  GETUPDIR
  DROPDUP context!
  CONTEXT!
 ;



ASSEMBLE
_F48DOWNDIR
RPL
::
  F48$Index@
  DROPDUP DUPTYPERRP? NOTcase2DROP
  context!
  CONTEXT!
  TRUEreload!
 ;



ASSEMBLE
_F48RENAME
RPL
::
  F48$Index@
  DROPDUP
  F48HiddenDir@
  EQcase DIRARGERR
  RAM-WORDNAME ID>$
  TRUE refresh!
  "Rename " OVER " to:" &$ &$SWAP
  F48Input NOTcaseDROP

ASSEMBLE
_F48ParseName
RPL
  ::
    BEGIN
    ::
      DUPLEN$ Blank$ OVER EQUALcase SETSTACKERR
      $>ID DoHere: DUP@ NOTcaseTRUE
      DROP ID>$ DUP
      " already Exists\ntry again:" &$SWAP
      F48Input NOTcase ABORT
      FALSE
     ;
    UNTIL
    TRUEreload!
   ;

  SWAPTRUE updir!
*****************************************
* Renames the given object "In-Place"
*
* 2:	new_ID
* 1:	Object	->
*****************************************
  CODE
		GOSBVL	=SAVPTR
		C=DAT1	A
		D0=C			* D0->Object to be Renamed
		R3=C			* R3[A]= Save Object!
		GOSBVL	=TRAVERSE-	* D0 ->Ob_Name
		A=0	A
		A=DAT0	B		* A[A]= Name_Length
		D1=D1+	5		* D1 ->Level2
		C=DAT1	A		* C[A]= ->newID
		RSTK=C			* Save it!
		D1=C			* D1 ->newID
		D1=D1+	5		* skip Prologue
		C=0	A
		C=DAT1	B		* C[A]= newID_Length
		?C=A	B		* Same Name Length?
		GOYES	Rename!
		?A#0	A		* Null Name?
		GOYES	+
		C=C+1	A		* Add Second Lenght Field
+		?C#0	A		* Null new Name?
		GOYES	+
		A=A+1	A		* Add Second Lenght Field
+		ST=1	5
		C=C-A	A
		GONC	++
		ST=0	5
		C=-C	A
++		C=C+C	A
		B=C	A
		AD0EX
		C=R3
		D0=C
		C=B	A
		GOSBVL	=ECUSER
		A=B	A
		D0=A
Rename!		C=RSTK
		D1=C
		D1=D1+	5
		C=DAT1	B
		D=C	B
RenameLp	A=DAT1	B
		DAT0=A	B
		D0=D0+	2
		D1=D1+	2
		C=C-1	B
		GONC	RenameLp
		?D=0	B
		GOYES	RenQuit
		C=D	B
		DAT0=C	B
RenQuit		GOVLNG	=GETPTRLOOP
  ENDCODE
  prevContext! DROP
 ;



ASSEMBLE
_F48KeyUp
RPL
::
  F48KeyRepeat
  ELEVEN

ASSEMBLE
_F48UP
RPL
  ::
    index@ min@
    #=case
    ::
      index@ #1= ?SEMI  ( already at TOP? )

      max@ #1- max!
      min@ #1-DUP min!
      DUP index!
      ONE TRUE
      CODE
		STITLE	UP-KEY Display Refresh
		GOSUB	CpyScreenDwn
		P=	16-6		* Loop counter
cpyInvbarLineUp D0=D0-	2
		D1=D1-	2
		D0=D0-	16
		D1=D1-	16
		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		D0=D0-	16
		D1=D1-	16
		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		P=P+1
		GONC	cpyInvbarLineUp
		GOSBVL	=GETPTR
		GOLONG	File>Disp
*****************************************
* When scrolling:
* Refreshes the screen for next item
*****************************************
CpyScreenDwn	GOSBVL	=SAVPTR
		D0=(5)	#8068D
		A=DAT0	A
		C=0	A
		LC(3)	50*34
		A=A+C	A
		D0=A
		LC(3)	6*34
		A=A+C	A
		D1=A
		LC(2)	36-1		* Lines to copy
		B=C	A
copyLineUp	D0=D0-	2		* ->PreviousLine
		D1=D1-	2		* ->PreviousLine
		C=0	A
		LC(2)	32		* 32 Nibbles to copy
		GOSBVL	=MOVEUP
		B=B-1	A
		GONC	copyLineUp
		RTN
      ENDCODE
      F48Slider
     ;

    index@ #1-
    F48IndexDraw
   ;

  FALSE downEnter!
 ;



ASSEMBLE
_F48KeyDown
RPL
::
  F48KeyRepeat
  SEVENTEEN

ASSEMBLE
_F48DOWN
RPL
  ::
    index@ max@
    #=case
    ::
      index@ n@ #= ?SEMI ( already at BOTTOM? )

      min@ #1+ min!
      max@ #1+DUP max!
      DUP index!
      EIGHT TRUE
      CODE
		STITLE	DOWN-KEY Display Refresh
		GOSUB	CpyScreenUp
		P=	16-6		* Loop counter
cpyInvbarLineDn A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		D0=D0+	16
		D1=D1+	16
		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		D0=D0+	16
		D1=D1+	16
		D0=D0+	2
		D1=D1+	2
		P=P+1
		GONC	cpyInvbarLineDn
		GOSBVL	=GETPTR
		GOLONG	File>Disp
*****************************************
* When scrolling:
* Refreshes the screen for next item
*****************************************
CpyScreenUp	GOSBVL	=SAVPTR
		D0=(5)	#8068D
		A=DAT0	A
		C=0	A
		LC(3)	8*34
		A=A+C	A
		D1=A
		LC(3)	6*34
		A=A+C	A
		D0=A
		LC(2)	36-1		* Lines to copy
		B=C	A
copyLineDown	C=0	A
		LC(2)	32		* 32 Nibbles to copy
		GOSBVL	=MOVEDOWN
		D0=D0+	2		* ->nextLine
		D1=D1+	2		* ->nextLine
		B=B-1	A
		GONC	copyLineDown
		RTN
      ENDCODE
      F48Slider
     ;

    index@ #1+
    F48IndexDraw
   ;

  TRUE downEnter!
 ;



ASSEMBLE
_F48EDIT
RPL
::
  F48$Index@		( Id Ob #Type)
  TRUEreload!
  OVER 1LAMBIND		( Save Object! )
  ::
* Algebraic
    TWO #=casedrop ViewLevel1

* Array
    TWENTYTWO #=casedrop ViewLevel1

* System RPL
    TWENTYFOUR #=casedrop SETTYPEERR

* Assembly Language
    EIGHT #=case SETTYPEERR

* General Purpose Editor
    EditLevel1
   ;

  1GETABND
  REPLACE
  prevContext! TRUE updir!
 ;



ASSEMBLE
_F48SELECT
RPL
::
  "Select Zero"
  "Invert Selection"
  "Select All"
  THREE ZEROFALSE
  F48Choose NOT?SEMI

ASSEMBLE
_F48Select!
RPL
  ::
    $vars@ SWAPTRUE refresh!
********* FILE SELECTION HANDLER ********
* 2: $vars
* 1: #action (0=All / 1=Invert / 2=None)
*****************************************
    CODE
		STITLE	File-Selection Engine
		GOSBVL	=POP#
		R0=A
		GOSBVL	=PopASavptr
		R1=A			* R1.A= ->$vars
		C=R0
		B=C	A		* B.A= #action
		D0=A			* D0 ->$vars
		D0=D0+	10		* skip prolog & size
		A=DAT0	A		* A.A= #files
		D0=D0+	5		* skip #files
*****************************************
		?B=0	P		* Select All?
		GOYES	All$Checks
		B=B-1	P
		?B=0	P		* Invert?
		GOYES	Invert$Checks
		GOTO	None$Checks
*****************************************
*	Select All Files
*****************************************
All$Checks	B=A	A		* B.A= #files
		LC(5)	999
		ACEX	A		* A.A= 999, C.A= #files
		?C<=A	A
		GOYES	+
		C=A	A		* Set Max # of selected
+		DAT0=C	A		* Update #Selected
		D0=D0+	15		* ->First_Ob
		D=C	A		* D.A= Max # of selected
		A=0	A		* Reset Wiper
		C=0	A		* Reset Counter
All$Lp		B=B-1	A
		GOC	TotalSize!
		?C>=D	A		* If Counter >= Max, then skip
		GOYES	+
		C=C+1	A		* Increase Counter
		DAT0=C	X		* Select File!
		GONC	nxtFile
+		DAT0=A	X		* Unselect File!
nxtFile		D0=D0+	15
		GOTO	All$Lp
*****************************************
*	Inverts Files Selection
*****************************************
Invert$Checks	B=A	A		* B.A= # Objects
		C=DAT0	A		* C.A= # Selected
		A=A-C	A		* A.A= #Obs - #Sel
		LC(5)	999
		ACEX	A		* A.A= 999, C.A= new #Selected
		?C<=A	A
		GOYES	+
		C=A	A
+		D=C	A		* D.A= Max # of checked
		DAT0=C	A		* Write new #checked
		D0=D0+	15		* ->First_Ob
		C=0	A		* C.A= Object Counter
inv$Lup		B=B-1	A
		GOC	TotalSize!
		A=DAT0	X
		?A=0	X
		GOYES	+
		A=0	A
		DAT0=A	X
		GONC	invCont
+		?C>=D	A
		GOYES	invCont
		C=C+1	A
		DAT0=C	X
invCont		D0=D0+	15
		GOTO	inv$Lup
*****************************************
*	Select None...
*****************************************
None$Checks	C=0	W
		DAT0=C	10		* Clear #Sel and SelSize Fields!
		D0=D0+	15		* ->First_Ob
None$Lp		A=A-1	A
		GOC	SelecExit
		DAT0=C	X
		D0=D0+	15		* D0 ->Next_Ob
		GONC	None$Lp
*****************************************
* Calculates Total size of Selected Files
*****************************************
TotalSize!	A=R1
		D0=A
		D0=D0+	10		* skip prolog + size
		C=DAT0	A		* C.A= #obs
		D=C	A		* D.A= Loop Counter
		D0=D0+	10		* D0 ->SelSize Field
		C=0	A
		DAT0=C	A		* Clear SelSize Field
		AD0EX
		D0=A
		D1=A
		D1=D1+	5		* ->Mem_Field

addLup		D1=D1+	5		* ->Sel_Field
		D=D-1	A
		GONC	+
SelecExit	GOVLNG	=GETPTRLOOP

+		A=DAT1	A
		D1=D1+	10
		?A=0	A		* Not Selected?
		GOYES	addLup

		C=DAT1	A
		B=C	A		* ->Ob
		CD0EX
		RSTK=C			* Save ->Total_Field
		GOSBVL	=SKIPOB
		C=RSTK			* Restore ->Total_Field
		CD0EX
		C=C-B	A		* C.A= Ob Size

		A=DAT0	A
		A=A+C	A		* Add Size to Total_Field
		DAT0=A	A
		GOTO	addLup
*****************************************
    ENDCODE
   ;
 ;



ASSEMBLE
_F48NEW
RPL
::
  "Object"
  "Directory"
  TWO ZEROFALSE
  F48Choose
  NOT?SEMI

  TRUE refresh!
  #0=case
  ::
    "New Directory:"
    NULL$

ASSEMBLE
_F48Input
RPL
    ::
      #ZERO#ONE ONEONE
      <SkipKey >SkipKey
      NullMenuKey DUPDUP
      TogInsertKey
      SIX {}N
      ONEFALSE ZERO
      InputLine
     ;

    NOT?SEMI
    F48ParseName
    # 7FF CRDIR#	( dir )
    OVER ?STO_HERE	( id dir id -> id )
    @DROP prevContext!
    TRUE updir!
   ;

  "Enter New Object:"
  NULL$
  ONEONE
  #TWO#TWO
  EditMenu
  ONEFALSE TWO
  InputLine NOT?SEMI

  "Enter Name:"
  NULL$
  F48Input NOT?SEMI
  F48ParseName
  SWAPOVER ?STO_HERE
  @DROP prevContext!
  TRUE updir!
 ;



ASSEMBLE
_F48KeyEnter
RPL
::
  F48KeyRepeat
  TWENTYFIVE
  ::
    n@ #0=?SEMI
    $vars@ index@

*****************************************
* Select/Un-Select #nth Object from $vars
* 2:  $vars
* 1:  #nth_ob	->
*****************************************
    CODE

max		EQU 2

		STITLE	File Check/Uncheck Engine
		GOSBVL	=POP#
		R0=A			* R0.A= #index
		GOSBVL	=PopASavptr
		R1=A			* R1.A= ->$vars
		D1=A
		D1=D1+	10		* ->#obs_Field
		C=DAT1	A
		R2=C			* R2.A= #obs
		D1=D1+	5		* D1 ->#Sel_Field
		A=DAT1	A		* A[A]= #Selected Obs
		LC(5)	999
		ST=0	max
		?A<C	A		* Max Selection not Reached?
		GOYES	+
		ST=1	max		* set max Flag!

* Find #index Object

+		A=R0			* C.A= #index
		A=A+1	A		* C.A= +1 because of Data_Fields
		C=A	A
		CSL	A		* C.A= (#index)*16
		C=C-A	A		* C.A= (#index)*15
		A=R1			* ->$vars
		A=A+C	A
		D0=A			* ->Sel_Field
		D0=D0+	10		* ->Ob_Field

* Calculate Size of index Obj

		C=DAT0	A
		B=C	A		* Save Start_Address
		CD0EX			* ->Ob
		RSTK=C			* Save D0
		GOSBVL	=SKIPOB
		C=RSTK
		CD0EX			* Restore D0
		C=C-B	A		* C.A= Ob_Size

* Read Sel_Field to see if we
* check or uncheck index Obj

		D0=D0-	10		* D0 ->Sel_Field
		A=DAT0	A
		?A#0	A		* Selected Object?
		GOYES	uncheck		* yes, uncheck it!

		?ST=1	max		* if max Reached, quit!
		GOYES	pExit

* Increase #Sel_Field & Select Object

		A=DAT1	A
		A=A+1	A		* Increase #sel files
		DAT1=A	A
		DAT0=A	X		* Select Index Obj!

* Update TotalSize_Field

		D1=D1+	5		* ->SelSize_Field
		A=DAT1	A		* A.A= Total
		A=A+C	A		* A.A= Total + Ob_Size
		DAT1=A	A		* new Total!
pExit		GOVLNG	=GETPTRLOOP
*****************************************
uncheck		B=A	A		* B.A= Save Selection#
		A=0	A
		DAT0=A	A		* Un-Select object

* Decrease #sel_Field

		A=DAT1	A
		A=A-1	A
		DAT1=A	A		* Update #Selected

* Update TotalSize_Field

		D1=D1+	5
		A=DAT1	A		* A.A= Total
		A=A-C	A		* A.A= Total - Ob_Size
		DAT1=A	A		* new Total!
		D1=D1+	10		* ->First_Ob

		C=R2			* C.A= #obs
		D=C	A		* Loop counter
decLup		D=D-1	A
		GOC	pExit
		C=DAT1	X
		?C<B	X
		GOYES	+
		C=C-1	X		* Update Sel_Field
		DAT1=C	X
+		D1=D1+	15
		GOTO	decLup
    ENDCODE
    F48StatusDraw  ( Actualizar Estado )
*****************************************
    max@ #1+ min@
    DO
      INDEX@
      DUP min@ #-+1
      OVER index@ #=
*****************************************
* 3:   #nthel (1-n)
* 2:	 #pos (1-8)
* 1:  Invert? (true/false)  ->
*****************************************
      CODE
		ST=1	check		* Display the Check Only!
		GOLONG	Check>Disp
      ENDCODE
    LOOP
    downEnter? ITE F48DOWN F48UP
   ;
 ;



ASSEMBLE
_F48ZIP
RPL
::
  F48$Index@		( id obj #type )
  SWAPDUP
  F48HiddenDir@
  EQcase DIRARGERR	( HiddenDir? -> Error )
  RAM-WORDNAME
  SWAPROT
  # 1BC02
  "BZ" palparse DROPTRUE refresh!
  DUP DUPTYPEROMP? ITE ROMPTR@ @
  NOTcasedrop DO#EXIT
  TYPECOL? NOTcasedrop DO#EXIT
  UNROTDROP		( Id Obj BZ #Type )

* Auto-Unzip Program?
  TWENTYFOUR OVER#= IT
  ::
    3PICK ONE NTHELCOMP NOT?SEMI
    DUPTYPECSTR? NOTcaseDROP
    DUPONE TWO SUB$ "BZ"
    EQUALNOTcase DROP
    4ROLLDROP UNROTDROP
    THIRTY
   ;

* Zip File -> Unzip
  THIRTY #=case
  ::
    EIGHT FORTYEIGHT BLANKIT
    FORTYTWO TWENTYSEVEN
    "Extract?" $>BIGGROB XYGROBDISP
    PTR 17F15		( Display YES, NO labels )
    PTR 17FB1		( YES, NO Key Handler )
    case 3DROP	( Cancel Operation! )
    NOTcase 3DROP
    EVAL OVER STO
    @DROP prevContext!
    TrueTrue updir! reload!
   ;

* Any Object -> Zip
  CLEARVDISP DispStsBound
  DUPUNROT EVAL
  TWENTYSEVEN TWENTYSEVEN
  "Auto-Extract?" $>BIGGROB XYGROBDISP
  PTR 17F15		( Display YES, NO labels )
  PTR 17FB1		( YES, NO Key Handler )
  case 3DROP		( Cancel Operation! )
  ITE
  ::
    SWAP' EVAL THREE ::N
   ;
  SWAPDROP

  OVER STO
  @DROP prevContext!
  TrueTrue updir! reload!
 ;



ASSEMBLE
_F48LINK
RPL
::

ASSEMBLE
_F48GetIO
RPL
  :: ( Recall Sender & Receiver... )
    { xSEND xRECV }
    # 1BC03		( Invalid 'F48IO' )
    ' ID F48IO @ NOTcaseDROP
    DUPTYPELIST? NOTcasedrop ERROROUT
    DUPLENCOMP #2= NOTcasedrop ERROROUT
    UNROT2DROP
   ;

  INCOMPDROP SWAP
  "Receive "
  "Send    "
  TWO
  #1+_ONE_DO
    ROT DO>STR EIGHT 1_#1-SUB$ CHR_LeftPar >H$ CHR_RightPar >T$
    &$SWAP
  LOOP
  TWO
  ZEROFALSE
  F48Choose NOT?SEMI

  ( Receive Files... )
  #1=case
ASSEMBLE
_F48RECV
RPL
  ::
    F48GetIO
    TRUEreload!
    TWO NTHCOMPDROP 2PUTLAM
    BEGIN
      2GETEVAL
      ATTO?
    UNTIL
   ;

  ( Send Files... )
ASSEMBLE
_F48SEND
RPL
  ::
    F48$Checks@
    F48GetIO
    TRUEreload!
    ONE NTHCOMPDROP 2PUTLAM

    toLEN_DO
      DUPINDEX@ NTHCOMPDROP	( Get Object )
      RAM-WORDNAME
      2GETEVAL
    LOOP
    DROP
   ;
;



ASSEMBLE
_F48VIEW
RPL
::
  F48$Index@
  TRUE refresh!

ASSEMBLE
_F48ObView
RPL
  ::
    TWENTYTWO #=casedrop ViewLevel1	( ARRAY )

    TWO #=casedrop ViewLevel1		( ALGEBRAIC )

    TWENTYFOUR #=case SETTYPEERR	( SYSTEM RPL )

    ( GROB or { STR GROB...} )
    DUPTYPEGROB?
    OVER DUPTYPELIST?
    ITE :: CARCOMP TYPECSTR? OR ;
	DROP

    ?SKIP DO>STR
    GARBAGE
    TWO ROMPTR 101 2		( Font2 Present? )
    DUP ITE ROMPTR 101 4	( Yes, FONT2 -> )
	    :: ' PTR 7B24D ;	( No, Use Built-In )

    ROMPTR 101 3		( FONT1 -> )
    TURNMENUOFF
********* STRING VIEWER ENGINE **********
* 4: $
* 3: UFL2?
* 2: Font2
* 1: Font1	->
*****************************************
* R0=	->$view
* R1=	Last_Font2_Char
* R2=	->Font1/2
* R3=
* R4=	X-OFFSET
*****************************************
    CODE

* Keyboard Codes:
CSTCODE		EQU 9
MTHCODE		EQU 7
VARCODE		EQU 10
UPCODE		EQU 11
NXTCODE		EQU 12
LEFTCODE	EQU 16
DOWNCODE	EQU 17
RIGHTCODE	EQU 18
EEXCODE		EQU 27
KEY0		EQU 46
KEY1		EQU 41
KEY2		EQU 42
KEY3		EQU 43
KEY4		EQU 36
KEY5		EQU 37
KEY6		EQU 38
KEY7		EQU 31
KEY8		EQU 32
KEY9		EQU 33
MINUSCODE	EQU 44
PLUSCODE	EQU 49

sWordWrap	EQU 0	* Use Word Wrap?
sUpSearch	EQU 1	* Up-Search for a Title?
sInvFont	EQU 2	* Invert Font?
sHalfChar	EQU 3	* FONT2 Half Char?
sUFL1		EQU 4	* miniFont Display?
sUFL2		EQU 5	* UFL2 Present?
sFAST		EQU 6	* Fast Scroll?
sDISPLAY	EQU 7	* Refresh Display?
sListOb		EQU 8	* List Object? (str + grobs)
sFull		EQU 9	* Wide-Line Mode? ($Pack)
sNewLine	EQU 3	* New-Line Char? ($Pack)
sRepeat		EQU 10	* Key-Repeat?
sWrapWidth	EQU 33	* Word-Wrap Width

* Some Local Variables:
		ABASE	#80100		* Base Address
vSCRNLINES	ALLOC	5		* #ScreenLines FNT2:8 - FNT1:10
vBLOCKCOUNT	ALLOC	5		* Available RAM: #Blocks
aOBJECT		ALLOC	5		* ->Object
vTOPLINE	ALLOC	5		* #TopLine
vLINECOUNT	ALLOC	5		* #Lines
aFONT1		ALLOC	5		* ->Font1
aFONT2		ALLOC	5		* ->Font2
vTIMESAVE	ALLOC	5		* Timer
vTOPTITLE	ALLOC	5		* #TopTitle Always=0
vTITLECOUNT	ALLOC	5		* #Titles
vLINESLEFT	ALLOC	5		* #Lines to Scan for Titles
a$VIEW		ALLOC	5		* $View Pointer during Make$Titles


$TITLES		EQU	=uart_buffer

		TITLE	String VIEW Engine
		STITLE	Main Engine

		GOSBVL	=DisableIntr	* Interruptions OFF!
		A=DAT1	A		* A[A]= ->Font1
		D=D-1	A
		D1=D1+	5		* Drop Font1 from Stack
		A=A+CON	A,10
		LC(5)	aFONT1
		CD0EX			* D0 ->aFONT1
		DAT0=A	A		* Save ->Font1
		D0=D0+	5		* D0 ->aFONT2
		A=DAT1	A		* A[A]= ->Font2
		D=D-1	A
		D1=D1+	5		* Drop Font2 from Stack
		A=A+CON	A,10
		DAT0=A	A		* Save ->Font2
		D0=C			* Restore D0
		C=0	A
		LC(2)	#91		* #91= 010010001 Bits
		ST=C			* Set Status Flags!
		GOSBVL	=popflag	* Using UFL FONT2?
		GONC	+
		ST=1	sUFL2
+		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=(5)	aOBJECT
		DAT0=A	A		* Save ->Object!

SVTop$Main	C=0	A
		D0=(5)	vTOPLINE	* ->vTOPLINE
		DAT0=C	A		* TopLine=0
		R4=C			* Clear Xoffset!

MK$Main		GOSUB	Make$View	* Build the $View Structure
		D0=(5)	(=ANNCTRL)+1
		C=DAT0	P
		CBIT=0	1		* Clear I/O Annunciator
		?ST=1	sWordWrap	* Word-Wrap Enabled?
		GOYES	+		* YES
		CBIT=1	1		* NO - Set I/O Annunciator
+		DAT0=C	P		* Update it!

SVMain!		C=0	A
		LC(1)	10		* 10 Lines!
		D0=(5)	aFONT1
		?ST=1	sUFL1
		GOYES	+
		LC(1)	8
		D0=D0+	5		* ->aFONT2
+		A=DAT0	A		* Read Current Font
		R2=A			* R2= ->FONT Data
		D0=(2)	vSCRNLINES
		DAT0=C	A		* Update #ScreenLines
		GOSUB	SVSaveTim
		GOSUB	SVDispClear	* Clear Screen!

SVMain		?ST=0	sDISPLAY
		GOYES	+
		GOSUB	SVDispScreen

+		?ST=0	sRepeat
		GOYES	+
		LC(5)	8192*35/100
		GOSUB	SVKeyDelay
		ST=0	sRepeat
		GONC	++

+		?ST=1	sFAST
		GOYES	++
		LC(5)	8192*6/100	* .06 seconds
		GOSUB	SVDelay

++		GOSUB	SVKeyboard?
		GOC	+
		GOSBVL	=clrbusy
		SHUTDN
		GOSBVL	=showbusy
		ST=1	sRepeat
+		ST=1	sDISPLAY
		GOSUB	SVSaveTim

		LC(2)	=LEFTCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoLt

+		LC(2)	=RIGHTCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoRt

+		LC(2)	=DOWNCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoDn

+		LC(2)	=UPCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoUp

+		LC(2)	=NXTCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=0	sUpSearch
		GOTO	SVFindTitle

+		LC(2)	=MTHCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=1	sUpSearch
		GOTO	SVFindTitle

+		GOSUB	SVCSTDn?
		GONC	++
*-		GOSUB	SVCSTDn?
*		GOC	-		* Wait Until Key Released!
		?ST=1	sUFL1
		GOYES	+
		ST=1	sUFL1
		GONC	GoMain!
+		ST=0	sUFL1
GoMain!		?ST=0	sListOb
		GOYES	+
		GOTO	MK$Main
+		GOTO	SVMain!

++		LC(2)	VARCODE
		GOSUB	SVKeyDn?
		GONC	++
*-		LC(2)	VARCODE
*		GOSUB	SVKeyDn?
*		GOC	-		* Wait until Key Released!
		?ST=1	sWordWrap	* Word Wrap Enabled?
		GOYES	+
		ST=1	sWordWrap	* Enabled it!
		GONC	GoTopMain
+		ST=0	sWordWrap	* Disable it!
GoTopMain	GOTO	SVTop$Main	* Reload $view

++		LC(2)	PLUSCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=1	sFAST

+		LC(2)	MINUSCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=0	sFAST

+		LC(2)	EEXCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOSUB	$TitleEngine
		GOC	SVMainOk
		GOTO	SVMain

+		GOSBVL	=OnKeyDown?
		GOC	SVExit
SVMainOk	ST=0	sDISPLAY
		GOTO	SVMain
SVExit		GOSUB	SVKeyboard?
		GOC	SVExit
		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP
*****************************************
SVCSTDn?	LC(2)	CSTCODE
SVKeyDn?	A=C	B
		GOVLNG	=ThisKeyDown?
*****************************************
SVKeyboard?	GOVLNG	=Kbd_OR
*****************************************
SVSaveTim	D1=(5)	=TIMER2
		A=DAT1	A
		D1=(5)	vTIMESAVE
		DAT1=A	A		* Save Time!
		RTN
*****************************************
* C[A]= Ticks to Delay
*****************************************
SVKeyDelay	D0=(5)	vTIMESAVE
		A=DAT0	A		* A.A= key_time
		A=A-C	A
		D0=(5)	=TIMER2
-		GOSUB	SVKeyboard?
		RTNNC
		C=DAT0	A
		?C>A	A
		GOYES	-
		RTN
*****************************************
* C[A]= Ticks to Delay
*****************************************
SVDelay		D1=(5)	vTIMESAVE
		A=DAT1	A		* A.A= key_time
		A=A-C	A
		D1=(5)	=TIMER2
-		C=DAT1	A
		?C>A	A
		GOYES	-
		RTN
*****************************************
SVDoLt		A=R4.F	B
		A=A-1	B
		GOC	SVbadcrs
SVnewcrs	R4=A.F	B		* Update it!
		GOTO	SVMain
*****************************************
SVDoRt		A=R4.F	B
		A=A+1	B
		GONC	SVnewcrs
SVbadcrs	GOTO	SVMainOk
*****************************************
SVDoUp		D0=(5)	vTOPLINE
		A=DAT0	A		* A.A= #TopLine
		A=A-1	A		* A.A= PrevLine
		GOC	++
		DAT0=A	A		* Update TopLine
		D0=(5)	=DISP1CTLg
		A=DAT0	A		* ->row1
		C=0	A
		?ST=0	sUFL1
		GOYES	+
		LC(3)	9*6*34
		A=A+C	A
		D0=A
		LC(3)	6*34
		A=A+C	A
		D1=A
		LC(3)	9*6*34
		GONC	MovUp
+		LC(3)	7*8*34
		A=A+C	A
		D0=A
		LC(3)	8*34
		A=A+C	A
		D1=A
		LC(3)	7*8*34
MovUp		GOSBVL	=MOVEUP
		C=0	A
		GOSUB	SVDispLine
++		GOTO	SVMainOk
*****************************************
SVDoDn		D0=(5)	vLINECOUNT
		A=DAT0	A		* A.A= #Lines
		D0=D0-	5		* ->vTOPLINE
		C=DAT0	A
		B=C	A		* B.A= #TopLine
		D1=(5)	vSCRNLINES
		C=DAT1	A
		C=C+B	A		* C.A= #Line to Draw
		?C>=A	A		* Line out of Range?
		GOYES	++
		C=B	A
		C=C+1	A		* new TopLine
		DAT0=C	A		* Update it!

		D1=(5)	=DISP1CTLg
		A=DAT1	A		* ->row1
		D1=A
		C=0	A
		?ST=0	sUFL1
		GOYES	+
		LC(2)	6*34
		A=A+C	A
		D0=A
		LC(3)	9*6*34
		GONC	MovDn
+		LC(3)	8*34
		A=A+C	A
		D0=A
		LC(3)	7*8*34
MovDn		GOSBVL	=MOVEDOWN
		D0=(5)	vSCRNLINES
		C=DAT0	A		* C.A= #ScreenLines 8 or 10
		C=C-1	A
		GOSUB	SVDispLine
++		GOTO	SVMainOk
*****************************************
SVDispClear	GOSBVL	=D0->Row1
		D1=A
		LC(5)	64*34
		GOVLNG	=WIPEOUT
*****************************************
SVDispScreen	B=0	S		* Row 1
-		C=B	S
		C=0	A
		CSLC			* C.A= #ScreenLine to Draw
		D0=(5)	vSCRNLINES
		A=DAT0	A
		?C>=A	B		* Line in Range?
		RTNYES
		GOSUB	SVDispLine
		B=B+1	S
		GONC	-
*****************************************
* Points D1 ->ScreenLine and Wipes it!
* D0-> vTOPLINE
*****************************************
D1->WipeLine	B=C	A		* B.A= #Screen Line
		C=C+C	A
		A=C	A
		C=C+A	A
		C=C+A	A
		?ST=1	sUFL1
		GOYES	+
		ST=0	sHalfChar	* Clear HalfChar (Line Start!)
		C=C+A	A
+		C=C+C	A
		A=C	A
		CSL	A
		C=C+A	A		* #CC * Y
		D1=(5)	=DISP1CTLg
		A=DAT1	A		* ->Display row1
		C=C+A	A
		RSTK=C
		D1=C			* ->Display Row to Draw!
		C=0	A
		LC(2)	6*34
		?ST=1	sUFL1
		GOYES	+
		LC(3)	8*34
+		GOSBVL	=WIPEOUT
		C=RSTK
		D1=C			* Restore D1->Display

* Now check if Line to Draw is in Range

		A=DAT0	A		* A.A= #TopLine
		A=A+B	A		* A.A= #Line to Draw (#TopLine + #ScreenLine)
		D0=D0+	5		* ->vLINECOUNT
		C=DAT0	A		* C.A= #Total_Lines
		?A<C	A		* Line in Range?
		RTNYES			* Yes!
		C=RSTK			* No! Pop Rtn Addres! Nothing do Draw!
		RTN
*****************************************
* Draws on Screen the C.A Line Number
*****************************************
SVDispLine	D0=(5)	vTOPLINE
		GOSUB	D1->WipeLine
		A=A+A	A
		A=A+A	A
		A=A+A	A		* B.A= 8*(Line_Number)
		C=R0.F	A
		C=C+A	A
		D0=C
		C=DAT0	P		* C.P= #Rows
		D0=D0+	1		* ->#Cols_Field
		?C#0	P		* Is it a Grob Line?
		GOYES	SVPutGrobLn
		GOTO	SVPut$Line
*****************************************
* Here we Process a GROB Structure
*****************************************
SVPutGrobLn	P=C	0
		C=0	S
		CPEX	15		* C.S= #Rows (6 or 8)
		A=0	A
		A=DAT0	B
		B=A	A		* B.A= GROB Width
		R1=A.F	A		* R1.A= GROB Width
		D0=D0+	2
		C=DAT0	A
		D=C	A		* D.A= ->Pixels
		LC(2)	34
		?B<C	B
		GOYES	GrobCenter
		C=R4.F	A		* C.A= X_Offset
		D=D+C	A		* ->Pixels + Offset
		A=C	B
		A=B-A	B		* C.A= Grob_Width - X_Offset
		RTNC			* If CARRY then GROB is OUT of SIGHT!
		?A=0	A
		RTNYES			* Nothing to Display!
		C=0	A
		LC(2)	34
		?A<C	A
		GOYES	Grob->Disp
		A=C	A
		GONC	Grob->Disp

* Here We Center the GROB in the Display

GrobCenter	C=C-B	B
		CSRB.F	B		* C.A= X Value (34 - Grob_Width)/2
		A=R4.F	A		* A.B= X Offset
		A=A-C	B		* A.A= X Offset - X Value
		GOC	+
		C=A	A
		D=D+C	A		* Advance ->Grob data
		A=B-A	A		* A=B-A (Grob_Width - New_offset)
		RTNC			* If CARRY then GROB is OUT of SIGHT
		GONC	Grob->Disp
+		A=-A	B		* A.A= X_Value - X_Offset
		CD1EX
		C=C+A	A
		CD1EX			* D1 ->Display Center
		A=R1.F	A
*****************************************
* GROB Line -> Display
* Writes One Grob Line to the Screen
* IN:
* C.A= #Columns to Write
* B.B= #Grob Width
* C.S= #Grob Rows
* D0->Grob_Data		D1->Display
*****************************************
Grob->Disp	C=A	A
		CDEX	A		* D.A= #Cols to Write
		D0=C			* D0-> Grob Data
GBLoop		C=C-1	S
		RTNC
		C=D	A
		GOSBVL	=MOVEDOWN
		C=D	A		* C.A= #Cols to Write
		A=C	A
		A=B-A	A		* C.A= Grob_Width - #Cols to Write (Data out of sight)
		CD0EX
		C=C+A	A
		CD0EX			* D0-> next Grob Line
		LC(2)	34
		C=C-D	B
		AD1EX
		A=A+C	A
		D1=A			* D1-> next Display Line
		GOTO	GBLoop
*****************************************
* Here we Process a TEXT Structure
*****************************************
SVPut$Line	A=R4.F	B		* C.A= #Cols_Offset ->
		B=0	A
		B=A	B
		C=DAT0	B		* C.B= #Cols
		D0=D0+	2		* ->Chars_Address
		A=DAT0	A		* A.A= Chars_Address
		?B=0	B
		GOYES	gotxtoff
		C=C-B	B
		GOC	+
		B=B+B	X
		A=A+B	A
		GONC	gotxtoff
+		C=0	B
gotxtoff	D0=A			* ->Chars
		?C=0	B		* Nothing to Display?
		RTNYES
		D=C	B		* D.B= #Chars
		?ST=0	sUFL1
		GOYES	Line->Font2
*****************************************
* Writes Chars to Display with FONT1
* IN:	D0->Chars	C.B= #Chars
*	D1->Display
*****************************************
Line->Font1	LC(2)	33		* C.B= Max_Cols to Display
		?D<=C	B
		GOYES	Ln->Fnt1Lp
		D=C	B
Ln->Fnt1Lp	D=D-1	B
		RTNC
		A=0	A
		A=DAT0	B
		D0=D0+	2
*		LCASC	'\n'
*		?A=C	B
*		RTNYES
Chr->Fnt1	A=A+A	A
		C=R2.F	A
		C=C+A	A
		C=C+A	A
		C=C+A	A
		CD1EX			* ->Font
		A=DAT1	6		* C.6= Font_Char
		D1=C			* ->Display
		?ST=0	sInvFont
		GOYES	Fnt1->Disp
		P=	5
		A=-A-1	WP
		P=	0
Fnt1->Disp	DAT1=A	P
		D1=D1+	34
		P=P+1
		?P#	6
		GOYES	Fnt1->Disp
		P=	0
		D1=C			* ->Restore Display
		D1=D1+	1		* Display ->next Char
		GONC	Ln->Fnt1Lp
*****************************************
Line->Font2	LC(2)	22
Line->Fnt2	?D<=C	B
		GOYES	Ln->Fnt2Lp
		D=C	B
Ln->Fnt2Lp	D=D-1	B		* Next Char?
		RTNC
		A=0	A
		A=DAT0	B		* A[B]= Chr1
		D0=D0+	2
*		LCASC	'\n'
*		?A=C	B
*		RTNYES
Chr->Fnt2	?ST=1	sUFL2		* Using UFL FNT2?
		GOYES	+
		LC(2)	30		* Normal Char?
		?A>C	B
		GOYES	+
		LC(2)	158
		A=C	B
+		ASL	A
		C=R2.F	A		* C[A]= ->Font2
		C=C+A	A
		CD0EX
		A=DAT0	W		* A[W]= Char_Data
		D0=C
		?ST=0	sInvFont
		GOYES	+
		A=-A-1	W
		LCHEX	3F3F3F3F3F3F3F3F
		A=A&C	W		* Aply Mask to Clear 2 bits of Shared Nibble
+		?ST=0	sHalfChar
		GOYES	Complete
		A=A+A	W
		A=A+A	W
		C=R1			* C[W]= Previous Char_Data
		CSR	W
		GOTO	WR2IN		* ------+
WR2LP		D1=D1+	34-1		* <------------+
		P=P+1			*		
WR2IN		C=C!A	P		* <-----+	
		DAT1=C	P		*		
		D1=D1+	1		*		
		P=P+1			*		
		DAT1=A	P		*		
		?P#	15		*		
		GOYES	WR2LP		* --------------+
		ST=0	sHalfChar
		GONC	SVF2RTN
*****************************************
Complete	R1=A			* R1[A]= Char_Data
		GOC	+
-		D1=D1+	34-1
		P=P+1
+		DAT1=A	P
		D1=D1+	1
		P=P+1
		DAT1=A	P
		?P#	15
		GOYES	-
		ST=1	sHalfChar
		D1=D1-	1
*****************************************
SVF2RTN		P=	0
		AD1EX
		LC(5)	7*34-1
		A=A-C	A
		D1=A			* Display ->next Char
		GOTO	Ln->Fnt2Lp
*****************************************
* Sets TOPLINE= Previous/Next Title
*****************************************
SVFindTitle	D0=(5)	vTOPLINE
		A=DAT0	A
		?ST=0	sUpSearch
		GOYES	+
		C=A	A
		GONC	++
+		D0=D0+	5
		C=DAT0	A		* C.A= #Lines
		C=C-A	A
++		D=C	A		* D.A= #Lines to Scan
		A=A+A	A
		A=A+A	A
		A=A+A	A		* A.A= #TopLine * 8
		C=R0
		C=C+A	A
		D0=C			* ->$view (Current TopLine)
		GOSUB	SVGetTitle	* Get Prev/Next Title
		GONC	+		* CC: Title Found
		GOTO	SVMainOk	* CS: No More Titles - Quit
+		?ST=0	sUpSearch
		GOYES	+
		C=D	A
+		D0=(5)	vTOPLINE
		DAT0=C	A		* Update TopLine
		C=0	A
		R4=C			* Reset X-Offset
		GOTO	SVMain
*****************************************
* Builds the $view structure, wich is a
* List of Pointers for the str & grobs to Display.
* We directly use the "Raw Temp Memory" between
* the RPL Return Stack and the Data Stack.
*
* 1: #Rows	(6->FONT1 and 8->FONT2)
* 2: #Cols	(#Chars for $ / #Cols for Grob)
* 5: ->Data	(Chars / Pixels)
*
* Note: if #Rows is ZERO then is a Text Line
*
* R0= ->$view
* R1= ->$Line Start
* R2= ->Last Space_Char
* R3= #Memory Blocks (8 Nibb each)
*****************************************
		STITLE	$View Engine

Make$View	GOSBVL	=ROOM		* C.A= Available Nibbles
		C=C+A	A		* C.A= ->Dsktop
		A=A+CON	A,5		* -> Rsktop + 5
		C=C-A	A		* C.A= Free Mem
		R0=A			* R0.A= ->$view (RSKTOP+5)
		D1=A
		CSRB.F	A		* C.A = $View Size/2
		CSRB.F	A		* C.A = $View Size/4
		CSRB.F	A		* C.A = $View Size/8
		R3=C	A		* B.A= #Memory Blocks (of 8 nibbles)
		D0=(5)	vBLOCKCOUNT
		DAT0=C	A		* Save Total Blocks

* We Dispatch the Object...

		D0=D0+	5		* D0 ->aOBJECT
		A=DAT0	A
		D0=A			* D1 ->Object
		A=DAT0	A		* A.X= Object Prologue
		LC(5)	=DOLIST
		ST=0	sListOb
		?A#C	A		* Is it a List?
		GOYES	+
		ST=1	sListOb
		D0=D0+	5		* D0 ->$
		GONC	PackStr
+		LC(3)	=DOCSTR
		?A=C	A		* Is it a String?
		GOYES	PackStr
		ST=0	sUFL1		* Use 8 Rows to Pack Each Line!
		GOSUB	PackGrob	* Assume its a Grob!
		GOTO	CountLines
*****************************************
* We Pack a String
*****************************************
PackStr		ST=1	sNewLine	* LineFeed Pack!
		D0=D0+	5
		C=DAT0	A
		D0=D0+	5
		AD0EX
		D0=A
		D0=D0-	2
		R1=A			* R1.A= ->First $Line
		C=C-CON	A,5
		CSRB.F	A
		D=C	A		* D.A= #Chars loop
$Scan1		B=0	B		* Word-Wrap Char Counter
$Scan2		C=0	A
		R2=C.F	A		* Clear ->Space_Char
		ST=0	sFull		* Not Full Width!
$Scan		D=D-1	A		* <-------------+
		GOC	$ScanDone	*		|
		D0=D0+	2		*		|
		A=DAT0	B		* A.B= Char	|
		LC(2)	10		*		|
		?A#C	B		* LineFeed?	|
		GOYES	+
		GOSUB	Pack$Line
		GONC	$Scan1

+		LC(1)	2
		?A=C	B		* GROB Control Char?
		GOYES	FindGrob

		LC(2)	32
		?A#C	B		* Space Char?
		GOYES	$Width
		CD0EX
		D0=C
		R2=C.F	A		* R2.A= ->Last Space_Char

$Width		?ST=0	sWordWrap	* WordWrap Disabled?
		GOYES	$Scan
		?ST=1	sFull		* Full Line?
		GOYES	$Scan
		B=B+1	B		* Inc. Width Counter
		LC(2)	(sWrapWidth)+1
		?B#C	B
		GOYES	$Scan
		C=R2.F	A
		?C#0	A		* Space Char?
		GOYES	+
		ST=1	sFull
		GONC	$Scan

+		AD0EX
		D0=A			* A.A= ->Current_Char
		A=A-C	A
		ASRB.F	A
		B=A	B		* Update Width Counter!
		GOSUB	Pack$Line'
		GONC	$Scan2

$ScanDone	D0=D0+	2
		GOSUB	Pack$Line	* Pack String's Last Line!

CountLines	D0=(5)	vBLOCKCOUNT
		C=DAT0	A		* C.A= Total #Blocks
		A=R3			* A.A= Available #Blocks
		C=C-A	A		* C.A= #Lines = (Total-Available)
		D0=(2)	vLINECOUNT
		DAT0=C	A		* Save #Lines
		RTN
*****************************************
* Search for a GROB inside the List,
* if we find it, we Pack it!
*****************************************
FindGrob	?ST=1	sListOb		* No List to Scan?
		GOYES	+
		GOTO	$Scan
+		D=D-1	A		* Remove \02 char
		GOC	$ScanDone

		ST=0	sNewLine
		GOSUB	Pack$Line
		ST=1	sNewLine
		D0=D0+	2
		C=DAT0	B

		CDEX	A
		RSTK=C			* Save D.A (# Chars Counter)
		LC(5)	aOBJECT
		CD0EX
		RSTK=C			* Save D0

		C=DAT0	A		* C.A= ->Object
		C=C+CON	A,10
		D0=C			* ->$ Size Field
		A=DAT0	A
		A=A+C	A
		D0=A			* ->First GROB / SEMI
FGLoop		A=DAT0	A
		LC(5)	=SEMI
		?A=C	A
		GOYES	FGQuit
		D=D-1	B
		?D=0	B		* This Grob?
		GOYES	GrobFound
		GOSBVL	=SKIPOB
		GONC	FGLoop
GrobFound	LC(5)	=DOGROB
		?A#C	A
		GOYES	FGQuit
		GOSUB	PackGrob
FGQuit		C=RSTK
		D0=C			* Restore D0
		C=RSTK
		D=C	A		* Restore D.A
		GOTO	$Scan1
*****************************************
* We Pack a TEXT Line
* IN:
* R0.A= ->$LineStart	D0-> $LineEnd
* Uses: A,C,D1,R1
*****************************************
Pack$Line	CD0EX
		D0=C
Pack$Line'	A=R3.F	A
		A=A-1	A		* Alloc 8 Nibbles
		GOC	$MemErr
		R3=A.F	A		* Update Free Memory

* Set Type= Text_Line

		A=0	P
		DAT1=A	P		* Write #Rows=0 (Text Line)
		D1=D1+	1

* Write Line Length

		A=C	A		* A.A= ->$ Line End Pointer
		C=C+CON	A,2		* ->New $begin (skip \n,' ')
		?ST=1	sNewLine
		GOYES	+
		C=C+CON	A,2
+		CR1EX.F	A		* R1= ->New $Begin,  C.A= ->old $begin
		A=A-C	A
		ASRB.F	A		* A.A= #Chars Between...
		DAT1=A	B		* Write #chars
		D1=D1+	2

* Write ->Chars Pointer

		DAT1=C	A		* Write ->$ Line Begin Pointer
		D1=D1+	5
		RTNCC
*****************************************
$MemErr		C=RSTK			* Pop RTN address
		C=RSTK
		GOVLNG	=GPMEMERR
*		D0=(5)	=ANNCTRL
*		C=DAT0	P
*		CBIT=1	3
*		DAT0=C	P
*		GOTO	CountLines
*****************************************
* Pack a GROB into $View
* In:
* D0 ->GROB
* B.A= #Memory Blocks (8 Nibbles)
* D1 ->$View
* R2= Grob Width
* Note: We can use R2 since it's going
* to get clear anyway in: $scan1
*****************************************
PackGrob	D0=D0+	10
		C=DAT0	A
		D=C	A		* D.A= Grob Height
		D0=D0+	5
		A=DAT0	A		* A.A= Grob Width (Pixels)
		D0=D0+	5
		GOSBVL	=w->W		* Pixels -> Nibbles
		R2=A			* A.A= Grob Width (Nibbles)

PackGrobLine	C=R3.F	A
		C=C-1	A		* Alloc 8 Nibbles
		GOC	$MemErr
		R3=C.F	A
		C=0	A
		LC(1)	6
		?ST=1	sUFL1	* Using Font1? Then Code 6 Pixels Height per Line
		GOYES	+
		LC(1)	8
+		?D>C	A		* Full Grob Line?
		GOYES	+
		C=D	A		* Pack a $Line with fewer Rows
+		D=D-C	A
		DAT1=C	P		* Write #Rows
		D1=D1+	1

		A=R2.F	A
		DAT1=A	B		* Write Grob Width
		D1=D1+	2

		A=A+A	A
		C=A	A
		C=C+C	A
		C=C+A	A		* C.A= 6*(Grob_Width)
		?ST=1	sUFL1
		GOYES	+
		C=C+A	A
+		AD0EX
		DAT1=A	A		* Write ->Data Pointer
		D1=D1+	5
		A=A+C	A
		D0=A			* D0-> Next $Line Pointer (6 or 8 Rows Below)
		?D=0	A		* No more Rows?
		RTNYES
		GONC	PackGrobLine
*****************************************
*	TITLE - ENGINE
* Show an Index, displaying Title Lines
* and allowing Fast jump to them...
*****************************************
		STITLE	$Title Engine

$TitleEngine	D0=(5)	vLINECOUNT
		C=DAT0	A
		D0=(2)	vLINESLEFT
		DAT0=C	A		* Save #Lines to Do
		C=R0
		C=C-CON	A,8
		D0=(2)	a$VIEW
		DAT0=C	A
next$Titles	GOSUB	Make$Titles
		?A#0	A		* Any Titles?
		GOYES	+		* No - Return!
		GOTO	$TQuit
+		C=0	A
		D0=(2)	vTOPTITLE
		DAT0=C	A
		D0=D0+	5		* ->vTITLECOUNT
		DAT0=A	A		* Save #Titles
*****************************************
$TMain!		GOSUB	SVDispTitles
$TMain		GOSUB	SVKeyboard?
		GOC	$TMain		* Wait Key Release!

		GOSBVL	=clrbusy
		SHUTDN
		GOSBVL	=showbusy

		LC(2)	EEXCODE
		GOSUB	SVKeyDn?
		GOC	next$Titles

		B=0	A		* B.A= #Key
		LC(2)	KEY0
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	Jump2Title

+		LC(2)	KEY1
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY2
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY3
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY4
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY5
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY6
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY7
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY8
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY9
		GOSUB	ThisShort?
		GOC	Jump2Title

$TOk		GOSBVL	=OnKeyDown?
		GOC	$TQuit
		GOTO	$TMain
$TQuit		GOSUBL	SVKeyboard?	* Loop Until Keyboard Released!
		GOC	$TQuit
		RTN
*****************************************
ThisShort?	B=B+1	A		* Increase Key Shortcut!
		GOLONG	SVKeyDn?
*****************************************
* Jump to Title in B[A]
*****************************************
Jump2Title	D0=(5)	vTITLECOUNT	* ->vTITLECOUNT
		C=DAT0	A
		?B>=C	A		* Title in Range?
		GOYES	$TOk		* No - Quit
		B=B+B	A
		B=B+B	A
		LC(5)	$TITLES
		C=C+B	A
		D1=C			* -> #Line (from $view)
		C=0	A
		R4=C			* Reset X-offset
		C=DAT1	4		* C.A= #Line
		D0=(2)	vTOPLINE
		DAT0=C	A		* Update it!
		RTN			* Quit!
*****************************************
* Build the $Titles structure, starting
* from the #Line in R3[A]
*****************************************
Make$Titles	D1=(5)	$TITLES		* ->$titles (output buffer)
		D0=(5)	vSCRNLINES
		C=DAT0	A
		B=C	A		* B.A= #Titles Counter
		D0=(2)	vLINESLEFT
		C=DAT0	A
		D=C	A		* D.A= #Lines Left to Scan
		D0=(2)	a$VIEW
		C=DAT0	A
		D0=C			* ->$view
		ST=0	sUpSearch	* Search Down!

$TLoop		GOSUB	SVGetTitle
		GOC	$TDone		* CS: No Title - Quit
		C=C-1	A		* C.A= Current Line 0-N
		DAT1=C	4		* Write Title's #Line
		D1=D1+	4
		B=B-1	B		* Decrease Title Counter
		?B#0	B
		GOYES	$TLoop

$TDone		CD0EX
		D0=(5)	a$VIEW
		DAT0=C	A		* Save $view Pointer
		C=D	A
		D0=(2)	vLINESLEFT
		DAT0=C	A		* Save #Lines to Scan
		D0=(2)	vSCRNLINES
		A=DAT0	A
		A=A-B	A
		RTN
*****************************************
* Returns in C.A next #Title_Line
* CS: Title Not Found
* CC: Title Found
*****************************************
SVGetTitle	?D=0	A
		RTNYES
		D=D-1	A
		?ST=1	sUpSearch	* Search Backwards?
		GOYES	+
		D0=D0+	8
		GONC	++
+		D0=D0-	8
++		C=DAT0	P
		?C#0	P		* String Line?
		GOYES	SVGetTitle	* No, ->Loop
		D0=D0+	3
		C=DAT0	A		* C.A= ->Chars
		D0=D0-	3
		CD0EX
		A=DAT0	B		* A.B= First Char
		D0=C			* Restore D0
		LCASC	'*'
		?A#C	B		* Title Line?
		GOYES	SVGetTitle	* No, ->Loop
		AD0EX
		D0=(5)	vLINECOUNT
		C=DAT0	A		* C.A= #Lines
		D0=A			* Restore D0
		C=C-D	A
		RTNCC
*****************************************
SVDispTitles	D=0	A		* Start in Row 0
-		C=0	A
		C=D	XS
		CSR	X
		CSR	X		* C.A= #ScreenLine
		D0=(5)	vSCRNLINES
		A=DAT0	A
		?C>=A	B		* ScreenLine in Range?
		RTNYES
		GOSUB	DispTitle
		D=D+1	XS
		GONC	-
*****************************************
* Display a Title. IN:
* C.X= #ScreenLine
*****************************************
DispTitle	D0=(5)	vTOPTITLE
		GOSUB	D1->WipeLine	* D1 ->ScreenLine, B.A= #Title

* Display the Shorcut Number 0-9

		ABEX	A		* A.A= #ScreenLine, B.A= #Title
		C=0	A
		LCASC	'0'
		A=A+C	A		* A.A= Char# (0-9)
		D=0	B
		ST=1	sInvFont	* Invert the Font!
		?ST=1	sUFL1
		GOYES	+
		GOSUB	Chr->Fnt2
		GOC	++
+		GOSUB	Chr->Fnt1
++		ST=0	sInvFont

* Display the Title Line

		B=B+B	A
		B=B+B	A
		LC(5)	$TITLES
		C=C+B	A
		D0=C			* ->#Title
		C=0	A
		C=DAT0	4		* C.A= #Line to Display from $view
		C=C+C	A
		C=C+C	A
		C=C+C	A		* C.A= 8*(#Line)
		A=R0
		C=C+A	A
		D0=C			* ->String_Structure ($view)
		D0=D0+	1		* skip #Rows Field
		C=DAT0	B		* A.A= #Chars
		C=C-1	B		* Remove First Char
		D0=D0+	2
		A=DAT0	A
		A=A+CON	A,2		* Skip '*' Char
		D0=A
		?C=0	B
		RTNYES
		D=C	B
		?ST=1	sUFL1
		GOYES	+
		LC(2)	21
		GOTO	Line->Fnt2
+		GOTO	Line->Font1	* Display the Line!
    ENDCODE
   ;
  DROP
 ;



ASSEMBLE
_$>miniFont
RPL
::
  SIX OVERLEN$ FOUR #* MAKEGROB
  SWAP
  ROMPTR 101 3
*****************************************
* 3:	GROB W x 6	( Grob for $ )
* 2:	"string"
* 1:	Library Data	( MiniFont )
*****************************************
  CODE
		STITLE	String -> miniFont
		A=DAT1	A		* A.A= ->miniFont
		A=A+CON A,10
		R0=A			* R0.A= ->Font_Data
		D1=D1+	5		* ->$
		D=D+1	A		* drop Library Data
		GOSBVL	=PopASavptr
		C=A	A
		A=DAT1	A		* A.A= -> GROB
		D0=A
		D0=D0+	15		* ->#Rows
		A=DAT0	A		* A.A= Rows
		GOSBVL	=w->W		* Convert Rows -> Nibbles
		B=A	A
		D0=D0+	5
		ST=0	invFont
		GOSUB	C$>miniFont
		GOVLNG	=GETPTRLOOP
  ENDCODE
 ;



ASSEMBLE
_F48IndexDraw
RPL
********************************************
* Codigo Optimizado para UP & DOWN, ya que
* File>Disp retrasa la escritura del tamao
* del objeto en Pantalla
*
* 1:	index (new)	->
********************************************
::
  index@ DUP min@ #-+1 FALSE
  4ROLL DUPDUP index! min@ #-+1 TRUE
  CODE
	GOTO	File>Disp
  ENDCODE
  CODE
	GOTO	File>Disp
  ENDCODE
 ;



ASSEMBLE
_F48FilesDraw
RPL
::
  n@ #0=case
  ::
    EIGHT FORTYNINE BLANKIT
    ZERO EIGHT
    "No Entries"
    $>miniFont XYGROBDISP
   ;

  max@ #1+ min@
  DO
    INDEX@
    DUP min@ #-+1
    OVER index@ #=
*****************************************
*	FILER DISPLAY ENGINE
*
* Outputs directly to the Screen the
* nth element from $vars.
*
* 3:   #nthel (1-n)
* 2:	 #pos (1-8)
* 1:  Invert? (true/false)  ->
*****************************************
CODE

Props		EQU 2	display properties?
wide1		EQU 26	Name Width if Props Disabled
wide2		EQU 13	Name Width if Props Enabled
LAMprops	EQU 16
LAM$vars	EQU 12
LAMminiFont	EQU 9

		STITLE	Filer Display Engine

File>Disp	ST=0	check		* Ensure to Display Full Line!
Check>Disp	INTOFF
*		GOSBVL	=DisableIntr	* Interruptions OFF!
		C=ST			* Get Status Bits
		C=0	B		* Clear Flags 0-7
		ST=C			* Save Status Bits!
		GOSBVL	=popflag
		GONC	+
		ST=1	invFont
+		GOSBVL	=POP2#
		R3=A			* R3.A= #nthel
		A=C	A		* A.A= #pos
		GOSBVL	=SAVPTR
		GOSUB	D0->Row1(A)	* D0 ->Disp

		D1=(5)	=TEMPENV
		C=DAT1	A
		D=C	A		* Save TEMP addr

		C=0	A
		LC(2)	(LAMminiFont)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		A=A+CON A,10
		R0=A			* R0.A= ->Font

		C=0	A
		LC(2)	(LAMprops)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		LC(5)	=FALSE
		?A=C	A
		GOYES	+
		ST=1	Props

+		C=0	A
		LC(2)	(LAM$vars)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		D1=A			* D1 ->$vars
		D1=D1+	10
		A=DAT1	A		* A.A= # Obs
		C=0	A
		LC(1)	8
		?A>C	A
		GOYES	+
		ST=1	Wide
+		D1=D1+	10		* ->SelSize_Field
		A=R3			* A.A= #nthel
		C=A	A
		ASL	A		* A.A= (#nthel)*16
		A=A-C	A		* A.A= (#nthel)*15
		CD1EX
		C=C+A	A
		R1=C			* R1.A= ->Name_Field
		D1=C			* D1 ->Name_Field
*****************************************
* If Selected write the Number
*****************************************
		D1=D1-	5		* ->Sel_Field
		A=DAT1	A
		?A#0	A		* Selected Ob?
		GOYES	+
		C=0	A
		LC(1)	3
		GOSUB	F48ClearOut
		GONC	CheckField
+		GOSUB	hxs->dec
		RSTK=C			* Save #Chars
		C=-C	A		* C's Two-Complement
		C=C+CON	A,3		* C= 3 - C
		GOSUB	F48ClearOut
		C=RSTK			* Restore #Chars
		GOSUB	#>grob
*****************************************
* If check flag is Set, then Quit.
* Optimized for ENTER key
*****************************************
CheckField	?ST=0	check		* Display Full Line?
		GOYES	IconBegin	* yep...
		GOTO	GetPtrLp3	* No! Quit here
*****************************************
* Find out wich type the Object is
*****************************************
IconBegin	C=R1.F	A
		D1=C
		D1=D1+	5
		C=DAT1	A
		CD0EX			* D0 ->Ob
		RSTK=C			* Save D0
		GOSUBL	F48GetObType
		R3=C.F	A		* R3.A= #Type
		A=C	A
		ASL	A		* *16
		A=A-C	A		* 16-1=15
		C=RSTK
		D0=C			* Restore D0
*****************************************
* Now Draw Icon according to Object type
*****************************************
IconSet		GOSUB	getIcons
		NIBHEX	E10FF7104104FF7		* dir
		NIBHEX	8014D34D7CD3411		* accptr
		NIBHEX	FC23236212A0E41		* alg
		NIBHEX	FF7984555326FF7		* aunit (DOEXT3)
		NIBHEX	EF3BD6154BD6E83		* bckup
		NIBHEX	A00F90A81F92A82		* bin (hex)
		NIBHEX	401212134252451		* bint
		NIBHEX	000616131151651		* char
		NIBHEX	E010C37D70C3C11		* code
		NIBHEX	870490410490870		* cmplx
		NIBHEX	0E12527502520E1		* ecmplx
		NIBHEX	0F12527D3251072		* ereal
		NIBHEX	FF7984555326FF7		* ext1 (DOEXT4)
		NIBHEX	F67194144104F57		* exter [?]
		NIBHEX	0F58228E0A20C10		* font (DOEXT2)
		NIBHEX	000365557555565		* gname
		NIBHEX	420A24FF71620A1		* grob
		NIBHEX	BD69849A4984BD6		* lnkarry
		NIBHEX	FF7984555326FF7		* libdat
		NIBHEX	000E73FF6FF6E73		* lib
		NIBHEX	603202104202603		* list
		NIBHEX	000165157155665		* lam
		NIBHEX	BD6984984984BD6		* array
		NIBHEX	C704904F0450C90		* real
		NIBHEX	000EF3FF7FF7EF3		* system RPL prog
		NIBHEX	5055050000008A0		* str
		NIBHEX	0002020002028F0		* tag
		NIBHEX	0040850548A0FA0		* unit
		NIBHEX	451A82505A82451		* user RPL prog
		NIBHEX	000EF3FF7FF7EF3		* romptr
		NIBHEX	575545020010070		* zip
getIcons	C=RSTK
		C=C+A	A
		CD0EX
		A=DAT0	15		* Read Icon
		D0=C			* Restore D0->Disp
		P=	16-5
		?ST=0	invFont
		GOYES	IconLup
		A=-A-1	W		* Invert the Icon!
IconLup		DAT0=A	X
		ASR	W
		ASR	W
		ASR	W
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		GONC	IconLup
		A=0	A
		?ST=0	invFont
		GOYES	+
		A=-A-1	A
+		DAT0=A	3		* Wipe line under Icon
		D0=C
		D0=D0+	3		* D0 ->1st Nibble after Icon
*****************************************
* Put Object's Name
*****************************************
		C=R1.F	A
		D1=C
		C=DAT1	A
		R2=C.F	A		* Save ->Name
		D1=C			* D1 ->Name
		C=0	A
		C=DAT1	B
		D=C	A		* D.A= save #chars
		?C#0	B
		GOYES	+
		LC(2)	34
		A=C	A
		GOSUB	oneChar		* Write (") NULLID Name
		GONC	ClearSpace
+		D1=D1+	2		* D1 -> chars
		LC(2)	wide1
		?ST=0	Props
		GOYES	+
		LC(2)	wide2
+		?D<=C	B		* Name lenght Ok?
		GOYES	+
		D=C	B		* Set Max Name lenght
+		GOSUB	nxtChrLp
*****************************************
ClearSpace	C=R2.F	A
		D1=C
		A=DAT1	B		* A[B]= #chars
		?A#0	B
		GOYES	+
		A=A+1	B		* Ensure 1 char (")
+		C=0	A
		?ST=1	Props
		GOYES	F48Details
		LC(2)	wide1		* Nibbs to ClearOut
		C=C-A	B
		GOC	ClrExit
		GOSUB	F48ClearOut
ClrExit		GOTO	FinalSpc?Lp
*****************************************
F48Details	LC(1)	(wide2)+1
		?A>=C	B
		GOYES	+
		C=C-A	B
		GONC	ClearOut
+		LC(2)	1
ClearOut	GOSUB	F48ClearOut
		A=R3.F	A		* Get Obj Count
		LC(2)	LIBTYPE
		?A#C	B		* Not a Library?
		GOYES	NotLibType
*****************************************
* Write the Library's ID #
*****************************************
		D=0	A
		C=0	A
		LCASC	'L'
		A=C	A
		GOSUB	oneChar
		C=R1			* Get ->&Name, Library
		CD0EX			* ->Name_Field
		D=C	A		* Save D0
		D0=D0+	5		* ->Ob_Field
		C=DAT0	A		* Read Lib addr
		D0=C			* ->Lib
		D0=D0+	10		* skip prolog + size
		GOSBVL	=TRAVERSE+	* skip Name
		A=0	A
		A=DAT0	X		* Read Library Number
		C=D	A
		D0=C			* Restore D0 ->Disp
		GOSUB	hxs->dec	* A[W]=decNumber, C.A=#chars
		R2=C			* Save #chars
		GOSUB	#>grob
		C=R2			* Recover #chars
		C=C-CON	A,4
		C=-C	A		* C.A= 4 - #chars
		GOSUB	F48ClearOut
		GOTO	PutObSize
*****************************************
* Write Normal Object Type
*****************************************
NotLibType	C=A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A
		A=A+A	A		* A.A= * 10
		GOSUB	getTypes
		NIBASC	\DIR  ACPTRALG  AUNITBCKUPBIN  BINT \
		NIBASC	\CHAR CODE CPLX ECPLXEREALEXT1 EXTER\
		NIBASC	\FONT GNAMEGROB LARRYLBDATLIB  LIST \
		NIBASC	\LNAMEMATRXREAL SPROGSTRNGTAG  UNIT \
		NIBASC	\UPROGXLIB ZIP  \
getTypes	C=RSTK
		C=C+A	A
		D1=C			* D1 -> object Type "Chars"
		C=0	A
		LC(1)	5
		GOSUB	D1>miniFont
*****************************************
* Writes Object's Size in Bytes
*****************************************
PutObSize	C=R1.F	A
		CD0EX			* D0 ->Name_Field
		R3=C.F	A		* Save ->Disp addr
		D0=D0+	5		* D0 ->Object
		C=DAT0	A
		D=C	A		* Save start_Addr
		D0=C
		GOSBVL	=SKIPOB
		C=R3.F	A		* Recover ->Disp addr
		CD0EX			* end_Addr
		C=C-D	A		* ObSize= end-start Addr
		CSRB.F	A		* size Nibbs -> bytes
		A=C	A
		GOSUB	hxs->dec	* A[W]=decNumber, C.A=#chars
		R3=C.F	A		* Save #chars
		C=C-CON	A,7
		C=-C	A		* C.A= 7 - #chars
		GOSUB	F48ClearOut	* Clear space between Type & ObSize
		C=R3.F	A		* Recover #chars
		GOSUB	#>grob
FinalSpc?Lp	?ST=0	Wide
		GOYES	GetPtrLp3
		C=0	A
		LC(1)	1
		GOSUB	F48ClearOut	* Clear space after ObSize
*		GOSBVL	=AllowIntr	* Interruptions OFF!
GetPtrLp3	GOVLNG	=GETPTRLOOP
*****************************************
ENDCODE
  LOOP

  n@ SEVEN OVER#< caseDROP
  #6* #8+
  FIFTYSIX OVER#-
  BLANKIT
 ;



ASSEMBLE
*****************************************
* Convert Hex to Dec.
* In:	A.A=	Hex Number
* Out:	A.W=	Dec Number
*	C.A=	#chars of Number
* Uses: A,C,D
*****************************************
hxs->dec	C=0	W
		C=C+1	A
		SETDEC
		D=0	W
toDecLp		SB=0			* <-----+
		ASRB.F	A		*	
		?SB=0			*	
		GOYES	+		*	 Convert # to Decimal
		D=D+C	W		*	
+		C=C+C	W		*	
		?A#0	A		*	
		GOYES	toDecLp		*	+
		C=D	W
		A=C	W
		SETHEX
		C=0	A
-		C=C+1	P		* <-----+
		ASRC			*	 Find out How many
		?A#0	A		*	  decimal #'s are they
		GOYES	-		*	+
		RTN
*****************************************
* Write Decimal Number to ->Display.
* In:	D0 ->DISP
*	A.W= Dec Number
*	C.A= #chars of Dec Number
* Uses:
*	A,C,D,R3, 1 RSTK
*****************************************
#>grob		R3=A			* R3= Save decimal #
#>grobLp	C=C-1	B
		RTNC
		RSTK=C			* Save loop counter
		C=R3
		CSLC
		R3=C			* update decimal #
		P=	1
		LC(1)	3
		P=	0
		A=0	A
		A=C	B
		D=0	A
		GOSUB	oneChar
		C=RSTK
		GONC	#>grobLp
*****************************************
* Write $ to Dest. using miniFont data.
* In:	D0 ->DESTINATION
*	C.A= ->$
* Out:
*	D0 ->DESTINATION after Font data.
*****************************************
C$>miniFont	GOSBVL	=GetStrLenC
D1>miniFont	D=C	A
nxtChrLp	D=D-1	A
		GONC	+
		RTNCC
+		A=0	A
		A=DAT1	B		* Read 1 char
oneChar		A=A+A	A
		C=R0.F	A		* C.A= Chars Font
		C=A+C	A
		C=A+C	A
		C=A+C	A
		CD0EX			* D1 -> Char Font data
		A=DAT0	6
		D0=C
		?ST=0	invFont
		GOYES	nxtLine
		P=	5
		A=-A-1	WP		* Invert the Char Font
		P=	0
nxtLine		DAT0=A	P
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		?P#	6
		GOYES	nxtLine
		P=	0
		D0=C
		D0=D0+	1
		D1=D1+	2
		GOTO	nxtChrLp
*****************************************
* Wipe/Clear Nibbles at Display Position
* Covering 6 Lines Down.
* In:	C.A= Nibbs to Wipe/Clear
*	D0= ->DISPLAY
* Uses:
*	D0,A,C,D,R4, 1 RSTK
*****************************************
F48WipeOut	ST=0	invFont		* Wipe!
F48ClearOut	C=C-1	A
		GOC	RCC
		D=C	A
		P=	15
		LC(1)	5
		P=C	0		* P= Lost Nibbles
		CD0EX
		D0=C
		C=C+D	A
		RSTK=C			* Save ->Disp after Wipe
		R4=A			* Save A[W]
		A=0	W
		?ST=0	invFont		* Wipe?
		GOYES	LineWipeLp
		A=-A-1	W		* No, Clear!
LineWipeLp	C=D	A		* Recover Nibbs	<---------------+
		CSR	A		* Nibbs / 16			
WipeLp		C=C-1	A		* <-----+			
		GOC	WipeLast	*				
		DAT0=A	W		*				
		D0=D0+	16		*				
		GONC	WipeLp		* ------+			
WipeLast	DAT0=A	WP		*				
		CD0EX			*				
		C+P+1			* advance "last Nibbs"		
		C=C+B	A		* ->nextLine			
		C=C-D	A
		C=C-1	A		* -1 because of above instr	
		D0=C			* ->Disp to Wipe		
		C=C-1	S		*				
		GONC	LineWipeLp	* ------------------------------+
		P=	0
		A=R4			* Restore A[W]
		C=RSTK
		D0=C
		D0=D0+	1		* Restore D0 ->Disp
RCC		RTNCC
*****************************************
* Makes D0 ->DISP, just in the Exact
* place according to object Pos.
* In:	A= Pos# (1-8)
* Out:	D0 ->DISP + ( ( A*6 + 2 )*34 )
*****************************************
D0->Row1(A)	A=A+A	A		* bint * 2
		C=A	A
		C=C+A	A
		C=C+A	A		* bint * 6
		C=C+1	A
		C=C+1	A		* (bint * 6) + 2
		C=C+C	A
		A=C	A
		ASL	A
		C=C+A	A		* ((bint * 6) + 2 ) * 34
		D0=(5)	#8068D
		A=DAT0	A
		A=A+C	A
		D0=A			* D0 ->Display

* Set B.A= 34 Nibbles, (Screen Width)

		C=0	A
		LC(2)	34
		B=C	A		* B.A= Nibbs for nxtLine
		RTN



_F48Tree
RPL
::
  TRUE refresh!

  ZEROZERO ONE		( max, index, min )
  ZEROZEROZERO		( n, dy, barHeight )
  NULL$			( $dirs )
  miniFont@
  8NULLLAM{} BIND

  GARBAGE

*****************************************
*	LIST ALL HP48 DIRECTORIES
*
*	->  $dirs #offset #dirs
*****************************************
*	STRUCTURE FOR TOKENBUFF
*
* We use the IRAMBUFF as a buffer to
* store the Tokens:

*  "#Dirs DirOffset Tokens..."
*     5       5       22
*
* Tokens:	0=" "	1=""	2=""
*		3=""	4=".."
*****************************************
*	STRUCTURE FOR $dirs
*
* "<ChrSt> <DirSt> <DirSt> <DirSt> ... <DirSt>"
*
* First we have 2 Char_Structures for
* the "Port :0:" and "Home [\]" chars.
* The rest of them are Directory_Structures
* as follows:
*
* <ChrSt> = xx chchchchchchchchchch 00000
*   Nibbs =  2     16 (8 chars)       5
*
* <DirSt> = xx tokens DirAddr
*   Nibbs =  2   N       5
*
* Where xx is the size field for the
* Number of Tokens N.
*****************************************
*	CPU use:
* R0.A= ->$dirs
* R1.A= Home's Last Object Offset (for Stop-Sign)
* R2.A= ->$Stack TOP
* R3.A= ->DIR (Current DIR been analyzed)
* R4.A= #Level_Depth
*****************************************
  CODE


DIRSCOUNT	EQU =IRAMBUFF		* Dirs Counter
DIROFFSET	EQU (=IRAMBUFF)+5	* Dir Index Offset
TOKENS		EQU (=IRAMBUFF)+10	* Tokens Data

Match		EQU 0	Directory Match?
lastDir		EQU 1	Last directory?

		STITLE	Directory TREE Engine
		GOSBVL	=DisableIntr
		GOSBVL	=SAVPTR

* Calculate Free Memory

		AD1EX
		A=A-B	A		* A.A= FREE RAM (Dsktop - Rstktop)

* Allocate big chunk $.

		C=0	A
		LC(2)	200		* Leave some Room
		C=A-C	A
		GOC	TreeErr
		C=C+CON	A,5		* Alloc 1 pointer for $Stack
		GOSBVL	=MAKE$N
		B=A	A		* B.A= Free RAM
		CD0EX
		D1=C			* ->$Dirs
		C=0	A
		R4=C			* Reset #Level_Depth

* Output "Home" chars

		LC(2)	2+8*2+5		* Alloc HomeDir Structure
		B=B-C	A
		GONC	+
TreeErr		GOVLNG	=GPMEMERR
+		LC(2)	8*2
		DAT1=C	B
		D1=D1+	2
		LCSTR	\Home [\\]\
		DAT1=C	W
		D1=D1+	16

* Initialize The Buffer

		D0=(5)	DIRSCOUNT	* ->#dirs_Field
		C=0	W
		LC(1)	1
		DAT0=C	10		* 1 Dir by default! (Home)

* Initilize The $Stack

		C=R0
		D0=C			* ->$dirs
		D0=D0+	5
		A=DAT0	A		* A.A= $dirs len
		C=C+A	A
		R2=C			* R2.A= ->$Stack TOP

* Prepare Directory Scanner

		D0=(5)	=USEROB
		A=DAT0	A
		R3=A			* R3.A= ->Current DIR
		DAT1=A	A		* Write ->HOMEDIR
		D1=D1+	5
		D0=C			* ->$Stack TOP
		DAT0=A	A		* Push HOMEDIR into $Stack
		D0=A			* D0 ->HomeDir
		ST=0	Match
		GOSUB	dirMatch?
		D0=D0+	5
		C=DAT0	A
-		C=C-1	X
		GOC	+
		D0=D0+	13		* Skip Home's attached Libraries
		GONC	-
+		D0=D0+	3
		A=DAT0	A
		R1=A			* R1.A= Home's last object offset
		GOTO	InvLink
*****************************************
dirMatch?	?ST=1	Match		* Match already found?
		RTNYES
		LC(5)	DIROFFSET	* ->Dir_Offset
		CD0EX			* Save ->DIR
		A=DAT0	A
		A=A+1	A		* Increase DIR offset
		DAT0=A	A
		D0=(5)	=CONTEXT	* D0 -> current Dir
		A=DAT0	A
		D0=C			* Restore ->DIR
		?A#C	A		* Current Dir?
		RTNYES			* No, return
		ST=1	Match		* Yes, Don't test this again!
		RTN
*****************************************
Level--		C=R4.F	A
		C=C-1	A		* Decrease Level Depth
		R4=C.F	A

		B=B+CON	A,5		* Return 5 Nibbs (1 Pointer)
		C=R2.F	A		* ->$Stack TOP
		C=C+CON	A,5		* Shrink $Stack (Destroy 1 Pointer)
		R2=C.F	A		* update ->$Stack TOP
		CD0EX
		A=DAT0	A		* A.A= ->UPDIR
		R3=A.F	A		* Save it!
		D0=C			* Restore D0
		RTNCC
*****************************************
dirScan!	GOSUB	dirMatch?	* Match this dir
		CD0EX
		R3=C.F	A		* R3.A= Save ->DIR
		GOSUB	Level++
		C=R3.F	A		* get -> DIR
		DAT1=C	A		* write dir pointer
		D1=D1+	5
		D0=C			* Restore D0 -> DIR
		D0=D0+	8		* D0 ->LastRam-Word
		A=DAT0	A
		?A#0	A		* Not an Empty Dir?
		GOYES	InvLink
		GOSUB	Level--
		GONC	continue
InvLink		A=-A	A
*****************************************
nxtVarLp	?A=0	A		* Link=0?
		GOYES	upDir
		CD0EX
		C=C-A	A

* Safety Check: if ->Name < ->UPDIR
* then Corrupted Directory! skip

		A=R3.F	A		* ->UPDIR
		?C<A	A
		GOYES	invalidObj

		D=C	A		* D.A= Save ->Name
		D0=C			* ->Name
		GOSBVL	=TRAVERSE+	* ->Ob
		A=DAT0	A
		LC(5)	=DORRP
		?A=C	A		* Is it a Dir?
		GOYES	dirScan!	* yes, go and Scan it!
continue	C=D	A		* Restore ->Name
		D0=C
linkChk		D0=D0-	5
		A=DAT0	A		* A.A= ->next Link
		GOTO	nxtVarLp
*****************************************
upDir		GOSUB	Level--		* Decrease Level Depth
		D0=D0-	5
		A=DAT0	A		* ->Current Last_Ob offset
		C=R1.F	A		* ->HOME's Last_Ob offset
		?A=C	A
		GOYES	ScanDone	* Are we HOME yet?
		D0=D0-	8		* ->DIR
dirName		GOSBVL	=TRAVERSE-	* ->Name
		GONC	linkChk
*****************************************
* If Corrupted DIR, skip it and continue
*****************************************
invalidObj	D0=(5)	=USEROB
		C=DAT0	A
		?A=C	A		* HOMEDIR?
		GOYES	ScanDone
		D0=A			* ->UPDIR
		GOSUB	Level--
		GONC	dirName
*****************************************
* Allocate Room for the Link Table.
*****************************************
ScanDone	D0=(5)	DIRSCOUNT	* ->#Dirs_Field
		C=DAT0	A		* C.A= #dirs
		A=C	A
		A=A+A	A
		A=A+A	A
		A=A+C	A		* A.A= (#dirs)*5
		B=B-A	A		* Alloc LinkTable pointers
		GOC	TreeErr1
		D=C	A		* D.A= Loop counter for #dirs

* Move the DIR_STRUCTS down, so the
* LinkTable is at $dirs begin.

		CD1EX
		D0=C			* D0 ->$dirs End
		A=A+C	A
		D1=A			* D1 ->new $dirs End
		A=R0
		C=C-A	A
		C=C-CON	A,10
		GOSBVL	=MOVEUP

* Start Writing Link Table addresses

LnkTabLp	D=D-1	A
		GOC	Shrink$dirs
		A=0	A
		A=DAT1	B		* Read Size Field #tokens
		CD1EX
		DAT0=C	A		* Write Address
		D0=D0+	5
		C=C+A	A
		D1=C
		D1=D1+	2+5		* skip #tok, ->DIR Fields
		GOTO	LnkTabLp
TreeErr1	GOTO	TreeErr

* Finally Shrink$ and Push #offset & #dirs

Shrink$dirs	AD1EX
		D0=A
		GOSBVL	=Shrink$
		GOSBVL	=AllowIntr
		A=R0
		GOSBVL	=GPPushA
		GOSBVL	=SAVPTR
		D0=(5)	DIRSCOUNT
		A=DAT0	A		* A.A= #Dirs
		R1=A
		D0=D0+	5
		A=DAT0	A		* A.A= #Dir Offset
		R0=A
		GOVLNG	=Push2#Loop	* push #offset, #dirs
*****************************************
Level++		B=B-CON	A,5		* Alloc 1 Pointer for $Stack
		GOC	TreeErr1
		A=R2.F	A		* ->$Stack TOP
		A=A-CON	A,5		* Expand $Stack (add 1 Pointer)
		R2=A.F	A		* Update ->$Stack TOP
		D0=A
		DAT0=C	A		* OverWrite Dir!

		A=R4.F	A
		A=A+1	A		* Increase Level Depth
		R4=A.F	A
		A=A-1	A
		?A=0	A
		GOYES	LASTDIR?
		C=0	A
		LC(2)	22
		?A>C	A
		GOYES	LASTDIR?
		LC(5)	(TOKENS)-1	* ->Tokens Data
		C=C+A	A
		D0=C
		A=DAT0	P		* read current Token
		?A=0	P		* Load " " token
		GOYES	LASTDIR?
		LC(1)	2		* Load "" token
		?A=C	P
		GOYES	LASTDIR?
		LC(1)	1		* Load "" token
		?A=C	P
		GOYES	+
		LC(1)	2		* Load "" token
		GONC	tokenWr
+		C=0	A		* Load " " token
tokenWr		DAT0=C	P
*****************************************
* Now we have to check if R3.A Dir is
* the last inside it's context
*****************************************
LASTDIR?	ST=1	lastDir		* Assume Last Dir
		C=R2.F	A
		D0=C
		D0=D0+	5
		C=DAT0	A
		CBEX	A		* B.A= ->UPDIR
		RSTK=C			* Save Free Memory

		C=R3.F	A
		D0=C
LnkCheck	GOSBVL	=TRAVERSE-
		D0=D0-	5
		C=DAT0	A
nxtDirLp	?C=0	A		* If Link=0 then Last Dir!
		GOYES	LastQuit
		AD0EX
		A=A-C	A

* Safety Check: if ->Name < ->UPDIR
* then Corrupted Directory! skip

		?A<B	A
		GOYES	LastQuit

		D0=A
		GOSBVL	=TRAVERSE+
		A=DAT0	A
		LC(5)	=DORRP
		?A#C	A
		GOYES	LnkCheck
		ST=0	lastDir
LastQuit	C=RSTK
		B=C	A		* Restore Free Memory
*****************************************
TokensCpy	D0=(5)	DIRSCOUNT	* D0 ->#Dirs_Field
		A=DAT0	A
		A=A+1	A		* Increase #dirs
		DAT0=A	A
		D0=D0+	5+5-1		* skip #dirs and #offset
		A=R4.F	A		* Read Level Depth
		C=0	A
		LC(2)	22
		?A<=C	A		* Level depth <= 22?
		GOYES	+
		A=C	A		* set Level depth= 22
		LC(1)	4		* Load ".." token
		GONC	tokWr
+		LC(1)	3		* Load "" token
		?ST=0	lastDir
		GOYES	tokWr
		LC(1)	1		* Load "" token
tokWr		CD0EX
		C=C+A	A
		CD0EX
		DAT0=C	P		* Write last Token
		C=A	A		* C.A= level depth
		C=C+CON A,2+5		* + #toks + ->DIR fields
		B=B-C	A
		GOC	TreeErr2
		C=A	A		* C.A= #tokens
		DAT1=C	B		* Write # Tokens for current Dir
		D1=D1+	2
		D0=(5)	TOKENS		* ->Tokens Data
		GOVLNG	=MOVEDOWN	* Copy Tokens
TreeErr2	GOTO	TreeErr
*****************************************
  ENDCODE

  Tn!	( save #dirs )
  Tindex!
  T$dirs!

  Tn@ EIGHT #>ITE ::
		    EIGHT Tindex@ #MAX
		    DUP SEVEN #- Tmin!
		   ;
		  Tn@
  Tmax!

  ( Title )
  ITE "FILER48"
      "PICK DESTINATION"
  ROMPTR 0E0 044

  EIGHT FORTYNINE BLANKIT

ASSEMBLE
_F48DirsDraw
RPL
  ::
    Tmax@ #1+ Tmin@
    DO
      INDEX@
      DUP Tmin@ #-+1
      OVER Tindex@ #=
*****************************************
* 3:  #nthel  (1-n)
* 2:  #pos    (1-8)
* 1:  Invert?  T/F  ->
*****************************************
      CODE
		STITLE	$Dir -> Display
*****************************************
TPath>DispLp	GOSUB	TPath>Disp
		GOVLNG	=Loop
*****************************************
TPath>Disp	ST=0	invFont
		GOSBVL	=popflag
		GONC	+
		ST=1	invFont
+		GOSBVL	=POP2#
		R3=A			* Save #nthel
		A=C	A		* A.A= #pos
		GOSBVL	=SAVPTR
		GOSUB	D0->Row1(A)	* Make D0->Screen

		D1=(5)	=TEMPENV	* Read miniFont from LAM #1
		A=DAT1	A
		D1=A
		D1=D1+	1*10+5		* ->LAM #1
		A=DAT1	A
		A=A+CON	A,10
		R0=A			* R0.A= ->miniFont

		D1=D1+	10		* ->LAM #2
		A=DAT1	A		* A.A= ->$dirs

		C=R3			* C.A= #NhtOb
		C=C+1	A
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A
		D1=A			* D1 ->#NthOb Addr
		C=DAT1	A
		D1=C			* D1 ->NthOb

		A=R3			* A.A= #nthel
		C=0	A
		LC(1)	1
		?A>C	A		* Nthel > 1 ?
		GOYES	TokBegin	* yep, we have DirAddr
*****************************************
* If Nthel = 1.  Write "Home"
*****************************************
		LC(1)	8		* C.A= #chars
		D1=D1+	2		* D1 ->chars
		GOSUB	D1>miniFont
		C=0	A
		LC(2)	24
		GOSUB	F48WipeOut	* Wipe final Space
		GOVLNG	=GETPTR
*****************************************
* You can switch Tokens to See
* wich one looks Better!
* NIBHEX 000000117000111111117111000050
*****************************************
TokBegin	GOSUB	TokAdr
		NIBHEX	000000		* tok 0
		NIBHEX	226000		* tok 1
		NIBHEX	222222		* tok 2
		NIBHEX	226222		* tok 3
		NIBHEX	000050		* tok 4
TokAdr		C=RSTK
		R1=C			* R1.A= ->TokensFont
		C=0	A
		C=DAT1	B
		D1=D1+	2		* skip #tok_field
		D=C	A		* D.A= #tokens
		A=C	A
		A=A+1	A
		A=A+1	A		* #tokens + DirIcon
		LC(2)	32
		C=C-A	A		* Max_Name_Lenght= 32 -#tokens -DirIcon
		R2=C			* R2.A= Max_Name_Lenght
nxtTokenLp	D=D-1	A
		GOC	putDirIcon
		A=0	A
		A=DAT1	P		* Read 1 Token
		A=A+A	A
		C=R1.F	A		* C.A= Read Token's Font
		C=A+C	A
		C=A+C	A
		C=A+C	A
		CD0EX			* C.A= ->Disp
		A=DAT0	6		* A= Token_Font_Data
		D0=C			* restore D0
nxtTokLine	DAT0=A	P
		CD0EX
		C=C+B	A
		CD0EX			* ->next Disp_Row
		P=P+1
		?P#	6
		GOYES	nxtTokLine
		P=	0
		D0=C			* Restore D0 ->Disp
		D0=D0+	1
		D1=D1+	1		* -> next Token
		GOTO	nxtTokenLp
*****************************************
putDirIcon	AD0EX
		D0=A			* Save D0
		LCHEX	007F41417F0E	* Standard Folder Icon
		?ST=0	invFont
		GOYES	IconDraw!
		LCHEX	003F7FFD110E	* Open Folder Icon
IconDraw!	P=	16-6
IconLp		DAT0=C	B
		CSR	W
		CSR	W		* get nxt Icon Line
		CD0EX
		C=C+B	A
		CD0EX			* D0 ->next Disp_Row
		P=P+1
		GONC	IconLp
		D0=A			* Restore D0
		D0=D0+	2		* skip dir Icon
*****************************************
putDirName	C=DAT1	A
		D1=C			* D1 ->DIR
		D1=D1-	2		* D1 ->Second Name's field
		C=0	A
		C=DAT1	B
		D=C	A		* D.A= Save # of Chars
		?C#0	B
		GOYES	+
		LC(2)	34		* Load char 34 ( " )
		A=C	A
		GOSUB	oneChar
		D1=D1-	2		* Ensure D1 ->nameLength
		GONC	ClearLast
+		C=C+C	A
		AD1EX
		A=A-C	A
		D1=A			* D1 -> Chars
		C=R2			* C.A= Max_Name_Lenght
		?D<=C	A		* Name lenght Ok?
		GOYES	+
		D=C	A		* Set Max Name lenght
+		GOSUB	nxtChrLp
*****************************************
ClearLast	A=0	A
		A=DAT1	B		* read #chars
		?A#0	B
		GOYES	+
		A=A+1	A		* if Nullid, ensure 1 char (")
+		C=R2			* C.A= Max_Name_Lenght
		C=C-A	A		* Blank= Max_Name_Lenght - #chars
		GOC	+
		GOSUB	F48WipeOut
+		GOVLNG	=GETPTR
*****************************************
    ENDCODE
    LOOP
   ;

  F48SliderCalc

  ( Menu Labels )
  "OK"
  "CANCL"
  NULL$ DUPDUP DUP
  F48CustomMenu

  BEGIN
    F48GetKey
    CODE
*****************************************
* TREE Key Handler.
* 1:	#Key	->
*****************************************
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		GOSUB	->KeysEnd
KeysBegin	CON(2)	6
		REL(3)	_TreeOK
		CON(2)	18
		REL(3)	_TreeOK
		CON(2)	25
		REL(3)	_TreeOK
		CON(2)	45
		REL(3)	_TreeCANCL
		CON(2)	5
		REL(3)	_TreeCANCL
		CON(2)	11
		REL(3)	_3KeyUP
		CON(2)	17
		REL(3)	_3KeyDOWN
		CON(2)	#CB
		REL(3)	_3MaxUp
		CON(2)	#D1
		REL(3)	_3MaxDown
		CON(2)	#4B
		REL(3)	_3PageUp
		CON(2)	#51
		REL(3)	_3PageDown
->KeysEnd	C=RSTK
		D0=C
		C=0	A
		LC(2)	((->KeysEnd)-(KeysBegin))/5
		B=C	A
3KeyLup		B=B-1	A
		GOC	3KeyQuit
		C=DAT0	B
		?A=C	X
		GOYES	3KeyEval
		D0=D0+	5
		GONC	3KeyLup

3KeyQuit	GOVLNG	=GPPushFLoop

3KeyEval	D0=D0+	2
		C=DAT0	X
		AD0EX
		C=C+A	A
		GOVLNG	=GETPTREVALC
    ENDCODE
  UNTIL
  ITE ::
	T$dirs@
	Tindex@
*****************************************
* Recalls #index Dir from $dirs
* 2:  $dirs
* 1: #index  ->  DIR
*****************************************
	CODE
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		A=A+1	A		* A.A= (#index)+1
		C=A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A		* A.A= (#index+1)*5
		C=DAT1	A
		C=C+A	A
		D0=C
		C=DAT0	A
		D0=C
		A=0	A
		A=DAT0	B		* A.A= Tok_Field
		CD0EX
		C=C+A	A		* skip Tokens
		D0=C
		D0=D0+	2		* skip Tok_Field
		A=DAT0	A		* A.A= ->DIR
		DAT1=A	A		* OverWrite it!
		GOVLNG	=GPPushTLoop
	ENDCODE
       ;
      FALSE
  ABND
 ;



ASSEMBLE
_TreeOK
RPL
::
  TrueTrue
 ;



ASSEMBLE
_TreeCANCL
RPL
::
  FalseTrue
 ;



ASSEMBLE
_3KeyUP
RPL
::
  F48KeyRepeat
  ELEVEN
  ::
    Tindex@ Tmin@
    #=case
    ::
      Tindex@ #1= ?SEMI ( Window Top? )
      Tmin@ #1-DUP Tmin! #7+ Tmax!
      Tindex@ TWO FALSE
      Tindex@ #1-DUP Tindex!
      ONE TRUE

*****************************************
* Refresca por Completo la Pantalla!
*****************************************
      CODE
		GOSUBL	CpyScreenDwn	* refresh Screen
		GOSBVL	=GETPTR
		GOSUB	TPath>Disp
		GOTO	TPath>DispLp
      ENDCODE
*****************************************

      F48Slider
     ;

    Tindex@ #1-
    F48DirIndxDrw
   ;
  FALSE
 ;



ASSEMBLE
_3KeyDOWN
RPL
::
  F48KeyRepeat
  SEVENTEEN
  ::
    Tindex@ Tmax@
    #=case
    ::
      Tindex@ Tn@ #= ?SEMI ( Window bottom? )
      Tmin@ #1+DUP Tmin! #7+ Tmax!
      Tindex@ SEVEN FALSE
      Tindex@ #1+DUP Tindex!
      EIGHT TRUE

*****************************************
* Refresca por Completo la Pantalla!
*****************************************
      CODE
		GOSUBL	CpyScreenUp	* Refreshes screen
		GOSBVL	=GETPTR
		GOSUB	TPath>Disp
		GOTO	TPath>DispLp
      ENDCODE
*****************************************

      F48Slider
     ;

    Tindex@ #1+
    F48DirIndxDrw
   ;
  FALSE
 ;



ASSEMBLE
_3MaxUp
RPL
::
  F48MaxUpSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_3MaxDown
RPL
::
  F48MaxDnSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_3PageUp
RPL
::
  F48PageUpSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_3PageDown
RPL
::
  F48PageDnSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_F48DirIndxDrw
RPL
::
  Tindex@ DUP Tmin@ #-+1 FALSE
  4ROLL DUPDUP
  Tindex! Tmin@ #-+1 TRUE
  CODE
	GOSUB	TPath>Disp
	GOTO	TPath>DispLp
  ENDCODE
 ;



ASSEMBLE
_F48StatusDraw
RPL
::
  ClrDA1IsStat
  $vars@
  $path@
  miniFont@
  mainStatus?
****************************************
* Displays the Status on the Screen.
* 4:	   $vars
* 3:	   $path
* 2:	miniFont
* 1: mainStatus?  ->
****************************************
  CODE

MainStatus	EQU 1

		STITLE	Status -> Display

		CLRST			* ST=0 invFont
		GOSBVL	=popflag
		GONC	+
		ST=1	MainStatus

* Pop the miniFont from stack

+		A=DAT1	A
		A=A+CON	A,10
		R0=A			* R0.A= ->miniFont
		D=D+1	A
		D1=D1+	5		* drop the Font

* Pop $path from Stack

		A=DAT1	A
		R2=A			* R2.A= ->$path
		D1=D1+	5
		D=D+1	A

* Pop $vars from stack

		GOSBVL	=PopASavptr
		A=A+CON	A,10
		R1=A			* R1.A= $vars
		D1=A			* ->$vars

* Make D0 ->Display and set
* Screen Width in B[A]= 34

		GOSBVL	=D0->Row1
		C=0	A
		LC(2)	34
		B=C	A

* Find out wich Status to
* Display.

		?ST=1	MainStatus
		GOYES	PathDisp
		GONC	MemDisp
****************************************
* Displays the Path Status
* Including #obs count
****************************************
PathDisp	A=DAT1	A		* A.A= #obs
		GOSUBL	hxs->dec
		RSTK=C			* Save #Chars
		GOSUBL	#>grob
		GOSUB	+
		NIBASC	\obj \
+		C=RSTK
		D1=C
		C=0	A
		LC(1)	4
		D=C	A
		GOSUBL	nxtChrLp

		C=RSTK			* Restore #chars
		A=C	A
		C=0	A
		LC(2)	32-4
		C=C-A	A		* 28 - #chars
		A=C	A		* A.A= max $len
		C=R2
		GOSBVL	=GetStrLenC	* D1 ->$ (chars)
		?C<=A	A		* $Len <= 32 chars?
		GOYES	+
		C=A	A		* Set max $len
+		D=C	A		* D.A= #chars
		A=A+1	A		* max $len + 1
		C=A-C	A		* C.A= #Chars to Wipe
		RSTK=C			* Save Nibbs to Wipe
		GOSUBL	nxtChrLp
		C=RSTK
		GOSUBL	F48WipeOut	* Wipe blank space after path
		GONC	StatusLine
****************************************
* Display the Memory Status:
* - Free Memory
* - Total Size of Selected Obs.
****************************************
MemDisp		GOSUB	+
		NIBASC	\ Memory:\
+		C=RSTK
		D1=C
		C=0	A
		LC(1)	8
		D=C	A
		GOSUBL	nxtChrLp

		A=R1
		D1=A			* ->#Obs_Field ($vars)
		D1=D1+	5*3		* ->Mem_Field
		GOSUB	WriteBytes

		GOSUB	+
		NIBASC	\ | Select:\
+		C=RSTK
		D1=C
		C=0	A
		LC(1)	10
		D=C	A
		GOSUBL	nxtChrLp

		A=R1
		D1=A			* ->#Obs_Field
		D1=D1+	10		* ->SelSize_Field
		GOSUB	WriteBytes

		C=0	A
		C=C+1	A
		GOSUBL	F48ClearOut

****************************************
* Draw the Line under the Status and
* Wipe the Line under it.
****************************************
StatusLine	AD0EX
		C=0	A
		LC(2)	5*34+1		* ->Disp just for Line!
		A=A+C	A
		D1=A			* ->Disp, just to Write Line

		D0=(5)	(=LineGrob)+20	* ->LineGrob Data
		LC(2)	2*34		* 2 Lines
		GOSBVL	=MOVEDOWN	* Output the Line!
		GOVLNG	=GETPTRLOOP	* Quit!
****************************************
* Reads the Bytes at the D1 field
* and outputs them to the display
****************************************
WriteBytes	A=DAT1	A
		ASRB.F	A		* Nibbs/2 = bytes
		GOSUBL	hxs->dec
		R3=C			* Save #chars
		C=C-CON	A,7
		C=-C	A		* C.A= 7 - #chars
		GOSUBL	F48ClearOut	* Clear Alignment space before bytes
		C=R3			* Recover #chars
		GOLONG	#>grob
  ENDCODE
 ;



ASSEMBLE
_F48MenuDraw
RPL
::
  TURNMENUON
  mainMenu?
  ITE
  {
    "SORT"
    "TREE"
    "NEW"
    "RENAM"
    "EDIT"
    "VIEW"
  }
  {
    "LINK"
    "ZIP"
    "ORDER"
    "MOVE"
    "COPY"
    "SELEC"
  }
  INCOMPDROP
  F48CustomMenu	( Display Menu! )
 ;



ASSEMBLE
_F48$Index@
RPL
::
  n@ #0=case :: RDROP ;
  $vars@
  index@
*****************************************
* Recall #Nth Object from $vars, aimed
* to VIEW, EDIT, RENAM.
*
* 2:	$vars		Object
* 1:	#index	->	#Type
*****************************************
  CODE
		STITLE	$Index@ -> Ob
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		A=A+1	A		* +1 to skip Data_Fields
		C=A	A
		ASL	A		* *16
		A=A-C	A		* 16-1=15
		C=DAT1	A
		C=C+A	A
		D0=C
		D0=D0+	10		* ->Ob_Field
		A=DAT0	A
		DAT1=A	A		* OverWrite Object!
		D0=A
		GOSUBL	F48GetObType
		A=C	A
		GOVLNG	=PUSH#ALOOP
  ENDCODE
 ;



ASSEMBLE
_F48$Checks@
RPL
::
  n@ #0=case :: RDROP ;
  $vars@
  index@
*****************************************
* Recall Selected Objects from $vars
* 2: $vars
* 1: #index	-> { ob1, ob2, ... obn }
*****************************************
* CPU Use:
* R0= ->new_List
* R1=
* R2= #index
* R3= ->Hidden_DIR
* R4=
*****************************************
  CODE
		STITLE	$Checks -> {}

		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		R2=A			* R2.A= #index

* Calculate Free RAM

		AD1EX
		A=A-B	A		* A.A= Free RAM
		C=0	A
		LC(2)	200
		C=A-C	A
		GONC	+
ChksErr!	GOTO	ChksErr
+		GOSBVL	=GETTEMP
		B=C	A		* B.A= Free Memory
		B=B-CON	A,10		* Alloc DOLIST + SEMI
		GOC	ChksErr!
		CD0EX
		R0=C			* R0.A= ->List
		D1=C
		LC(5)	=DOLIST
		DAT1=C	A
		D1=D1+	5

* Get Hidden_Dir's address and save it!

		GOSUB	Hidden_Dir@
		R3=A			* R3.A= ->Hidden_Dir

* Get $vars and # selected files

		GOSBVL	=D0=DSKTOP
		C=DAT0	A
		D0=C			* ->$vars
		D0=D0+	15		* ->Sel_Field
		C=DAT0	A		* C.A= #Selected Files
		D0=D0+	15		* ->First_Ob
		?C#0	A
		GOYES	ChksFind

* If No Selected Files, then we Pack
* the Index Object into the List.

		A=R2			* A.A= #index
		A=A-1	A
		C=A	A
		ASL	A
		A=A-C	A
		CD0EX
		C=C+A	A
		D0=C			* ->index_Object
		GOSUB	Ob->List

* Shrink List and Overwrite it!

ChksEnd		LC(5)	=SEMI
		DAT1=C	A
		D1=D1+	5
		AD1EX
		D0=A			* A,D0 = List_End
		GOSBVL	=ShrinkOb
		GOVLNG	=GPOverWrR0Lp

* Pack Selected Files into the List!

ChksFind	AD0EX
		R1=A			* R1.A= ->$vars (First_Ob)
		D=C	A		* D[B]= Loop Counter

* Get Objects in Same Selection Order.
* Start Searching from $vars begining

nxtCheck	C=R1		<<----------------------+
		D0=C			* D0 ->$vars	
FindLp		C=DAT0	B	<<------+		
		?C=D	B				
		GOYES	ObFound				
		D0=D0+	15				
		GONC	FindLp		+		
ObFound		GOSUB	Ob->List			
		D=D-1	B				
		?D=0	B		* More Objects?	
		GOYES	ChksEnd				
		GONC	nxtCheck	----------------+
*****************************************
* Pack Object from $vars to the List.
* In:	D0 ->Object	D1 ->List
* Out:	Object packed!
*****************************************
Ob->List	B=B-CON	A,5
		GONC	+
ChksErr		GOVLNG	=GPMEMERR

* Skip Hidden Dir if Selected!

+		D0=D0+	10		* -> OB_Field
		A=DAT0	A		* A.A= ->Ob
		C=R3			* C.A= ->Hidden_Dir
		?A=C	A		* Hidden Dir?
		RTNYES

		DAT1=A	A
		D1=D1+	5
		RTN
*****************************************
  ENDCODE

  DUPNULL{}? IT DROPRDROP	( Lista Vacia? )
 ;



ASSEMBLE
_F48HiddenDir@
RPL
CODE
		GOSUB	Hidden_Dir@
		GOVLNG	=PUSHA
*****************************************
* Returns Hidden_Dir Address
* Out:	A[A]= ->Hidden_Dir
* Uses: A,C,D0.
*****************************************
Hidden_Dir@	LC(5)	=USEROB
		CD0EX			* Save D0
		A=DAT0	A
		D0=A			* ->HOMEDIR
		D0=D0+	5
		A=0	A
		A=DAT0	X		* A[A]= #Attached Libs
		D0=D0+	15		* Skip some Fields
		CD0EX			* Restore D0
		C=C-A	A
		C=C-A	A
		C=C-A	A		* -3
		ASL	A
		A=A+C	A		* -3+16 = +13 (Skip Libs)
		RTN
ENDCODE



ASSEMBLE
_F48Copy/Move
RPL
::
  RDROP
  FALSE F48Tree NOTcase2DROP
  TRUEreload!
  CONTEXT!
  moveMode!	( Save Flag )
  FalseFalse delMode! all!

  INNERCOMP

  ( HOME -> HOME )
  ZERO_DO
    CODE
		STITLE	Directory Recursion?

		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		A=DAT0	A
		LC(5)	=DORRP
		?A=C	A
		GOYES	+
obOk		GOVLNG	=GETPTRLOOP
+		A=DAT1	A
		D0=(5)	=CONTEXT
		C=DAT0	A
		?A=C	A
		GOYES	Recursion!Err
		?A>C	A
		GOYES	obOk
		D=C	A		* D.A= -> dest-Dir
		D0=A
		GOSBVL	=SKIPOB
		CD0EX
		?C<D	A
		GOYES	obOk
Recursion!Err	GOVLNG	(=SETDIRRECUR)+5
    ENDCODE

    DUP RAM-WORDNAME
    BEGIN
    ::
      DoHere: DUP@ NOTcaseTRUE
      F48AskUser NOTcase DROPFALSE
      OBPURGE!
      TRUE
     ;
    UNTIL

    OVER
    moveMode? ITE OBPURGE!
		  DROP
    CREATE
  LOOP
  context@ CONTEXT!	( Return to Original Dir when finish.. )
 ;



ASSEMBLE
_F48AskUser
RPL
::
  all? caseTRUE

  delMode?
  ITE :: DUP RAM-WORDNAME ;
  OVER

  DO>STR
  ZERO FIFTYSIX BLANKIT
  DISPROW2

  delMode? ITE "Are You Sure?"
	       "Already Exists\nOverwrite?"
  %4 DODISP

  "NO"
  "ABORT"
  NULL$
  delMode? ITE NULL$ "REN"
  "ALL"
  "YES"

  ASSEMBLE
_F48CustomMenu
  RPL
  ::
    SIX
    ZERO_DO
      INDEX@ TWENTYTWO #*
      SWAP
      ROMPTR 101 3	( FONT1 -> )
      CODE
		GOSBVL	=PopASavptr
		A=A+CON	A,10
		R0=A
		C=DAT1	A
		B=C	A		* B[A]= ->"Label"
		D1=(5)	=uart_buffer
		GOSUB	SoftGrob
		NIBHEX	E1B20F30008000051000000000FFFFF1FFFFF1FFFFF1FFFFF1FFFFF1FFFFF1FFFFF1
SoftGrob	C=RSTK
		D0=C
		C=0	A
		LC(2)	68
		GOSBVL	=MOVEDOWN
		D0=(5)	(=uart_buffer)+32
		C=0	A
		LC(1)	6
		BCEX	A		* B[A]= Grob Width
		ST=1	invFont
		GOSBVL	=GetStrLenC
		RSTK=C			* Save #chars
		GOSUBL	D1>miniFont
		C=RSTK			* C[A]= #chars
		C=C+C	A
		C=C+C	A		* C[A]= 4*(#chars)
		A=C	A
		LC(2)	21
		C=C-A	A
		CSRB.F	A		* C[A]= # Bits to Shift Left
		D1=(5)	(=uart_buffer)+32
		P=	16-6
CenterLup	B=C	A
		A=DAT1	A
-		A=A+A	A
		ABIT=1	0
		B=B-1	A
		GONC	-
		DAT1=A	A
		D1=D1+	6
		P=P+1
		GONC	CenterLup
		LC(5)	=uart_buffer
		A=C	A
		GOVLNG	=GPOverWrALp
      ENDCODE
      Grob>Menu
    LOOP
   ;

  ClrDA1IsStat
  BEGIN
    F48GetKey
    ::
      ONE #=casedrop	( YES )
      TRUETRUE

      TWO #=casedrop	( ALL )
      :: TRUE all! TRUETRUE ;

      THREE #=casedrop	( REN )
      ::
	delMode? caseFALSE
	"Rename " ROT ID>$ &$
	NULL$
	F48Input NOTcasedrop ABORT
	$>ID SWAP
	FalseTrue
       ;

      SIX #=casedrop	( NO )
      ::
	delMode? case FalseTrue
	3DROP
	2RDROP 3RDROP
	' LOOP
	Ob>Seco
	>R
       ;

      FIVE #=casedrop	( ABORT )
      ABORT

      DROPFALSE
     ;
  UNTIL
 ;



ASSEMBLE
_F48KeyRepeat
RPL
::
  'R'R
  SWAPOVER EVAL
*****************************************
*	KEY AUTO-REPEAT ENGINE
*
* Waits for stady Key before starting
* the Auto-Repeat loop.
*
* 2: << PRG >>
* 1: KEY#	->
*****************************************
  CODE
		STITLE	Key-AutoRepeat Engine

KEYCODE		EQU	=IRAMBUFF
TIMESAVE	EQU	(=IRAMBUFF)+5

KeyLoop!	ST=0	15		* Interruptions Disabled!
		INTOFF			* Keyboard Scan Off!
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		D0=(5)	=KEYCODE
		DAT0=A	A		* Save Key#
		LC(5)	8192*30/100	* Wait .3 Seconds
		GOSUB	TIME!		* Save Stop_Time
-		GOSUB	KeyDown?	* Wait Loop <-----------+
		GOC	+		*			
ExitKey!	INTON			* Allow Keyboard	|
		ST=1	15		* Interruptions On!	|
		GOVLNG	=GETPTRLOOP	*			
+		D0=(5)	TIMESAVE	*			
		A=DAT0	A		* A.A= Stop_Time	
		D0=(5)	=TIMER2		*			
		C=DAT0	A		* C.A= Actual Time	
		?C>A	A		* Stop_Time Reached?	
		GOYES	-		* ----------------------+
*****************************************
KeyRepeater	C=0	A		*<------------------------------+
		LC(2)	8192*3/100	* Wait .03 Seconds		
		GOSUB	TIME!		*				
		GONC	OBEVAL		* Run Program!			
WaitLup		GOSUB	KeyDown?	* Key Still Down?		
		GONC	ExitKey!	* Quit Now!			
		D0=(5)	TIMESAVE	*				
		A=DAT0	A		* A.A= Stop_Time <------+	
		D0=(5)	=TIMER2		*				
		C=DAT0	A		* C.A= Actual Time		
		?C>A	A		* Stop_Time Reached?		
		GOYES	WaitLup		*-----------------------+	
		GONC	KeyRepeater	*-------------------------------+
*****************************************
KeyDown?	D0=(5)	KEYCODE
		A=DAT0	A		* A.A= Key#
		GOVLNG	=ThisKeyDown?
*****************************************
* C.A= Ticks To Wait until Stop_Time
* TIMER2 Counts Backwards
*****************************************
TIME!		D0=(5)	=TIMER2
		A=DAT0	A		* A.A= Actual_Time
		A=A-C	A		* Stop_Time = Actual - Wait
		D0=(5)	TIMESAVE
		DAT0=A	A		* Save Stop_Time
		RTNCC
*****************************************
OBEVAL		GOSUB	Ob_Addr@
		CON(5)	=DOCOL
		CON(5)	=DUP
		CON(5)	=EVAL
		CON(5)	=COLA
		CON(5)	=DOCODE
		REL(5)	->CodeEnd
		GOSBVL	=SAVPTR
		GONC	WaitLup
Ob_Addr@	C=RSTK
		GOVLNG	=GETPTREVALC
->CodeEnd
*****************************************
  ENDCODE
  DROP
 ;



ASSEMBLE
_F48Choose
RPL
*****************************************
* 3: "strings"
* 2: #n
* 1: #index-1
* 1: T/F ( Sort Mode? )  ->
*****************************************
::
  3PICK
  #1-ROT		( #n-1, #index-1 )
  3PICK
  ITE ::
	THREE OVER#<	( invert? )
	SWAPOVER IT #4-
       ;
      :: FALSE SWAP ;

  TWENTYFIVE		( Xoffset )

* Calculate Yoffset= (64 - n*6)/2

  SIXTYFOUR
  7PICK	#6*		( #n * 6 )
  #-#2/			( Yoffset )
  EIGHTYONE		( barSize )

  7NULLLAM{} BIND

  CXoff@ #4- CYoff@ #5-
  3PICK			( #n )
  #6* #9+		( #n*6 + 9 )
  89			( Window Width )

  MAKEGROB
*****************************************
* Draws a Window on the given GROB X*Y
* Note: X must be a factor of 8+1
*****************************************
  CODE
		GOSBVL	=SAVPTR
		C=DAT1	A
		D1=C			* D1 ->GROB
		D1=D1+	10
		C=DAT1	A
		D=C	A		* D[A]= #rows
		D1=D1+	5
		A=DAT1	A
		GOSBVL	=w->W		* Cols->Nibbs
		B=A	A		* B[A]= #Cols (Nibbs)
		D1=D1+	5-1		* -1 because in HorLine D1=D1+1
		CD1EX
		C=C+B	A		* Advance 1 Row
		D1=C			* D1->Second Row

* Write Top Lines

		LC(2)	#AA		* A= #1010 Pixels
		GOSUB	HorLine
		D1=D1+	1
		DAT1=C	P
		D1=D1+	3
		LC(2)	#54		* 4= #0100, 5=0101 Pixels
		GOSUB	HorLine
		LC(1)	13
		DAT1=C	P		* Write Top-Right Corner
		D1=D1+	3

* Write Vertical Lines

		D=D-CON	A,7
		C=0	A
		LC(1)	12
		A=C	A
		LC(2)	#42
vertLines	DAT1=C	P
		P=C	0
		CSR	A
		CPEX	1
		CD1EX
		C=C+B	A
		CD1EX
		D1=D1-	3
		DAT1=A	P
		D1=D1+	3
		D=D-1	A
		GONC	vertLines

* Write Bottom Lines

		LC(2)	#FC
		GOSUB	HorLine
		D1=D1+	3
		LC(2)	#FE
		GOSUB	HorLine
BoxQuit		GOVLNG	=GETPTRLOOP
***********************************
HorLine		A=B	A
		A=A-CON	A,4
		DAT1=C	P
		CSR	A
HLineLp		D1=D1+	1
		DAT1=C	P
		A=A-1	A
		GONC	HLineLp
		RTNCC
***********************************
  ENDCODE
  XYGROBDISP

  ZERO_DO
    INDEX@ #1+ #:>$ SWAP&$
    $>miniFont
    SIX CbarSize@ MAKEGROB
    SWAPOVER
    ONE ZERO GROB!
    Cindex@ INDEX@ #= IT INVGROB
    ABUFF
    CXoff@ INDEX@ #6* CYoff@ #+
    GROB!
  LOOP

  "OK"
  "CANCL"
  NULL$
  CsortMode?
  ITE "  INV"
      NULL$
  OVERDUP
  F48CustomMenu

  ( Muestra/Oculta el Cheque )
ASSEMBLE
_F48CheckDraw
RPL
  ::
    CsortMode? NOT?SEMI
    Cinvert?
    ITE GROB 14 5000050000F0702181D1
	GROB 14 5000050000FFFFFFFFFF
    HARDBUFF2
    FORTYSIX TWO
    GROB!
   ;

  BEGIN
    F48GetKey
    ::
      FIVE #=casedrop FalseTrue		( CANCEL )
      SIX #=casedrop TrueTrue		( OK )
      TWENTYFIVE #=casedrop TrueTrue	( ENTER )
      FORTYFIVE #=casedrop FalseTrue	( ON )

      THREE #=casedrop		( CHECK )
      ::
	CsortMode? NOT?SEMI
	Cinvert? NOT Cinvert!
	F48CheckDraw
	FALSE
       ;

      ELEVEN #=casedrop		( UP )
      ::
	FALSE
	Cindex@ DUP#0=csDROP
	F48ChsCurDrw
	#1- Cindex!
	F48ChsCurDrw
       ;

      SEVENTEEN #=casedrop	( DOWN )
      ::
	FALSE
	Cindex@ DUP Cn@ #= caseDROP
	F48ChsCurDrw
	#1+ Cindex!
	F48ChsCurDrw
       ;

      FORTY OVER#<
      OVER FORTYFOUR #<
      ANDcase
      ::
	FORTYONE #- Cn@ OVER#< casedrop FALSE
	Cindex!
	TrueTrue
       ;

      THIRTYSIX #=casedrop
      ::
	CsortMode? NOTcaseFALSE
	THREE Cindex!
	TrueTrue
       ;

      DROPFALSE
     ;
  UNTIL
  ITE ::
	Cindex@
	Cinvert? IT #4+
	TRUE
       ;
      FALSE
  ABND
  F48FilesDraw
  F48MenuDraw
 ;



ASSEMBLE
_F48ChsCurDrw
RPL
::
  CXoff@ Cindex@ #6* CYoff@ #+
  ABUFF
  3PICK 3PICK
  OVER CbarSize@ #+ OVER #6+
  SUBGROB INVGROB
  XYGROBDISP
 ;



ASSEMBLE
*****************************************
* MESSAGE TABLE:
* We use a Linked Array because LIB->DIR
* programs can't crack the Library.
*****************************************
FilerMsg	CON(5)	=DOLNKARRY	* Linked Array of String
		REL(5)	->MsgEnd	* Size Field
		CON(5)	=DOCSTR		* String Type
		CON(5)	1		* 1 Dimension
		CON(5)	3		* 3 Messages

* Now we have Offsets to the Messages:

		REL(5)	->m1
		REL(5)	->m2
		REL(5)	->m3

* Finally the Messages themeselves:

->m1		REL(5)	->m2
		NIBASC	\Library UFL not Found\
->m2		REL(5)	->m3
		NIBASC	\BZ Program not Found\
->m3		REL(5)	->MsgEnd
		NIBASC	\Invalid 'F48IO'\
->MsgEnd



FilerCfg
RPL
::
  444 ONSRRP?TOSRRP
*****************************************
* Find the Appropriate A3 Library and
* Execute its Config Code, to fix the
* Link Table's Offsets.
*****************************************
  CODE
		GOSBVL	=SAVPTR
		C=0	A
		LC(2)	163
		A=C	A
		GOSBVL	=D0->LIB#
		GONC	+
Cfg_Quit	GOVLNG	=GETPTRLOOP
+		D1=C
		D1=D1+	8
		C=DAT1	A
		?A#C	X
		GOYES	Cfg_Quit
		D1=D1+	3
		C=DAT1	13
		D1=D1-	16
		A=DAT1	13
		?A<C	A
		GOYES	+
		ACEX	W
+		D0=C
		D0=D0+	23
		B=A	A		* Save A[A]
		A=DAT0	B
		?A#0	B
		GOYES	Cfg_Quit
		A=B	A		* Restore A[A]
		DAT1=C	13		* Swap Libraries!
		D1=D1+	16
		DAT1=A	13
		D0=D0-	5		* ->Config Offset
		A=DAT0	A
		CD0EX
		C=C+A	A		* ->Config Code
		GOVLNG	=GETPTREVALC
  ENDCODE
 ;



ASSEMBLE
		CON(4)	0		* Library CRC
->LibEnd
RPL
