*****************************************************************************
* Name:		FILER48
* Type:		Library
* Platform:	HP48G/G+/GX
* Language:	50% System RPL / 50% Assembly Language
* Author:	Raul del cid Lopez, Guatemala C.A.
* Email:	Raoolio@yahoo.com
* Copyright:
*	(c) 2000-2005 by Raul del Cid Lopez. ALL rights reserved.
*
* Description:
*	Complete File Manager to handle all files inside the HP48.
*	It replaces the built-in MEMORY browser and has full support
*	for Port:0: Object Handling.
*
* Introduced Features:
*	v2.0: Browse through Files like Windows' Explorer.
*	      New API for Customizing Filer48.
*      v1.93: Improved Memory Handling, Reduced 9% + 44%
*      v1.92: Memory Counter for Selected Files.
*	v1.9: 4 New Flavors are Compiled now.
*	v1.8: Can Explore Covered Ports!!! (2-32). Port 1 also.
*	v1.7: 100% customizable via MetaKernel's Filer Extensions.
*
* Uses:
*	- Library  163: Right-Shift Key Plane
*	- Library  257: UFL Font Lev. 1
*	- Library 1698: USND 3.0
*****************************************************************************



*****************************************
* Library Command Definitions
*****************************************
DEFINE xFILER48		ROMPTR 1BC 00
DEFINE xVIEW		ROMPTR 1BC 01
DEFINE xFAPP		ROMPTR 1BC 02
DEFINE F48BROWSE	ROMPTR 1BC 03
******* Main Display Routines ***********
DEFINE F48$>miniFont	ROMPTR 1BC 04
DEFINE F48IndexDraw	ROMPTR 1BC 05
DEFINE F48FilesDraw	ROMPTR 1BC 06
DEFINE F48DirsDraw	ROMPTR 1BC 07
DEFINE F48DirIndxDrw	ROMPTR 1BC 08
DEFINE F48Tree		ROMPTR 1BC 09
DEFINE F48Reload	ROMPTR 1BC 0A
DEFINE F48LoadTree	ROMPTR 1BC 0B
DEFINE F48IndexCenter	ROMPTR 1BC 0C
DEFINE F48DirCenter	ROMPTR 1BC 0D
DEFINE F48SliderCalc	ROMPTR 1BC 0E
DEFINE F48SafeSlider	ROMPTR 1BC 0F
DEFINE F48Slider	ROMPTR 1BC 10
DEFINE F48StatusDraw	ROMPTR 1BC 11
DEFINE F48MenuDraw	ROMPTR 1BC 12
*****************************************
DEFINE F48BarSetup	ROMPTR 1BC 13
DEFINE F48BarDraw	ROMPTR 1BC 14
DEFINE F48BarDraw_LOOP	ROMPTR 1BC 15
*****************************************
DEFINE F48$Dir@		ROMPTR 1BC 16
DEFINE F48$Index@	ROMPTR 1BC 17
DEFINE F48$Checks@	ROMPTR 1BC 18
DEFINE F48HiddenDir@	ROMPTR 1BC 19
*****************************************
DEFINE F48Copy/Move	ROMPTR 1BC 1A
DEFINE F48Portn_Ob@	ROMPTR 1BC 1B
DEFINE F48Id?Home>	ROMPTR 1BC 1C
DEFINE F48Id?Port0>	ROMPTR 1BC 1D
DEFINE F48Id?Portn>	ROMPTR 1BC 1E
DEFINE F48LibUse?Err	ROMPTR 1BC 1F
DEFINE F48Mov?Home>	ROMPTR 1BC 20
DEFINE F48Mov?Port0>	ROMPTR 1BC 21
DEFINE F48Mov?Portn>	ROMPTR 1BC 22
DEFINE F48PortWr?Err	ROMPTR 1BC 23
DEFINE F48RoomInPort?	ROMPTR 1BC 24
*****************************************
DEFINE F48ParseName	ROMPTR 1BC 25
DEFINE F48AskUser	ROMPTR 1BC 26
DEFINE F48Input		ROMPTR 1BC 27
DEFINE F48Store		ROMPTR 1BC 28
DEFINE F48KeyRepeat	ROMPTR 1BC 29
*****************************************
DEFINE F48GetKey	ROMPTR 1BC 2A
DEFINE F48ItemEval	ROMPTR 1BC 2B
DEFINE F48Mode?OK	ROMPTR 1BC 2C
DEFINE F48#EVAL		ROMPTR 1BC 2D
DEFINE F48{}Menu	ROMPTR 1BC 2E
DEFINE F48PageUpSetup	ROMPTR 1BC 2F
DEFINE F48PageDnSetup	ROMPTR 1BC 30
DEFINE F48MaxUpSetup	ROMPTR 1BC 31
DEFINE F48MaxDnSetup	ROMPTR 1BC 32
*****************************************
DEFINE F48Choose	ROMPTR 1BC 33
DEFINE F48ChsCurDrw	ROMPTR 1BC 34
DEFINE F48CheckDraw	ROMPTR 1BC 35
DEFINE F48CustomMenu	ROMPTR 1BC 36
*****************************************
DEFINE F48GotoTree	ROMPTR 1BC 37
DEFINE F48SwapLocals	ROMPTR 1BC 38
DEFINE F48MakeTree	ROMPTR 1BC 39
DEFINE F48DirUp		ROMPTR 1BC 3A
DEFINE F48DirDown	ROMPTR 1BC 3B
DEFINE F48TreeLabel	ROMPTR 1BC 3C
DEFINE F48IndexPos	ROMPTR 1BC 3D
DEFINE F48FileDraw	ROMPTR 1BC 3E
DEFINE F48DirDraw	ROMPTR 1BC 3F
DEFINE F48Shift7->8	ROMPTR 1BC 40
DEFINE F48Shift8->7	ROMPTR 1BC 41
DEFINE F48Files/Dirs	ROMPTR 1BC 42
DEFINE F48Str>Label	ROMPTR 1BC 43
*****************************************
DEFINE F48Font?Ok	ROMPTR 1BC 44
DEFINE F48NewEq/Mat	ROMPTR 1BC 45
DEFINE F48ObView	ROMPTR 1BC 46
DEFINE F48Sort!		ROMPTR 1BC 47
DEFINE F48Select!	ROMPTR 1BC 48
DEFINE F48GetIO		ROMPTR 1BC 49



******************************************
* Lambda Definitions
******************************************
DEFINE {}menu@		THIRTYNINE GETLAM
DEFINE {}menu!		THIRTYNINE PUTLAM
DEFINE $types@		THIRTYEIGHT GETLAM
DEFINE stackDepth@	THIRTYSEVEN GETLAM
DEFINE context@		THIRTYSIX GETLAM
DEFINE context!		THIRTYSIX PUTLAM
************** TREE Vars **************** Used by F48SwapLocals!!!
*DEFINE T_n@		THIRTYFIVE GETLAM
*DEFINE T_n!		THIRTYFIVE PUTLAM
*DEFINE T_max@		THIRTYFOUR GETLAM
*DEFINE T_max!		THIRTYFOUR PUTLAM
*DEFINE T_index@	THIRTYTHREE GETLAM
*DEFINE T_index!	THIRTYTHREE PUTLAM
*DEFINE T_min@		THIRTYTWO GETLAM
*DEFINE T_min!		THIRTYTWO PUTLAM
*DEFINE T_dy@		THIRTYONE GETLAM
*DEFINE T_dy!		THIRTYONE PUTLAM
*DEFINE T_barHeight@	THIRTY GETLAM
*DEFINE T_barHeight!	THIRTY PUTLAM
DEFINE T_$title@	TWENTYNINE GETLAM
DEFINE T_$title!	TWENTYNINE PUTLAM
*************** Safety ******************
DEFINE F48Safe$Vars	TWENTYEIGHT GETLAM EVAL
*****************************************
DEFINE quit?		TWENTYSEVEN GETLAM	( ROM P issue )
DEFINE quit!		27PUTLAM		( don't move this one! )
DEFINE downEnter?	TWENTYSIX GETLAM
DEFINE downEnter!	TWENTYSIX PUTLAM
************* MENU LABELS ***************
DEFINE pageMax@		TWENTYFIVE GETLAM
DEFINE pageMax!		TWENTYFIVE PUTLAM
DEFINE page@		TWENTYFOUR GETLAM
DEFINE page!		24PUTLAM
*****************************************
DEFINE updir?		TWENTYTHREE GETLAM	( ROM T issue )
DEFINE updir!		23PUTLAM
DEFINE $dirs@		22GETLAM
DEFINE $dirs!		22PUTLAM
DEFINE $vars@		21GETLAM
DEFINE $vars!		21PUTLAM
DEFINE port@		20GETLAM ( Port# )
DEFINE port!		20PUTLAM
DEFINE $path@		19GETLAM
DEFINE $path!		19PUTLAM
************ Saved Vars *****************
DEFINE prtLabels@	18GETLAM
DEFINE prtLabels!	18PUTLAM
DEFINE sortBy@		17GETLAM
DEFINE sortBy!		17PUTLAM
DEFINE dispMode@	16GETLAM
DEFINE dispMode!	16PUTLAM
DEFINE statusMode@	15GETLAM
DEFINE statusMode!	15PUTLAM
*********** Browser Vars ****************
DEFINE maxFiles@	14GETLAM
DEFINE maxFiles!	14PUTLAM
DEFINE n@		13GETLAM
DEFINE n!		13PUTLAM
DEFINE max@		12GETLAM
DEFINE max!		12PUTLAM
DEFINE index@		11GETLAM
DEFINE index!		11PUTLAM
DEFINE min@		10GETLAM
DEFINE min!		10PUTLAM
*************** Slider ******************
DEFINE dy@		9GETLAM
DEFINE dy!		9PUTLAM
DEFINE barHeight@	8GETLAM
DEFINE barHeight!	8PUTLAM
************ STATUS FLAGS ***************
DEFINE miniFont@	7GETLAM
DEFINE inTree?		6GETLAM
DEFINE inTree!		6PUTLAM
DEFINE libOb?		5GETLAM
DEFINE libOb!		5PUTLAM
DEFINE dirOb?		4GETLAM
DEFINE dirOb!		4PUTLAM
DEFINE portMode?	3GETLAM
DEFINE portMode!	3PUTLAM
*********************************
DEFINE 3API?		2GETLAM
DEFINE 3API!		2PUTLAM
DEFINE refresh?		2GETLAM
DEFINE refresh!		2PUTLAM
DEFINE reload?		1GETLAM
DEFINE reload!		1PUTLAM
DEFINE TRUEreload!	TRUE1PUTLAM
*********** COPY/MOVE FLAGS *************
DEFINE depthSave@	21GETLAM
DEFINE depthSave!	21PUTLAM
DEFINE moveMode?	13GETLAM
DEFINE moveMode!	13PUTLAM
DEFINE dest@		10GETLAM
DEFINE dest!		10PUTLAM
DEFINE all?		9GETLAM
DEFINE all!		9PUTLAM
DEFINE delMode?		8GETLAM
DEFINE delMode!		8PUTLAM
******** UPDIR/PROGRESS BAR VARS ********
DEFINE prevContext@	8GETLAM
DEFINE prevContext!	8PUTLAM
DEFINE %bar@		2GETLAM
DEFINE %bar!		2PUTLAM
*************** EDIT ********************
DEFINE id@		2GETLAM
DEFINE type@		1GETLAM
************** CHOOSE *******************
DEFINE CsortMode?	8GETLAM
DEFINE Cn@		7GETLAM
DEFINE Cn!		7PUTLAM
DEFINE Cinvert?		6GETLAM
DEFINE Cinvert!		6PUTLAM
DEFINE Cindex@		5GETLAM
DEFINE Cindex!		5PUTLAM
DEFINE CXoff@		4GETLAM
DEFINE CXoff!		4PUTLAM
DEFINE CYoff@		3GETLAM
DEFINE CYoff!		3PUTLAM
DEFINE CDispGrob@	2GETLAM
DEFINE CDispGrob!	2PUTLAM
DEFINE CMenuGrob@	1GETLAM
DEFINE CMenuGrob!	1PUTLAM
*****************************************


ASSEMBLE
		TITLE Filer48 2.41 Full

* Some Lambda Constants:
LAMdispMod	EQU 16	DispMode Lambda
LAMstatus	EQU 15	statusMode Lambda
LAMfont		EQU 7	miniFont Lambda
LAM3Api		EQU 2	3API Lambda

* Max Label Length:
MaxChrs		EQU 8	Maximum Port Label Lenght

* Object Type Constants
LIBTYPE		EQU 19

* Some Status Flags:
check		EQU 8	Display the Check Field Only?
Files		EQU 7	Drawing Files?
Windows		EQU 6	Windows' Style?
FullStatus	EQU 5	Full Status?	( Display Only 7 Lines )

Card1_128K	EQU 7	Card 1 is 128K?
Card1		EQU 6	Card 1 Plugged?
HighPort	EQU 5	Covered Port?
PortMode	EQU 4	Port Mode?

PortRoot	EQU 3	In Port Root?

invFont		EQU 3	Invert Font data?
Wide		EQU 0	Full screen width?
RomId		EQU 444


		CON(5)	=DOLIB		* Library Prologue
		REL(5)	->LibEnd	* Size Field

		CON(2)	(($end)-($beg))/2
$beg		NIBASC	\FILER48-F 2.41\n\
		NIBASC	\Raul del Cid Lopez\n\
		NIBASC	\raoolio@yahoo.com\n\
		NIBASC	\Aug 2005\
$end		CON(2)	(($end)-($beg))/2

		CON(3)	RomId		* Library#

		REL(5)	FilerHash	* ->Hash Table Offset
		REL(5)	FilerMsg	* ->Message Table Offset
		REL(5)	FilerLink	* ->Link Table Offset
		REL(5)	FilerCfg	* ->Config PRG Offset


*****************************************
* LINK TABLE:
*****************************************
FilerLink	CON(5)	=DOHSTR		* Link Table Prologue
		REL(5)	->LinkEnd	* Size Field

		REL(5)	_xFILER48
		REL(5)	_xVIEW
		REL(5)	_xFAPP
		REL(5)	_F48BROWSE
		REL(5)	_F48$>miniFont
		REL(5)	_F48IndexDraw
		REL(5)	_F48FilesDraw
		REL(5)	_F48DirsDraw
		REL(5)	_F48DirIndxDrw
		REL(5)	_F48Tree
		REL(5)	_F48Reload
		REL(5)	_F48LoadTree
		REL(5)	_F48IndexCenter
		REL(5)	_F48DirCenter
		REL(5)	_F48SliderCalc
		REL(5)	_F48SafeSlider
		REL(5)	_F48Slider
		REL(5)	_F48StatusDraw
		REL(5)	_F48MenuDraw
		REL(5)	_F48BarSetup
		REL(5)	_F48BarDraw
		REL(5)	_F48BarDraw_LOOP
		REL(5)	_F48$Dir@
		REL(5)	_F48$Index@
		REL(5)	_F48$Checks@
		REL(5)	_F48HiddenDir@
		REL(5)	_F48Copy/Move
		REL(5)	_F48Portn_Ob@
		REL(5)	_F48Id?Home>
		REL(5)	_F48Id?Port0>
		REL(5)	_F48Id?Portn>
		REL(5)	_F48LibUse?Err
		REL(5)	_F48Mov?Home>
		REL(5)	_F48Mov?Port0>
		REL(5)	_F48Mov?Portn>
		REL(5)	_F48PortWr?Err
		REL(5)	_F48RoomInPort?
		REL(5)	_F48ParseName
		REL(5)	_F48AskUser
		REL(5)	_F48Input
		REL(5)	_F48Store
		REL(5)	_F48KeyRepeat
		REL(5)	_F48GetKey
		REL(5)	_F48ItemEval
		REL(5)	_F48Mode?OK
		REL(5)	_F48#EVAL
		REL(5)	_F48{}Menu
		REL(5)	_F48PageUpSetup
		REL(5)	_F48PageDnSetup
		REL(5)	_F48MaxUpSetup
		REL(5)	_F48MaxDnSetup
		REL(5)	_F48Choose
		REL(5)	_F48ChsCurDrw
		REL(5)	_F48CheckDraw
		REL(5)	_F48CustomMenu
		REL(5)	_F48GotoTree
		REL(5)	_F48SwapLocals
		REL(5)	_F48MakeTree
		REL(5)	_F48DirUp
		REL(5)	_F48DirDown
		REL(5)	_F48TreeLabel
		REL(5)	_F48IndexPos
		REL(5)	_F48FileDraw
		REL(5)	_F48DirDraw
		REL(5)	_F48Shift7->8
		REL(5)	_F48Shift8->7
		REL(5)	_F48Files/Dirs
		REL(5)	_F48Str>Label
		REL(5)	_F48Font?Ok
		REL(5)	_F48NewEq/Mat
		REL(5)	_F48ObView
		REL(5)	_F48Sort!
		REL(5)	_F48Select!
		REL(5)	_F48GetIO
->LinkEnd


*****************************************
* HASH TABLE:
*****************************************
FilerHash	CON(5)	=DOHSTR		* Hash Table Prologue
		REL(5)	->HashEnd	* Size Field

		CON(5)	0		* ->Len 1 offset
		CON(5)	0		* ->Len 2
		CON(5)	0		* ->Len 3
		REL(5)	->L4N1		* ->Len 4
		CON(5)	0		* ->Len 5
		CON(5)	0		* ->Len 6
		REL(5)	->L7N1		* ->Len 7
		CON(5)	0		* ->Len 8
		CON(5)	0		* ->Len 9
		CON(5)	0		* ->Len 10
		CON(5)	0		* ->Len 11
		CON(5)	0		* ->Len 12
		CON(5)	0		* ->Len 13
		CON(5)	0		* ->Len 14
		CON(5)	0		* ->Len 15
		CON(5)	0		* ->Len 16

		REL(5)	->NamesEnd	* Names Area Size Field
->L4N1		CON(2)	4
		NIBASC	\VIEW\
		CON(3)	1
->L4N2		CON(2)	4
		NIBASC	\FAPP\
		CON(3)	2
->L7N1		CON(2)	7
		NIBASC	\FILER48\
		CON(3)	0

->NamesEnd	CON(5)	(->NamesEnd)-(->L7N1)
O2		CON(5)	(O2)-(->L4N1)
O3		CON(5)	(O3)-(->L4N2)
->HashEnd



		CON(1)	8
		CON(3)	RomId
		CON(3)	2
_xFAPP
RPL
*****************************************
* FAPP (Filer Application) command
* It Allows to make an Application
* with Filer48.
*
* 3:	{ Path }
* 2:	{ Types }
* 1:	{ Menu }
*****************************************
::
  CK3&Dispatch
  # 555
  ::
    F48Font?Ok	( UFL present? )

    UNROT
**************************************
* Here we Pack the %types list
* to a suitable form compatible
* with the Directory_Engine
*
* 1:  { %Type.. }  -> $Types
**************************************
    ::
      DUPNULL{}? casedrop "\00"
      INNERCOMP
      DUP #>CHR
      NULL$
      SWAPROT
      ZERO_DO
	SWAPROT CKREAL COERCE #>CHR >H$
      SWAPLOOP
      >H$
     ;

    SWAP
*    DUPTYPETAG? case
*    ::
*      TAG> palparse NOTcase SETTYPEERR
*      CKREAL COERCE SWAP
*      ::
*	DUPNULL{}? caseFALSE
*	CARCOMP DUPTYPEIDNT? NOTcasedrop SETTYPEERR
*	Port0_Ob@ NOTcase SETNONEXTERR
*	TRUE
*       ;
*      TRUE
*      F48BROWSE
*     ;

    ::
      DUPNULL{}? casedrop HOMEDIR
      LISTRCL DUPTYPERRP? NOTcasedrop SETTYPEERR
      CONTEXT!
     ;
    COLA F48BROWSE
   ;
 ;



ASSEMBLE
		CON(1)	8
		CON(3)	RomId
		CON(3)	1
_xVIEW
RPL
::
  CK1
  F48Font?Ok
  CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		GOSUB	F48GetObType
		A=0	A
		A=C	B
		GOVLNG	=PUSH#ALOOP
  ENDCODE
  F48ObView
 ;



ASSEMBLE
		CON(1)	8
		CON(3)	RomId
		CON(3)	0
_xFILER48
RPL
::
  CK0

ASSEMBLE
_F48Font?Ok
RPL
::
* Error if Running in Covered Port (in Temp Memory)
  CODE
		GOSBVL	=SAVPTR
		A=PC
		D0=(5)	=TEMPOB
		C=DAT0	A		* C.A= ->TEMPOB
		?A<C	A
		GOYES	+
		D0=D0+	5
		C=DAT0	A		* C.A= ->TEMPTOP
		?A>C	A
		GOYES	+
		LC(5)	#1BC06
		GOVLNG	=GPErrjmpC	* "Put Filer in Port0/1"
+		GOVLNG	=GETPTRLOOP
  ENDCODE

* Library 257 Present?
  # 1BC01
  ' ROMPTR 101 000
  ROMPTRDECOMP NOTcase ERROROUT
  ' ID FNT EQUALNOTcase ERROROUT
  DROP
 ;


ASSEMBLE
_F48{}Menu
RPL
    {
	{ "VIEW"  ZERO THREE }			( VIEW  )
	{ "EDIT"  FIVE TWENTYFIVE #5A }		( EDIT  )
	{ "RENAM" FIVE THIRTY }			( RENAM )
	{ "NEW"   FIVE THIRTYONE }		( NEW   )
	{ "TREE"  ZERO FOUR }			( TREE  )
	{ "SORT"  ZERO ONE }			( SORT  )

	{ "SELEC" ZERO TWO }			( SELEC )
	{ "COPY"  ZERO TWENTYSIX }		( COPY  )
	{ "MOVE"  FIVE TWENTYSEVEN }		( MOVE  )
	{ "ORDER" ONE THIRTYTWO }		( ORDER )
	{ "ZIP"   ONE THIRTYTHREE }		( ZIP )
	{ "LINK"  ZERO THIRTYFOUR }		( LINK )
    }
  "\00"		( $Types: All Files! )
  COLA

ASSEMBLE
_F48BROWSE
RPL
*****************************************
* Filer Browser Engine...
*
* 2:	{ Menu }
* 1:	$Types
*****************************************
::
  PATHDIR ' LAM Pth ONE DOBIND
  ERRSET
  ::
    DEPTH #2-
    CONTEXT@
    ZEROZEROZERO	( T_n, max, T_index )
    ZEROZEROZERO	( T_min, T_$title, T_dy )
    DUP'		( T_barHeight, ->Code to Stack )
*****************************************
*	LIST DIR/LIB/PORT Vars
*
* 6:	Context@
* 5:	$types@
* 4:	Port#
* 3:	dirOb?
* 2:	libOb?
* 1:	PortMode?	-> $vars #obs
*****************************************
*	$Vars Structure:
* "00000 00000 00000 00000 00000 <VarStruct>.."
*    5     5     5     5     5       20
*
* 5:	->$Vars address (for GC Safety)
* 5:	#Objects
* 5:	#Selected Objects
* 5:	Size of Selected obs
* 5:	Free Memory
*
************* <VarStruct> ***************
* 3:	Selection Field
* 5:	->Name
* 2:	Type
* 5:	Size (Nibbs)
* 5:	->Obj
************** CPU USE ******************
* R0.A=	->$vars		B.A= free RAM
* R3.A=	#Obs		D.A= ob count
* R4.A= ->$types
* D1	->$vars
*****************************************
CODE

NullNames	EQU 9	Show Null Names?
TypeSrch	EQU 8	Search Files by Type?
LibOb		EQU 3	Library Object?
InDir		EQU 2	Inside Dir?
InLib		EQU 1	Inside Lib?

		GOSBVL	=DisableIntr
		CLRST			* Clear Status Flags 0-11
		GOSBVL	=popflag
		GONC	+
		ST=1	PortMode
+		GOSBVL	=popflag
		GONC	+
		ST=1	InLib
+		GOSBVL	=popflag
		GONC	+
		ST=1	InDir
+		GOSBVL	=POP#
		R2=A			* R2.A= Port#
		GOSBVL	=PopASavptr
		D0=A			* ->$Types
		D0=D0+	10		* ->Size_Field
		C=DAT0	B
		?C=0	B		* No Types?
		GOYES	+
		ST=1	TypeSrch
		R4=A			* R4= ->Type_List

* Fetch User Status Flag #6

+		C=0	A
		LC(1)	6
		A=C	A
		ST=1	0
		GOSBVL	=TestFlag
		C=C&A	XS
		?C=0	XS
		GOYES	+
		ST=1	NullNames

+		C=DAT1	A
		R1=C			* Save Context@
		D0=C			* ->Context@
		A=DAT0	A
		LC(5)	=DOBINT
		?A#C	A		* Not a Bint?
		GOYES	+
		D0=D0+	5
		C=DAT0	A
		R1=C			* Save current DIR/LIB

* Calculate Free Memory

+		AD1EX			* A.A= Free Ram End Address (Stack)
		?ST=0	PortMode	* Not in Port Mode?
		GOYES	FreeRam
		C=R2			* C.A= Port#
		?C=0	A		* Port 0?
		GOYES	FreeRam
		C=C-1	A
		?C=0	A		* Port 1?
		GOYES	FreeRam
		ST=1	HighPort	* Access High Port!

* Now if Card1 is plugged & Merged
* Check that Free Memory End is in
* a safe area before address #C0000,
* since #C0000 is unconfigured to
* have access to High Ports, we can
* not use this as Free Mem.

		D1=(5)	=CARD1STAT
		C=DAT1	B
		?CBIT=0	3		* Card1 Not Present?
		GOYES	FreeRam
		ST=1	Card1		* Card 1 Plugged!

		?CBIT=0	5		* 32K Card?
		GOYES	+
		ST=1	Card1_128K	* Card 1 is 128K!

+		?CBIT=0	1		* Card1 Not Merged?
		GOYES	FreeRam
		LC(5)	#C0000		* C.A= Card1&2 start Address
		?A<C	A		* Free Mem in Safe Area?
		GOYES	FreeRam
		A=C	A		* Set Free Mem End ->#C0000
FreeRam		A=A-B	A		* A.A= FREE RAM (Dsktop - Rstktop)

* Allocate Big Chunck $

		C=0	A
		LC(2)	200		* Leave 200 Nibbles Free
		C=A-C	A
		GOC	G$E
		GOSBVL	=MAKE$N
		C=A	A
		GOSBVL	=DIV5
		C=C-1	A		* Alloc ->$Vars Pointer
		GOC	G$E
		CSRB.F	A
		CSRB.F	A
		C=C-1	A		* Alloc $Vars Header Fields
		GONC	+
G$E		GOTO	$Error
+		R3=C			* R3.A= #Total Blocks
		B=C	A
		CD0EX
		D1=C			* D1 ->$vars

		C=0	W
		DAT1=C	W		* Clear All Fields!
		D1=D1+	16
		DAT1=C	9
		D1=D1+	9		* skip Mem_Field

* Now Check if we are accessing
* a Covered Port, if so then
* Unconfigure Card1, so Card2
* is accesible.

		?ST=0	HighPort	* Not accessing a High Port?
		GOYES	RunEngine

		?ST=0	Card1		* Card 1 Not Plugged?
		GOYES	PullBank

		LC(5)	#C0000		* Load Card1 start address
		UNCNFG			* Unconfigure it!

* At this point Card 2 is already visible,
* so just Pull Bank (n-2).
* To make Port n visible we read
* a byte from:  #7F040 + 2(n-2)
* and throw away.

PullBank	A=R2			* A.A= Port#
		A=A-1	A
		A=A-1	A		* A.A= Bank# (Port# - 2)
		A=A+A	A		* A.A= (Bank#)*2
		LC(5)	#7F040
		C=C+A	A
		D0=C
		C=DAT0	B		* tells bank switcher bank# to read

* Execute Appropiate Engine

RunEngine	A=R1			* Recover ->DIR/LIB
		?ST=1	InLib
		GOYES	+
		?ST=1	InDir
		GOYES	DirEngine
		GOTO	PortEngine
+		GOTO	LibEngine
*****************************************
* Skip this Object?
* ->Object Type is not in the Type List?
*
* In:	D0->Object	C.B= #Type
*
* Out:  D0->Object	A.B= #Type
*
* Uses: A,C,D,D0, 1 RSTK
*****************************************
SkipType?	A=R4.F	A
		AD0EX			* D0->Type_List
		ACEX	A
		RSTK=C			* Save D0
		D0=D0+	10		* ->Size_Field
		C=DAT0	B
		D=C	B
TypeLup		D=D-1	B
		GOC	TypeDone
		D0=D0+	2
		C=DAT0	B
		?A#C	B
		GOYES	TypeLup
TypeDone	C=RSTK
		D0=C			* Restore D0
		GONC	PackVar
		GOTO	SkipVar
*****************************************
GoVarsDone	GOTO	VarsDone
*****************************************
$Error		GOVLNG	=GPMEMERR
*****************************************
		STITLE	Dir Vars Search Engine
*****************************************
DirEngine	GOSBVL	=D0->LastRamWrd
		C=DAT0	A
		C=-C	A		* C.A= Last object's offset
nextVarLup	?C=0	A		* Empty Dir? (Link=0)
		GOYES	GoVarsDone
		AD0EX
		A=A-C	A
		R1=A.F	A		* Save ->Name
		D0=A			* D1 ->Name
		C=0	A
		C=DAT0	B		* A.B= Name Length
		?C#0	B		* Not a NullID?
		GOYES	+
		?ST=0	NullNames
		GOYES	GoVarsDone
+		GOSBVL	(=TRAVERSE+)+5	* D0 ->Obj
		GOSUB	F48GetObType	* C.B= Object Type
		?ST=1	TypeSrch	* Search by Type?
		GOYES	SkipType?
		A=C	B
PackVar		B=B-1	A		* Reserve 1 <VarStruct> (20 Nibbs)
		GOC	$Error
		C=0	A
		DAT1=C	X		* Wipe Selection Field!
		D1=D1+	3

		C=R1.F	A
		DAT1=C	A		* Write Name's address!
		D1=D1+	5

		DAT1=A	B
		D1=D1+	2		* Write #Type!

		CD0EX
		D0=C
		D=C	A
		GOSBVL	=SKIPOB
		CD0EX
		C=C-D	A
		DAT1=C	A		* Write Object Size!
		D1=D1+	5

		C=D	A
		DAT1=C	A		* Write Object's address!
		D1=D1+	5

SkipVar		A=R1.F	A
		D0=A
		D0=D0-	5
		C=DAT0	A
		GOTO	nextVarLup
*****************************************
VarsDone	C=R3			* C.A= Total #Blocks
		C=C-B	A		* C.A= #Objects = (#Total - #Used)
		R3=C			* R3.A= Save it!
		A=R0
		D0=A
		D0=D0+	15		* ->#Obs_Field
		DAT0=C	A		* Write #obs in $vars

* If we accessed a Covered Port and
* Card 1 is Plugged, then we have to
* Re-Configure Card 1 back at #C0000

		?ST=0	HighPort	* Not a High Port?
		GOYES	Shrink$vars

		?ST=0	Card1		* Card 1 Not Plugged?
		GOYES	Shrink$vars

		GOSUB	Names>$		* Copy All Names to $ end

		C=0	A
		P=	4
		LC(1)	#C
		?ST=1	Card1_128K	* Card 1 is 128K?
		GOYES	+
		LC(1)	#F		* 32K Card
+		CONFIG			* Give Card Size Using Complementation
		LC(1)	#C
		CONFIG			* Configure Card 1 back at #C0000

* Finally Shrink $vars and Push #obs

Shrink$vars	AD1EX
		D0=A			* D0 ->$End
		GOSBVL	=Shrink$	* Sets P=0

		GOSBVL	=ROOM		* C.A= Free RAM
		A=R1
		D1=A			* ->$vars+5 (done by Shrink$)
		D1=D1+	25		* ->Mem_Field
		DAT1=C	A		* Write Free Mem!

		GOSBVL	=AllowIntr	* Enable Interruptions!
		GOSBVL	=GETPTR
		C=R0
		DAT1=C	A
		A=R3
		GOVLNG	=PUSH#ALOOP
*****************************************
* Check if Program is User or System RPL
*****************************************
PrgCheck	D0=D0+	5
		A=DAT0	A
		D0=D0-	5
		LC(5)	=x<<
		?A=C	A		* User RPL program?
		GOYES	+
		LC(2)	24		* C= System RPL Type
		RTN
+		LC(2)	28		* C= User RPL Type
		RTN
*****************************************
* Check if "String" is a "BZ.." File
*****************************************
StrCheck	D0=D0+	10
		A=DAT0	4
		D0=D0-	10
		LCSTR	'BZ'
		P=	3
		?A=C	WP		*  $BZ ?
		GOYES	+
		P=	0
		LC(2)	25
		RTN
+		P=	0
		LC(2)	30
		RTN
*****************************************
* Gets Object Type
* In:	D0 ->Obj
* Out:	C[B]= #Type
* Uses:	A, C, D, D0, 2 RSTK
*****************************************
F48GetObType	A=DAT0	X
		LC(3)	=DOCOL
		?A=C	X		* Program?
		GOYES	PrgCheck
		LC(3)	=DOCSTR
		?A=C	X		* String?
		GOYES	StrCheck
		LC(2)	26-1
		CDEX	A
		RSTK=C			* Save Object Counter
		GOSUB	PrologTable
		CON(3)	=DORRP
		CON(2)	0
		CON(3)	=DOLIST
		CON(2)	20
		CON(3)	=DOREAL
		CON(2)	23
		CON(3)	=DOCMP
		CON(2)	9
		CON(3)	=DOARRY
		CON(2)	22
		CON(3)	=DOSYMB
		CON(2)	2
		CON(3)	=DOHSTR
		CON(2)	5
		CON(3)	=DOGROB
		CON(2)	16
		CON(3)	=DOLIB
		CON(2)	19
		CON(3)	=DOEXT0
		CON(2)	18
		CON(3)	=DOCODE
		CON(2)	8
		CON(3)	=DOIDNT
		CON(2)	15
		CON(3)	=DOROMP
		CON(2)	29
		CON(3)	=DOBINT
		CON(2)	6
		CON(3)	=DOLNKARRY
		CON(2)	17
		CON(3)	=DOTAG
		CON(2)	26
		CON(3)	=DOLAM
		CON(2)	21
		CON(3)	=DOEXT
		CON(2)	27
		CON(3)	=DOBAK
		CON(2)	4
		CON(3)	=DOCHAR
		CON(2)	7
		CON(3)	=DOEREL
		CON(2)	11
		CON(3)	=DOECMP
		CON(2)	10
		CON(3)	=DOACPTR
		CON(2)	1
		CON(3)	=DOEXT3
		CON(2)	3
		CON(3)	=DOEXT2
		CON(2)	14
		CON(3)	=DOEXT4
		CON(2)	12
		CON(2)	13		* External [?]
PrologTable	C=RSTK
		CD0EX			* D0= PrologTable  C=D0
		RSTK=C			* Save D0
PrologLup	C=DAT0	X
		D0=D0+	3
		?A=C	X
		GOYES	ReadType
		D0=D0+	2
		D=D-1	B
		GONC	PrologLup
ReadType	A=DAT0	B		* Read Object Type
		C=RSTK
		D0=C			* Restore D0
		C=RSTK
		D=C	A		* Restore D
		C=A	B
		RTN
*****************************************
* Copy all Names to $vars end, and adjust
* each Object's ->NAME Pointer field.
*****************************************
Names>$		D=C	A		* D.A= Loop Counter
		D0=D0-	5
		DAT0=A	A		* Write $vars Pointer!
		D0=D0+	20		* skip #obs, #sel, SelSize, Mem Fields

		C=B	A		* C.A= # Available Blocks of 20-Nibbs Each
		C=C+C	A
		C=C+C	A		* C.A= (blocks)*4
		BSL	A		* B.A= (blocks)*16
		B=B+C	A		* B.A= Available Nibbles: (Blocks)*20 ~ 4+16

NameCpyLp	D0=D0+	8		* ->nxt Name_Field
		D=D-1	A
		RTNC

		AD1EX			* ->$vars End
		D1=A
		C=DAT0	A
		DAT0=A	A		* Write new ->Name ($End)
		CD0EX			* D0 ->Name
		RSTK=C			* Save ->Name_Field ($vars Current NAME)

		ST=0	NullNames	* Assume NOT Null Name
		C=0	A
		C=DAT0	B		* C.A= #chars
		C=C+C	A		* C.A= nibbs
		?C#0	B		* Not Null Name?
		GOYES	AllocName
		ST=1	NullNames	* Null Name!
AllocName	C=C+CON	A,2		* + Size_Field
		B=B-C	A
		GONC	Name->$End
		GOTO	$Error
Name->$End	GOSBVL	=MOVEDOWN

		C=RSTK
		D0=C			* Restore ->Name_Field ($vars Current NAME)
		D0=D0+	5		* ->Type_Field
		A=DAT0	B
		D0=D0+	7		* D0 ->Ob_Field
		LC(2)	LIBTYPE		* C.B= Library Type
		?A#C	B		* Not a Library?
		GOYES	NameCpyLp

		B=B-CON	A,5		* Alloc 2nd Name Field + Lib#
		GONC	+
		GOTO	$Error

+		C=DAT0	A
		CD0EX			* D0 ->Library
		RSTK=C			* Save D0
		D0=D0+	10
		GOSBVL	=TRAVERSE+
		?ST=1	NullNames	* Null Name?
		GOYES	+
		D1=D1+	2		* skip 2nd Size_Field (Emulated)
+		A=DAT0	X		* Read Lib#
		DAT1=A	X
		D1=D1+	3		* Write it!
		C=RSTK
		D0=C			* Restore D0
		GOTO	NameCpyLp
*****************************************
		STITLE	Port Vars Search Engine
*****************************************
PortEngine	LC(5)	#C0000		* Card1&2 start address
		A=R2
		?A#0	A		* Port > 0?
		GOYES	+
		D0=(5)	=ROMPARTS
		C=DAT0	A
+		D0=C			* D0 ->First Port Lib/Bak

LibBakLoop	ST=1	LibOb		* Assume Lib
		A=DAT0	X
		LC(3)	=DOLIB		* #02B40
		?A=C	X		* Library Object?
		GOYES	LibBakPack
		ST=0	LibOb
		LC(2)	=DOBAK		* #02B62
		?A=C	X		* Backup Object?
		GOYES	LibBakPack
		GOTO	VarsDone
*****************************************
* D0=	->Lib/Bak
* D1=	->$vars
* B.A=	Free RAM
* D.A=	#obs
*****************************************
LibBakPack	B=B-1	A		* Alloc Object's fields
		GONC	+
		GOTO	$Error

+		C=0	A
		DAT1=C	X		* Clear SELECTION Field
		D1=D1+	3

		AD0EX
		D0=A			* D0 ->Lib/Bak
		A=A+CON	A,10
		DAT1=A	A		* Write ->NAME
		D1=D1+	5

		?ST=1	LibOb		* Library Object?
		GOYES	TypePack
		D0=A			* D0 ->Backup_Name
		GOSBVL	=TRAVERSE+	* D0 ->Object
TypePack	GOSUB	F48GetObType
		DAT1=C	B		* Write #Type
		D1=D1+	2

		CD0EX
		D0=C
		D=C	A		* Save ->Lib
		GOSBVL	=SKIPOB		* D0 ->nxt_Lib/Bak
		CD0EX
		D0=C
		C=C-D	A
		DAT1=C	A		* Write SIZE (Nibbs)
		D1=D1+	5

		C=D	A
		DAT1=C	A		* Write ->LIB/BAK address
		D1=D1+	5
		?ST=0	LibOb		* Backup?
		GOYES	+
		GOTO	LibBakLoop
+		D0=D0+	5+5		* D0 ->nxt_Lib/Bak (skip CRC bint)
		GOTO	LibBakLoop
*****************************************
		STITLE	Library Vars Search Engine
* R1.A	->Hash_Table offsets
* R2.A	->Link_Table offsets
*****************************************
LibEngine	D0=A			* ->LIB
		D0=D0+	10		* ->Name
		GOSBVL	=TRAVERSE+	* skip Name
		D0=D0+	3+5+5		* ->Link_offset
		A=DAT0	A
		CD0EX
		D0=C
		A=A+C	A
		A=A+CON A,10		* skip prlg + size
		R2=A			* R2.A= ->Link_Table offsets
		D0=D0-	10		* ->Hash_offset
		C=DAT0	A
		?C=0	A		* No Hash Table?
		GOYES	CmdEnd
		AD0EX
		A=A+C	A
		D0=A			* ->Hash_table
		D0=D0+	5
		C=DAT0	A
		C=C+CON A,5
		C=C+A	A
		D=C	A		* Save Hash_Table end
		C=0	A
		LC(2)	18*5		* skip offsets by Name Lenght
		C=C+A	A
		D0=C			* ->Names Area
		A=DAT0	A
		CD0EX
		C=C+A	A
		R1=C			* R1.A ->Hash_Table offsets
		D=D-C	A
		C=D	A
		GOSBVL	=DIV5
		D=C	A		* for loop counter

ComandsLp	D=D-1	A
		GONC	+
CmdEnd		GOTO	VarsDone
+		B=B-1	A		* Alloc Command's Fields
		GONC	+
		GOTO	$Error
+		C=0	A
		DAT1=C	X
		D1=D1+	3		* Clear SELECTION Field

		C=R1
		D0=C			* ->Hash_offset
		C=C+CON A,5
		R1=C			* ->nxt_name offset
		C=DAT0	A
		AD0EX
		A=A-C	A
		DAT1=A	A		* Write ->NAME address
		D1=D1+	5
		C=R2
		D0=C			* ->Link_offset
		C=C+CON A,5
		R2=C			* ->nxt_Link offset
		C=DAT0	A
		AD0EX
		C=C+A	A
		D0=C			* D0 ->OBJ
		RSTK=C			* Save ->OBJ
		GOSUB	F48GetObType
		DAT1=C	B		* Write #Type
		D1=D1+	2

		GOSBVL	=SKIPOB
		C=RSTK			* Restore ->OBJ
		AD0EX
		A=A-C	A
		DAT1=A	A		* Write SIZE
		D1=D1+	5

		DAT1=C	A		* Write ->OBJ
		D1=D1+	5
		GOTO	ComandsLp
    ENDCODE
*****************************************
    TOTEMPOB

    FalseTrue		( quit?, downEnter? )
    FOURTEEN PICK
    LENCOMP #6 #/
    SWAP #0=?SKIP #1+	( pageMax )
    ONEFALSE		( page, updir? )
    NULL$ DUPZERO	( $dirs, $vars, port )
    DUP'		( $path, ->ID to Stack )
    ID F48F
    RclHiddenVar ITE INCOMPDROP
    ::
      $ ""			( Ensure a $ not a Pointer: NULL$ )
      THIRTYFOUR NDUPN {}N	( build portLabs )
      #TWO#ONE			( sortBy@, dispMode@ )
      TWO			( statusMode@ )
     ;

    DUP#0=ITE SEVEN EIGHT	( maxFiles )
    ZEROZEROZERO		( n, max, index )
    ZEROZEROZERO		( min, dy, barH )
    ROMPTR 101 3		( miniFont )
    FalseFalse			( inTree?, libOb? )
    TrueFalse			( dirOb?, portMod? )
    FalseTrue			( refresh?, reload? )
    ' NULLLAM THIRTYNINE NDUPN DOBIND

    TOADISP	( To Text Disp )
    REDISPHBUFF	( Window -> #0 #0 )
    RSZVDISP	( Set Std Size )

  BEGIN
    reload? IT
    ::
      inTree? IT F48SwapLocals

      ::
	( Library Mode? )
	libOb? case $path@

	( Dir Mode? )
	dirOb? case
	::
	  context@ DUP HOMEDIR? casedrop "HOME"
	  NULL$SWAP
	  NULLID
	  BEGIN
	    ID>$ CHR \\ >H$
	    ROT &$SWAP
	    port@
	    portMode?
	    CODE
		GOLONG	F48GetUpDir
	    ENDCODE
	  NOT_UNTIL
	  ID>$ DUPNULL$?
	  ITE :: DROP CDR$ ;
	      SWAP&$
	  portMode? NOT?SEMI
	  port@ #>$ CHR_: >T$ SWAP&$
	 ;

	port@ #>$
	CHR_: >T$
	prtLabels@ port@ #1+ NTHCOMPDROP
	&$
       ;

      $path!

      TrueFalse reload! refresh!
      NULL$ $vars!
      GARBAGE

      context@
      $types@
      port@
      dirOb?
      libOb?
      portMode?

      F48Safe$Vars	( Generate -> $vars n )
      n!		( save #Files )

      ( Write Port Memory? )
      portMode? ?SKIP 2SKIP
      port@
      CODE
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		?A=0	A
		GOYES	+
		GOSUBL	PortMem
		C=DAT1	A
		D1=C			* ->$Vars
		D1=D1+	30
		DAT1=A	A
+		GOVLNG	=GETPTRLOOP
      ENDCODE

*****************************************
*		SORT-ENGINE
*
* Hoare's UltraFast Quick-Sort Algorithm.
* Written by Tamir Demri for Reals.
* Highly Optimized for Filer48 by Raul.
*
* 1:	$vars -> $vars' (sorted)
*
* R0.W= ->$stack
* R3.A= ->Last_Ob
* R4.A= ->$stack (Current Recursion Level)
*****************************************
CODE

TypeSort	EQU 0	Sort by Type?
NameSort	EQU 1	Sort by Name?
Carry		EQU 2	Carry Set?
Reverse		EQU 3	Reverse Order?
LAMsortBy	EQU 17

		STITLE	Quick-Sort Engine

ML-Sort!	GOSBVL	=DisableIntr
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		D0=D0+	15		* ->#Obs_Field
		C=DAT0	A
		?C#0	A		* No Files?
		GOYES	+
		GOTO	QSEnd!
+		D0=(5)	=TEMPENV
		A=DAT0	A
		C=0	A
		LC(2)	(LAMsortBy)*10+5
		A=A+C	A
		D0=A			* -> &LAMsortBy
		A=DAT0	A
		D0=A			* -> bint
		D0=D0+	5
		A=DAT0	A		* A.A= sortBy#

* Now adjust Flags according to Sort Method.

		CLRST
		LC(1)	4
		?A<C	P
		GOYES	+
		ST=1	Reverse
		A=A-CON	A,4
+		?A#0	P
		GOYES	+
		GOTO	QSReverse
+		A=A-1	A
		?A#0	P
		GOYES	+
		ST=1	NameSort
		GONC	Make$stack
+		A=A-1	A
		?A#0	P
		GOYES	Make$stack
		ST=1	TypeSort

* Allocate (#obs)*10 Nibbs for $Stack,
* used to save the Return Pointers.

Make$stack	A=DAT1	A
		D1=A
		D1=D1+	15		* ->#obs_Field
		A=DAT1	A
		C=A	A
		C=C+C	A
		C=C+C	A
		C=C+A	A		* (#obs)*5
		GOSBVL	=MAKE$		* Alloc #n*10 Nibbs

* Sort the Objects!!!

		A=DAT1	A		* ->$vars
		AD0EX			* D0 ->#Obs_Field
		D1=A			* D1 ->$stack
		D0=D0+	15		* ->#Obs_Field
		C=DAT0	A		* C.A= #obs
		GOSUB	IntMult20	* C.A= (#obs)*21

* Make D0 ->Field, according to Sort Method.

		D0=D0+	23		* D0 ->Name_Field
		?ST=1	NameSort
		GOYES	>Last_Ob

		D0=D0+	5		* D0 ->Type_Field
		?ST=1	TypeSort
		GOYES	>Last_Ob

		D0=D0+	2		* D0 ->Size_Field

>Last_Ob	AD0EX
		D0=A
		A=A+C	A		* A.A ->Last_Ob
		GOSUB	QuickSort
*****************************************
* Inverts the order of $vars objects!
*****************************************
QSReverse	?ST=0	Reverse
		GOYES	QSEnd!
		GOSBVL	=D0=DSKTOP
		C=DAT0	A
		D0=C
		D0=D0+	15		* D0 ->#Obs_Field
		C=DAT0	A
		D=C	A		* D.A= #obs
		GOSUB	IntMult20	* C.A= (#obs)*20
		D0=D0+	23		* D0 ->Name_Field
		AD0EX
		D0=A
		A=A+C	A
		D1=A			* D1 ->Slot after Last_Ob
		DSRB.F	A		* D.A= (#obs)/2

* Swap Objects from both Sides until middle.

QSReverseLp	D=D-1	A		* D.A= Loop - 1
		GOC	QSEnd!
		D1=D1-	20
		GOSUB	QSSwap17+
		D0=D0+	20
		GONC	QSReverseLp
QSEnd!		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP
*****************************************
* Swaps two Files inside $vars.
* The Fields to swap take 18 Nibbs.
* The Selection Field is ignored because
* it's the Same for all Files.
*
* In:	D0->Ob1   D1->Ob2
* Out:	D0->Ob2   D1->Ob1 (Data Swaped!)
*
* There is a Swap Routine special for
* each Sort Method (Faster!!!).
*****************************************
QSSwap		?ST=1	NameSort	* Name Sort?
		GOYES	QSSwap17+

		?ST=0	TypeSort	* Size Sort?
		GOYES	QSSwap17-

* Optimized Swap Routine for Type Sort

QSSwapType	A=DAT0	12		* Swap: Type, Size, ->OB Fields
		C=DAT1	12
		DAT0=C	12
		DAT1=A	12
		D0=D0-	5
		D1=D1-	5
		A=DAT0	A		* Swap: ->Name Field
		C=DAT1	A
		DAT0=C	A
		DAT1=A	A
		D0=D0+	5
		D1=D1+	5
		RTNCC

* Optimized Swap Routine for Name Sort

QSSwap17+	A=DAT0	W		* Swap: ->Name and Type Fields
		C=DAT1	W
		DAT0=C	W
		DAT1=A	W
		D0=D0+	16
		D1=D1+	16
		A=DAT0	P		* Swap: Size and ->OB Fields
		C=DAT1	P
		DAT0=C	P
		DAT1=A	P
		D0=D0-	16
		D1=D1-	16
		RTNCC

* Optimized Swap Routine for Size Sort

QSSwap17-	A=DAT0	10		* Swap: Size and ->OB Fields
		C=DAT1	10
		DAT1=A	10
		DAT0=C	10
		D0=D0-	7
		D1=D1-	7
		A=DAT0	7		* Swap: ->Name and Type Fields
		C=DAT1	7
		DAT1=A	7
		DAT0=C	7
		D0=D0+	7
		D1=D1+	7
		RTNCC
*****************************************
* Sorts the Objects between the start
* and End addresses.
* Arguments:
* D0 ->First_Ob			(start address)
* D1 ->$Stack
* A.A= ->Slot after Last_Ob	(end address)
*****************************************
QuickSort	C=RSTK
		DAT1=C	A		* Save RETURN Address in $stack
		D1=D1+	5
		CD0EX
		D0=C
		DAT1=C	A		* Save ->First_Ob Addr in $stack
		D1=D1+	5

		C=A-C	A		* C.A= Nibbs between: Last-First
		R3=A.F	A		* R3.A= ->Last_Ob
		AD1EX			* D1 ->Last_Ob
		R4=A.F	A		* R4.A= ->$stack

		GOSBVL	=DIV5
		CSRB.F	A
		CSRB.F	A		* C= #Obs to sort ~ (Nibbs Between)/20

*		?C=0	A
*		GOYES	QSPopStkRTN
		C=C-1	A		* N-1
		A=0	A
		A=A+1	A		* A.A= 1
		?C>A	A		* More than 2 Objects?
		GOYES	QS#Obs>2
*****************************************
* We have only 2 Objects,
* compare them swap? and Return
*****************************************
		?C=0	A		* Only 1 Object?
		GOYES	QSPopStkRTN
		D1=D1-	20
		A=DAT1	A
		C=DAT0	A
		GOSUB	A>=C?		* Last_Ob >= First_Ob?
		GOC	QSPopStkRTN
		GOSUB	QSSwap
QSPopStkRTN	GOSUB	QSPopStk	* Pop address into C.A
		D0=C			* Restore D0->First_Ob
		GOTO	QSReturn
*****************************************
* Multiplicate Integer by 20
* In:	C.A= Integer
* Out:	C.A= (Integer)*20
*****************************************
IntMult20	A=C	A
		C=C+C	A
		C=C+C	A		* C[A]= (int)*4
		ASL	A		* A[A]= (int)*16
		C=C+A	A		* C[A]=  4 + 16 = (int)*20
		RTN
*****************************************
* Set Partition Element as
* arbitrary midpoint of First & Last
*****************************************
QS#Obs>2	D=C	A
		CSRB.F	A		* C.A= (#obs-1)/2 = Middle
		GOSUB	IntMult20	* C.A= (Middle)*20
		AD0EX			* Save D0
		C=C+A	A
		D0=C			* D0 ->Middle_Ob
		C=DAT0	A
		D0=A			* Restore D0
		GOTO	QSReadOb
*****************************************
* Find first Element > Partition Element,
* starting from Left->
*****************************************
QSLeft->Lup	D=D-1	A
		GOC	QSContinue
		D0=D0+	20
QSReadOb	A=DAT0	A
		GOSUB	A>=C?		* First_Ob >= Middle_Ob?
		GONC	QSLeft->Lup
*****************************************
* Find first Element <= Partition Element,
* starting from <-Right
*****************************************
		A=C	A		* A.A= Middle_Ob
QS<-RightLup	D=D-1	A
		GOC	++
		D1=D1-	20
		C=DAT1	A
		GOSUB	A>=C?		* Middle_Ob >= Last_Ob?
		GONC	QS<-RightLup
		B=A	A		* Save Middle_Ob
		GOSUB	QSSwap
		C=B	A		* Restore Middle_Ob
		GONC	QSLeft->Lup
*****************************************
QSContinue	D0=D0+	20
++		A=R3.F	A		* Restore A.A= ->Last_Ob
		C=R4.F	A
		D1=C			* Restore D1->RTNaddress
		GOSUB	QuickSort
		AD0EX
		GOSUB	QSPopStk
		D0=C			* Restore D0 ->First_Ob
		GOSUB	QuickSort
QSReturn	GOSUB	QSPopStk	* Pop address into C.A
		PC=C			* Return there...
*****************************************
QSPopStk	C=R4.F	A		* Get ->$stack
		C=C-CON	A,5
		R4=C.F	A		* update ->$stack
		D1=C			* D1= ->$stack
		C=DAT1	A		* Pop Address
		RTN
*****************************************
* Compares two Fields:  Field1 >= Field2?
*
* In:	A.A= Field1	C.A= Field2
* Out:	CS= if >=		CC= if <
*****************************************
A>=C?		?ST=1	NameSort
		GOYES	ID1>=ID2?

		?ST=0	TypeSort
		GOYES	+
		?A>=C	B
		RTNYES
		RTN

+		?A>=C	A
		RTNYES
		RTN

* Name at D0 >= than Name at D1?
* Uses:	A,B,C,D,D0,D1, & 5 RSTK

ID1>=ID2?	RSTK=C			* Save C.A
		CD1EX			* D1 ->Name2
		RSTK=C			* Save D1
		C=A	A
		RSTK=C			* Save A.A
		CD0EX			* D0 ->Name1
		RSTK=C			* Save D0
		C=D	A
		RSTK=C			* Save D.A

		C=DAT1	B
		C=C-1	B
		GOC	CmpOk
		D=C	B		* D[B]= Name2 Counter

		A=DAT0	B
		A=A-1	B
		GOC	CmpFail
		B=A	B		* B[B]= Name1 Counter

nxtChar		D0=D0+	2
		D1=D1+	2
		A=DAT0	B
		C=DAT1	B
		?A>C	B
		GOYES	CmpOk
		?A<C	B
		GOYES	CmpFail
		D=D-1	B
		GONC	+
*****************************************
CmpOk		ST=1	Carry
		GOC	GetPtrRTN
*****************************************
+		B=B-1	B
		GONC	nxtChar
CmpFail		ST=0	Carry
*****************************************
GetPtrRTN	C=RSTK
		D=C	A		* Restore D.A
		C=RSTK
		D0=C			* Restore D0
		C=RSTK
		A=C	A		* Restore A.A
		C=RSTK
		D1=C			* Restore D1
		C=RSTK			* Restore C.A

		?ST=1	Carry		* Carry Set?
		RTNYES
		RTN
ENDCODE
************ SORT-ENGINE END ************
      $vars!
      ::
	updir? case
	::
	  prevContext@
	  ZEROFALSE updir! prevContext!	( Free the Object! )
	  $vars@

*****************************************
* $Vars Updir Position Finder.
* 2: Obj or <Obj>
* 1: $vars	->	#Pos
*****************************************
	  CODE
		STITLE	UpDir-Pos Finder

		GOSUB	PopArgs
		D1=D1+	5		* ->#Obs_Field
		C=DAT1	A
		D=C	A		* D.A= #Obs
		D1=D1+	15		* ->MEM_Field
		A=0	A		* init offset Counter
nxtDirptr	D=D-1	A
		GOC	push#1
		A=A+1	A
		D1=D1+	20
		C=DAT1	A
		?C#B	A		* Not This Object?
		GOYES	nxtDirptr
		GONC	push#
push#1		A=0	A		* Not found!
		A=A+1	A
push#		GOVLNG	=PUSH#ALOOP	* Push DIR/LIB offset
*****************************************
* Pop Some Arguments:
* B= ->Context / Port#
* D1= ->String (after Header)
*****************************************
PopArgs		A=DAT1	A
		R0=A			* Save String!
		D1=D1+	5		* DROP Level 1
		D=D+1	A
		GOSBVL	=PopASavptr
		D0=A
		LC(5)	=DOBINT
		B=C	A
		C=DAT0	A
		?B#C	A		* Not a BINT?
		GOYES	+
		D0=D0+	5
		A=DAT0	A
+		B=A	A		* B.A= Context / Port#
		A=R0			* A.A= ->String
		D1=A			* D1 ->String
		D1=D1+	10		* Skip String's Header
		RTN
*****************************************
	  ENDCODE
	  index!

ASSEMBLE
_F48IndexCenter
RPL
	  ::
	    ONE min!
	    n@ maxFiles@ #>ITE
	    ::
	      maxFiles@ index@ #MAX
	      DUP maxFiles@ #1-- min!
	     ;
	    n@

	    max!
	   ;
	 ;

	ONEONE min! index!
	maxFiles@ n@ #MIN max!
       ;

ASSEMBLE
_F48SliderCalc
RPL
      ::
	n@ maxFiles@ #1+ #< ?SEMI

	n@ UNCOERCE
	maxFiles@ SEVEN #=ITE % 40 % 46
	DUP3PICK
	maxFiles@ UNCOERCE %T %OF
	%2 %MAX
	DUP COERCE barHeight!
	%- SWAP maxFiles@ UNCOERCE %- %/ dy!
       ;

      dispMode@ #0<> ?SEMI	( NOT Explorer Mode? )
      $dirs@ NULL$?		( Reload $dirs ? )
      NOTcase :: inTree? IT F48SwapLocals ;

ASSEMBLE
_F48LoadTree
RPL
      ::
	F48SwapLocals	( Get $dirs Locals )
	F48MakeTree	( Rebuild $dirs )
	F48IndexCenter
	F48SliderCalc
	F48SwapLocals	( Restore $vars Locals )
       ;
      inTree? IT
      F48SwapLocals	( Restore $dirs Locals )
     ;	( Fin-Reload? )

    refresh?
    IT
    ::
      FALSE refresh!
      F48StatusDraw

      ( We Display the Files first! )
      ::
	inTree? IT F48SwapLocals

	index@ ZERO
	inTree? ITE index! DROP
	F48FilesDraw
	index!

	inTree? FALSE inTree!

ASSEMBLE
_F48SafeSlider
RPL
	::
	  n@ maxFiles@ #>case

ASSEMBLE
_F48Slider
RPL
	  ::
	    dy@ min@ #1- UNCOERCE %* COERCE	( Y Pos )
	    barHeight@				( Bar Height )
	    statusMode@				( statusMode )
	    inTree?
	    3API?
	    CODE

inTree		EQU 2
TreeAPI		EQU 1

		STITLE	Slider Display Engine
		CLRST
		GOSBVL	=popflag
		GONC	+
		ST=1	TreeAPI
+		GOSBVL	=popflag
		GONC	+
		ST=1	inTree
+		GOSBVL	=POP#
		?ST=1	TreeAPI
		GOYES	+
		?A#0	A
		GOYES	+
		ST=1	FullStatus

+		GOSBVL	=POP2#		* A.A= statusMode
		R0=A			* R0.A= Y pos
		R1=C			* R1.A= vertHeight
		GOSBVL	=SAVPTR

* Bug Fix for n=32

		C=0	A
		LC(2)	42-1
		?ST=1	FullStatus	* Full Status?
		GOYES	+
		LC(2)	48-1
+		R2=C			* R2.A= BarSize
		D=C	A		* B.A= vertHeight Safe Counter

* Prepare D1 ->offset in Screen (fast version)

		LC(5)	15*34-2
		?ST=1	FullStatus	* Full Status?
		GOYES	+
		LC(5)	9*34-2
+		D1=(5)	#8068D
		A=DAT1	A
		A=A+C	A		* Skip Status Lines - 2 nibbs
		D1=A			* ->Disp, just for Slider!
		?ST=0	inTree
		GOYES	start
		D1=D1-	16		* ->Middle Slider Bar!

* Start drawing:  frame, blank space and bar!

start		GOSUB	1Black		* Write Top Line
		A=R0
		B=A	A		* B.A= Y pos
		?A=0	A		* Bar at Top?
		GOYES	+		* yep, no leading space
		A=A-1	A
		GOSUB	White		* Write leading blank space
+		A=R1
		A=A-1	A
		GOSUB	Black		* Write Bar

* Now compute & draw final white space

		C=R2
		C=C-1	A
		C=C-1	A		* BarSize - borders
		C=C-B	A
		A=R1
		C=C-A	A		* Final=BarSize-Y-vertHeight
		GOC	+		* just in case of underflow...
		A=C	A
		GOSUB	White		* Write final blank space
+		GOSUB	1Black		* Write bottom Line
SlideQuit	GOVLNG	=GETPTRLOOP
*********************************
* #5= 0101 pixels
* #7= 0111 pixels
*********************************
White		LCHEX	5
		GONC	BarLp
1Black		A=0	A
Black		LCHEX	7
BarLp		DAT1=C	P
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2		* D1 ->nextLine

		D=D-1	A		* If Bar Limit Exeeded?
		GOC	BadLimit	* Quit!

		A=A-1	A
		GONC	BarLp
		RTNCC

* Bugfix when Bar Limit Exceeded (n=32)

BadLimit	C=RSTK			* Pop Return Address
		GOC	SlideQuit	* and Quit!
	    ENDCODE
	   ;
	 ;

	inTree!

	inTree? IT F48SwapLocals

	dispMode@ #0<> ?SEMI		( Not in Windows Mode? )

	( Here We Display the Dirs )
	inTree? ?SKIP F48SwapLocals

	index@ ZERO
	inTree? ITE DROP index!
	F48DirsDraw
	index!

	inTree? TRUE inTree!
	n@ maxFiles@ #> ITE F48Slider
	::	( Display Vertical Line! )
	  maxFiles@ #6*
	  statusMode@
	  CODE
*		CLRST
		ST=0	FullStatus
		GOSBVL	=POP2#
		?C#0	A
		GOYES	+
		ST=1	FullStatus
+		GOSBVL	=SAVPTR
		B=A	A		* B.A= Loop Counter
		D0=(5)	=DISP1CTLg	* ->Display Address
		A=DAT0	A		* A.A= ->Display
		LC(5)	8*34+16
		?ST=0	FullStatus
		GOYES	+
		LC(3)	14*34+16
+		A=A+C	A
		D0=A			* ->Disp just for Line!
		LC(1)	2		* #2= 0010 pixels
LnLup		B=B-1	A
		GOC	LnQuit
		DAT0=C	P
		D0=D0+	34
		GONC	LnLup
LnQuit		GOVLNG	=GETPTRLOOP
	  ENDCODE
	 ;
	inTree!

	inTree? ?SKIP F48SwapLocals
       ;

      F48MenuDraw
     ;

ASSEMBLE
_F48GetKey
RPL
    ::
      GETKEY* ?SKIP DROP#131d

      BINT80h #=casedrop	( ALPHA )
      ::
	# 100
	SetAlphaAnn
	GETKEY* NOTcasedrop DROP#131d

	BINT40h
	OVER#=case
	::
	  #+
	  SetLeftAnn
	  GETKEY* NOTcasedrop DROP#131d
	  #+
	  ClrLeftAnn
	  ClrAlphaAnn
	 ;

	BINTC0h
	OVER#=case
	::
	  #+
	  SetRightAnn
	  GETKEY* NOTcasedrop DROP#131d
	  #+
	  ClrRightAnn
	  ClrAlphaAnn
	 ;

	#+
	ClrAlphaAnn
       ;

      BINT40h			( LEFT SHIFT )
      OVER#=case
      ::
	SetLeftAnn
	GETKEY* NOTcasedrop DROP#131d
	#+
	ClrLeftAnn
       ;

      BINTC0h			( RIGHT SHIFT )
      OVER#=case
      ::
	SetRightAnn
	GETKEY* NOTcasedrop DROP#131d
	#+
	ClrRightAnn
       ;
     ;


    ERRSET
    ::
      {}menu@
*****************************************
*	Hard Key Assignment Scanner
* 2: #Key
* 1: { Menu }	-> Ob True / False
*****************************************
      CODE

Internal	EQU 0	* Internal Call?

		GOSBVL	=PopASavptr
		D0=A			* ->List
		GOSBVL	=READ#
		R0=A			* R0.A= #ShortKey
		D0=D0+	5		* Skip DOLIST
		LC(5)	=SEMI
		B=C	A		* B.A= SEMI
KeyScanLp	A=DAT0	A
		?A=B	A		* List End Reached?
		GOYES	NotFound
		GONC	Sub-ListScan
ScanCont	GOSBVL	=SKIPOB
		GONC	KeyScanLp
*****************************************
NotFound	GOVLNG	=GPPushFLoop
*****************************************
Sub-ListScan	AD0EX
		R1=A			* R1.A= Save D0
		AD0EX
		LC(5)	=DOLIST
		?A#C	A
		GOYES	Sub-ListDone
		D0=D0+	5
		LC(1)	2
		GOSUB	SkipNobs	* ->Action_Item
		GOSUB	A=VALUE		* A.A= Action_Item Value
		C=0	A
		LC(2)	37
		?A>C	A
		GOYES	Sub-ListDone
		ST=1	Internal
		LC(2)	16
		?A<C	A
		GOYES	GetShortKey
		LC(2)	23
		?A>C	A
		GOYES	GetShortKey
		ST=0	Internal
GetShortKey	LC(1)	1
		?ST=1	Internal
		GOYES	+
		LC(1)	2
+		GOSUB	SkipNobs	* ->ShortKey Item
		GOSUB	A=VALUE
		C=R0
		?A#C	A
		GOYES	Sub-ListDone
*****************************************
		GOSBVL	=GETPTR
		A=R1
		DAT1=A	A		* OverWrite List_Item!
		GOVLNG	=PushTLoop
*****************************************
Sub-ListDone	A=R1
		D0=A			* Restore D0
		GOTO	ScanCont
*****************************************
* Skips N Objects in D0
*****************************************
SkipNobs	D=C	P
SkipNLp		A=DAT0	A
		?A=B	A		* List End?
		GOYES	Invalid
		D=D-1	P
		RTNC
		GOSBVL	=SKIPOB
		GONC	SkipNLp
*****************************************
Invalid		C=RSTK			* Drop Return Address
		GOTO	Sub-ListDone
*****************************************
A=VALUE		D1=A			* ->Value to Read
		A=DAT1	A
		LC(5)	=PRLG
		?A#C	A		* Object Pointer?
		GOYES	+
		AD0EX
		D0=A
		D1=A			* D1-> Object
+		A=DAT1	A
		D1=D1+	5
		LC(5)	=DOBINT
		?A=C	A
		GOYES	ReadVal
		LC(3)	=DOHSTR
		?A#C	A		* Hex Number?
		GOYES	Invalid
		D1=D1+	5		* Skip Size Field
ReadVal		A=DAT1	A
		RTN
      ENDCODE
      case F48ItemEval

      DUP#<7 case 		( Menu_Labels )
      ::
	page@ #1- #6* #+
	{}menu@
	SWAP NTHELCOMP NOT?SEMI
	DUPTYPELIST? NOTcasedrop INVFUNCERR
	DUPNULL{}? caseDROP

ASSEMBLE
_F48ItemEval
RPL
	::
	  DUP THREE NTHELCOMP NOTcasedrop INVFUNCERR
	  DUP3PICK TWO NTHCOMPDROP
	  ::
	    CK&DISPATCH2
	    #1F1F NOP		( 2 bints )
	    2HXS 2HXS>#		( 2 hex	  )
	   ;

	  inTree?
	  F48Mode?OK
	  NOTcase2DROP
	  F48#EVAL
	 ;
       ;

*****************************************
* KEY HANDLER:
* 1:	#KeyCode ->
* Dispatches the given #KeyCode, we have
* an Offset for each available Shortkey.
*****************************************
      CODE
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		GOSUB	->KeyTable
KeyStart	CON(3)	11
		REL(4)	_F48KeyUp
		CON(3)	17
		REL(4)	_F48KeyDown
		CON(3)	25
		REL(4)	_F48KeyEnter
		CON(3)	18
		REL(4)	_F48DOWNDIR
		CON(3)	16
		REL(4)	_F48UPDIR
		CON(3)	#4B
		REL(4)	_F48PAGEUP
		CON(3)	#51
		REL(4)	_F48PAGEDOWN
		CON(3)	#CB
		REL(4)	_F48MAXUP
		CON(3)	#D1
		REL(4)	_F48MAXDOWN
		CON(3)	9
		REL(4)	_F48CST
		CON(3)	#C9
		REL(4)	_F48SWAPHEADER
		CON(3)	10
		REL(4)	_F48LIST
		CON(3)	12
		REL(4)	_F48NXTMENU
		CON(3)	#4C
		REL(4)	_F48PREVMENU
		CON(3)	#D0
		REL(4)	_F48TREE
		CON(3)	#CE
		REL(4)	_F48RCL
		CON(3)	15
		REL(4)	_F48EVAL
		CON(3)	28
		REL(4)	_F48PURGE
		CON(3)	45
		REL(4)	_F48QUIT
		CON(3)	46
		REL(4)	_F48Key0
		CON(3)	#ED
		REL(4)	_F48Off
		CON(3)	#1D		* Drop Key
		REL(4)	_F48QuitHere
		CON(3)	#59
		REL(4)	_F48Equation
		CON(3)	#D9
		REL(4)	_F48Matrix
		CON(3)	#CD
		REL(4)	_F48Home
		CON(3)	#2F
		REL(4)	_F48Key.
* SORT - Shortcuts
		CON(3)	#D		* [']
		REL(4)	_F48Hidden
		CON(3)	#E		* N
		REL(4)	_F48NameSort
		CON(3)	#13		* S
		REL(4)	_F48SizeSort
		CON(3)	#14		* T
		REL(4)	_F48TypeSort
		CON(3)	#15		* U
		REL(4)	_F48Original
		CON(3)	#4E		* LS+N
		REL(4)	_F48NameRev
		CON(3)	#53		* LS+S
		REL(4)	_F48SizeRev
		CON(3)	#54		* LS+T
		REL(4)	_F48TypeRev
		CON(3)	#55		* LS+U
		REL(4)	_F48OrigRev
* SELECT - Shotcuts
		CON(3)	#101		* [Alpha]+A
		REL(4)	_F48SelAll
		CON(3)	#109		* [Alpha]+I
		REL(4)	_F48SelInv
		CON(3)	#10E		* [Alpha]+N
		REL(4)	_F48SelNone
* I/O - Shortcuts
		CON(3)	#E9		* [RS]+1
		REL(4)	_F48LINK
		CON(3)	#112		* [Alpha]+R
		REL(4)	_F48RECV
		CON(3)	#113		* [Alpha]+S
		REL(4)	_F48SEND
* Misc - Shortcuts
		CON(3)	#103		* [Alpha]+C
		REL(4)	_F48COPY
		CON(3)	#10D		* [Alpha]+M
		REL(4)	_F48MOVE
		CON(3)	#11B		* [Alpha]+Z
		REL(4)	_F48ZIP
		CON(3)	#50		* [LS]+PICTURE
		REL(4)	_F48PrintDisp
		CON(3)	#83		* Alarm/Sleep Event!
		REL(4)	_F48QUIT


->KeyTable	C=RSTK
		D0=C
		C=0	A
		LC(2)	((->KeyTable)-(KeyStart))/7
		B=C	A
KeyLup		B=B-1	A
		GOC	KeyLpQuit
		C=DAT0	X
		?A=C	X
		GOYES	KeyEval
		D0=D0+	7
		GONC	KeyLup

KeyLpQuit	GOVLNG	=GETPTRLOOP

KeyEval		D0=D0+	3
		C=DAT0	4
		AD0EX
		C=C+A	A
		GOVLNG	=GETPTREVALC
*		A=A+C	A
*		GOVLNG	=GPPushALp
      ENDCODE
*      DUPTYPECOL? case EVAL
     ;
    ERRTRAP
    ::
      TOADISP
      stackDepth@ RESETDEPTH
      ERROR@ DUP#0=csDROP
      JstGETTHEMSG

      ZEROZERO FOURTEEN BLANKIT
      TWELVE LineGrob XYGROBDISP
      ERRBEEP
      ZEROZEROZERO "Error:" F48$>miniFont XYGROBDISP
      SIX ROT F48$>miniFont XYGROBDISP
      TRUEreload!
      ClrDA1IsStat
      WaitForKey 2DROP
     ;
  quit?
  UNTIL

  ( Save Options )
    prtLabels@
    sortBy@
    dispMode@
    statusMode@
    FOUR ::N
    ' ID F48F StoHiddenVar
    ABND
   ;
  ERRTRAP
  ::
    'REVAL
    ERRJMP
   ;
  ::
    1GETLAM DEPTH 1PUTLAM
    COMPEVAL
    1GETABND #1- RESETDEPTH
    ClrDAsOK
   ;
 ;

 ;


ASSEMBLE
_F48Hidden
RPL
****************************
* Show/Hide Null-Named Vars
****************************
::
  SIX DUP
  TestUserFlag
  ITE ClrUserFlag
      SetUserFlag
  TRUEreload!
 ;

ASSEMBLE
_F48Original
RPL
:: ZERO F48Sort! ;

ASSEMBLE
_F48NameSort
RPL
:: ONE F48Sort! ;

ASSEMBLE
_F48TypeSort
RPL
:: TWO F48Sort! ;

ASSEMBLE
_F48SizeSort
RPL
:: THREE F48Sort! ;

ASSEMBLE
_F48OrigRev
RPL
:: FOUR F48Sort! ;

ASSEMBLE
_F48NameRev
RPL
:: FIVE F48Sort! ;

ASSEMBLE
_F48TypeRev
RPL
:: SIX F48Sort! ;

ASSEMBLE
_F48SizeRev
RPL
:: SEVEN F48Sort! ;


ASSEMBLE
_F48SelAll
RPL
:: ZERO F48Select! ;

ASSEMBLE
_F48SelInv
RPL
:: ONE F48Select! ;

ASSEMBLE
_F48SelNone
RPL
:: TWO F48Select! ;

ASSEMBLE
_F48PrintDisp
RPL
:: DOLCD> ;


ASSEMBLE
_F48Key0
RPL
::
  ZERO port!
  TrueTrue portMode! reload!
  FalseFalse dirOb! libOb!

ASSEMBLE
_F48DirCenter
RPL
  ::
    dispMode@ #0<> ?SEMI	( NOT in Explorer-Mode? )
    inTree? ?SKIP F48SwapLocals	( Get $dirs Locals? )
    portMode? ITE port@ :: context@ ;
    $dirs@
*****************************************
*	TREE Current DIR/PORT Finder
* 2: Context/Port#
* 1: $dirs -> #Index
*****************************************
    CODE
		GOSUBL	PopArgs
		C=DAT1	A
		D=C	A		* D.A= #Dirs
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A
		D0=A
		D0=D0+	10		* ->First Struct (-5)
		A=0	A
DirFindLp	D=D-1	A
		GOC	DFDone
		A=A+1	A
		D0=D0+	5		* next ->Struct
		C=0	A
		C=DAT0	B		* C.A= #Tokens
		AD0EX
		A=A+C	A		* Skip Tokens
		AD0EX			* ->DIR Pointer
		D0=D0+	2		* Skip #Tokens_Field
		C=DAT0	A		* C.A= ->DIR
		?C#B	A		* This Dir/Port ?
		GOYES	DirFindLp
DFDone		GOVLNG	=PUSH#ALOOP
    ENDCODE
    index!
    F48IndexCenter
    inTree? ?SEMI F48SwapLocals	( Restore $vars Locals? )
   ;
 ;



ASSEMBLE
_F48Off
RPL
CODE
*****************************************
		GOSBVL	=SAVPTR
		GOSBVL	=DisableIntr	* Turn Off Interruptions...
		GOSBVL	=clrbusy
		GOSBVL	=DispOff
OffLup		SHUTDN
		GOSUB	ON_Down?
		GONC	OffLup
		GOSBVL	=DispOn
-		GOSUB	ON_Down?
		GOC	-
		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP
*****************************************
ON_Down?	GOVLNG	=OnKeyDown?
*****************************************
ENDCODE
*::
*  TurnOff
* ;



ASSEMBLE
_F48QuitHere
RPL
::
  PATHDIR ' LAM Pth STOLAM
  TRUE quit!
 ;



ASSEMBLE
_F48Equation
RPL
::
  ' DoNewEQ
  "NEWEQ"

ASSEMBLE
_F48NewEq/Mat
RPL
  ::
    palparse DROP
    DUPTYPEROMP? IT SWAP
    DROPTRUE refresh!

    DEPTH 1LAMBIND
    EVAL
    DEPTH 1GETABND
    #<> ?SEMI

    "Enter Name:"
    NULL$
    F48Input NOT?SEMI
    F48ParseName
    F48Store
   ;
 ;



ASSEMBLE
_F48Matrix
RPL
::
  ' DoNewMatrix
  "NEWMAT"
  F48NewEq/Mat
 ;



ASSEMBLE
_F48Home
RPL
::
  HOMEDIR
  CONTEXT@ context!
  TrueTrue reload! dirOb!
  FalseFalse libOb! portMode!
  F48DirCenter
 ;



ASSEMBLE
_F48Key.
RPL
::
  TRUE refresh!
  statusMode@ #0=ITE FOURTEEN EIGHT
  FIFTYSIX OVER#- BLANKIT
  "Select a Port" BIGDISPROW2

  POLSaveUI	( *VERY IMPORTANT: Save User Interface BEFORE* )
  ERRSET
  ::
    ' :: TrueTrue 1PUTLAM ;
    FALSE' NULLLAM TWO NDUPN {}N BIND

** POL Parameters **
**Level 9
    ' DispMenu.1

**Level 8
    '
    ::
      DROP
      DUP#<7 casedrpfls
      FORTYFIVE ?CaseKeyDef
      :: TakeOver 2GETEVAL DROPFALSE ;  ( *Mark NOT on port* )

      TWELVE #=casedrpfls		( *Eventually NXT Key* )
      DROPDEADTRUE
     ;

**Level 6&7
    TrueTrue

**Level 5
    #ZERO#ONE

    THIRTYFOUR			( *G_maxport+1* )
    ONE_DO	(DO)
    ::
      INDEX@ DUP PORTSTATUS 2DROP
      case 3DROP
      DROP NOTcaseDROP
      SWAP#1+
     ;
    LOOP

    DUP1LAMBIND
    ZERO_DO
      1GETLAM ROLL
      DUP #:>$ CHR_: >H$
      ' TakeOver SWAP' MakeDirLabel
      THREE ::N

      ' TakeOver
      ROT ' 2GETEVAL
      THREE ::N
      TWO{}N
    LOOP
    1GETABND {}N

**Level 4&3&2
    ONEFALSE' 1GETLAM

**Level 1
    'ERRJMP
    POLSetUI POLKeyUI
    ABND
   ;
  ERRTRAP
    POLResUI&Err	( *Restore saved User Interface & ERRJMP* )
  POLRestoreUI		( *Restore saved User Interface* )

  NOT?SEMI
  port!
  TRUEreload!
  FalseFalse dirOb! libOb!
  TRUE portMode!
  F48DirCenter		( Show Current Port in Tree )
 ;



ASSEMBLE
_F48$>miniFont
RPL
::
  SIX OVERLEN$ FOUR #* MAKEGROB
  SWAP
  ROMPTR 101 3
*****************************************
* 3:	GROB W x 6	( Grob for $ )
* 2:	"string"
* 1:	Library Data	( MiniFont )
*****************************************
CODE
		STITLE	String -> miniFont
		A=DAT1	A		* A.A= ->miniFont
		A=A+CON A,10
		R0=A			* R0.A= ->Font_Data
		D1=D1+	5		* ->$
		D=D+1	A		* drop Library Data
		GOSBVL	=PopASavptr
		C=A	A
		A=DAT1	A		* A.A= -> GROB
		D0=A
		D0=D0+	15		* ->#Rows
		A=DAT0	A		* A.A= Rows
		GOSBVL	=w->W		* Convert Rows -> Nibbles
		B=A	A
		D0=D0+	5
		ST=0	invFont
		GOSUB	C$>miniFont
		GOVLNG	=GETPTRLOOP
ENDCODE
 ;



ASSEMBLE
_F48IndexDraw
RPL
********************************************
* Actualiza Objeto Index en Pantalla.
*
* 1:	index (new)	->
********************************************
::
  index@ DUP min@ #-+1 FALSE
  4ROLL DUPDUP index! min@ #-+1 TRUE
  F48FileDraw
  F48FileDraw
 ;



ASSEMBLE
_F48FilesDraw
RPL
::
  n@ #0=case
  ::
    miniFont@
    maxFiles@
    statusMode@
    dispMode@
*****************************************
* Displays "No Entries" and Wipes the
* rest of the Screen!
*
* 4: miniFont@
* 3: maxFiles@
* 2: statusMode@
* 1: dispMode@  ->
*****************************************
    CODE
		CLRST
		GOSBVL	=POP2#
		?C#0	A
		GOYES	+
		ST=1	Windows
+		?A#0	A
		GOYES	+
		ST=1	FullStatus
+		GOSBVL	=POP#
		R1=A			* R1.A= #maxFiles
		GOSBVL	=PopASavptr
		A=A+CON	A,10
		R0=A			* R0.A= miniFont
		A=0	A
		A=A+1	A
		GOSUBL	D0->Row1(A)
		?ST=0	Windows
		GOYES	+
		D0=D0+	17
+		GOSUB	noEntries
		NIBASC	\No Entries\
noEntries	C=RSTK
		D1=C
		C=0	A
		LC(1)	10
		GOSUB	D1>miniFont
		C=0	A
		LC(1)	6
		?ST=1	Windows
		GOYES	+
		LC(2)	23
+		GOSUB	F48WipeOut
		A=0	A
		A=A+1	A
		C=R1			* Restore #maxFiles
		ST=1	Files
		GOTO	Wipe!Bottom
    ENDCODE
   ;

  max@ #1+ min@
  DO
    INDEX@
    DUP min@ #-+1
    OVER index@ #=
*****************************************
*	FILER DISPLAY ENGINE
*
* Outputs directly to the Screen the
* nth element from $vars.
*
* 3:   #nthel (1-n)
* 2:	 #pos (1-8)
* 1:  Invert? (true/false)  ->
*****************************************
ASSEMBLE
_F48FileDraw
RPL
CODE

$Names		EQU 4	Are Names inside $vars?
Props		EQU 2	Display Properties?
wide1		EQU 26	Char Width if Props Disabled
wide2		EQU 13	Char Width if Props Enabled
LAM$vars	EQU 21

		STITLE	Filer Display Engine

File>Disp	ST=0	check		* Ensure to Display Full Line!
Check>Disp
		INTOFF
*		GOSBVL	=DisableIntr	* Interruptions Disabled!
		GOSUB	InitStatus	* Set Status Flags!

		C=0	A
		LC(2)	(LAM$vars)*10+5
		C=C+D	A
		D1=C
		C=DAT1	A		* C.A= ->$Vars

		D1=C
		D1=D1+	10		* ->$Vars Address Field
		A=DAT1	A
		?A=0	A		* Not in Covered Area?
		GOYES	AddressOK
		ST=1	$Names		* Names are inside $vars!
		?A=C	A		* $Vars in Same Place?
		GOYES	AddressOK

* Updates the ->Name pointers if $vars
* has moved due to a Garbage Collection.
* 1:	$vars ->

		DAT1=C	A		* Update $Vars Address!
		RSTK=C			* Save ->$Vars
		A=A-C	A		* A.A= Nibbs That $Vars moved
		D1=D1+	5
		C=DAT1	A		* C.A= #obs
		D1=D1+	3
		D=C	A		* D.A= Loop Counter
AdjustLup	D=D-1	A		* <-----+
		GOC	AdjustDone!	*	
		D1=D1+	20		*	
		C=DAT1	A		*	
		C=C-A	A		*	
		DAT1=C	A		*	
		GOTO	AdjustLup	* ------+

AdjustDone!	C=RSTK
		D1=C
		D1=D1+	10		* Skip Prolog + Size

AddressOK	D1=D1+	5		* ->#Obs_Field
		A=DAT1	A		* A.A= # Obs
		?A#0	A		* Any Files?
		GOYES	+
		GOTO	GetPtrLp3	* Quit Right Now!
+		C=0	A
		LC(1)	7
		?ST=1	FullStatus
		GOYES	+
		C=C+1	A		* C.A= 8
+		?A>C	A
		GOYES	+
		ST=1	Wide
+		D1=D1+	3
		A=R1			* A[A]= #nthel obj
		C=A	A
		C=C+C	A
		C=C+C	A		* C[A]= (#nth)*4
		ASL	A
		C=A+C	A		* C[A]= (#nthel)*20
		AD1EX
		A=A+C	A
		R1=A			* R1.A= ->Name_Field
		D1=A			* D1 ->Name_Field

* Finally Get Screen Address, taking
* into a count the Status Flags.

		GOSUB	D0->Row1(R2)	* D0 ->Disp
		?ST=0	Windows		* Not in Window Mode?
		GOYES	+
		D0=D0+	17

*****************************************
* If Selected write the Number
*****************************************
+		D1=D1-	3		* ->Sel_Field
		A=0	A
		A=DAT1	X
		?A#0	A		* Selected Ob?
		GOYES	+
		C=0	A
		LC(1)	3
		GOSUB	F48ClearOut
		GONC	CheckField
+		GOSUB	hxs->dec
		RSTK=C			* Save #Chars
		C=-C	A		* C's Two-Complement
		C=C+CON	A,3		* C= 3 - C
		GOSUB	F48ClearOut
		C=RSTK			* Restore #Chars
		GOSUB	#>grob
*****************************************
* If check flag is Set, then Quit.
* Optimized for F48ENTER
*****************************************
CheckField	?ST=0	check		* Display Full Line?
		GOYES	IconSet		* yep...
GetPtrLp2	GOTO	GetPtrLp3	* No! Quit here
*****************************************
* Now Draw Icon according to Object type
*****************************************
IconSet		C=R1.F	A
		D1=C
		D1=D1+	5		* ->Type Field
		C=0	A
		C=DAT1	B		* D.A= Object Type
		R3=C.F	A		* R3.A= Object Type
		D=C	A
		DSL	A		* *16
		D=D-C	A		* 16-1=15
		GOSUB	getIcons
		NIBHEX	E10FF7104104FF7		* dir
		NIBHEX	8014D34D7CD3411		* accptr
		NIBHEX	FC23236212A0E41		* alg
		NIBHEX	FF7984555326FF7		* aunit (DOEXT3)
		NIBHEX	EF3BD6154BD6E83		* bckup
		NIBHEX	A00F90A81F92A82		* bin (hex)
		NIBHEX	401212134252451		* bint
		NIBHEX	000616131151651		* char
		NIBHEX	E010C37D70C3C11		* code
		NIBHEX	870490410490870		* cmplx
		NIBHEX	0E12527502520E1		* ecmplx
		NIBHEX	0F12527D3251072		* ereal
		NIBHEX	FF7984555326FF7		* ext1 (DOEXT4)
		NIBHEX	F67194144104F57		* exter [?]
		NIBHEX	0F58228E0A20C10		* font (DOEXT2)
		NIBHEX	000365557555565		* gname
		NIBHEX	420A24FF71620A1		* grob
		NIBHEX	BD69849A4984BD6		* lnkarry
		NIBHEX	FF7984555326FF7		* libdat
		NIBHEX	000E73FF6FF6E73		* lib
		NIBHEX	603202104202603		* list
		NIBHEX	000165157155665		* lam
		NIBHEX	BD6984984984BD6		* array
		NIBHEX	C704904F0450C90		* real
		NIBHEX	000EF3FF7FF7EF3		* system RPL prog
		NIBHEX	5055050000008A0		* str
		NIBHEX	0002020002028F0		* tag
		NIBHEX	0040850548A0FA0		* unit
		NIBHEX	451A82505A82451		* user RPL prog
		NIBHEX	000EF3FF7FF7EF3		* romptr
		NIBHEX	575545020010070		* zip
getIcons	C=RSTK
		C=C+D	A
		CD0EX
		A=DAT0	15		* Read Icon
		D0=C			* Restore D0->Disp
		P=	16-5
		?ST=0	invFont
		GOYES	IconLup
		A=-A-1	W		* Invert the Icon!
IconLup		DAT0=A	X
		ASR	W
		ASR	W
		ASR	W
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		GONC	IconLup
		A=0	A
		?ST=0	invFont
		GOYES	+
		A=-A-1	A
+		DAT0=A	3		* Wipe line under Icon
		D0=C			* Restore D0
		D0=D0+	3		* D0 ->1st Nibble after Icon
*****************************************
* Put Object's Name
*****************************************
		C=R1.F	A
		D1=C			* ->Name_Field
		C=DAT1	A
		R2=C.F	A		* Save ->Name
		D1=C			* D1 ->Name
		C=0	A
		C=DAT1	B
		D=C	A		* D.A= save #chars
		?C#0	B
		GOYES	IdOk
		LC(2)	34
		A=C	A
		GOSUB	oneChar		* Write (") NULLID Name
		GONC	ClearSpace
IdOk		D1=D1+	2		* D1 -> chars
		LC(2)	9		* Name Max Length (Windows Style)
		?ST=1	Windows		* Windows Style?
		GOYES	ChkLen
		LC(2)	wide2		* Name Max Lenght (Props Enabled)
		?ST=1	Props		* Details?
		GOYES	ChkLen
		LC(2)	wide1		* Name Max Length (Props Disabled)
ChkLen		?D<=C	B		* Name lenght Ok?
		GOYES	+
		D=C	B		* Set Max Name lenght
+		GOSUB	nxtChrLp
*****************************************
ClearSpace	C=R2.F	A
		D1=C			* ->Name
		A=DAT1	B		* A[B]= #name Lenght
		?A#0	B
		GOYES	+
		A=A+1	B		* Ensure 1 char (")
+		C=0	A
		?ST=1	Props
		GOYES	F48Details
		LC(1)	9
		?ST=1	Windows
		GOYES	+
		LC(2)	wide1		* Nibbs to ClearOut
+		C=C-A	B
		GOC	ClrExit
		GOSUB	F48ClearOut
ClrExit		GOTO	FinalSpc?Lp
*****************************************
F48Details	LC(1)	(wide2)+1
		?A>=C	B
		GOYES	+
		C=C-A	B
		GONC	ClearOut
+		LC(2)	1
ClearOut	GOSUB	F48ClearOut
		A=R3.F	A		* Get Object Type
		LC(2)	LIBTYPE
		?A#C	B		* Not a Library?
		GOYES	NotLibType
*****************************************
* Write the Library's ID #
*****************************************
		D=0	A
		C=0	A
		LCASC	'L'
		A=C	A
		GOSUB	oneChar
		C=R1			* ->Name_Field
		CD0EX			* ->Name_Field
		D=C	A		* Save D0

		?ST=1	$Names
		GOYES	+

		D0=D0+	12		* ->Ob_Field
		C=DAT0	A
		D0=C			* ->Lib
		D0=D0+	10		* ->Name
		GONC	skpLName

+		C=DAT0	A
		D0=C			* ->Name

skpLName	GOSBVL	=TRAVERSE+	* skip Name
		A=0	A
		A=DAT0	X		* Read Lib#
		C=D	A
		D0=C			* Restore D0 ->Disp
		GOSUB	hxs->dec	* A[W]=decNumber, C.A=#chars
		R2=C			* Save #chars
		GOSUB	#>grob
		C=R2			* Recover #chars
		C=-C	A
		C=C+CON	A,4		* C.A= 4 - #chars
		GOSUB	F48ClearOut
		GOTO	PutObSize
*****************************************
* Write Normal Object Type
*****************************************
NotLibType	C=A	A
		A=A+A	A
		A=A+A	A
	A=A+C	A
		A=A+A	A		* A.A= * 10
		GOSUB	getTypes
		NIBASC	\DIR  ACPTRALG  AUNITBCKUPBIN  BINT \
		NIBASC	\CHAR CODE CPLX ECPLXEREALEXT1 EXTER\
		NIBASC	\FONT GNAMEGROB LARRYLBDATLIB  LIST \
		NIBASC	\LNAMEMATRXREAL SPROGSTRNGTAG  UNIT \
		NIBASC	\UPROGXLIB ZIP  \
getTypes	C=RSTK
		C=C+A	A
		D1=C			* D1 -> object Type "Chars"
		C=0	A
		LC(1)	5
		GOSUB	D1>miniFont
*****************************************
* Writes Object's Size in Bytes
*****************************************
PutObSize	C=R1.F	A
		D1=C			* ->Name_Field
		D1=D1+	7		* ->Size_Field
		A=DAT1	A		* A.A= Object Size (Nibbs)
		ASRB.F	A		* A.A= Object Size (bytes)
		GOSUB	hxs->dec	* A[W]=decNumber, C.A=#chars
		R3=C.F	A		* Save #chars
		C=C-CON	A,7
		C=-C	A
		GOSUB	F48ClearOut	* Clear space between Type & ObSize
		C=R3.F	A		* Recover #chars
		GOSUB	#>grob
FinalSpc?Lp	?ST=0	Wide
		GOYES	GetPtrLp3
		C=0	A
		LC(1)	1
		GOSUB	F48ClearOut	* Clear space after ObSize
*		GOSBVL	=AllowIntr	* Allow Interruptions!
GetPtrLp3	GOVLNG	=GETPTRLOOP
*****************************************
ENDCODE
  LOOP

  n@ maxFiles@
  TRUE		( Files? )
*****************************************
* Wipes Bottom Lines if n < maxFiles.
* It Assumes that all Filer Flags have
* been recovered (Windows, FullStatus..).
*
* 3: n@
* 2: maxFiles@
* 1: 3API?
*****************************************
  CODE
Wipe?Bottom	ST=0	Files		* Reset Flag
		GOSBVL	=popflag	* Read 3API Flag
		GONC	+		* Wipe Files?
		ST=1	Files
+		GOSBVL	=POP2#
		RSTK=C
		GOSBVL	=SAVPTR
		C=RSTK
		?A>=C	A
		GOYES	DispOK
Wipe!Bottom	C=C-A	A
		RSTK=C			* save #File_Lines to Wipe
		A=A+1	A
		GOSUB	D0->Row1(A)
		D1=C			* D1 ->Disp to Wipe
		C=0	A
		LC(2)	34
		?ST=1	Files
		GOYES	+
		LC(2)	16
		GONC	WipeSetup
+		?ST=0	Windows
		GOYES	WipeSetup
		D1=D1+	17
		LC(2)	16
WipeSetup	D=C	A
		LC(2)	34
		C=C-D	A
		R0=C			* R0.A= Nibbs for next Line
		C=RSTK			* Restore #File_Lines
		C=C+C	A		* 2*(#Lines)
		B=C	A
		B=B+C	A
		B=B+C	A		* B.A= 6*(#Lines)
		B=B-1	A		* -1 for carry lup
WipeLup		C=D	A
		GOSBVL	=WIPEOUT
		C=R0.F	A
		AD1EX
		A=A+C	A
		D1=A
		B=B-1	A
		GONC	WipeLup
DispOK		GOVLNG	=GETPTRLOOP
  ENDCODE
 ;



ASSEMBLE
*****************************************
* Write $ to Dest. using miniFont data.
* In:	D0 ->DESTINATION
*	C.A= ->$
* Out:
*	D0 ->DESTINATION after Font data.
*****************************************
C$>miniFont	GOSBVL	=GetStrLenC
D1>miniFont	D=C	A
nxtChrLp	D=D-1	A
		GONC	+
		RTNCC
+		A=0	A
		A=DAT1	B		* Read 1 char
oneChar		A=A+A	A
		C=R0.F	A		* C.A= Chars Font
		C=A+C	A
		C=A+C	A
		C=A+C	A
		CD0EX			* D1 -> Char Font data
		A=DAT0	6
		D0=C
		?ST=0	invFont
		GOYES	nxtLine
		P=	5
		A=-A-1	WP		* Invert the Char Font
		P=	0
nxtLine		DAT0=A	P
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		?P#	6
		GOYES	nxtLine
		P=	0
		D0=C
		D0=D0+	1
		D1=D1+	2
		GOTO	nxtChrLp
*****************************************
* Convert Hex to Dec.
* In:	A.A=	Hex Number
* Out:	A.A=	Dec Number
*	C.A=	#chars of Number
* Uses: A,C,D
*****************************************
hxs->dec	C=0	W
		C=C+1	A
		SETDEC
		D=0	W
toDecLp		SB=0			* <-----+
		ASRB.F	A		*	
		?SB=0			*	
		GOYES	+		*	 Convert # to Decimal
		D=D+C	W		*	
+		C=C+C	W		*	
		?A#0	A		*	
		GOYES	toDecLp		*	+
		C=D	W
		A=C	W
		SETHEX
		C=0	A
-		C=C+1	P		* <-----+
		ASRC			*	 Find out How many decimal #'s are they
		?A#0	A		*	
		GOYES	-		*	+
		RTN
*****************************************
* Write Decimal Number to ->Display.
* In:	D0 ->DISP
*	A.A= Dec Number
*	C.A= #chars of Number
* Uses:
*	A,C,D,R3, 1 RSTK
*****************************************
#>grob		R3=A			* R3= Save decimal #
#>grobLp	C=C-1	B
		RTNC
		RSTK=C			* Save loop counter
		C=R3
		CSLC
		R3=C			* update decimal #
		P=	1
		LC(1)	3
		P=	0
		A=0	A
		A=C	B
		D=0	A
		GOSUB	oneChar
		C=RSTK
		GONC	#>grobLp
*****************************************
* Wipe/Clear Nibbles at Display Position
* Covering 6 Lines Down.
* In:	C.A= Nibbs to Wipe/Clear
*	D0= ->DISPLAY
* Uses:
*	D0,A,C,D,R4, 1 RSTK
*****************************************
F48WipeOut	ST=0	invFont		* Wipe!
F48ClearOut	C=C-1	A
		GOC	RCC
		D=C	A
		P=	15
		LC(1)	5
		P=C	0		* P= Lost Nibbles
		CD0EX
		D0=C
		C=C+D	A
		RSTK=C			* Save ->Disp after Wipe
		R4=A			* Save A[W]
		A=0	W
		?ST=0	invFont		* Wipe?
		GOYES	LineWipeLp
		A=-A-1	W		* No, Clear!
LineWipeLp	C=D	A		* Recover Nibbs	<---------------+
		CSR	A		* Nibbs / 16			
WipeLp		C=C-1	A		* <-----+			
		GOC	WipeLast	*				
		DAT0=A	W		*				
		D0=D0+	16		*				
		GONC	WipeLp		* ------+			
WipeLast	DAT0=A	WP		*				
		CD0EX			*				
		C+P+1			* advance "last Nibbs"		
		C=C+B	A		* ->nextLine			
		C=C-D	A
		C=C-1	A		* -1 because of above instr	
		D0=C			* ->Disp to Wipe		
		C=C-1	S		*				
		GONC	LineWipeLp	* ------------------------------+
		P=	0
		A=R4			* Restore A[W]
		C=RSTK
		D0=C
		D0=D0+	1		* Restore D0 ->Disp
RCC		RTNCC
*****************************************
* Reads Common Lambdas and Sets the
* Status Flags accordingly.
* Out:	D= ->TempEnv
*****************************************
InitStatus	C=ST			* Get Status Bits
		C=0	B		* Clear Flags 0-7
		ST=C			* Save Status Bits!
		GOSBVL	=popflag
		GONC	+
		ST=1	invFont
+		GOSBVL	=POP2#
		R1=A			* R1.A= #nthel
		R2=C			* R2.A= #pos
		GOSBVL	=SAVPTR

		D1=(5)	=TEMPENV
		C=DAT1	A
		D=C	A		* Save ->TempEnv addr

		C=0	A
		LC(2)	(LAMfont)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		A=A+CON A,10
		R0=A			* R0.A= ->Font

		C=0	A
		LC(2)	(LAMdispMod)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		D1=A
		D1=D1+	5
		A=DAT1	A
		?A#0	A		* #dispMode <> 0?
		GOYES	+
		ST=1	Windows
		GONC	->Stat
+		?ABIT=0	0		* #dispMode = 0?
		GOYES	->Stat
		ST=1	Props

->Stat		C=0	A
		LC(2)	(LAMstatus)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		LC(5)	=ZERO
		?A#C	A
		RTNYES
		ST=1	FullStatus	* Only 7 Lines on Screen
		RTN
*****************************************
* Makes D0 ->DISP, just in the Exact
* place according to object Pos.
* In:	A= Pos# (1-8)
* Out:	D0 ->DISP + ( ( A*6 + 2 )*34 )
*****************************************
D0->Row1(R2)	A=R2			* Get #Pos
D0->Row1(A)	C=0	A
		LC(2)	34		* (Screen Width)
		B=C	A		* B.A= Nibbs for nxtLine

		A=A+A	A		* bint * 2
		C=A	A
		C=C+A	A
		C=C+A	A		* bint * 6
		C=C+1	A
		C=C+1	A		* (bint * 6) + 2
		?ST=0	FullStatus
		GOYES	+
		C=C+CON	A,6		* Skip 1 Line More
+		C=C+C	A
		A=C	A
		ASL	A
		A=A+C	A		* ((bint * 6) + 2 ) * 34

* Read Display Address

DispAdd		D0=(5)	#8068D
		C=DAT0	A
		C=C+A	A
		D0=C			* D0 ->Display
		RTN



_F48DirsDraw
RPL
::
  max@ #1+ min@
  DO
    INDEX@
    DUP min@ #-+1
    OVER index@ #=
*****************************************
*	TREE DISPLAY ENGINE
*
* Outputs directly to the Screen the
* nth element from $dirs.
*
* 3:  #nthel  (1-n)
* 2:  #pos    (1-8)
* 1:  Invert?  T/F	->
*****************************************
ASSEMBLE
_F48DirDraw
RPL
    CODE
		STITLE	TREE Display Engine

LAM$dirs	EQU 22	$dirs Lambda
LAMn		EQU 13	#dirs Lambda
LAMPortMode	EQU  3	PortMode? Lambda
maxTokens	EQU  1	More than 9 Tokens?

Dir>DispLp	GOSUB	Dir>Disp
		GOVLNG	=Loop
*****************************************
Dir>Disp	GOSUB	InitStatus	* Read Lambdas and Set Status Flags!
		C=D	A
		D1=C			* ->TempEnv
		D1=D1+	(LAM3Api)*10+5
		A=DAT1	A
		LC(5)	=FALSE
		?A=C	A
		GOYES	+
		ST=0	Windows
		ST=0	FullStatus
+		GOSUB	D0->Row1(R2)

* Check if #dirs > 8

		C=0	A
		LC(2)	(LAMn)*10+5
		C=C+D	A
		D1=C			* ->#dirs LAM
		C=DAT1	A
		D1=C			* ->Bint (#ports/dirs)
		D1=D1+	5		* skip prologue
		A=DAT1	A		* #Ports/Dirs
		C=0	A
		LC(1)	7
		?ST=1	FullStatus
		GOYES	+
		C=C+1	A		* C.A= 8
+		?A>C	A
		GOYES	+
		ST=1	Wide

* Read PortMode? Lambda

+		LC(2)	(LAMPortMode)*10+5
		C=C+D	A
		D1=C
		A=DAT1	A
		LC(5)	=FALSE
		?A=C	A
		GOYES	+
		ST=1	PortMode

* Get $dirs Address

+		C=0	A
		LC(2)	(LAM$dirs)*10+5
		C=C+D	A
		D1=C			* ->$dirs LAM
		A=DAT1	A
		GOSUB	D1->nthDIR

		A=DAT1	B		* A.B= nth Size_Field
		LC(2)	(MaxChrs)*2+8*2
		?A#C	B		* If Size_Field=32 then Char_Structure
		GOYES	TokBegin
*****************************************
* Write the "Chars" to Display
*****************************************
		D1=D1+	2		* D1 ->chars
		A=DAT1	B
		LCASC	' '
		?A#C	B		* Not "  Home" String?
		GOYES	putChars
		D1=D1+	8*2+(MaxChrs)*2	* D1-> (DIR)
		GOSUB	DrawDirIcon
		D1=D1-	6*2+(MaxChrs)*2
		C=0	A
		LC(2)	6+(MaxChrs)
		GONC	+
putChars	C=0	A
		LC(2)	8+(MaxChrs)	* C.A= #chars
+		GOSUB	D1>miniFont
		?ST=1	Windows
		GOYES	GetPt
		C=0	A
		LC(2)	32-(MaxChrs)-8
		?ST=0	Wide
		GOYES	+
		C=C+1	A
+		GOSUB	F48WipeOut
GetPt		GOVLNG	=GETPTR
*****************************************
* You can switch Tokens to See
* wich one looks Better!
*****************************************
TokBegin	GOSUB	TokAdr
*		NIBHEX	000000		* tok 0
*		NIBHEX	226000		* tok 1
*		NIBHEX	222222		* tok 2
*		NIBHEX	226222		* tok 3
*		NIBHEX	000050		* tok 4
		NIBHEX 000000117000111111117111000050

TokAdr		C=RSTK
		R1=C			* R1.A= ->TokensFont
		C=0	A
		C=DAT1	B
		D1=D1+	2		* skip #tok_field
		D=C	A		* D.A= #tokens
		?ST=0	Windows
		GOYES	++
		LC(2)	10
		?D<C	A
		GOYES	++
		ST=1	maxTokens
		LC(1)	8
		CDEX	A
		C=C-D	A
		R3=C			* R3.A= 8 - #Tokens
		LC(2)	5
		R2=C			* R2.A= Max_Name_Length
		GONC	nxtTokenLp
++		C=D	A
		A=C	A
		A=A+1	A
		A=A+1	A		* #tokens + DirIcon
		LC(2)	32
		?ST=0	Windows
		GOYES	+
		LC(2)	16
+		C=C-A	A		* Max_Name_Lenght= 32 -#tokens -DirIcon
		R2=C			* R2.A= Max_Name_Lenght
nxtTokenLp	D=D-1	A
		GOC	chkLength
		A=0	A
		A=DAT1	P		* Read 1 Token
		A=A+A	A
		C=R1.F	A		* C.A= Read Token's Font
		C=A+C	A
		C=A+C	A
		C=A+C	A
		CD0EX			* C.A= ->Disp
		A=DAT0	6		* A= Token_Font_Data
		D0=C			* restore D0
nxtTokLine	DAT0=A	P
		CD0EX
		C=C+B	A
		CD0EX			* ->next Disp_Row
		P=P+1
		?P#	6
		GOYES	nxtTokLine
		P=	0
		D0=C			* Restore D0 ->Disp
		D0=D0+	1
		D1=D1+	1		* -> next Token
		GOTO	nxtTokenLp
*****************************************
* If Maxtokens then Write '..' at the end!
*****************************************
chkLength	?ST=0	maxTokens
		GOYES	putDirIcon
		C=0	A
		D=C	A
		CD0EX
		D0=C
		LAHEX	050000
		GOSUB	nxtLine		* Write '..' at end
		D1=D1-	2
		AD1EX
		C=R3			* C.A= Skipped Tokens
		A=A+C	A
		D1=A			* ->DIR
*****************************************
putDirIcon	GOSUB	DrawDirIcon
*****************************************
putDirName	A=DAT1	A
		D1=A			* D1 ->DIR
		D1=D1-	2		* D1 ->Second Name's field
		C=0	A
		C=DAT1	B
		D=C	A		* D.A= Save # of Chars
		?C#0	B
		GOYES	+
		LC(2)	34		* Load char 34 ( " )
		A=C	A
		GOSUB	oneChar
		D1=D1-	2		* Ensure D1 ->nameLength
		GONC	ClearLast
+		C=C+C	A
		AD1EX
		A=A-C	A
		D1=A			* D1 -> Chars
		C=R2			* C.A= Max_Name_Lenght
		?D<=C	A		* Name lenght Ok?
		GOYES	+
		D=C	A		* Set Max Name lenght
+		GOSUB	nxtChrLp
*****************************************
ClearLast	A=0	A
		A=DAT1	B		* read #chars
		?A#0	B
		GOYES	+
		A=A+1	A		* if Nullid, ensure 1 char (")
+		C=R2			* C.A= Max_Name_Lenght
		?ST=1	Windows		* Windows Mode?
		GOYES	+		* Skip Wide test!
		?ST=0	Wide		* Not full Width?
		GOYES	+
		C=C+1	A		* Ensure to Wipe Slider too!
+		C=C-A	A		* Blank= Max_Name_Lenght - #chars
		GOC	GetPtr
		GOSUB	F48WipeOut
GetPtr		GOVLNG	=GETPTR
*****************************************
* Points to nthDir from $dirs.
* In:	A= ->$dirs
*	R1.A= #nthDir
*
* Out:	D1 ->nthDIR
*
* Uses:	A,C,D1,R1
*****************************************
D1->nthDIR	C=R1			* C.A= #nthDir
		C=C+1	A		* +1 to Skip Prologue
		C=C+1	A		* +1 to Skip #Dirs_Field
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A		* A.A= ($dirs) + 5*(#nthDir+2)
		D1=A			* ->nthDIR offset
		C=DAT1	A
		A=A+C	A
		D1=A			* ->nthDIR
		RTN
*****************************************
* Draws Open or Close Folder Icon
* D0 -> Display
* D1 ->(DIR)
*****************************************
DrawDirIcon	?ST=1	PortMode
		GOYES	CloseIcon
		LC(5)	=CONTEXT
		CD1EX
		A=DAT1	A		* A.A= Context DIR
		D1=C			* Restore D1
		C=DAT1	A		* C.A= Index DIR
		?A#C	A
		GOYES	CloseIcon
		LCHEX	003F7FFD110E	* Open Folder Icon
		GONC	IconDraw!
CloseIcon	LCHEX	007F41417F0E	* Close Folder Icon
IconDraw!	AD0EX
		D0=A			* Save D0
		P=	16-6
IconLp		DAT0=C	B
		CSR	W
		CSR	W		* get nxt Icon Line
		CD0EX
		C=C+B	A
		CD0EX			* D0 ->next Disp_Row
		P=P+1
		GONC	IconLp
		D0=A			* Restore D0
		D0=D0+	2		* Skip Dir Icon!
		RTNCC
    ENDCODE
  LOOP

  n@ maxFiles@
  3API?
  CODE
		GOTO	Wipe?Bottom
  ENDCODE
 ;



ASSEMBLE
_F48DirIndxDrw
RPL
::
  index@ DUP min@ #-+1 FALSE
  4ROLL DUPDUP
  index! min@ #-+1 TRUE
  CODE
	GOSUB	Dir>Disp
	GOTO	Dir>DispLp
  ENDCODE
 ;



ASSEMBLE
_F48Tree
RPL
::
  ITE "FILER48"
      "PICK DESTINATION"
  T_$title!
  F48SwapLocals
  dispMode@ #0=ITE SKIP	( Explorer Mode? Don't Build $Dirs )
  GARBAGE		( Ensure some Room )

ASSEMBLE
_F48MakeTree
RPL
  ::
    prtLabels@
    port@
    portMode?
*****************************************
*	BUILD PORTS/DIRECTORIES LIST
*
* 3:  {}prtLabs		$dirs
* 2:	  port#	 ->	#offset
* 1:  portMode?		#dirs
*****************************************
*	STRUCTURE FOR $tokens
*
*  "#Dirs #Offset Tokens..."
*     5       5       22
*
*   #Dirs: Total Ports/Dirs in List.
* #Offset: Index element for TREE.
*  Tokens: 0=" "   1=""   2=""
*	   3=""   4=".."
*****************************************
*	STRUCTURE FOR $dirs
*
* "#Dirs LinkTable <PortStruct> ... <DirStruct> ..."
*    5
*
* First the Algorithm Scans the HP and
* outputs a <PortStruct> for each available
* Port (0-33).
*
* Then the DIRECTORY scan begins, and
* Outputs a <DirStruct> for each Directory
* found on the HP.
*
* The Structures are as follows:
*****************************************
* <PortStruct>: xx chchchchchchchchch 00000
*	 Nibbs:	 2	   28		5
*
*     xx= Size Field for Chars (Nibbs)
* chch..= Chars,  ie: "Port 01 131072"
*  00000= Port Number
*****************************************
* <DirStruct>: xx tokens DirAddr
*	Nibbs:  2   N       5
*
*      xx= Size Field #Tokens (Nibbs)
*  tokens= each token takes 1 Nibb.
* DirAddr= ->DIR Pointer.
*****************************************
* NOTE:  Even dough HOME is a Directory,
* the Algorithm outputs the HOME dir
* as a <PortStruct>.
*****************************************
    CODE
		ABASE	=IRAMBUFF
DIRSCOUNT	ALLOC	5		* Dirs Counter
DIROFFSET	ALLOC	5		* Dir Index Offset
TOKENS		ALLOC	22		* Tokens Data

LastDir		EQU 3	Last directory?
Match		EQU 2	Index Offset Found?

		STITLE	Port/Directory TREE Engine

		GOSBVL	=DisableIntr
		CLRST
		GOSBVL	=popflag
		GONC	+
		ST=1	PortMode
+		GOSBVL	=POP#
		R1=A			* R1= #PortMatch
		GOSBVL	=SAVPTR

* Calculate Free Memory

		AD1EX
		A=A-B	A		* A.A= FREE RAM (Dsktop - Rstktop)
		R2=A			* R2.A= Home's MEM (Nibbs)

* Allocate big chunk $.

		C=0	A
		LC(2)	200		* Leave some Room
		C=A-C	A
		GONC	+
		GOTO	TreeErr
+		C=C+CON	A,5		* Alloc 1 #Dirs_Field
		GOSBVL	=MAKE$N
		A=A-CON	A,5		* Remove Size_Field
		B=A	A		* B.A= $Dirs Size (Available Space)
		CD0EX
		D1=C			* D1 ->new$
		D1=D1+	5		* Skip #Dirs_Field

* Initialize The Buffer

		D0=(5)	DIRSCOUNT	* ->#dirs_Field
		C=0	W
		DAT0=C	10		* Clear DirsCount and DirOffset

*****************************************
*	PORT SCANNER.
*****************************************
*	CPU use:
* R0.A= ->$dirs
* R1.A= #PortMatch
* R2.A= Home's free MEMORY
* R3.A= #Ports to Scan
* R4.A= Loop Counter
*****************************************

* Recall { Port_Labels } from Stack

		GOSBVL	=D0=DSKTOP
		C=DAT0	A
		C=C+CON	A,5		* Skip LeftPar (
		R3=C			* R3.A= ->PortLabels

* Get #Banks in Card 2, and Loop PortN -> Port0

		D0=(5)	(=CARD2STAT)+2	* ->#Banks in Card 2
		A=0	A
		A=DAT0	B		* A.A= #Banks in Card 2
		A=A+1	B		* + Port 1
nxtPort		R4=A	A		* R4.A= Port Counter

* Port 0 is always Present.

		?A=0	A		* Port 0?
		GOYES	PortMem>$	* Yes.
		LC(2)	1
		?A#C	B		* Port >1?
		GOYES	PortMem>$	* Yes.

* Check Card 1 status.
* Port 1 Exists only if Card 1 Plugged and NOT Merged.

		AD0EX			* Save D0
		D0=(5)	=CARD1STAT
		C=DAT0	B
		D0=A			* Restore D0
		?CBIT=0	3		* Card 1 Plugged?
		GOYES	+		* Nope.
		?CBIT=0	1		* Card 1 Not Merged?
		GOYES	PortMem>$	* Yep.
+		GOTO	PortCont

* Output "Port " to D1 ->$.
* Note: Size_Field is included for
* Compatibility with Dir_Struct.

PortMem>$	C=0	A
		LC(2)	2+8*2+(MaxChrs)*2+5
		B=B-C	A
		GONC	+
TreeErr		GOVLNG	=GPMEMERR
+		LC(2)	8*2+(MaxChrs)*2
		DAT1=C	B
		D1=D1+	2
		A=R4
		GOSUB	hxs->dec	* Port# ->dec
		?CBIT=1	1		* 2 Chars?
		GOYES	+		* yep, no Leading '0' chr
		LAASC	'0'
		DAT1=A	B
		D1=D1+	2
+		GOSUB	dec->$		* Output Port# to $
		LCASC	':'
		DAT1=C	B
		D1=D1+	2

* Find Port Label and Read it!

		C=R3
		D0=C			* ->Port_Labels
		C=R4
		D=C	A
SkipLabel	D=D-1	A		* Port Counter
		GOC	ReadLabel
		GOSBVL	=SKIPOB
		GONC	SkipLabel
ReadLabel	D0=D0+	5		* -> $Label Size_Field
		C=DAT0	A
		D0=D0+	5		* ->chars
		C=C-CON	A,5		* - size_Field
		?C#0	A
		GOYES	PortName
		LCSTR	\Port\
		DAT1=C	8
		D1=D1+	8
		C=0	A
		LC(1)	(MaxChrs)-4+1
		GONC	blnk$

PortName	RSTK=C			* Save #chars (Nibbs)
		GOSBVL	=MOVEDOWN
		C=RSTK
		A=C	A
		ASRB.F	A
		C=0	A
		LC(1)	(MaxChrs)+1
		C=C-A	A
blnk$		GOSUB	blank$

* Output Free MEM to D1 ->$.

		A=R4			* A.A= Port#
		GOSUB	PortMem		* A.A= Free MEM of Port#
		GOSUB	MEM->$		* Output MEM chars to $
		LCASC	'K'
		DAT1=C	B
		D1=D1+	2

		A=R4
		DAT1=A	A		* Write #Port_Field at End
		D1=D1+	5
		GOSUB	OffsetMatch?	* Match this Port#

PortCont	A=R4			* A.A= Loop Counter
		?A=0	A		* Ports Finished?
		GOYES	HomeMem
		A=A-1	A		* next Port
		GOTO	nxtPort

* Finally Include $Home and Free MEM

HomeMem		C=0	A
		LC(2)	2+8*2+(MaxChrs)*2+5
		B=B-C	A		* Alloc Size_Field + 14 chars + #Port_Field
		GONC	+
		GOTO	TreeErr
+		LC(2)	8*2+(MaxChrs)*2
		DAT1=C	B
		D1=D1+	2
		LCSTR	\  Home\
		DAT1=C	12
		D1=D1+	12
		C=0	A
		LC(1)	(MaxChrs)-2
		GOSUB	blank$
		A=R2			* A.A= Home's Free MEM
		GOSUB	MEM->$
		LCASC	'K'
		DAT1=C	B
		D1=D1+	2
		GOTO	Dir_Scanner	* Now Scan for Dirs!

*****************************************
* Output MEM chars to D1 $.
* In:	A.A= MEM
*****************************************
MEM->$		C=B	A
		RSTK=C			* Save Free RAM
		LC(5)	2048
		GOSBVL	=IntDiv		* Nibbs -> KiloBytes
		A=C	A
		C=RSTK
		B=C	A		* Restore Free RAM
		GOSUBL	hxs->dec
		RSTK=C			* save #chars
		ACEX	A
		LC(1)	3
		C=C-A	A
		GOSUB	blank$
		C=RSTK			* Restore #chars
*****************************************
* Outputs dec number to D1 $.
* In:	A=  dec number
*	C.A= #chars
* Uses: A,C,D1
*****************************************
dec->$		P=	1
		C=C-1	B
#>CharLp	ASLC			* <-----+
		LA(1)	3		*	
		DAT1=A	B		*	
		D1=D1+  2		*	
		C=C-1	B		*	
		GONC	#>CharLp	*	+
		P=	0
		RTNCC
*****************************************
* Outputs Space_Chars to D1.
* In:	C.A= # chars to write
*****************************************
blank$		A=C	A		* A.A= #chars
		LCASC	' '		* C.B= Space_Char
-		A=A-1	A		* <-----+
		RTNC			*	
		DAT1=C	B		*	 Write Space_Char
		D1=D1+	2		*	
		GONC	-		* ------+
*****************************************
* Calculates Free MEM in given Port.
* In:	A.A= PORT#
* Out:	A.A= FREE MEM (Nibbs)
* Uses:	A,C,D,D0,2_RSTK
*****************************************
PortMem		?A#0	A		* Port 0?
		GOYES	+
		A=R2			* A[A]: Home (Port0) FREE MEM
		RTN

+		CD0EX
		RSTK=C			* Save D0
		C=A	A
		RSTK=C			* Save PORT#
		A=A+A	A
		A=A+A	A
		A=A+C	A		* A[A]:(PORT#)*5
		LC(5)	=PORT0EOS
		C=C+A	A
		D0=C			* D0 ->PORTn EOS
		C=DAT0	A
		D=C	A		* D[A]: PORTn EOS

		D0=(2)	=CARD1STAT
		C=RSTK			* C[A]: PORT#
		C=C-1	A
		?C=0	A		* Port1?
		GOYES	CardSize
		D0=D0+	2		* D0 ->CARD2STAT

CardSize	C=0	A
		A=DAT0	B
		?ABIT=1	5		* 128K Card?
		GOYES	PortFree
		LC(5)	#D0000		* 32K Card

PortFree	C=C-D	A		* PORT FREE= CARDSIZE - PORTEND
		A=C	A
		C=RSTK
		D0=C			* Restore D0
		RTN

*****************************************
*	DIRECTORY SCANNER.
*****************************************
*	CPU use:
* R0.A= ->$dirs
* R1.A= ->$Stack
* R2.A= Home's Last Object Offset, for Stop-Sign
* R3.A= ->DIR, Current DIR been analyzed
* R4.A= #Level_Depth
*****************************************
Dir_Scanner	C=0	A
		R4=C			* Reset Level_Depth#

* Initilize The $Stack

		C=R0
		D0=C			* ->$dirs
		D0=D0+	5
		A=DAT0	A		* A.A= $dirs len
		C=C+A	A
		R1=C			* R1.A= ->$Stack TOP

		D0=(5)	=USEROB
		A=DAT0	A
		R3=A			* R3.A= ->HOMEDIR
		DAT1=A	A		* Write HOMEDIR addr
		D1=D1+	5
		D0=C			* ->$Stack
		DAT0=A	A		* Push HOMEDIR into $Stack
		D0=A			* D0 ->HOMEDIR
		GOSUB	OffsetMatch?
		D0=D0+	5
		C=DAT0	A
-		C=C-1	X
		GOC	+
		D0=D0+	13		* Skip Home's attached Libraries
		GONC	-
+		D0=D0+	3
		A=DAT0	A
		R2=A			* R2.A= Home's last object offset
		GOTO	InvLink
*****************************************
OffsetMatch?	LC(5)	DIRSCOUNT
		CD0EX			* Save ->DIR
		A=DAT0	A
		A=A+1	A		* Increase #dirs counter
		DAT0=A	A
		CD0EX			* Restore ->DIR
		?ST=1	Match		* Offset already found?
		RTNYES

		CD0EX			* Save ->DIR
		D0=D0+	5		* Skip #dirs
		A=DAT0	A
		A=A+1	A		* Increase #Offset
		DAT0=A	A
		?ST=1	PortMode	* Match for Port#?
		GOYES	+

		D0=(5)	=CONTEXT	* D0 -> current Dir
		A=DAT0	A
		D0=C			* Restore ->DIR
		GONC	Compare

+		D0=C			* Restore ->Label
		A=R4			* A.A= current Port#
		C=R1			* C.A= #PortMatch

Compare		?A#C	A		* Current Port/Dir?
		RTNYES			* No, Return..
		ST=1	Match		* Yes, Don't test this again!
		RTN
*****************************************
Level--		C=R4.F	A
		C=C-1	A		* Decrease Level_Depth#
		R4=C.F	A

		B=B+CON	A,5		* Return 5 Nibbs (1 Pointer)
		C=R1.F	A		* ->$Stack TOP
		C=C+CON	A,5		* Shrink $Stack (Destroy 1 Pointer)
		R1=C.F	A		* update ->$Stack TOP
		CD0EX
		A=DAT0	A		* A.A= ->UPDIR
		R3=A.F	A		* Save it!
		D0=C			* Restore D0
		RTNCC
*****************************************
dirScan!	GOSUB	OffsetMatch?	* Match this Dir
		CD0EX
		R3=C.F	A		* R3.A= Save ->DIR
		GOSUB	Level++
		C=R3.F	A		* get -> DIR
		DAT1=C	A		* write dir pointer
		D1=D1+	5
		D0=C			* Restore D0 -> DIR
		D0=D0+	8		* D0 ->LastRam-Word
		A=DAT0	A
		?A#0	A		* Not an Empty Dir?
		GOYES	InvLink
		GOSUB	Level--
		GONC	continue
InvLink		A=-A	A
*****************************************
nxtVarLp	?A=0	A		* Link=0?
		GOYES	upDir
		CD0EX
		C=C-A	A

* Safety Check: if ->Name < ->UPDIR
* then Corrupted Directory! skip

		A=R3.F	A		* ->UPDIR
		?C<A	A
		GOYES	invalidObj

		D=C	A		* D.A= Save ->Name
		D0=C			* ->Name
		GOSBVL	=TRAVERSE+	* ->Ob
		A=DAT0	A
		LC(5)	=DORRP
		?A=C	A		* Is it a Dir?
		GOYES	dirScan!	* yes, go and Scan it!
continue	C=D	A		* Restore ->Name
		D0=C
linkChk		D0=D0-	5
		A=DAT0	A		* A.A= ->next Link
		GOTO	nxtVarLp
*****************************************
upDir		GOSUB	Level--
		D0=D0-	5
		A=DAT0	A		* Read last Object offset
		C=R2.F	A
		?A=C	A		* Are we HOME Yet?
		GOYES	ScanDone
		D0=D0-	8		* ->DIR
dirName		GOSBVL	=TRAVERSE-	* ->Name
		GONC	linkChk
*****************************************
* If Corrupted DIR, skip it and continue
*****************************************
invalidObj	D0=(5)	=USEROB
		C=DAT0	A
		?A=C	A		* HOMEDIR?
		GOYES	ScanDone
		D0=A			* ->UPDIR
		GOSUB	Level--
		GONC	dirName
*****************************************
* Allocate Room for the Link Table.
*****************************************
ScanDone	D0=(5)	DIRSCOUNT	* ->#Dirs_Field
		C=DAT0	A		* C.A= #dirs
		A=C	A
		A=A+A	A
		A=A+A	A
		A=A+C	A		* A.A= (#dirs)*5
		B=B-A	A		* Alloc LinkTable pointers
		GOC	TreeErr1
		D=C	A		* D.A= Loop counter for #dirs

* Move the DIR_STRUCTS down, so the
* LinkTable is at $dirs begin.

		CD1EX
		D0=C			* D0 ->$dirs End
		A=A+C	A
		D1=A			* D1 ->new $dirs End
		A=R0
		C=C-A	A
		C=C-CON	A,15
		GOSBVL	=MOVEUP

* Start Writing Link Table Offsets

LnkTabLp	D=D-1	A
		GOC	Shrink$dirs
		A=0	A
		A=DAT1	B		* Read #Tokens
		B=A	A		* B[A]= #Tokens

		AD1EX
		CD0EX			* C[A]= ->Link_Table
		D0=C			* ->Link_Table
		C=A-C	A		* C[A]= Offset: End_Address - Start_Address
		DAT0=C	A		* Write it!
		D0=D0+	5

		A=A+B	A		* Skip Tokens
		D1=A
		D1=D1+	2+5		* Skip #Toks, ->DIR Fields
		GOTO	LnkTabLp

TreeErr1	GOTO	TreeErr

* Finally Shrink$ and Push #offset & #dirs

Shrink$dirs	AD1EX
		D0=A
		GOSBVL	=Shrink$
		GOSBVL	=AllowIntr
		GOSBVL	=GETPTR
		C=R0
		DAT1=C	A		* OverWrite $dirs!
		D0=(5)	DIROFFSET
		A=DAT0	A
		R0=A			* R0= #Dir_Offset
		D0=D0-	5
		A=DAT0	A
		D0=C			* ->$Dirs
		D0=D0+	10
		DAT0=A	A		* Write #Dirs
		GOVLNG	=Push2#aLoop	* push #offset, #dirs
*****************************************
Level++		B=B-CON	A,5		* Alloc 1 Pointer for $Stack
		GOC	TreeErr1
		A=R1.F	A		* ->$Stack TOP
		A=A-CON	A,5		* Expand $Stack (add 1 Pointer)
		R1=A.F	A		* Update ->$Stack TOP
		D0=A
		DAT0=C	A		* OverWrite Dir!

		A=R4.F	A
		A=A+1	A		* Increase Level_Depth#
		R4=A.F	A
		A=A-1	A
		?A=0	A
		GOYES	LASTDIR?
		C=0	A
		LC(2)	22
		?A>C	A
		GOYES	LASTDIR?
		LC(5)	(TOKENS)-1	* ->Tokens Data
		C=C+A	A
		D0=C
		A=DAT0	P		* read current Token
		?A=0	P		* Load " " token
		GOYES	LASTDIR?
		LC(1)	2		* Load "" token
		?A=C	P
		GOYES	LASTDIR?
		LC(1)	1		* Load "" token
		?A=C	P
		GOYES	+
		LC(1)	2		* Load "" token
		GONC	tokenWr
+		C=0	A		* Load " " token
tokenWr		DAT0=C	P
*****************************************
* Now we have to check if R3.A Dir is
* the last inside it's context
*****************************************
LASTDIR?	ST=1	LastDir		* Assume Last Dir
		C=R1.F	A
		D0=C
		D0=D0+	5
		C=DAT0	A
		CBEX	A		* B.A= ->UPDIR
		RSTK=C			* Save Free Memory

		C=R3.F	A
		D0=C			* ->DIR
LnkCheck	GOSBVL	=TRAVERSE-	* ->Name
		D0=D0-	5		* ->nxt_Link
		C=DAT0	A
nxtDirLp	?C=0	A		* If Link=0 then Last Dir!
		GOYES	LastQuit
		AD0EX
		A=A-C	A

* Safety Check: if ->Name < ->UPDIR
* then Corrupted Directory! skip

		?A<B	A
		GOYES	LastQuit

		D0=A			* ->nxt_Name
		GOSBVL	=TRAVERSE+	* ->OB
		A=DAT0	A
		LC(5)	=DORRP
		?A#C	A		* Not a DIR?
		GOYES	LnkCheck
		ST=0	LastDir		* Dir Found!
LastQuit	C=RSTK
		B=C	A		* Restore Free Memory
*****************************************
TokensCpy	D0=(5)	(TOKENS)-1	* ->Tokens Data
		A=R4.F	A		* Read Level Depth
		C=0	A
		LC(2)	22
		?A<=C	A		* Level depth <= 22?
		GOYES	+
		A=C	A		* set Level depth= 22
		LC(1)	4		* Load ".." token
		GONC	tokWr
+		LC(1)	3		* Load "" token
		?ST=0	LastDir
		GOYES	tokWr
		LC(1)	1		* Load "" token
tokWr		CD0EX
		C=C+A	A
		CD0EX
		DAT0=C	P		* Write last Token
		C=A	A		* C.A= level depth
		C=C+CON A,2+5		* + #toks + ->DIR fields
		B=B-C	A
		GOC	TreeErr2
		C=A	A		* C.A= #tokens
		DAT1=C	B		* Write # Tokens for current Dir
		D1=D1+	2
		D0=(5)	TOKENS		* ->Tokens Data
		GOVLNG	=MOVEDOWN	* Copy Tokens
TreeErr2	GOTO	TreeErr
*****************************************
    ENDCODE	( $dirs, index, n )
    n!
    index!
    $dirs!
   ;

  FIFTYFIVE ClrSysFlag	( Allow Argument Saving! )
  min@ index@ max@	( Recall TREE's Actual Position )
  CK3NOLASTWD		( Save Arguments! )
  3DROPTRUE 3API!
  TRUEreload!

  EIGHT maxFiles!
  F48IndexCenter
  F48SliderCalc

  BEGIN
    reload?
    IT
    ::
      T_$title@ ROMPTR 0E0 044
      SEVEN ONE BLANKIT

      ( Draw Dirs )
      F48DirsDraw

      ( Slider )
      F48SafeSlider

      ( Menu Labels )
      "OK"
      "CANCL"
      NULL$ DUPDUP
      DUP
      F48CustomMenu

      ClrDA1IsStat
      FALSE reload!
     ;

    ZERO
    F48$Dir@ DROP
    TYPEBINT? ITE "LABEL" NULL$
    F48Str>Label
    Grob>Menu

    F48GetKey

    CODE
*****************************************
* TREE Key Handler.
* 1:	#Key	->
*****************************************
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		GOSUB	->KeysEnd
KeysBegin	CON(2)	6
		REL(3)	_TreeOK
		CON(2)	18
		REL(3)	_TreeOK
		CON(2)	25
		REL(3)	_TreeOK
		CON(2)	45
		REL(3)	_TreeCANCL
		CON(2)	5
		REL(3)	_TreeCANCL
		CON(2)	1
		REL(3)	_F48TreeLabel'
		CON(2)	11
		REL(3)	_3KeyUP
		CON(2)	17
		REL(3)	_3KeyDOWN
		CON(2)	#CB
		REL(3)	_3MaxUp
		CON(2)	#D1
		REL(3)	_3MaxDown
		CON(2)	#4B
		REL(3)	_3PageUp
		CON(2)	#51
		REL(3)	_3PageDown
		CON(2)	#50
		REL(3)	_PrintTree
->KeysEnd	C=RSTK
		D0=C
		C=0	A
		LC(2)	((->KeysEnd)-(KeysBegin))/5
		B=C	A
3KeyLup		B=B-1	A
		GOC	3KeyQuit
		C=DAT0	B
		?A=C	X
		GOYES	3KeyEval
		D0=D0+	5
		GONC	3KeyLup

3KeyQuit	GOVLNG	=GPPushFLoop

3KeyEval	D0=D0+	2
		C=DAT0	X
		AD0EX
		C=C+A	A
		GOVLNG	=GETPTREVALC
    ENDCODE
  UNTIL

  ITE
ASSEMBLE
_F48$Dir@
RPL
  ::
    $dirs@
    index@
*****************************************
* Recalls index Dir/Port# from $dirs
* 2:  $dirs
* 1: #index  ->  DIR/PORT# True
*****************************************
    CODE
		GOSBVL	=POP#		* A.A= #nthDir
		R1=A			* D1->nthDIR wants it there!
		GOSBVL	=PopASavptr
		GOSUBL	D1->nthDIR

		C=0	A
		C=DAT1	B
		A=A+C	A
		D1=A
		D1=D1+	2		* Skip #toks field & tokens/chars

		A=DAT1	A		* A[A]= PORT# or ->DIRptr
		D1=(5)	=USEROB
		C=DAT1	A
		?A<C	A		* If A[A] < HOMEDIR Then Push PORT#
		GOYES	+
		GOVLNG	=GPPushALp	* Push DIR!
+		GOVLNG	=PUSH#ALOOP	* Push PORT#
    ENDCODE
    TRUE
   ;
  FALSE

  ( Restore Default Settings... )
  statusMode@ #0=ITE SEVEN EIGHT
  maxFiles!		( Restore maxFiles )
  LastArgs@		( Recall Arguments )
  max! index! min!	( Restore TREE's Position )
  WipeLastArgs!		( Wipe Arguments )
  F48SliderCalc		( Restore Slider )
  F48SwapLocals		( Restore Vars )
  dispMode@ #0=?SEMI	( NOT Windows Mode? )
  NULL$ $dirs!		( Destroy DirList! )
 ;



ASSEMBLE
_TreeOK
RPL
::
  TrueTrue
 ;



ASSEMBLE
_TreeCANCL
RPL
::
  FalseTrue
 ;



ASSEMBLE
_F48TreeLabel'
RPL
:: ( LABEL )
  F48$Dir@ reload!
  DUPTYPEBINT? NOTcasedrop FALSE

ASSEMBLE
_F48TreeLabel
RPL
  :: ( #Port -> )
    #1+
    prtLabels@
    OVER NTHCOMPDROP

    "New LABEL?" SWAP
    F48Input NOTcaseDROP

    NINE 1_#1-SUB$ ( Max Len= 8 chars )
    SWAP
    prtLabels@
    PUTLIST prtLabels!

    TRUEreload!
    3API? case F48MakeTree
    NULL$ $dirs!	( Rebuild $Dirs! )
   ;
  FALSE
 ;



ASSEMBLE
_3KeyUP
RPL
:: ( UP )
  F48KeyRepeat
  ELEVEN
ASSEMBLE
_F48DirUp
RPL
  ::
    index@ min@
    #=case
    ::
      index@ #1= ?SEMI ( Window Top? )
      min@ #1- min!
      max@ #1- max!
      index@ TWO FALSE
      index@ #1-DUP index! ONE TRUE

      statusMode@
      dispMode@
      3API?
*****************************************
* Refresca por Completo la Pantalla!
*****************************************
      CODE
		ST=0	Files		* Ensure Dirs!
		GOSUBL	CpyScreenDwn	* refresh Screen
		GOSBVL	=GETPTR
		GOSUBL	Dir>Disp
		GOLONG	Dir>DispLp
      ENDCODE
*****************************************

      F48Slider
     ;

    index@ #1-
    F48DirIndxDrw
   ;
  FALSE
 ;



ASSEMBLE
_3KeyDOWN
RPL
:: ( DOWN )
  F48KeyRepeat
  SEVENTEEN
ASSEMBLE
_F48DirDown
RPL
  ::
    index@ max@
    #=case
    ::
      index@ n@ #= ?SEMI ( Window bottom? )
      min@ #1+ min!
      max@ #1+ max!
      index@ maxFiles@ #1- FALSE
      index@ #1+DUP index! maxFiles@ TRUE

      statusMode@
      dispMode@
      3API?
*****************************************
* Refresca por Completo la Pantalla!
*****************************************
      CODE
		ST=0	Files		* Ensure Dirs!
		GOSUBL	CpyScreenUp	* Refreshes screen
		GOSBVL	=GETPTR
		GOSUBL	Dir>Disp
		GOLONG	Dir>DispLp
      ENDCODE
*****************************************

      F48Slider
     ;

    index@ #1+
    F48DirIndxDrw
   ;
  FALSE
 ;



ASSEMBLE
_3MaxUp
RPL
::
  F48MaxUpSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_3MaxDown
RPL
::
  F48MaxDnSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_3PageUp
RPL
::
  F48PageUpSetup
  F48DirsDraw
  FALSE
 ;



ASSEMBLE
_3PageDown
RPL
::
  F48PageDnSetup
  F48DirsDraw
  FALSE
 ;


ASSEMBLE
_PrintTree
RPL
::
  DOLCD>
  FALSE
 ;


ASSEMBLE
_F48StatusDraw
RPL
::
  ClrDA1IsStat		( don't draw clock )
  $vars@
  $path@
  miniFont@
  statusMode@
****************************************
* Display the Status on the Screen.
* 4:	   $vars
* 3:	   $path
* 2:	miniFont
* 1: statusMode@	->
****************************************
  CODE
		STITLE	Status -> Display
		GOSBVL	=POP#
		R4=A			* R4.A= statusMode

* Pop the miniFont from Stack

+		A=DAT1	A
		A=A+CON	A,10
		R0=A			* R0.A= ->miniFont
		D=D+1	A
		D1=D1+	5		* drop the Font

* Pop $path from Stack

		A=DAT1	A
		R2=A			* R2.A= ->$path
		D=D+1	A
		D1=D1+	5

* Pop $vars from stack

		GOSBVL	=PopASavptr
		A=A+CON	A,15
		R1=A			* R1.A= $vars

* Make D0 ->Display and set
* Screen Width in B[A]= 34

		GOSBVL	=D0->Row1
		C=0	A
		LC(2)	34
		B=C	A		* B.A= Screen Width

****************************************
* Dispath the Status Mode to Display!
****************************************

		ST=0	invFont		* Ensure Clean Font!
		A=R4			* A.A= statusMode
		?A#0	A
		GOYES	+
		GOSUB	pathStatus
		AD0EX
		C=0	A
		LC(2)	5*34+1		* skip Five Screen Lines
		A=A+C	A
		D0=A			* ->Disp just for Mem Status!
		GOTO	memStatus

+		A=A-1	A
		?A=0	A
		GOYES	memStatus
		GOSUB	pathStatus
		GOTO	statusLine
****************************************
* Displays the Path Status
* Including #obs count
****************************************
pathStatus	A=R1
		D1=A
		A=DAT1	A		* A.A= #obs
		GOSUBL	hxs->dec
		RSTK=C			* Save #Chars
		GOSUBL	#>grob
		GOSUB	+
		NIBASC	\obj \
+		C=RSTK
		D1=C
		C=0	A
		LC(1)	4
		D=C	A
		GOSUBL	nxtChrLp

		C=RSTK			* Restore #chars
		A=C	A
		C=0	A
		LC(2)	32-4
		C=C-A	A		* 28 - #chars
		A=C	A		* A.A= max $len
		C=R2
		GOSBVL	=GetStrLenC	* D1 ->$ (chars)
		?C<=A	A		* $Len <= 32 chars?
		GOYES	+
		C=A	A		* Set max $len
+		D=C	A		* D.A= #chars
		A=A+1	A		* max $len + 1
		C=A-C	A		* C.A= #Chars to Wipe
		RSTK=C			* Save Nibbs to Wipe
		GOSUBL	nxtChrLp
		C=RSTK
		GOLONG	F48WipeOut	* Wipe blank space after path

****************************************
* Display the Memory Status:
* - Free Memory
* - Total Size of Selected Obs.
****************************************
memStatus	GOSUB	+
		NIBASC	\ Memory:\
+		C=RSTK
		D1=C
		C=0	A
		LC(1)	8
		D=C	A
		GOSUBL	nxtChrLp

		A=R1
		D1=A			* ->#Obj_Field
		D1=D1+	15		* ->Mem_Field
		GOSUB	WriteBytes

		GOSUB	+
		NIBASC	\ | Select:\
+		C=RSTK
		D1=C
		C=0	A
		LC(1)	10
		D=C	A
		GOSUBL	nxtChrLp

		A=R1
		D1=A			* ->#Obs_Field
		D1=D1+	10		* ->SelSize_Field
		GOSUB	WriteBytes

		C=0	A
		C=C+1	A
		GOSUBL	F48ClearOut

****************************************
* Draw the Line under the Status and
* Wipe the Line under it.
****************************************
statusLine	AD0EX
		C=0	A
		LC(2)	5*34+1		* ->Disp just for Line!
		A=A+C	A
		D1=A
		A=0	W
		A=A-1	W
		LC(2)	1*34
		GOSBVL	(=WIPEOUT)+3	* Draw the Line!
		C=0	A
		LC(2)	1*34
		GOSBVL	=WIPEOUT	* Wipe the Line Below!
		GOVLNG	=GETPTRLOOP
*****************************************
* Reads the Bytes at the D1 field
* and outputs them to the display
*****************************************
WriteBytes	A=DAT1	A
		ASRB.F	A		* Nibbs/2 = bytes
		GOSUBL	hxs->dec
		RSTK=C			* Save #chars
		C=C-CON	A,7
		C=-C	A		* C.A= 7 - #chars
		GOSUBL	F48ClearOut	* Clear Alignment space before bytes
		C=RSTK			* Recover #chars
		GOLONG	#>grob
  ENDCODE
 ;



ASSEMBLE
_F48MenuDraw
RPL
::
  TURNMENUON

  {}menu@		( Menu List )
  page@ #6* DUP #5- SWAP
  SUBCOMP
  INNERCOMP
  SIX OVER#> IT :: NULL{} SIX ROT#- NDUPN DROP SIX ;
  reversym

  ZERO_DO
    INDEX@ TWENTYTWO #*
    SWAP
    ::
      DUPTYPELIST? NOTcasedrop NULL$
      DUPNULL{}? casedrop NULL$
      ::
	( Get Location_Item )
	DUPTWO NTHELCOMP NOTcaseTRUE
	::
	  DUPTYPEBINT? ?SEMI
	  DUPTYPEHSTR? case HXS>#
	  DROPRDROP TRUE
	 ;
	( Get #Function )
	::
	  OVER THREE NTHELCOMP NOTcase THREE
	  DUPTYPEBINT? ?SEMI
	  DUPTYPEHSTR? case HXS>#
	  DROP THREE
	 ;
	SWAP
	inTree?

ASSEMBLE
_F48Mode?OK
RPL
*****************************************
*	Display this Menu Label?
* Checks the Filer Mode and inTree? to see
* if a Label is going to be shown in the Menu
*****************************************
	CODE
		ST=0	PortMode
		GOSBVL	=popflag
		GONC	+
		ST=1	PortMode
+		GOSBVL	=POP2#		* A.A = #Function
		R0=C			* R0.A= #Mode
		GOSBVL	=SAVPTR
		?ST=0	PortMode
		GOYES	Check_Mode
		GOSUB	->ValidFuncs
		CON(2)	0
		CON(2)	1
		CON(2)	2
		CON(2)	5
		CON(2)	6
		CON(2)	7
		CON(2)	8
		CON(2)	10
		CON(2)	11
		CON(2)	12
		CON(2)	13
		CON(2)	15
		CON(2)	24
		CON(2)	30
		CON(2)	31
		CON(2)	34
		CON(2)	35
		CON(2)	36
		CON(2)	37
->ValidFuncs	C=RSTK
		D0=C
		LC(2)	19
		D=C	B
FuncLup		D=D-1	B
		GOC	PushFalse
		C=DAT0	B
		D0=D0+	2
		?C=A	B		* Valid Function?
		GOYES	Check_Mode
		GONC	FuncLup
PushFalse	LC(5)	=FALSE
		GOC	Eval_C
*****************************************
Check_Mode	GOSUB	->SoftMode
		REL(3)	fEverywhere
		REL(3)	fVar
		REL(3)	fNoLib
		REL(3)	fNoBackup
		REL(3)	fHomePort
		REL(3)	fVar&HomePort
->SoftMode	C=RSTK
		A=R0
		C=C+A	A
		A=A+A	A
		C=C+A	A
		D0=C
		A=DAT0	X
		C=C+A	A
Eval_C		GOVLNG	=GETPTREVALC
	ENDCODE
       ;

      NOTcasedrop NULL$
      CARCOMP EVAL
      DUPTYPECSTR? ?SEMI
      DUPTYPEGROB? NOTcasedrop NULL$
     ;
    DUPTYPECSTR? IT
ASSEMBLE
_F48Str>Label
RPL
    ::
      ROMPTR 101 3	( FONT1 -> )
*****************************************
* Makes a Menu Label using miniFont:
* 2:	"String"
* 1:	 FONT1	-> Grob 21 x 8
*****************************************
      CODE
		STITLE	UFL Menu Label

		GOSBVL	=PopASavptr
		A=A+CON	A,10
		R0=A			* R0[A]= FONT1
		C=DAT1	A
		B=C	A		* B[A]= ->"Label"
		D1=(5)	=uart_buffer
		GOSUB	SoftGrob
		NIBHEX	E1B20F30008000051000000000FFFFF1FFFFF1FFFFF1FFFFF1FFFFF1FFFFF1FFFFF1
SoftGrob	C=RSTK
		D0=C
		C=0	A
		LC(2)	68
		GOSBVL	=MOVEDOWN
		D0=(5)	(=uart_buffer)+32
		C=0	A
		LC(1)	5
		D=C	A		* D[A]= 5
		LC(1)	6
		BCEX	A		* B[A]= Grob Width
		GOSBVL	=GetStrLenC
		?C<=D	A
		GOYES	+
		C=D	A
+		RSTK=C			* Save #chars
		ST=1	invFont
		GOSUBL	D1>miniFont
		C=RSTK			* C[A]= #chars
		C=C+C	A
		C=C+C	A		* C[A]= 4*(#chars)
		A=C	A
		LC(2)	21
		C=C-A	A
		CSRB.F	A		* C[A]= # Bits to Shift Left
		D1=(5)	(=uart_buffer)+32
		P=	16-6
CenterLup	B=C	A
		A=DAT1	A
-		A=A+A	A
		ABIT=1	0
		B=B-1	A
		GONC	-
		DAT1=A	A
		D1=D1+	6
		P=P+1
		GONC	CenterLup
		LC(5)	=uart_buffer
		A=C	A
		GOVLNG	=GPOverWrALp
      ENDCODE
     ;
    Grob>Menu
  LOOP
 ;


ASSEMBLE
fEverywhere
RPL
:: TRUE ;

ASSEMBLE
fVar
RPL
::
  dirOb? libOb? NOTAND portMode? NOTAND
 ;

ASSEMBLE
fNoLib
RPL
:: libOb? NOT ;

ASSEMBLE
fNoBackup
RPL
::
  dirOb? portMode? AND NOT
 ;

ASSEMBLE
fHomePort
RPL
::
  portMode? dirOb? NOTAND libOb? NOTAND
 ;

ASSEMBLE
fVar&HomePort
RPL
::
  dirOb?
  libOb?
  portMode? case ORNOT
  NOTAND
 ;


ASSEMBLE
_F48BarSetup
RPL
*****************************************
* Computes Progression Bar's settings.
* 2: { obs }	->  meta-ob
* 1: "message"
*****************************************
::

ASSEMBLE
_F48BarDraw
RPL
  ::
    CLEARLCD
    THIRTYONE FORTYFOUR
    FOUR 66
    MAKEGROB INVGROB
    ONEONE 65 THREE
    GROB!ZERO
    XYGROBDISP
   ;

  F48$>miniFont
  ABUFF
  FIFTY THIRTYSEVEN
  GROB!

  INNERCOMP #2/			( #obs/2= #cycles )
  % 64				( Bar Width= 64 Pixels )
  OVER UNCOERCE
  %/ %bar!
 ;



ASSEMBLE
_F48BarDraw_LOOP
RPL
*****************************************
* Draws the Progression Bar for current
* cycle.
*****************************************
::
  INDEX@ UNCOERCE
  %bar@ %*
  COERCE

  CODE
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		B=A	A
		D1=(5)	=DISP1CTLg
		A=DAT1	A
		LC(5)	45*34+8
		A=A+C	A
		D1=A			* D1 ->Display
		C=0	A
		LC(1)	3		* C[A]= #11
		C=C&B	A
		BCEX	A		* B[A]= Lost Pixels
		CSRB.F	A
		CSRB.F	A		* A[A]= Nibbs (#Pixels/4)
		D=C	A
		P=C	0
		C=0	W
		?B=0	A
		GOYES	MakeBar
		B=B-1	A
		LC(1)	#1
		?B=0	A
		GOYES	MakeBar
		B=B-1	A
		LC(1)	#3
		?B=0	A
		GOYES	MakeBar
		LC(1)	#7
MakeBar		?D=0	A
		GOYES	BarSetup
		P=P-1
		C=C-1	WP
		P=	0
BarSetup	A=0	A
		A=A+1	A
BarLineLp	DAT1=C	W
		D1=D1+	34
		A=A-1	A
		GONC	BarLineLp
		GOVLNG	=GETPTRLOOP
  ENDCODE
  COLA LOOP
 ;



ASSEMBLE
_F48$Index@
RPL
::
  n@ #0= inTree? ORcase :: RDROP ;
  port@ PORTEND  ( AccPtr )
  $vars@
  index@
  portMode?
  dirOb? libOb? ORNOT
*****************************************
* Recall #Nth Object from $vars
* 5: ACCPTR
* 4: $vars
* 3: #index		Ob/Accptr
* 2: portMode?	->	#Type
* 1: PortRoot?		Id/%Lib
*****************************************
  CODE
		STITLE	$Index@ -> Ob

		GOSUB	PopFlags	* Get Flags from Stack
		GOSBVL	=POP#
		R0=A			* R0.A= index#
		GOSBVL	=PopASavptr
		AR0EX			* R0= ->$vars
		C=A	A		* C.A= index#
		C=C+1	A		* +1 to skip Data Fields
		GOSUBL	IntMult20	* C.A= (index#)*20
		A=R0
		A=A+C	A
		A=A-CON	A,2
		B=A	A		* Save ->Name_Field
		D0=A			* ->Name_Field

		D0=D0+	12		* ->OB Field
		A=DAT0	A		* A.A= ->OB
		?ST=0	PortMode
		GOYES	ObWrite
		C=DAT1	A
		D1=C			* D1 ->Access Pointer
		D1=D1+	5		* D1 ->Object Address
ObWrite		DAT1=A	A		* OverWrite Object!

		C=B	A		* Restore ->Name_Field
		D1=C			* ->Name_Field
		C=DAT1	A
		RSTK=C			* Save Name!
		D1=D1+	5		* ->Type_Field
		A=0	A
		A=DAT1	B		* Read Object Type (2 Nibbs)
		R0=A			* R0.A= #Type
		GOSBVL	=PUSH#
		GOSBVL	=SAVPTR		* Save new Stack Pointer
		C=RSTK
		D0=C			* Restore Name!
		A=R0			* A.A= #Type
		LC(2)	LIBTYPE
		?A#C	B		* Not a Library?
		GOYES	pushID
		?ST=0	PortRoot	* Not in Port Root?
		GOYES	pushID

* Push the Library # to the Stack

		GOSBVL	=TRAVERSE+	* skip Name
		A=0	A
		A=DAT0	X		* Read Lib#
		GOVLNG	=Uncoerce	* Push %LibNum

* Push the Object Name to the Stack

pushID		GOSBVL	=MakeID		* Make the Name
		GOVLNG	=PUSHA		* Push it!
***************************************
* Pops the PortMode? and the PortRoot?
* flags from the Stack.
***************************************
PopFlags	CLRST			* Clear Status Flags 0-11
		GOSBVL	=popflag
		GONC	+
		ST=1	PortRoot
+		GOSBVL	=popflag
		RTNNC
		ST=1	PortMode
		RTN
  ENDCODE
  ROT ?ACCPTR>	( Fetch Object if Covered )
  ROT		( Id/%Lib Obj #Type )
 ;



ASSEMBLE
_F48$Checks@
RPL
::
  n@ #0= inTree? ORcase :: RDROP ;
  $vars@
  index@
  port@
  portMode?
  dirOb? libOb? ORNOT
*****************************************
* Recall Selected Objects from $vars
*
* 5: $vars
* 4: index#
* 3: Port#
* 2: portMode?
* 1: portRoot?	-> {}
*****************************************
  CODE

LiOb		EQU 2	Library Object?
Port>0		EQU 1	Port > 0?

		STITLE	$Checks -> { obs... }

		GOSUB	PopFlags	* Get Flags from Stack
		GOSBVL	=POP2#
		R1=A			* R1.A= index#
		R2=C			* R2.A= Port#
		GOSBVL	=SAVPTR
		AD1EX
		A=A-B	A		* A.A= Free RAM
		C=0	A
		LC(2)	200		* Leave some Room
		C=A-C	A
		GONC	+
		GOTO	ChksErr
+		C=C+CON	A,10		* Alloc DOLIST & SEMI
		GOSBVL	=GETTEMP
		B=C	A		* B.A= Free RAM
		CD0EX
		R0=C			* R0 ->List
		D1=C
		LC(5)	=DOLIST
		DAT1=C	A
		D1=D1+	5

* Get Hidden_Dir's address and save it!

		GOSUB	Hidden_Dir@
		R3=A			* R3.A= ->Hidden_Dir

* Prepare Bank_Switcher address
* according to Port# for the ACCPTR

		A=R2			* A.A= Port#
		?A=0	A		* Port 0?
		GOYES	Get$vars
		ST=1	Port>0
		A=A-1	A
		?A=0	A		* Port 1?
		GOYES	SaveAddr
		C=A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A		* (Port#-1)*5
		LC(5)	#705FC
		C=C+A	A
		D0=C
		A=DAT0	A
SaveAddr	R2=A			* Save Bank_Switcher address!

Get$vars	GOSBVL	=D0=DSKTOP
		C=DAT0	A
		D0=C			* D0 ->$vars
		D0=D0+	20		* Skip Fields
		C=DAT0	A		* C[A]= #Selected_Objects
		D0=D0+	15		* D0 ->First_Ob
		?C#0	A		* Is There a Selected File?
		GOYES	ChksFind

* If No Selected Files, then we Pack
* the Index Object into the List.

		C=R1			* C.A= index#
		C=C-1	A
		GOSUBL	IntMult20	* C.A= (index# - 1)*20
		AD0EX
		A=A+C	A
		D0=A			* D0 ->Index_Ob
		GOSUB	Ob->List	* Object to List!

* Shrink List and Overwrite it!

ChksEnd		LC(5)	=SEMI
		DAT1=C	A
		D1=D1+	5
		AD1EX
		D0=A			* A,D0 = List_End
		GOSBVL	=ShrinkOb
		GOVLNG	=GPOverWrR0Lp

* Pack Selected Files into the List!

ChksFind	AD0EX
		R1=A			* R1.A= ->$vars (First_Ob)
		D=C	A		* D[B]= Loop Counter

* Get Objects in Same Selection Order.

nxtCheck	C=R1			* <-------------+
		D0=C			* D0 ->$vars	
FindLp		C=DAT0	X		* <-----+	
		?C=D	X		*		
		GOYES	ObFound		*		
		D0=D0+	20		*		
		GONC	FindLp		* ------+	
ObFound		GOSUB	Ob->List	*		
		D=D-1	A		*		
		?D=0	A		* More Objects?	
		GOYES	ChksEnd		*		
		GONC	nxtCheck	* --------------+
*****************************************
* Pack Object from $vars to the List.
* In:	D0 ->Object	D1 ->List
* Out:	Object packed!
*****************************************
Ob->List	D0=D0+	15		* ->Obj_Field
		A=DAT0	A		* A.A= ->Ob
		B=B-CON	A,5		* Alloc ->Ob Pointer
		GOC	ChksErr
		?ST=1	PortMode
		GOYES	LibBak->List

* Copy the ->Ob Address to the List!

		C=R3			* C.A= ->Hidden_Dir
		?A=C	A		* Hidden Dir?
		RTNYES
		DAT1=A	A		* Write Ob!
		D1=D1+	5
		D0=D0-	12		* ->Name_Field
		C=DAT0	A
		D0=C			* ->Name
		GOTO	Name->List	* Copy it!

* Create an Access Pointer from Ob Address

LibBak->List	?ST=0	Port>0		* Port 0?
		GOYES	>LibBak

		B=B-CON	A,10		* Alloc Access Pointer Fields!
		GONC	+
ChksErr		GOVLNG	=GPMEMERR
+		LC(5)	=DOACPTR
		DAT1=C	A		* Write Prolog!
		D1=D1+	5

>LibBak		R4=A			* Save ->OB
		D0=D0-	7		* ->Type_Field
		A=DAT0	B
		D0=D0-	5		* ->Name_Field
		C=DAT0	A
		D0=C			* ->Name
		LC(2)	LIBTYPE
		ST=1	LiOb		* Assume Lib
		?A=C	B		* Library?
		GOYES	WrObAdr
		ST=0	LiOb

		?ST=0	PortRoot	* Dir Or Lib Mode?
		GOYES	WrObAdr

* Calculate Backup's address:
* Object Address - Name Length - 10

		C=0	A
		C=DAT0	B		* C.A= #chars
		?C=0	A		* Null ID?
		GOYES	+
		C=C+1	A		* + 1st Name_Field
		C=C+C	A		* C.A= Nibbs
+		C=C+CON	A,10+2		* + DOBAK + Size_Field + 2nd Name_Field
		A=R4
		A=A-C	A		* A.A= Backup's Address
		R4=A

WrObAdr		C=R4
		DAT1=C	A		* Write Ob Address!
		D1=D1+	5
		?ST=0	Port>0		* Port 0?
		GOYES	>Lib#Id

		C=R2
		DAT1=C	A		* Write Bank_Switcher Address!
		D1=D1+	5

>Lib#Id		?ST=0	LiOb		* Not a Lib?
		GOYES	Name->List
		?ST=0	PortRoot	* Not in Port Root?
		GOYES	Name->List

* Output Library # to List!

		B=B-CON	A,10		* Alloc Bint#
		GONC	+
ChksErr2	GOTO	ChksErr
+		GOSBVL	=TRAVERSE+	* skip Name
		A=0	A
		A=DAT0	X		* A.A= Lib#
		LC(5)	=DOBINT
		DAT1=C	A		* Write Prolog!
		D1=D1+	5
		DAT1=A	A		* Write Lib#
		D1=D1+	5
		RTN

* Output Name to List!

Name->List	C=0	A
		C=DAT0	B		* C.A= #chars
		C=C+C	A		* C.A= Nibbs
		C=C+CON	A,5+2		* + DOIDNT + Field
		B=B-C	A
		GOC	ChksErr2
		C=C-CON	A,5		* Set Prolog Separately
		LA(5)	=DOIDNT
		DAT1=A	A		* Write Prolog!
		D1=D1+	5
		GOVLNG	=MOVEDOWN	* Copy Chars
  ENDCODE

  DUPNULL{}? IT DROPRDROP	( Empty List? )
 ;



ASSEMBLE
_F48HiddenDir@
RPL
CODE
		GOSUB	Hidden_Dir@
		GOVLNG	=PUSHA
*****************************************
* Returns Hidden_Dir Address
* Out:	A[A]= ->Hidden_Dir
* Uses: A,C,D0.
*****************************************
Hidden_Dir@	LC(5)	=USEROB
		CD0EX			* Save D0
		A=DAT0	A
		D0=A			* ->HOMEDIR
		D0=D0+	5
		A=0	A
		A=DAT0	X		* A[A]= #Attached Libs
		D0=D0+	15		* Skip some Fields
		CD0EX			* Restore D0
		C=C-A	A
		C=C-A	A
		C=C-A	A		* -3
		ASL	A
		A=A+C	A		* -3+16 = +13 (Skip Libs)
		RTN
ENDCODE



ASSEMBLE
_F48Copy/Move
RPL
::
  RDROP
  FALSE F48Tree NOTcase2DROP
  DUPTYPEBINT? libOb? ANDcase 3DROP
  TRUEreload!
  NULL$ $dirs!		( Rebuild $dirs if in Expl-Mode )
  dest!			( Save Destination )
  moveMode!		( Save MoveMode? Flag )
  FalseFalse delMode! all!
  FIVE depthSave!
  moveMode? ITE "Moving\1F" "Copying\1F"

  dest@
  DUPTYPERRP?
  case
  ::
    CONTEXT!

    F48BarSetup

    portMode?			( HOME -> HOME )
    NOTcase
    ::
      '
      :: context@ CONTEXT! ;
      >R			( Return to Original Dir when finish.. )
      THREE depthSave!
      #1+_ONE_DO
	CODE
		STITLE	Directory Recursion?

		GOSBVL	=SAVPTR
		D1=D1+	5
		A=DAT1	A
		D0=A
		A=DAT0	A
		LC(5)	=DORRP
		?A=C	A
		GOYES	+
obOk		GOVLNG	=GETPTRLOOP
+		A=DAT1	A
		D0=(5)	=CONTEXT
		C=DAT0	A
		?A=C	A
		GOYES	Recursion!Err
		?A>C	A
		GOYES	obOk
		D=C	A	D.A= -> dest-Dir
		D0=A
		GOSBVL	=SKIPOB
		CD0EX
		?C<D	A
		GOYES	obOk
Recursion!Err	GOVLNG	(=SETDIRRECUR)+5
	ENDCODE

ASSEMBLE
_F48Id?Home>
RPL
	::
	  ::
	    BEGIN
	    ::
	      DoHere: DUP@ NOTcaseTRUE
	      F48AskUser NOTcase DROPFALSE
	      OBPURGE!
	      TRUE
	     ;
	    UNTIL
	   ;
	 ;

	OVER

ASSEMBLE
_F48Mov?Home>
RPL
	::
	  moveMode? case OBPURGE!
	  DROP
	 ;

	CREATE
      F48BarDraw_LOOP
     ;

    port@
    #0=case			( PORT0 -> HOME )
    ::
      #1+_ONE_DO
	2DUP
	::
	  DUPTYPEIDNT? ?SEMI

	  #>$ CHR_L >H$
	  $>ID
	 ;

	F48Id?Home>
	SWAP

	dirOb? libOb? OR ?SKIP :: DNOTLIBcase BAK>OB ;
	SWAP CREATE

ASSEMBLE
_F48Mov?Port0>
RPL
*****************************
* 2: Lib/Bak
* 1: Lib#/Id	->
*****************************
	::
	  moveMode? NOTcase2DROP
	  SWAP
	  ObInUse? case2drop SETOBINUSE
	  SWAP
	  DUPTYPEBINT?
	  ITE OFFSRRP DROP
	  Port0_ObPurge
	 ;

      F48BarDraw_LOOP
     ;

    #1+_ONE_DO			( PORTn -> HOME )
      OVER ?ACCPTR>		( Fetch Ob )
      OVER
      ::
	DUPTYPEIDNT? ?SEMI
	#>$
	CHR_L >H$
	$>ID
       ;

      F48Id?Home>
      SWAP

      dirOb? libOb? OR ?SKIP :: DNOTLIBcase BAK>OB ;
      SWAP CREATE

      F48Mov?Portn>
    F48BarDraw_LOOP
   ;

  DUP#0=csedrp
  ::
    portMode?
    NOTcase			( HOME -> PORT0 )
    ::
      THREE depthSave!
      F48BarSetup
      #1+_ONE_DO
	::
	  SWAP
	  DNOTLIBcase
	  ::
	    SWAP
	    F48Id?Port0>
	    SWAPDUP
	    F48Mov?Home>
	    >BAK
	   ;
	  SWAPDROPDUP
	  LIB>#DROP
	  F48LibUse?Err
	  DUP
	  F48Mov?Home>
	 ;
	Port0_Sto
      F48BarDraw_LOOP
     ;

    dirOb? case2DROP		( Can't copy from Backup to Port )
    port@ #0=case 2DROP		( In Same Port? )

    F48BarSetup
    #1+_ONE_DO			( PORTn -> PORT0 )
      ::
	OVER ?ACCPTR>		( Fetch Ob )
	DNOTLIBcase
	::
	  OVER
	  F48Id?Port0>
	  DROP
	 ;
	OVER
	F48LibUse?Err
       ;

      Port0_Sto
      F48Mov?Portn>
    F48BarDraw_LOOP
   ;

  F48PortWr?Err

  portMode?
  NOTcase			( HOME -> PORTn )
  ::
    FOUR depthSave!
    F48BarSetup
    #1+_ONE_DO
      OVER
      ::
	DNOTLIBcase
	::
	  SWAP
	  F48Id?Portn>
	  SWAP
	  DNOTBAKcase		( Not a Backup? )
	  ::
	    2DUP OSIZE
	    SWAP OSIZE #+
	    TWENTYTWO #+	( Osize +5 +17 ??? )
	   ;
	  OVERSWAP >BAK
	  DUP OSIZE #5+		( backup size )
	 ;
	SWAPDROPDUP
	LIB>#DROP
	DUP F48LibUse?Err
	SWAPDUP OSIZE #5+
       ;
      dest@
      DUP PORTEND UNROT
********************************
* Id Ob AccPtr Osize+5 Port# ->
********************************
ASSEMBLE
_F48RoomInPort?
RPL
      CODE
		GOSBVL	=SAVPTR
		GOSBVL	=READ#
		B=A	A		* B[A]= Port#
		D1=D1+	5
		GOSBVL	=READ#
		ABEX	A		* A[A]= Port#, B[A]= Ob Size
		GOSUBL	PortMem		* A.A= Room in Port#
		?A>B	A		* Enough Room in Port?
		GOYES	PortMemOk
NoRoomErr	C=0	A
		LC(1)	11		* "No Room in Port"
		GOVLNG	=GPErrjmpC
PortMemOk	GOVLNG	=GETPTRLOOP
      ENDCODE
      Portn_Sto!
      F48Mov?Home>
    F48BarDraw_LOOP
   ;

  dirOb? case2DROP		( Can't copy from Backup to Port )

  port@
  DUP#0=csedrp			( PORT0 -> PORTn )
  ::
    F48BarSetup
    #1+_ONE_DO
      ::
	2DUP
	DUPTYPEIDNT?
	case
	::
	  F48Id?Portn>
	 ;
	DUP
	F48LibUse?Err
       ;
      SWAP
      dest@ PORTEND
      OVER OSIZE #5+
      dest@
      F48RoomInPort?
      Portn_Sto!

      F48Mov?Port0>
    F48BarDraw_LOOP
   ;

  dest@ #= case2DROP		( Source = dest? )

  port@ #>1
  dest@ #>1
  ANDcase			( PORTn -> PORTn )
  ::
    F48BarSetup
    #1+_ONE_DO
      2DUP
      ::
	DUPTYPEIDNT?
	case
	::
	  F48Id?Portn>
	  DROP
	 ;
	F48LibUse?Err
       ;
      port@			( Source Port )
      dest@			( Destination Port )
      CODE
		GOSBVL	=DisableIntr
		CLRST
		GOSBVL	=POP2#
		GOSUB	BankAddress
		R0=A			* R0.A= Source Bank-Address (pulls Source Bank)
		R4=C			* R4.A= Dest. Port#
		A=C	A
		GOSUB	BankAddress
		R1=A			* R1.A= Dest. Bank-Address (pulls Dest. Bank)
		GOSBVL	=PopASavptr
		D1=A			* ->ACCPTR
		D1=D1+	5
		A=DAT1	A
		R2=A			* R2.A= ->Ob (Source Port)
		A=R4			* A.A= Dest. Port#
		GOSUBL	PortMem
		R3=A			* R3.A= Room in Dest. Port#

		D1=(5)	=CARD1STAT
		A=DAT1	B
		?ABIT=0	3		* Card1 Not Present?
		GOYES	SafeBank
		ST=1	Card1
		?ABIT=0	5		* 32K Card?
		GOYES	SafeBank
		ST=1	Card1_128K	* 128K Card!
SafeBank	GOSUB	>BankEnd

* The following Code is Copied to the
* uart_buffer for safe Evaluation!

>BankStart	?ST=0	Card1
		GOYES	>BankSetup
		LC(5)	#C0000
		UNCNFG			* Unconfigure Card1

>BankSetup	GOSUB	PullSource	* Pull "Source" Bank
		C=R2
		B=C	A
		D0=C			* ->Ob
		GOSBVL	=SKIPOB
		C=B	A
		CD0EX			* D0 ->Ob
		C=C-B	A		* Ob size
		A=C	A
		AR3EX			* A.A= Room in Dest, R3.A= Ob Size
		C=C+CON	A,5		* + 5 for PortEnd Mark
		?A>C	A
		GOYES	>BankCpy
		GOSUB	Card1?Cfg
		C=0	A
		LC(1)	11		* "No Room in Port"
		GOVLNG	=GPErrjmpC

>BankCpy	C=R4			* A.A= Dest. Port#
		A=C	A
		A=A+A	A
		A=A+A	A
		A=A+C	A
		LC(5)	=PORT0EOS
		A=A+C	A
		D1=A
		A=DAT1	A		* A.A= Dest. ->PortEnd
		C=R3			* C.A= Ob Size
		C=A+C	A
		DAT1=C	A		* Update new ->PortEnd
		D1=A			* D1 ->PortEnd

		C=R3
		C=C-1	A
		GOC	EndMark
		P=C	0		* Save "lost" nibbles
		D=C	A
		DSR	A
>BankCpyLp	D=D-1	A		* <-------+
		GOC	>BankCpyLast	* ------+ 
		GOSUB	PullSource	*	 
		A=DAT0	W		*	 
		D0=D0+	16		*	 
		GOSUB	PullDest	*	 
		DAT1=A	W		*	 
		D1=D1+	16		*	 
		GONC	>BankCpyLp	* -------+
>BankCpyLast	GOSUB	PullSource	* <-----+
		A=DAT0	WP
		GOSUB	PullDest
		DAT1=A	WP
		CD1EX
		C+P+1
		D1=C
EndMark		A=0	A
		DAT1=A	A		* Mark "PortEnd"

		GOSUB	Card1?Cfg
		GOVLNG	=GETPTRLOOP

PullSource	A=R0.F	A
		AD0EX			* ->Bank-Address
		C=DAT0	B		* Pull "Source" Bank
		D0=A			* Restore D0
		RTN

PullDest	B=A	A		* Save A.A
		A=R1.F	A
		AD1EX			* ->Bank-Address
		C=DAT1	B		* Pull "Dest." Bank
		D1=A			* Restore D1
		A=B	A		* Restore A.A
		RTN

* Configures Card1 back at #C0000

Card1?Cfg	?ST=0	Card1
		GOYES	AllowRtn
		C=0	A
		P=	4
		LC(1)	#C
		?ST=1	Card1_128K	* 128K Card?
		GOYES	+
		LC(1)	#F		* 32K Card!
+		CONFIG			* Give Card Size
		LC(1)	#C
		CONFIG			* Configure it at #C0000
		P=	0
AllowRtn	GOVLNG	=AllowIntr

>BankEnd	C=RSTK
		D0=C
		D1=(5)	=uart_buffer
		LC(5)	(>BankEnd)-(>BankStart)
		GOSBVL	=MOVEDOWN
		GOVLNG	=uart_buffer

BankAddress	A=A-1	A
		A=A-1	A		* Bank# = (Port#-2)
		A=A+A	A		* (Bank#)*2
		RSTK=C			* Save C.A
		LC(5)	#7F040
		A=A+C	A		* A.A= Bank-Address
		C=RSTK			* Restore C.A
		RTN
      ENDCODE

      F48Mov?Portn>
    F48BarDraw_LOOP
   ;

  port@ #1=case			( PORT1 -> PORTn )
  ::
    F48BarSetup
    #1+_ONE_DO
      2DUP
      ::
	DUPTYPEIDNT?
	case
	::
	  F48Id?Portn>
	  DROP
	 ;
	F48LibUse?Err
       ;
      dest@			( Destination Port# )
      CODE
		GOSBVL	=DisableIntr
		GOSBVL	=POP2#
		R1=A			* R1.A= ->Ob (Card1)
		R0=C			* R0.A= Port# (Covered Port)
		GOSBVL	=SAVPTR
		A=R0
		GOSUBL	PortMem
		B=A	A		* B.A= Room in Port#
		A=R1
		D0=A			* ->Ob
		GOSBVL	=SKIPOB
		CD0EX
		A=R1
		C=C-A	A
		R2=C			* R2.A= Ob Size
		C=C+CON	A,5		* + 5 for PortEnd Mark
		?B>C	A		* Enough Room?
		GOYES	+
		C=0	A
		LC(1)	11		* "No Room in Port"
		GOVLNG	=GPErrjmpC
+		GOSUB	>PortnEnd

* The following Code is Copied to the
* uart_buffer for safe Evalutation!

>PortnStart	A=R0			* A.A= Port#
		A=A-1	A
		A=A-1	A		* A.A= Bank#: (Port#-2)
		A=A+A	A		* A.A= (Bank#)*2
		LC(5)	#7F040
		A=A+C	A
		D1=A
		A=DAT1	B		* Pull Bank (n-2)

		C=0	B		* C[A]= #7F000
		UNCNFG			* Unconfigure Bank-Switcher
		P=	3
		LC(2)	#FF		* C[A]= #FF000
		CONFIG			* Give 2Kb size (Complement..)
		LC(2)	#3F		* C[A]= #3F000
		CONFIG			* Re-Configure Bank-Switcher at #3F000

		LC(2)	#C0		* C[A]= #C0000
		UNCNFG			* Unconfigure Card1
		CONFIG			* Give 128K size (Complement...)
		LC(2)	#40		* C[A]= #40000
		CONFIG			* Re-Configure Card1 at #40000
		P=	0

* Make D0 ->Ob.  Since Card1 was moved
* from #C0000 to #40000, we just remove
* #80000 to get the new Address.

		A=R1			* A.A= ->Ob (Card1)
		A=A-C	A
		A=A-C	A		* A.A= (ObAddr) - #80000
		D0=A			* D0 ->Ob (Configured Address)

* Get Port# End Address

		A=R0
		C=A	A		* C.A= Port#
		A=A+A	A
		A=A+A	A
		A=A+C	A		* A[A]:(PORT#)*5
		LC(5)	=PORT0EOS
		C=C+A	A
		D1=C
		A=DAT1	A		* A.A= PORTn EOS
		C=R2
		C=A+C	A		* C.A= new PORTn EOS
		DAT1=C	A		* Update it!
		D1=A			* D1 ->Portn End (Card2)

* Copy the Object:  Port1 -> Portn

		C=R2
		GOSBVL	=MOVEDOWN
		A=0	A
		DAT1=A	A		* Mark Port End

* Configure Card1 back at #C0000

		C=0	A
		P=	4
		LC(1)	#4		* C[A]= #40000
		UNCNFG
		LC(1)	#C		* C[A]= #C0000
		D1=(5)	=CARD1STAT
		A=DAT1	B
		?ABIT=1	5		* 128K Card?
		GOYES	+
		LC(1)	#F		* 32K Card!
+		CONFIG			* Configure Card1 Size
		LC(1)	#C
		CONFIG			* Configure Card1 Address

* Configure Bank-Switcher back at #7F000

		P=P-1
		LC(2)	#3F
		UNCNFG
		LC(2)	#FF
		CONFIG
		LC(2)	#7F
		CONFIG
		P=	0
		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP

>PortnEnd	C=RSTK
		D0=C
		D1=(5)	=uart_buffer
		C=0	A
		LC(2)	(>PortnEnd)-(>PortnStart)
		GOSBVL	=MOVEDOWN
		GOVLNG	=uart_buffer
      ENDCODE

      F48Mov?Portn>
    F48BarDraw_LOOP
   ;

    F48BarSetup
    #1+_ONE_DO			( PORTn -> PORT1 )
      2DUP
      ::
	DUPTYPEIDNT?
	case
	::
	  F48Id?Portn>
	  DROP
	 ;
	F48LibUse?Err
       ;
      port@			( Source Port# )
      CODE
		GOSBVL	=DisableIntr
		GOSBVL	=POP2#
		R1=A			* R1.A= ->Ob (Port#)
		R0=C			* R0.A= Port#
		GOSBVL	=SAVPTR
		A=0	A
		A=A+1	A
		GOSUBL	PortMem
		R2=A			* R2.A= Room in Port1
		GOSUB	>Port1End

* The following Code is Copied to the
* uart_buffer for safe Evaluation!

>Port1Start	A=R0			* A.A= Port#
		A=A-1	A
		A=A-1	A		* A.A= Bank#: (Port#-2)
		A=A+A	A		* A.A= (Bank#)*2
		LC(5)	#7F040
		A=A+C	A
		D1=A
		A=DAT1	B		* Pull Bank (n-2)

		C=0	B		* C[A]= #7F000
		UNCNFG			* Unconfigure Bank-Switcher
		P=	3
		LC(2)	#FF		* C[A]= #FF000
		CONFIG			* Give 2Kb size (Complement..)
		LC(2)	#3F		* C[A]= #3F000
		CONFIG			* Configure Bank-Switcher at #3F000

		LC(2)	#C0		* C[A]= #C0000
		UNCNFG			* Unconfigure Card1
		CONFIG			* Give 128K size (Complement...)
		LC(2)	#40		* C[A]= #40000
		CONFIG			* Re-Configure Card1 at #40000
		P=	0

* Calculate Object Size and check
* that it "fits" in Card 1.

		C=R1
		B=C	A
		D0=C			* ->Ob (Port#)
		GOSBVL	=SKIPOB
		C=R1
		CD0EX			* D0 ->Ob
		C=C-B	A		* C.A= Ob Size
		A=C	A
		AR2EX			* A.A= Port1 Room, R2.A= Ob Size
		C=C+CON	A,5		* +5 for PortEnd Mark
		?A>C	A		* Object Fits?
		GOYES	>Card1
		GOSUB	StdConfig	* Re-Configure Modules back
		C=0	A
		LC(1)	11		* "No Room in Port"
		GOVLNG	=GPErrjmpC

* Make D1 ->Port1End.  Since Card1 was moved
* from #C0000 to #40000, we just remove
* #80000 to get the new Address.

>Card1		D1=(5)	(=PORT0EOS)+5
		A=DAT1	A		* A.A= Port1 End
		C=R2			* C.A= Ob Size
		C=A+C	A
		DAT1=C	A		* Update "PortEnd"
		LC(5)	#80000
		A=A-C	A
		D1=A			* ->Port1 End

		C=R2
		GOSBVL	=MOVEDOWN
		A=0	A
		DAT1=A	A		* Write PortEnd "Mark"

		GOSUB	StdConfig
		GOVLNG	=GETPTRLOOP

* Reconfigures Card1 & Bank-Switcher
* back at their "std" state.

StdConfig	C=0	A
		P=	4
		LC(1)	#4		* C[A]= #40000
		UNCNFG
		LC(1)	#C		* C.A= #C0000
		D1=(5)	=CARD1STAT
		A=DAT1	B
		?ABIT=1	5		* 128K Card?
		GOYES	+
		LC(1)	#F		* 32K Card!
+		CONFIG			* Configure Card1 Size
		LC(1)	#C
		CONFIG			* Configure Card1 Address

		P=P-1
		LC(2)	#3F		* Unconfigure Bank-Switcher
		UNCNFG
		LC(2)	#FF
		CONFIG			* 2K size
		LC(2)	#7F
		CONFIG			* Configure back at #7F000
		P=	0
		GOVLNG	=AllowIntr

>Port1End	C=RSTK
		D0=C
		D1=(5)	=uart_buffer
		C=0	A
		LC(2)	(>Port1End)-(>Port1Start)
		GOSBVL	=MOVEDOWN
		GOVLNG	=uart_buffer
      ENDCODE

      F48Mov?Portn>
    F48BarDraw_LOOP
 ;



ASSEMBLE
_F48Id?Port0>
RPL
::
  BEGIN
  ::
    DUPZERO
    F48Portn_Ob@
    NOTcaseTRUE

    F48AskUser NOTcase DROPFALSE
    Port0_ObPurge
    TRUE
   ;
  UNTIL
 ;



ASSEMBLE
_F48Id?Portn>
RPL
::
  BEGIN
  ::
    DUP
    dest@
ASSEMBLE
_F48Portn_Ob@
RPL
    CODE

Idnt		EQU 3	Identifier?
Found		EQU 2	Lib#/Id Found?

		GOSBVL	=POP#
		GOSBVL	=DisableIntr
		GOSBVL	=SAVPTR
		R0=A			* R0.A= Port#
		CLRST
		A=DAT1	A
		D1=A			* ->Lib#/Id
		A=DAT1	A
		LC(5)	=DOIDNT
		?A#C	A		* Not an Id?
		GOYES	+
		ST=1	Idnt

		D1=D1+	5
		A=DAT1	B
		D1=D1+	2
		CD1EX
		R1=C			* R1[A]= ->Token
		GONC	SafeSearch

+		D1=D1+	5		* skip DOBINT
		A=DAT1	A

SafeSearch	B=A	A		* B[A]= Token/Lib#
		GOSUB	SearchEnd

* The following Code is copied to the
* uart_buffer for safe evaluation!

SearchStart	D0=(5)	=ROMPARTS
		C=DAT0	A
		D0=C			* D0 ->Port0 (First Ob)
		A=R0
		?A=0	A		* Port 0?
		GOYES	SearchLp

		D0=(5)	#C0000		* D0 ->Port-n (First Ob)
		A=A-1	A
		?A=0	A		* Port 1?
		GOYES	SearchLp
		ST=1	HighPort

		D1=(5)	=CARD1STAT
		C=DAT1	B
		?CBIT=0	3		* Card1 Not Present?
		GOYES	PullBank-n
		ST=1	Card1

		?CBIT=0	5		* 32K Card?
		GOYES	+
		ST=1	Card1_128K	* 128k Card!

+		LC(5)	#C0000		* Card1 base address
		UNCNFG			* Unconfigure "Card1"

PullBank-n	A=A-1	A		* Bank= (Port#-2)
		A=A+A	A		* (Bank#)*2
		LC(5)	#7F040
		A=A+C	A
		D1=A
		A=DAT1	B		* Pull Bank-n
		GOTO	SearchLp

LibBakFound	ST=1	Found		* Object Found!
		C=RSTK
		R1=C
		GOTO	Card1?Config

PopSrchCnt	C=RSTK
		D0=C			* Restore D0
SrchCont	GOSBVL	=SKIPOB
SearchLp	A=DAT0	A
		LC(5)	=DOLIB
		?A=C	A		* Library?
		GOYES	ThisLib?
		LC(2)	=DOBAK
		?A=C	A		* Backup?
		GOYES	ThisBak?
		GOTO	Card1?Config
*****************************************
*
*****************************************
ThisLib?	?ST=1	Idnt		* Lookig for Id?
		GOYES	SrchCont
		CD0EX
		D0=C
		RSTK=C			* Save D0
		D0=D0+	10
		GOSBVL	=TRAVERSE+
		C=DAT0	X
		?C=B	X
		GOYES	LibBakFound
		GONC	PopSrchCnt

ThisBak?	?ST=0	Idnt		* Looking for Lib#?
		GOYES	SrchCont
		CD0EX
		D0=C
		RSTK=C			* Save D0
		D0=D0+	10		* ->Name
		C=DAT0	B
		?C#B	B		* Name Lenght doesn't match?
		GOYES	PopSrchCnt

		D0=D0+	2		* Skip namelen field
		A=R1
		D1=A			* D1 = ->token
		C=0	XS
		C=C+C	X
		P=C	0
		CSR	X
		D=C	B
IdCmpLoop	D=D-1	B
		GOC	IdCmpLast
		A=DAT0	W
		C=DAT1	W
		D0=D0+	16
		D1=D1+	16
		?A=C	W
		GOYES	IdCmpLoop
IdCmpFail	P=	0
		GOTO	PopSrchCnt	* Failed
IdCmpLast	P=P-1
		GOC	IdCmpOk		* ?P=0
		A=DAT0	WP
		C=DAT1	WP
		?A#C	WP
		GOYES	IdCmpFail
IdCmpOk		P=	0
		GOTO	LibBakFound
*****************************************
* Re-Configures Card1 if Present
*****************************************
Card1?Config	?ST=0	HighPort
		RTNYES
		?ST=0	Card1
		RTNYES

		C=0	A
		P=	4
		LC(1)	#C
		?ST=1	Card1_128K	* 128K Card?
		GOYES	+
		LC(1)	#F		* 32K Card!
+		CONFIG			* Give Card Size
		LC(1)	#C
		CONFIG			* Configure at #C0000
		P=	0
		RTN

SearchEnd	C=RSTK
		D0=C
		D1=(5)	=uart_buffer
		LC(5)	(SearchEnd)-(SearchStart)
		GOSBVL	=MOVEDOWN
		GOSBVL	=uart_buffer

		?ST=1	Found
		GOYES	+
		GOVLNG	=GPOverWrFLp

+		A=R0
		?A=0	A		* Port 0?
		GOYES	GPOverWrR1TLp

MakeACCPTR	C=0	A
		LC(1)	15
		GOSBVL	=GETTEMP	* Alloc ACCPTR
		AD0EX
		D0=A
		AR1EX			* A[A]= ->Ob, R1[A]= ->AccPtr

		LC(5)	=DOACPTR
		DAT0=C	A
		D0=D0+	5		* Write Prolog

		DAT0=A	A
		D0=D0+	5		* Write ->Ob Addr

		A=R0
		A=A-1	A
		?A=0	A		* Port 1?
		GOYES	Addr!
		C=A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A		* (Port#-1)*5
		LC(5)	#705FC
		C=C+A	A
		D1=C
		A=DAT1	A
Addr!		DAT0=A	A

GPOverWrR1TLp	GOSBVL	=AllowIntr
		GOSBVL	=GETPTR
		A=R1
		DAT1=A	A		* OverWrite Object
		GOVLNG	=PushTLoop
    ENDCODE
    NOTcaseTRUE

    F48AskUser NOTcase DROPFALSE
    REMRPLOOP
    dest@
    CODE
		GOLONG	F48PrtObPurge
    ENDCODE
    TRUE
   ;
  UNTIL
 ;



ASSEMBLE
_F48LibUse?Err
RPL
::
  dest@
  F48Portn_Ob@
  case2drop SETOBINUSE
 ;



ASSEMBLE
_F48Mov?Portn>
RPL
*****************************
* 2: ACCPTR
* 1: Lib#/Id	->
*****************************
::
  moveMode? NOTcase2DROP
  SWAP
  ObInUse? case2drop SETOBINUSE
  SWAP
  DUPTYPEBINT?			( Library? )
  ITE ::
	OFFSRRP			( Detach it )
	REMRPLOOP		( Remove it from ROMPTAB )
       ;
      DROP

  port@
  CODE
		GOSBVL	=READ#		* A[A]= Port#
		A=A-1	A
		CD1EX			* Save D1
		D1=(5)	=CARD1STAT
		?A=0	A		* Port 1?
		GOYES	+
		D1=D1+	2		* ->CARD2STAT
+		A=DAT1	B
		D1=C			* Restore D1
		?ABIT=0	2		* Card Protected?
		GOYES	SetCardErr
		GOLONG	F48PrtObPurge
  ENDCODE
 ;



ASSEMBLE
_F48PortWr?Err
RPL
::
  PORTSTATUS
  3DROP SWAPDROP
  NOTcase
  CODE
SetCardErr	LC(5)	#1BC05
		GOVLNG	=ErrjmpC	* "Card is Write-Protected"
  ENDCODE
 ;



ASSEMBLE
_F48AskUser
RPL
::
  all? caseTRUE

  delMode?
  ITE
  ::
    DUP
    portMode? NOT?SEMI

    DUPTYPEBINT?
    ITE #>$ ID>$
    port@ #>$
    ": " &$ SWAP&$
   ;
  OVER

  DO>STR DISPROW1
  delMode? ITE "Are You Sure?"
	       "Already Exists\nOverwrite?"
  %3 DODISP

  "NO"
  "ABORT"
  NULL$
  delMode? ITE NULL$ "REN"
  "ALL"
  "YES"

ASSEMBLE
_F48CustomMenu
RPL
  ::
    SIX
    ZERO_DO
      INDEX@ TWENTYTWO #*
      SWAP F48Str>Label
      Grob>Menu
    LOOP
   ;

  ClrDA1IsStat
  BEGIN
    F48GetKey
    ::
      ONE #=casedrop TRUETRUE

      TWO #=casedrop :: TRUE all! TRUETRUE ;

      THREE #=casedrop ::
			 delMode? caseFALSE
			 "Rename " ROT ID>$ &$
			 NULL$
			 F48Input NOTcase ABORT
			 $>ID SWAP
			 F48BarDraw
			 FalseTrue
			;

      FIVE #=casedrop ABORT

      SIX #=casedrop ::
		       delMode? case FalseTrue
		       depthSave@ NDROP
		       2RDROP 2RDROP 3RDROP
		       ' F48BarDraw_LOOP
		       Ob>Seco
		       >R
		      ;

      DROPFALSE
     ;
  UNTIL
 ;



ASSEMBLE
_F48KeyRepeat
RPL
::
  'R'R
  SWAPOVER EVAL
*****************************************
*	KEY AUTO-REPEAT ENGINE
*
* Waits for stady Key before starting
* the Auto-Repeat loop.
*
* 2: << PRG >>
* 1: KEY#	->
*****************************************
  CODE
		STITLE	Key-AutoRepeat Engine

KEYCODE		EQU	=IRAMBUFF
TIMESAVE	EQU	(=IRAMBUFF)+5

KeyLoop!	ST=0	15		* Interruptions Disabled!
		INTOFF			* Keyboard Scan Off!
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		D0=(5)	=KEYCODE
		DAT0=A	A		* Save Key#
		LC(5)	8192*30/100	* Wait .3 Seconds
		GOSUB	TIME!		* Save Stop_Time
-		GOSUB	KeyDown?	* Wait Loop <-----------+
		GOC	+		*			
ExitKey!	INTON			* Allow Keyboard	|
		ST=1	15		* Interruptions On!	|
		GOVLNG	=GETPTRLOOP	*			
+		D0=(5)	TIMESAVE	*			
		A=DAT0	A		* A.A= Stop_Time	
		D0=(5)	=TIMER2		*			
		C=DAT0	A		* C.A= Actual Time	
		?C>A	A		* Stop_Time Reached?	
		GOYES	-		* ----------------------+
*****************************************
KeyRepeater	C=0	A		*<------------------------------+
		LC(2)	8192*3/100	* Wait .03 Seconds		
		GOSUB	TIME!		*				
		GONC	OBEVAL		* Run Program!			
WaitLup		GOSUB	KeyDown?	* Key Still Down?		
		GONC	ExitKey!	* Quit Now!			
		D0=(5)	TIMESAVE	*				
		A=DAT0	A		* A.A= Stop_Time <------+	
		D0=(5)	=TIMER2		*				
		C=DAT0	A		* C.A= Actual Time		
		?C>A	A		* Stop_Time Reached?		
		GOYES	WaitLup		*-----------------------+	
		GONC	KeyRepeater	*-------------------------------+
*****************************************
KeyDown?	D0=(5)	KEYCODE
		A=DAT0	A		* A.A= Key#
		GOVLNG	=ThisKeyDown?
*****************************************
* C.A= Ticks To Wait until Stop_Time
* TIMER2 Counts Backwards
*****************************************
TIME!		D0=(5)	=TIMER2
		A=DAT0	A		* A.A= Actual_Time
		A=A-C	A		* Stop_Time = Actual - Wait
		D0=(5)	TIMESAVE
		DAT0=A	A		* Save Stop_Time
		RTNCC
*****************************************
OBEVAL		GOSUB	Ob_Addr@
		CON(5)	=DOCOL
		CON(5)	=DUP
		CON(5)	=EVAL
		CON(5)	=COLA
		CON(5)	=DOCODE
		REL(5)	->CodeEnd
		GOSBVL	=SAVPTR
		GONC	WaitLup
Ob_Addr@	C=RSTK
		GOVLNG	=GETPTREVALC
->CodeEnd
*****************************************
  ENDCODE
  DROP
 ;



ASSEMBLE
_F48Choose
RPL
*****************************************
* 4: "strings"
* 3: #n
* 2: #index-1
* 1: T/F ( Sort Mode? )  ->
*****************************************
::
  3PICK
  #1-ROT		( #n-1, #index-1 )
  3PICK
  ITE ::
	THREE OVER#<	( invert? )
	SWAPOVER IT #4-
       ;
      :: FALSE SWAP ;

  TWENTYFIVE		( Xoffset )

* Calculate Yoffset= (64 - n*7)/2

  SIXTYFOUR
  7PICK	#6*		( #n * 6 )
  #-#2/			( Yoffset )
  ZERO			( DispGrob )
  HARDBUFF2 TOTEMPOB	( MenuGrob )

  8NULLLAM{} BIND

  CXoff@ #4-		( X pos )
  CYoff@ #5-		( Y pos )
  3PICK #6* #9+		( Window Height= n*6 + 9 )
  89			( Window Width )

  ( Now Save Display Grob )
  ABUFF
  5PICK
  5PICK
  OVER 5PICK #+
  OVER 7PICK #+
  SUBGROB CDispGrob!

  MAKEGROB
*****************************************
* Draws a Window on the given GROB X*Y
* Note: X must be a factor of 8+1
*****************************************
  CODE
		GOSBVL	=SAVPTR
		C=DAT1	A
		D1=C			* D1 ->GROB
		D1=D1+	10
		C=DAT1	A
		D=C	A		* D[A]= #rows
		D1=D1+	5
		A=DAT1	A
		GOSBVL	=w->W		* Cols->Nibbs
		B=A	A		* B[A]= #Cols (Nibbs)
		D1=D1+	5-1		* -1 because in HorLine D1=D1+1
		CD1EX
		C=C+B	A		* Advance 1 Row
		D1=C			* D1->Second Row

* Write Top Lines

		LC(2)	#AA		* A= #1010 Pixels
		GOSUB	HorLine
		D1=D1+	1
		DAT1=C	P
		D1=D1+	3
		LC(2)	#54		* 4= #0100, 5=0101 Pixels
		GOSUB	HorLine
		LC(1)	13
		DAT1=C	P		* Write Top-Right Corner
		D1=D1+	3

* Write Vertical Lines

		D=D-CON	A,7
		C=0	A
		LC(1)	12
		A=C	A
		LC(2)	#42
vertLines	DAT1=C	P
		P=C	0
		CSR	A
		CPEX	1
		CD1EX
		C=C+B	A
		CD1EX
		D1=D1-	3
		DAT1=A	P
		D1=D1+	3
		D=D-1	A
		GONC	vertLines

* Write Bottom Lines

		LC(2)	#FC
		GOSUB	HorLine
		D1=D1+	3
		LC(2)	#FE
		GOSUB	HorLine
BoxQuit		GOVLNG	=GETPTRLOOP
***********************************
HorLine		A=B	A
		A=A-CON	A,4
		DAT1=C	P
		CSR	A
HLineLp		D1=D1+	1
		DAT1=C	P
		A=A-1	A
		GONC	HLineLp
		RTNCC
***********************************
  ENDCODE
  XYGROBDISP

  ZERO_DO
    INDEX@ #1+ #:>$ SWAP&$
    F48$>miniFont
    SIX EIGHTYONE MAKEGROB
    SWAPOVER
    ONE ZERO GROB!
    Cindex@ INDEX@ #= IT INVGROB
    ABUFF
    CXoff@ INDEX@ #6* CYoff@ #+
    GROB!
  LOOP

  "OK"
  "CANCL"
  NULL$
  CsortMode?
  ITE "  INV"
      NULL$
  OVERDUP
  F48CustomMenu

  ( Muestra/Oculta el Cheque )
ASSEMBLE
_F48CheckDraw
RPL
  ::
    CsortMode? NOT?SEMI
    Cinvert?
    ITE GROB 14 5000050000F0702181D1
	GROB 14 5000050000FFFFFFFFFF
    HARDBUFF2
    FORTYSIX TWO
    GROB!
   ;

  BEGIN
    F48GetKey
    ::
      FIVE #=casedrop FalseTrue		( CANCEL )
      SIX #=casedrop TrueTrue		( OK )
      TWENTYFIVE #=casedrop TrueTrue	( ENTER )
      FORTYFIVE #=casedrop FalseTrue	( ON )

      THREE #=casedrop		( CHECK )
      ::
	FALSE
	CsortMode? NOT?SEMI
	Cinvert? NOT Cinvert!
	F48CheckDraw
       ;

      ELEVEN #=casedrop		( UP )
      ::
	FALSE
	Cindex@ DUP#0=csDROP
	F48ChsCurDrw
	#1- Cindex!
	F48ChsCurDrw
       ;

      SEVENTEEN #=casedrop	( DOWN )
      ::
	FALSE
	Cindex@ DUP Cn@ #= caseDROP
	F48ChsCurDrw
	#1+ Cindex!
	F48ChsCurDrw
       ;

      FORTY OVER#<
      OVER FORTYFOUR #<
      ANDcase
      ::
	FORTYONE #- Cn@ OVER#< casedrop FALSE
	Cindex!
	TrueTrue
       ;

      THIRTYSIX #=casedrop
      ::
	Cn@ #3= NOTcaseFALSE
	THREE Cindex!
	TrueTrue
       ;

      DROPFALSE
     ;
  UNTIL

  ( Restore Diplay )
  CXoff@ #4-
  CYoff@ #5-
  CDispGrob@ XYGROBDISP

  ( Restore Menu )
  ZERO CMenuGrob@ Grob>Menu

  ITE ::
	Cindex@
	Cinvert? IT #4+
	TRUE
       ;
      FALSE
  ABND
 ;



ASSEMBLE
_F48ChsCurDrw
RPL
::
  CXoff@ Cindex@ #6* CYoff@ #+
  ABUFF
  3PICK 3PICK
  OVER EIGHTYONE #+ OVER #6+
  SUBGROB INVGROB
  XYGROBDISP
 ;



ASSEMBLE
_F48#EVAL
RPL
::
*****************************************
* Filer48 Function Dispatcher
* 2:	{ Item }
* 1:	#Function	->
*
* Executes the given Internal Function.
* We use a custom Link Table, wich holds
* an offset to each available Function.
* If the Library is Cracked, we loose
* this Routines because they are not
* present in the Library Link Table.. :)
*****************************************
  CODE
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		LC(2)	37
		?A<=C	B
		GOYES	+
		GOTO	InvFunc
+		B=A	A		* B.A= #Call
		A=A+A	A
		A=A+A	A		* A.A= (#Call)*4
		GOSUB	->F48Calls	* Filer48's Calls:
		REL(4)	_F48QUIT	* 0
		REL(4)	_F48SORT	* 1
		REL(4)	_F48SELECT	* 2
		REL(4)	_F48VIEW	* 3
		REL(4)	_F48TREE	* 4
		REL(4)	_F48UP		* 5
		REL(4)	_F48MAXUP	* 6
		REL(4)	_F48DOWN	* 7
		REL(4)	_F48MAXDOWN	* 8
		REL(4)	_F48ENTER	* 9
		REL(4)	_F48UPDIR	* 10
		REL(4)	_F48DOWNDIR	* 11
		REL(4)	_F48PREVMENU	* 12
		REL(4)	_F48NXTMENU	* 13
		REL(4)	_F48EVAL	* 14
		REL(4)	_F48SWAPHEADER	* 15
		REL(4)	_F48CST1	* 16
		REL(4)	_F48CST2	* 17
		REL(4)	_F48CST3	* 18
		REL(4)	_F48CST4	* 19
		REL(4)	_F48CST5	* 20
		REL(4)	_F48CST6	* 21
		REL(4)	_F48CST7	* 22
		REL(4)	_F48CST8	* 23
		REL(4)	_F48LIST	* 24
		REL(4)	_F48EDIT	* 25
		REL(4)	_F48COPY	* 26
		REL(4)	_F48MOVE	* 27
		REL(4)	_F48RCL		* 28
		REL(4)	_F48PURGE	* 29
		REL(4)	_F48RENAME	* 30
		REL(4)	_F48NEW		* 31
		REL(4)	_F48ORDER	* 32
		REL(4)	_F48ZIP		* 33
		REL(4)	_F48LINK	* 34
		REL(4)	_F48CST		* 35
		REL(4)	_F48PAGEUP	* 36
		REL(4)	_F48PAGEDOWN	* 37
->F48Calls	C=RSTK
		C=C+A	A
		D0=C			* ->Function_Offset
		A=DAT0	4		* Fetch Function from Table
		A=A+C	A		* A.A= ->Filer_Function
		LC(2)	15
		?B<=C	B		* Internall Call?
		GOYES	SubEval
		LC(2)	24
		?B>=C	B		* Internall Call?
		GOYES	SubEval
		GOSBVL	=GETPTR
		GOVLNG	=PUSHA		* Push Function to Stack!
*****************************************
InvFunc		LC(5)	=INVFUNCERR
		GOC	+
*****************************************
SubEval		DAT1=A	A		* Overwrite Function to Stack!
*		GOVLNG	=GETPTRLOOP
		LC(5)	=COLA_EVAL
+		GOVLNG	=GETPTREVALC	* And Evaluate it!
*****************************************
  ENDCODE
*  COLA_EVAL

  n@ #0=case 2DROP
  SWAP FOUR NTHELCOMP NOTcasedrop INVFUNCERR
  DUPTYPECOL? NOTcase2drop INVFUNCERR
  TRUEreload!
  ::
    portMode? dirOb? NOTAND case NULL{}
    MINUSONE	( -1 )
    context@
    NULLID
    BEGIN
	TOTEMPOB UNROT
	SWAP#1+SWAP
	port@
	portMode?
	CODE
		GOLONG	F48GetUpDir
	ENDCODE
    NOT_UNTIL
    DUP ID>$ NULL$?
    ITE DROP SWAP#1+
    reversym {}N
    SWAPDROP
   ;
  port@ #>$
  portMode? ITE >TAG DROP
  SWAPROT
  EVAL
  DEPTH #0=?SEMI	( empty stack? )
  DUP' TakeOver EQ	( is it TakeOver? )
  NOT?SEMI		( no! )
  DROPTRUE quit!	( yes, force the Filer to Quit! )
 ;



ASSEMBLE
_F48QUIT
RPL
::
  TRUE quit!
 ;



ASSEMBLE
_F48SORT
RPL
::
  "Size"
  "Type"
  "Name"
  "Original"
  FOUR sortBy@ TRUE
  F48Choose NOT?SEMI

ASSEMBLE
_F48Sort!
RPL
  ::
    sortBy@ OVER#=case DROP

    DUP#0=
    SWAPDUP sortBy!
    FOUR #= ORcase TRUEreload!

    $vars@
*****************************************
* Clear all Selected Files before Calling
* the Sorting Algorithm!
*****************************************
    CODE
		C=DAT1	A
		CD1EX			* ->$Vars
		RSTK=C			* Save D1
		D1=D1+	15		* ->#Obs_Field
		C=DAT1	A		* C.A= #Obs
		D1=D1+	5		* ->#Sel_Field
		A=0	W
		DAT1=A	10		* Clear #Sel & SelSize Fields!
-		D1=D1+	15		* <-----+ ->Sel_Field
		C=C-1	A		*	
		GOC	+		*	
		DAT1=A	X		*	 Un-Select it!
		D1=D1+	5		*	
		GONC	-		*	+
+		C=RSTK
		D1=C			* Restore D1
		GOLONG	ML-Sort!
    ENDCODE
    DROPTRUE refresh!
   ;
 ;



ASSEMBLE
_F48SELECT
RPL
::
  "Select Zero"
  "Invert Selection"
  "Select All"
  THREE ZEROFALSE
  F48Choose NOT?SEMI

ASSEMBLE
_F48Select!
RPL
  ::
    $vars@ SWAPTRUE refresh!
********* FILE SELECTION HANDLER ********
* 2: $vars
* 1: #action (0=All / 1=Invert / 2=None)
*****************************************
    CODE
		STITLE	File-Selection Engine
		GOSBVL	=POP#
		R0=A
		GOSBVL	=PopASavptr
		A=A+CON	A,15
		R1=A			* R1.A= ->#Obs_Field
		D0=A			* ->#Obs_Field
		A=DAT0	A		* A.A= #obs
		B=A	A		* B.A= Loop Counter
		D0=D0+	5		* ->#Sel_Field
		C=R0			* C.A= #action
*****************************************
		?C=0	A		* Select All?
		GOYES	All$Checks
		C=C-1	A
		?C=0	A		* Invert?
		GOYES	Invert$Checks
		GOTO	None$Checks
*****************************************
*	Select All Files
*****************************************
All$Checks	LC(5)	999
		ACEX	A		* A.A= 999, C.A= #files
		?C<=A	A
		GOYES	+
		C=A	A		* Set Max # of selected
+		DAT0=C	A		* Update #Selected
		D0=D0+	15		* ->First_Ob
		D=C	A		* D.A= Max # of selected
		A=0	A		* Reset Wiper
		C=0	A		* Reset Counter
All$Lp		B=B-1	A
		GOC	AddSelSize!
		?C>=D	A		* If Counter >= Max, then skip
		GOYES	+
		C=C+1	A		* Increase Counter
		DAT0=C	X		* Select File!
		GONC	nxtFile
+		DAT0=A	X
nxtFile		D0=D0+	20
		GOTO	All$Lp
*****************************************
*	Inverts Files Selection
*****************************************
Invert$Checks	C=DAT0	A		* C.A= # Selected
		A=A-C	A		* A.A= #Obs - #Sel
		LC(3)	999
		ACEX	A		* A.A= 999, C.A= new #Selected
		?C<=A	A
		GOYES	+
		C=A	A
+		D=C	A		* D.A= Max # of checked
		DAT0=C	A		* Write new #checked
		D0=D0+	15		* ->First_Ob
		C=0	A		* C.A= Object Counter
inv$Lup		B=B-1	A
		GOC	AddSelSize!
		A=DAT0	X
		?A=0	X
		GOYES	+
		A=0	A
		DAT0=A	X
		GONC	invCont
+		?C>=D	A
		GOYES	invCont
		C=C+1	A
		DAT0=C	X
invCont		D0=D0+	20
		GOTO	inv$Lup
*****************************************
* Calculates Total size of Selected Files
*****************************************
AddSelSize!	A=R1
		D0=A			* ->#Obs_Field
		C=DAT0	A		* C.A= #obs
		D=C	A		* D.A= Loop Counter
		D0=D0+	10		* D0 ->SelSize Field
		D1=A
		D1=D1+	10
		C=0	A		* Clear Size Counter
addLup		D1=D1+	10		* ->Sel_Field
		D=D-1	A
		GOC	wrSize
		A=DAT1	X
		D1=D1+	10		* ->Size_Field
		?A=0	X		* Not Selected?
		GOYES	addLup
		A=DAT1	A		* A.A= Ob_Size
		C=C+A	A		* Add Size to Total
		GOTO	addLup
wrSize		DAT0=C	A		* Update Total Size
SelecExit	GOVLNG	=GETPTRLOOP
*****************************************
*	Select None...
*****************************************
None$Checks	C=0	W
		DAT0=C	10		* Clear #Sel & Size Fields
None$Lp		D0=D0+	15		* ->Sel_Field
		A=A-1	A
		GOC	SelecExit
		DAT0=C	X
		D0=D0+	5		* D0 ->Next_Ob
		GONC	None$Lp
*****************************************
    ENDCODE
   ;
 ;



ASSEMBLE
_F48VIEW
RPL
::
  F48$Index@
  ROTDROP
  TRUE refresh!

ASSEMBLE
_F48ObView
RPL
****************************************
*	GENERAL OBJECT VIEWER
*
* Runs a viewer according to object's
* Type.
*
* 2:	Object
* 1:	#Type	->
****************************************
  ::
    ( ARRAY )
    TWENTYTWO #=casedrop
    ::
      "MATRIX" palparse DROP
      DUPTYPEROMP? NOTcasedrop :: ViewLevel1 DROP ;
      EVAL
      DROP
     ;

    ( ALGEBRAIC )
    TWO OVER#= IT
    ::
      UNCOERCE	( %2 Use Font Size 2 )
      "AGROB" palparse DROP
      DUPTYPEROMP? NOTcase2drop :: ViewLevel1 DROPRDROP ;
      EVAL
      SIXTEEN
     ;

    ( System RPL / Assembly Language )
    TWENTYFOUR OVER#= SWAP EIGHT #= OR
    IT
    ::
      # 1BC04
      "DIS" palparse DROP
      DUPTYPEROMP? NOTcasedrop ERROROUT
      SWAPDROP
      COLA_EVAL
     ;

    ( GROB or { STR GROB...} )
    DUPTYPEGROB?
    OVER DUPTYPELIST?
    ITE :: CARCOMP TYPECSTR? OR ;
	DROP

    ?SKIP DO>STR
    GARBAGE
    TWO ROMPTR 101 2		( Font2 Present? )
    DUP ITE ROMPTR 101 4	( Yes, FONT2 -> )
	    :: ' PTR 7B24D ;	( No, Use Built-In )

    ROMPTR 101 3		( FONT1 -> )
    TURNMENUOFF
********* STRING VIEWER ENGINE **********
* 4: $
* 3: UFL2?
* 2: Font2
* 1: Font1	->
*****************************************
* R0=	->$view
* R1=	Last_Font2_Char
* R2=	->Font1/2
* R3=
* R4=	X-OFFSET
*****************************************
    CODE

* Keyboard Codes:
CSTCODE		EQU 9
MTHCODE		EQU 7
VARCODE		EQU 10
UPCODE		EQU 11
NXTCODE		EQU 12
LEFTCODE	EQU 16
DOWNCODE	EQU 17
RIGHTCODE	EQU 18
EEXCODE		EQU 27
KEY0		EQU 46
KEY1		EQU 41
KEY2		EQU 42
KEY3		EQU 43
KEY4		EQU 36
KEY5		EQU 37
KEY6		EQU 38
KEY7		EQU 31
KEY8		EQU 32
KEY9		EQU 33
MINUSCODE	EQU 44
PLUSCODE	EQU 49

sWordWrap	EQU 0	* Use Word Wrap?
sUpSearch	EQU 1	* Up-Search for a Title?
sInvFont	EQU 2	* Invert Font?
sHalfChar	EQU 3	* FONT2 Half Char?
sUFL1		EQU 4	* miniFont Display?
sUFL2		EQU 5	* UFL2 Present?
sFAST		EQU 6	* Fast Scroll?
sDISPLAY	EQU 7	* Refresh Display?
sListOb		EQU 8	* List Object? (str + grobs)
sFull		EQU 9	* Wide-Line Mode? ($Pack)
sNewLine	EQU 3	* New-Line Char? ($Pack)
sRepeat		EQU 10	* Key-Repeat?
sWrapWidth	EQU 33	* Word-Wrap Width

* Some Local Variables:
		ABASE	#80100		* Base Address
vSCRNLINES	ALLOC	5		* #ScreenLines FNT2:8 - FNT1:10
vBLOCKCOUNT	ALLOC	5		* Available RAM: #Blocks
aOBJECT		ALLOC	5		* ->Object
vTOPLINE	ALLOC	5		* #TopLine
vLINECOUNT	ALLOC	5		* #Lines
aFONT1		ALLOC	5		* ->Font1
aFONT2		ALLOC	5		* ->Font2
vTIMESAVE	ALLOC	5		* Timer
vTOPTITLE	ALLOC	5		* #TopTitle Always=0
vTITLECOUNT	ALLOC	5		* #Titles
vLINESLEFT	ALLOC	5		* #Lines to Scan for Titles
a$VIEW		ALLOC	5		* $View Pointer during Make$Titles


$TITLES		EQU	=uart_buffer

		TITLE	String VIEW Engine
		STITLE	Main Engine

		GOSBVL	=DisableIntr	* Interruptions OFF!
		A=DAT1	A		* A[A]= ->Font1
		D=D-1	A
		D1=D1+	5		* Drop Font1 from Stack
		A=A+CON	A,10
		LC(5)	aFONT1
		CD0EX			* D0 ->aFONT1
		DAT0=A	A		* Save ->Font1
		D0=D0+	5		* D0 ->aFONT2
		A=DAT1	A		* A[A]= ->Font2
		D=D-1	A
		D1=D1+	5		* Drop Font2 from Stack
		A=A+CON	A,10
		DAT0=A	A		* Save ->Font2
		D0=C			* Restore D0
		C=0	A
		LC(2)	#91		* #91= 010010001 Bits
		ST=C			* Set Status Flags!
		GOSBVL	=popflag	* Using UFL FONT2?
		GONC	+
		ST=1	sUFL2
+		GOSBVL	=PopASavptr
		D0=(5)	aOBJECT
		DAT0=A	A		* Save ->Object!

SVTop$Main	C=0	A
		D0=(5)	vTOPLINE	* ->vTOPLINE
		DAT0=C	A		* TopLine=0
		R4=C			* Clear Xoffset!

MK$Main		GOSUB	Make$View	* Build the $View Structure
		D0=(5)	(=ANNCTRL)+1
		C=DAT0	P
		CBIT=0	1		* Clear I/O Annunciator
		?ST=1	sWordWrap	* Word-Wrap Enabled?
		GOYES	+		* YES
		CBIT=1	1		* NO - Set I/O Annunciator
+		DAT0=C	P		* Update it!

SVMain!		C=0	A
		LC(1)	10		* 10 Lines!
		D0=(5)	aFONT1
		?ST=1	sUFL1
		GOYES	+
		LC(1)	8
		D0=D0+	5		* ->aFONT2
+		A=DAT0	A		* Read Current Font
		R2=A			* R2= ->FONT Data
		D0=(2)	vSCRNLINES
		DAT0=C	A		* Update #ScreenLines
		GOSUB	SVSaveTim
		GOSUB	SVDispClear	* Clear Screen!

SVMain		?ST=0	sDISPLAY
		GOYES	+
		GOSUB	SVDispScreen

+		?ST=0	sRepeat
		GOYES	+
		LC(5)	8192*35/100
		GOSUB	SVKeyDelay
		ST=0	sRepeat
		GONC	++

+		?ST=1	sFAST
		GOYES	++
		LC(5)	8192*6/100	* .06 seconds
		GOSUB	SVDelay

++		GOSUB	SVKeyboard?
		GOC	+
		GOSBVL	=clrbusy
		SHUTDN
		GOSBVL	=showbusy
		ST=1	sRepeat
+		ST=1	sDISPLAY
		GOSUB	SVSaveTim

		LC(2)	=LEFTCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoLt

+		LC(2)	=RIGHTCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoRt

+		LC(2)	=DOWNCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoDn

+		LC(2)	=UPCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	SVDoUp

+		LC(2)	=NXTCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=0	sUpSearch
		GOTO	SVFindTitle

+		LC(2)	=MTHCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=1	sUpSearch
		GOTO	SVFindTitle

+		GOSUB	SVCSTDn?
		GONC	++
*-		GOSUB	SVCSTDn?
*		GOC	-		* Wait Until Key Released!
		?ST=1	sUFL1
		GOYES	+
		ST=1	sUFL1
		GONC	GoMain!
+		ST=0	sUFL1
GoMain!		?ST=0	sListOb
		GOYES	+
		GOTO	MK$Main
+		GOTO	SVMain!

++		LC(2)	VARCODE
		GOSUB	SVKeyDn?
		GONC	++
*-		LC(2)	VARCODE
*		GOSUB	SVKeyDn?
*		GOC	-		* Wait until Key Released!
		?ST=1	sWordWrap	* Word Wrap Enabled?
		GOYES	+
		ST=1	sWordWrap	* Enabled it!
		GONC	GoTopMain
+		ST=0	sWordWrap	* Disable it!
GoTopMain	GOTO	SVTop$Main	* Reload $view

++		LC(2)	PLUSCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=1	sFAST

+		LC(2)	MINUSCODE
		GOSUB	SVKeyDn?
		GONC	+
		ST=0	sFAST

+		LC(2)	EEXCODE
		GOSUB	SVKeyDn?
		GONC	+
		GOSUB	$TitleEngine
		GOC	SVMainOk
		GOTO	SVMain

+		GOSBVL	=OnKeyDown?
		GOC	SVExit
SVMainOk	ST=0	sDISPLAY
		GOTO	SVMain
SVExit		GOSUB	SVKeyboard?
		GOC	SVExit
		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP
*****************************************
SVCSTDn?	LC(2)	CSTCODE
SVKeyDn?	A=C	B
		GOVLNG	=ThisKeyDown?
*****************************************
SVKeyboard?	GOVLNG	=Kbd_OR
*****************************************
SVSaveTim	D1=(5)	=TIMER2
		A=DAT1	A
		D1=(5)	vTIMESAVE
		DAT1=A	A		* Save Time!
		RTN
*****************************************
* C[A]= Ticks to Delay
*****************************************
SVKeyDelay	D0=(5)	vTIMESAVE
		A=DAT0	A		* A.A= key_time
		A=A-C	A
		D0=(5)	=TIMER2
-		GOSUB	SVKeyboard?
		RTNNC
		C=DAT0	A
		?C>A	A
		GOYES	-
		RTN
*****************************************
* C[A]= Ticks to Delay
*****************************************
SVDelay		D1=(5)	vTIMESAVE
		A=DAT1	A		* A.A= key_time
		A=A-C	A
		D1=(5)	=TIMER2
-		C=DAT1	A
		?C>A	A
		GOYES	-
		RTN
*****************************************
SVDoLt		A=R4.F	B
		A=A-1	B
		GOC	SVbadcrs
SVnewcrs	R4=A.F	B		* Update it!
		GOTO	SVMain
*****************************************
SVDoRt		A=R4.F	B
		A=A+1	B
		GONC	SVnewcrs
SVbadcrs	GOTO	SVMainOk
*****************************************
SVDoUp		D0=(5)	vTOPLINE
		A=DAT0	A		* A.A= #TopLine
		A=A-1	A		* A.A= PrevLine
		GOC	++
		DAT0=A	A		* Update TopLine
		D0=(5)	=DISP1CTLg
		A=DAT0	A		* ->row1
		C=0	A
		?ST=0	sUFL1
		GOYES	+
		LC(3)	9*6*34
		A=A+C	A
		D0=A
		LC(3)	6*34
		A=A+C	A
		D1=A
		LC(3)	9*6*34
		GONC	MovUp
+		LC(3)	7*8*34
		A=A+C	A
		D0=A
		LC(3)	8*34
		A=A+C	A
		D1=A
		LC(3)	7*8*34
MovUp		GOSBVL	=MOVEUP
		C=0	A
		GOSUB	SVDispLine
++		GOTO	SVMainOk
*****************************************
SVDoDn		D0=(5)	vLINECOUNT
		A=DAT0	A		* A.A= #Lines
		D0=D0-	5		* ->vTOPLINE
		C=DAT0	A
		B=C	A		* B.A= #TopLine
		D1=(5)	vSCRNLINES
		C=DAT1	A
		C=C+B	A		* C.A= #Line to Draw
		?C>=A	A		* Line out of Range?
		GOYES	++
		C=B	A
		C=C+1	A		* new TopLine
		DAT0=C	A		* Update it!

		D1=(5)	=DISP1CTLg
		A=DAT1	A		* ->row1
		D1=A
		C=0	A
		?ST=0	sUFL1
		GOYES	+
		LC(2)	6*34
		A=A+C	A
		D0=A
		LC(3)	9*6*34
		GONC	MovDn
+		LC(3)	8*34
		A=A+C	A
		D0=A
		LC(3)	7*8*34
MovDn		GOSBVL	=MOVEDOWN
		D0=(5)	vSCRNLINES
		C=DAT0	A		* C.A= #ScreenLines 8 or 10
		C=C-1	A
		GOSUB	SVDispLine
++		GOTO	SVMainOk
*****************************************
SVDispClear	GOSBVL	=D0->Row1
		D1=A
		LC(5)	64*34
		GOVLNG	=WIPEOUT
*****************************************
SVDispScreen	B=0	S		* Row 1
-		C=B	S
		C=0	A
		CSLC			* C.A= #ScreenLine to Draw
		D0=(5)	vSCRNLINES
		A=DAT0	A
		?C>=A	B		* Line in Range?
		RTNYES
		GOSUB	SVDispLine
		B=B+1	S
		GONC	-
*****************************************
* Points D1 ->ScreenLine and Wipes it!
* D0-> vTOPLINE
*****************************************
D1->WipeLine	B=C	A		* B.A= #Screen Line
		C=C+C	A
		A=C	A
		C=C+A	A
		C=C+A	A
		?ST=1	sUFL1
		GOYES	+
		ST=0	sHalfChar	* Clear HalfChar (Line Start!)
		C=C+A	A
+		C=C+C	A
		A=C	A
		CSL	A
		C=C+A	A		* #CC * Y
		D1=(5)	=DISP1CTLg
		A=DAT1	A		* ->Display row1
		C=C+A	A
		RSTK=C
		D1=C			* ->Display Row to Draw!
		C=0	A
		LC(2)	6*34
		?ST=1	sUFL1
		GOYES	+
		LC(3)	8*34
+		GOSBVL	=WIPEOUT
		C=RSTK
		D1=C			* Restore D1->Display

* Now check if Line to Draw is in Range

		A=DAT0	A		* A.A= #TopLine
		A=A+B	A		* A.A= #Line to Draw (#TopLine + #ScreenLine)
		D0=D0+	5		* ->vLINECOUNT
		C=DAT0	A		* C.A= #Total_Lines
		?A<C	A		* Line in Range?
		RTNYES			* Yes!
		C=RSTK			* No! Pop Rtn Addres! Nothing do Draw!
		RTN
*****************************************
* Draws on Screen the C.A Line Number
*****************************************
SVDispLine	D0=(5)	vTOPLINE
		GOSUB	D1->WipeLine
		A=A+A	A
		A=A+A	A
		A=A+A	A		* B.A= 8*(Line_Number)
		C=R0.F	A
		C=C+A	A
		D0=C
		C=DAT0	P		* C.P= #Rows
		D0=D0+	1		* ->#Cols_Field
		?C#0	P		* Is it a Grob Line?
		GOYES	SVPutGrobLn
		GOTO	SVPut$Line
*****************************************
* Here we Process a GROB Structure
*****************************************
SVPutGrobLn	P=C	0
		C=0	S
		CPEX	15		* C.S= #Rows (6 or 8)
		A=0	A
		A=DAT0	B
		B=A	A		* B.A= GROB Width
		R1=A.F	A		* R1.A= GROB Width
		D0=D0+	2
		C=DAT0	A
		D=C	A		* D.A= ->Pixels
		LC(2)	34
		?B<C	B
		GOYES	GrobCenter
		C=R4.F	A		* C.A= X_Offset
		D=D+C	A		* ->Pixels + Offset
		A=C	B
		A=B-A	B		* C.A= Grob_Width - X_Offset
		RTNC			* If CARRY then GROB is OUT of SIGHT!
		?A=0	A
		RTNYES			* Nothing to Display!
		C=0	A
		LC(2)	34
		?A<C	A
		GOYES	Grob->Disp
		A=C	A
		GONC	Grob->Disp

* Here We Center the GROB in the Display

GrobCenter	C=C-B	B
		CSRB.F	B		* C.A= X Value (34 - Grob_Width)/2
		A=R4.F	A		* A.B= X Offset
		A=A-C	B		* A.A= X Offset - X Value
		GOC	+
		C=A	A
		D=D+C	A		* Advance ->Grob data
		A=B-A	A		* A=B-A (Grob_Width - New_offset)
		RTNC			* If CARRY then GROB is OUT of SIGHT
		GONC	Grob->Disp
+		A=-A	B		* A.A= X_Value - X_Offset
		CD1EX
		C=C+A	A
		CD1EX			* D1 ->Display Center
		A=R1.F	A
*****************************************
* GROB Line -> Display
* Writes One Grob Line to the Screen
* IN:
* C.A= #Columns to Write
* B.B= #Grob Width
* C.S= #Grob Rows
* D0->Grob_Data		D1->Display
*****************************************
Grob->Disp	C=A	A
		CDEX	A		* D.A= #Cols to Write
		D0=C			* D0-> Grob Data
GBLoop		C=C-1	S
		RTNC
		C=D	A
		GOSBVL	=MOVEDOWN
		C=D	A		* C.A= #Cols to Write
		A=C	A
		A=B-A	A		* C.A= Grob_Width - #Cols to Write (Data out of sight)
		CD0EX
		C=C+A	A
		CD0EX			* D0-> next Grob Line
		LC(2)	34
		C=C-D	B
		AD1EX
		A=A+C	A
		D1=A			* D1-> next Display Line
		GOTO	GBLoop
*****************************************
* Here we Process a TEXT Structure
*****************************************
SVPut$Line	A=R4.F	B		* C.A= #Cols_Offset ->
		B=0	A
		B=A	B
		C=DAT0	B		* C.B= #Cols
		D0=D0+	2		* ->Chars_Address
		A=DAT0	A		* A.A= Chars_Address
		?B=0	B
		GOYES	gotxtoff
		C=C-B	B
		GOC	+
		B=B+B	X
		A=A+B	A
		GONC	gotxtoff
+		C=0	B
gotxtoff	D0=A			* ->Chars
		?C=0	B		* Nothing to Display?
		RTNYES
		D=C	B		* D.B= #Chars
		?ST=0	sUFL1
		GOYES	Line->Font2
*****************************************
* Writes Chars to Display with FONT1
* IN:	D0->Chars	C.B= #Chars
*	D1->Display
*****************************************
Line->Font1	LC(2)	33		* C.B= Max_Cols to Display
		?D<=C	B
		GOYES	Ln->Fnt1Lp
		D=C	B
Ln->Fnt1Lp	D=D-1	B
		RTNC
		A=0	A
		A=DAT0	B
		D0=D0+	2
*		LCASC	'\n'
*		?A=C	B
*		RTNYES
Chr->Fnt1	A=A+A	A
		C=R2.F	A
		C=C+A	A
		C=C+A	A
		C=C+A	A
		CD1EX			* ->Font
		A=DAT1	6		* C.6= Font_Char
		D1=C			* ->Display
		?ST=0	sInvFont
		GOYES	Fnt1->Disp
		P=	5
		A=-A-1	WP
		P=	0
Fnt1->Disp	DAT1=A	P
		D1=D1+	34
		P=P+1
		?P#	6
		GOYES	Fnt1->Disp
		P=	0
		D1=C			* ->Restore Display
		D1=D1+	1		* Display ->next Char
		GONC	Ln->Fnt1Lp
*****************************************
Line->Font2	LC(2)	22
Line->Fnt2	?D<=C	B
		GOYES	Ln->Fnt2Lp
		D=C	B
Ln->Fnt2Lp	D=D-1	B		* Next Char?
		RTNC
		A=0	A
		A=DAT0	B		* A[B]= Chr1
		D0=D0+	2
*		LCASC	'\n'
*		?A=C	B
*		RTNYES
Chr->Fnt2	?ST=1	sUFL2		* Using UFL FNT2?
		GOYES	+
		LC(2)	30		* Normal Char?
		?A>C	B
		GOYES	+
		LC(2)	158
		A=C	B
+		ASL	A
		C=R2.F	A		* C[A]= ->Font2
		C=C+A	A
		CD0EX
		A=DAT0	W		* A[W]= Char_Data
		D0=C
		?ST=0	sInvFont
		GOYES	+
		A=-A-1	W
		LCHEX	3F3F3F3F3F3F3F3F
		A=A&C	W		* Aply Mask to Clear 2 bits of Shared Nibble
+		?ST=0	sHalfChar
		GOYES	Complete
		A=A+A	W
		A=A+A	W
		C=R1			* C[W]= Previous Char_Data
		CSR	W
		GOTO	WR2IN		* ------+
WR2LP		D1=D1+	34-1		* <------------+
		P=P+1			*		
WR2IN		C=C!A	P		* <-----+	
		DAT1=C	P		*		
		D1=D1+	1		*		
		P=P+1			*		
		DAT1=A	P		*		
		?P#	15		*		
		GOYES	WR2LP		* --------------+
		ST=0	sHalfChar
		GONC	SVF2RTN
*****************************************
Complete	R1=A			* R1[A]= Char_Data
		GOC	+
-		D1=D1+	34-1
		P=P+1
+		DAT1=A	P
		D1=D1+	1
		P=P+1
		DAT1=A	P
		?P#	15
		GOYES	-
		ST=1	sHalfChar
		D1=D1-	1
*****************************************
SVF2RTN		P=	0
		AD1EX
		LC(5)	7*34-1
		A=A-C	A
		D1=A			* Display ->next Char
		GOTO	Ln->Fnt2Lp
*****************************************
* Sets TOPLINE= Previous/Next Title
*****************************************
SVFindTitle	D0=(5)	vTOPLINE
		A=DAT0	A
		?ST=0	sUpSearch
		GOYES	+
		C=A	A
		GONC	++
+		D0=D0+	5
		C=DAT0	A		* C.A= #Lines
		C=C-A	A
++		D=C	A		* D.A= #Lines to Scan
		A=A+A	A
		A=A+A	A
		A=A+A	A		* A.A= #TopLine * 8
		C=R0
		C=C+A	A
		D0=C			* ->$view (Current TopLine)
		GOSUB	SVGetTitle	* Get Prev/Next Title
		GONC	+		* CC: Title Found
		GOTO	SVMainOk	* CS: No More Titles - Quit
+		?ST=0	sUpSearch
		GOYES	+
		C=D	A
+		D0=(5)	vTOPLINE
		DAT0=C	A		* Update TopLine
		C=0	A
		R4=C			* Reset X-Offset
		GOTO	SVMain
*****************************************
* Builds the $view structure, wich is a
* List of Pointers for the str & grobs to Display.
* We directly use the "Raw Temp Memory" between
* the RPL Return Stack and the Data Stack.
*
* 1: #Rows	(6->FONT1 and 8->FONT2)
* 2: #Cols	(#Chars for $ / #Cols for Grob)
* 5: ->Data	(Chars / Pixels)
*
* Note: if #Rows is ZERO then is a Text Line
*
* R0= ->$view
* R1= ->$Line Start
* R2= ->Last Space_Char
* R3= #Memory Blocks (8 Nibb each)
*****************************************
		STITLE	$View Engine

Make$View	GOSBVL	=ROOM		* C.A= Available Nibbles
		C=C+A	A		* C.A= ->Dsktop
		A=A+CON	A,5		* -> Rsktop + 5
		C=C-A	A		* C.A= Free Mem
		R0=A			* R0.A= ->$view (RSKTOP+5)
		D1=A
		CSRB.F	A		* C.A = $View Size/2
		CSRB.F	A		* C.A = $View Size/4
		CSRB.F	A		* C.A = $View Size/8
		R3=C	A		* B.A= #Memory Blocks (of 8 nibbles)
		D0=(5)	vBLOCKCOUNT
		DAT0=C	A		* Save Total Blocks

* We Dispatch the Object...

		D0=D0+	5		* D0 ->aOBJECT
		A=DAT0	A
		D0=A			* D1 ->Object
		A=DAT0	A		* A.X= Object Prologue
		LC(5)	=DOLIST
		ST=0	sListOb
		?A#C	A		* Is it a List?
		GOYES	+
		ST=1	sListOb
		D0=D0+	5		* D0 ->$
		GONC	PackStr
+		LC(3)	=DOCSTR
		?A=C	A		* Is it a String?
		GOYES	PackStr
		ST=0	sUFL1		* Use 8 Rows to Pack Each Line!
		GOSUB	PackGrob	* Assume its a Grob!
		GOTO	CountLines
*****************************************
* We Pack a String
*****************************************
PackStr		ST=1	sNewLine	* LineFeed Pack!
		D0=D0+	5
		C=DAT0	A
		D0=D0+	5
		AD0EX
		D0=A
		D0=D0-	2
		R1=A			* R1.A= ->First $Line
		C=C-CON	A,5
		CSRB.F	A
		D=C	A		* D.A= #Chars loop
$Scan1		B=0	B		* Word-Wrap Char Counter
$Scan2		C=0	A
		R2=C.F	A		* Clear ->Space_Char
		ST=0	sFull		* Not Full Width!
$Scan		D=D-1	A		* <-------------+
		GOC	$ScanDone	*		|
		D0=D0+	2		*		|
		A=DAT0	B		* A.B= Char	|
		LC(2)	10		*		|
		?A#C	B		* LineFeed?	|
		GOYES	+
		GOSUB	Pack$Line
		GONC	$Scan1

+		LC(1)	2
		?A=C	B		* GROB Control Char?
		GOYES	FindGrob

		LC(2)	32
		?A#C	B		* Space Char?
		GOYES	$Width
		CD0EX
		D0=C
		R2=C.F	A		* R2.A= ->Last Space_Char

$Width		?ST=0	sWordWrap	* WordWrap Disabled?
		GOYES	$Scan
		?ST=1	sFull		* Full Line?
		GOYES	$Scan
		B=B+1	B		* Inc. Width Counter
		LC(2)	(sWrapWidth)+1
		?B#C	B
		GOYES	$Scan
		C=R2.F	A
		?C#0	A		* Space Char?
		GOYES	+
		ST=1	sFull
		GONC	$Scan

+		AD0EX
		D0=A			* A.A= ->Current_Char
		A=A-C	A
		ASRB.F	A
		B=A	B		* Update Width Counter!
		GOSUB	Pack$Line'
		GONC	$Scan2

$ScanDone	D0=D0+	2
		GOSUB	Pack$Line	* Pack String's Last Line!

CountLines	D0=(5)	vBLOCKCOUNT
		C=DAT0	A		* C.A= Total #Blocks
		A=R3			* A.A= Available #Blocks
		C=C-A	A		* C.A= #Lines = (Total-Available)
		D0=(2)	vLINECOUNT
		DAT0=C	A		* Save #Lines
		RTN
*****************************************
* Search for a GROB inside the List,
* if we find it, we Pack it!
*****************************************
FindGrob	?ST=1	sListOb		* No List to Scan?
		GOYES	+
		GOTO	$Scan
+		D=D-1	A		* Remove \02 char
		GOC	$ScanDone

		ST=0	sNewLine
		GOSUB	Pack$Line
		ST=1	sNewLine
		D0=D0+	2
		C=DAT0	B

		CDEX	A
		RSTK=C			* Save D.A (# Chars Counter)
		LC(5)	aOBJECT
		CD0EX
		RSTK=C			* Save D0

		C=DAT0	A		* C.A= ->Object
		C=C+CON	A,10
		D0=C			* ->$ Size Field
		A=DAT0	A
		A=A+C	A
		D0=A			* ->First GROB / SEMI
FGLoop		A=DAT0	A
		LC(5)	=SEMI
		?A=C	A
		GOYES	FGQuit
		D=D-1	B
		?D=0	B		* This Grob?
		GOYES	GrobFound
		GOSBVL	=SKIPOB
		GONC	FGLoop
GrobFound	LC(5)	=DOGROB
		?A#C	A
		GOYES	FGQuit
		GOSUB	PackGrob
FGQuit		C=RSTK
		D0=C			* Restore D0
		C=RSTK
		D=C	A		* Restore D.A
		GOTO	$Scan1
*****************************************
* We Pack a TEXT Line
* IN:
* R0.A= ->$LineStart	D0-> $LineEnd
* Uses: A,C,D1,R1
*****************************************
Pack$Line	CD0EX
		D0=C
Pack$Line'	A=R3.F	A
		A=A-1	A		* Alloc 8 Nibbles
		GOC	$MemErr
		R3=A.F	A		* Update Free Memory

* Set Type= Text_Line

		A=0	P
		DAT1=A	P		* Write #Rows=0 (Text Line)
		D1=D1+	1

* Write Line Length

		A=C	A		* A.A= ->$ Line End Pointer
		C=C+CON	A,2		* ->New $begin (skip \n,' ')
		?ST=1	sNewLine
		GOYES	+
		C=C+CON	A,2
+		CR1EX.F	A		* R1= ->New $Begin,  C.A= ->old $begin
		A=A-C	A
		ASRB.F	A		* A.A= #Chars Between...
		DAT1=A	B		* Write #chars
		D1=D1+	2

* Write ->Chars Pointer

		DAT1=C	A		* Write ->$ Line Begin Pointer
		D1=D1+	5
		RTNCC
*****************************************
$MemErr		C=RSTK			* Pop RTN address
		C=RSTK
		GOVLNG	=GPMEMERR
*		D0=(5)	=ANNCTRL
*		C=DAT0	P
*		CBIT=1	3
*		DAT0=C	P
*		GOTO	CountLines
*****************************************
* Pack a GROB into $View
* In:
* D0 ->GROB
* B.A= #Memory Blocks (8 Nibbles)
* D1 ->$View
* R2= Grob Width
* Note: We can use R2 since it's going
* to get clear anyway in: $scan1
*****************************************
PackGrob	D0=D0+	10
		C=DAT0	A
		D=C	A		* D.A= Grob Height
		D0=D0+	5
		A=DAT0	A		* A.A= Grob Width (Pixels)
		D0=D0+	5
		GOSBVL	=w->W		* Pixels -> Nibbles
		R2=A			* A.A= Grob Width (Nibbles)

PackGrobLine	C=R3.F	A
		C=C-1	A		* Alloc 8 Nibbles
		GOC	$MemErr
		R3=C.F	A
		C=0	A
		LC(1)	6
		?ST=1	sUFL1	* Using Font1? Then Code 6 Pixels Height per Line
		GOYES	+
		LC(1)	8
+		?D>C	A		* Full Grob Line?
		GOYES	+
		C=D	A		* Pack a $Line with fewer Rows
+		D=D-C	A
		DAT1=C	P		* Write #Rows
		D1=D1+	1

		A=R2.F	A
		DAT1=A	B		* Write Grob Width
		D1=D1+	2

		A=A+A	A
		C=A	A
		C=C+C	A
		C=C+A	A		* C.A= 6*(Grob_Width)
		?ST=1	sUFL1
		GOYES	+
		C=C+A	A
+		AD0EX
		DAT1=A	A		* Write ->Data Pointer
		D1=D1+	5
		A=A+C	A
		D0=A			* D0-> Next $Line Pointer (6 or 8 Rows Below)
		?D=0	A		* No more Rows?
		RTNYES
		GONC	PackGrobLine
*****************************************
*	TITLE - ENGINE
* Show an Index, displaying Title Lines
* and allowing Fast jump to them...
*****************************************
		STITLE	$Title Engine

$TitleEngine	D0=(5)	vLINECOUNT
		C=DAT0	A
		D0=(2)	vLINESLEFT
		DAT0=C	A		* Save #Lines to Do
		C=R0
		C=C-CON	A,8
		D0=(2)	a$VIEW
		DAT0=C	A
next$Titles	GOSUB	Make$Titles
		?A#0	A		* Any Titles?
		GOYES	+		* No - Return!
		GOTO	$TQuit
+		C=0	A
		D0=(2)	vTOPTITLE
		DAT0=C	A
		D0=D0+	5		* ->vTITLECOUNT
		DAT0=A	A		* Save #Titles
*****************************************
$TMain!		GOSUB	SVDispTitles
$TMain		GOSUB	SVKeyboard?
		GOC	$TMain		* Wait Key Release!

		GOSBVL	=clrbusy
		SHUTDN
		GOSBVL	=showbusy

		LC(2)	EEXCODE
		GOSUB	SVKeyDn?
		GOC	next$Titles

		B=0	A		* B.A= #Key
		LC(2)	KEY0
		GOSUB	SVKeyDn?
		GONC	+
		GOTO	Jump2Title

+		LC(2)	KEY1
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY2
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY3
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY4
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY5
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY6
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY7
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY8
		GOSUB	ThisShort?
		GOC	Jump2Title

		LC(2)	KEY9
		GOSUB	ThisShort?
		GOC	Jump2Title

$TOk		GOSBVL	=OnKeyDown?
		GOC	$TQuit
		GOTO	$TMain
$TQuit		GOSUBL	SVKeyboard?	* Loop Until Keyboard Released!
		GOC	$TQuit
		RTN
*****************************************
ThisShort?	B=B+1	A		* Increase Key Shortcut!
		GOLONG	SVKeyDn?
*****************************************
* Jump to Title in B[A]
*****************************************
Jump2Title	D0=(5)	vTITLECOUNT	* ->vTITLECOUNT
		C=DAT0	A
		?B>=C	A		* Title in Range?
		GOYES	$TOk		* No - Quit
		B=B+B	A
		B=B+B	A
		LC(5)	$TITLES
		C=C+B	A
		D1=C			* -> #Line (from $view)
		C=0	A
		R4=C			* Reset X-offset
		C=DAT1	4		* C.A= #Line
		D0=(2)	vTOPLINE
		DAT0=C	A		* Update it!
		RTN			* Quit!
*****************************************
* Build the $Titles structure, starting
* from the #Line in R3[A]
*****************************************
Make$Titles	D1=(5)	$TITLES		* ->$titles (output buffer)
		D0=(5)	vSCRNLINES
		C=DAT0	A
		B=C	A		* B.A= #Titles Counter
		D0=(2)	vLINESLEFT
		C=DAT0	A
		D=C	A		* D.A= #Lines Left to Scan
		D0=(2)	a$VIEW
		C=DAT0	A
		D0=C			* ->$view
		ST=0	sUpSearch	* Search Down!

$TLoop		GOSUB	SVGetTitle
		GOC	$TDone		* CS: No Title - Quit
		C=C-1	A		* C.A= Current Line 0-N
		DAT1=C	4		* Write Title's #Line
		D1=D1+	4
		B=B-1	B		* Decrease Title Counter
		?B#0	B
		GOYES	$TLoop

$TDone		CD0EX
		D0=(5)	a$VIEW
		DAT0=C	A		* Save $view Pointer
		C=D	A
		D0=(2)	vLINESLEFT
		DAT0=C	A		* Save #Lines to Scan
		D0=(2)	vSCRNLINES
		A=DAT0	A
		A=A-B	A
		RTN
*****************************************
* Returns in C.A next #Title_Line
* CS: Title Not Found
* CC: Title Found
*****************************************
SVGetTitle	?D=0	A
		RTNYES
		D=D-1	A
		?ST=1	sUpSearch	* Search Backwards?
		GOYES	+
		D0=D0+	8
		GONC	++
+		D0=D0-	8
++		C=DAT0	P
		?C#0	P		* String Line?
		GOYES	SVGetTitle	* No, ->Loop
		D0=D0+	3
		C=DAT0	A		* C.A= ->Chars
		D0=D0-	3
		CD0EX
		A=DAT0	B		* A.B= First Char
		D0=C			* Restore D0
		LCASC	'*'
		?A#C	B		* Title Line?
		GOYES	SVGetTitle	* No, ->Loop
		AD0EX
		D0=(5)	vLINECOUNT
		C=DAT0	A		* C.A= #Lines
		D0=A			* Restore D0
		C=C-D	A
		RTNCC
*****************************************
SVDispTitles	D=0	A		* Start in Row 0
-		C=0	A
		C=D	XS
		CSR	X
		CSR	X		* C.A= #ScreenLine
		D0=(5)	vSCRNLINES
		A=DAT0	A
		?C>=A	B		* ScreenLine in Range?
		RTNYES
		GOSUB	DispTitle
		D=D+1	XS
		GONC	-
*****************************************
* Display a Title. IN:
* C.X= #ScreenLine
*****************************************
DispTitle	D0=(5)	vTOPTITLE
		GOSUB	D1->WipeLine	* D1 ->ScreenLine, B.A= #Title

* Display the Shorcut Number 0-9

		ABEX	A		* A.A= #ScreenLine, B.A= #Title
		C=0	A
		LCASC	'0'
		A=A+C	A		* A.A= Char# (0-9)
		D=0	B
		ST=1	sInvFont	* Invert the Font!
		?ST=1	sUFL1
		GOYES	+
		GOSUB	Chr->Fnt2
		GOC	++
+		GOSUB	Chr->Fnt1
++		ST=0	sInvFont

* Display the Title Line

		B=B+B	A
		B=B+B	A
		LC(5)	$TITLES
		C=C+B	A
		D0=C			* ->#Title
		C=0	A
		C=DAT0	4		* C.A= #Line to Display from $view
		C=C+C	A
		C=C+C	A
		C=C+C	A		* C.A= 8*(#Line)
		A=R0
		C=C+A	A
		D0=C			* ->String_Structure ($view)
		D0=D0+	1		* skip #Rows Field
		C=DAT0	B		* A.A= #Chars
		C=C-1	B		* Remove First Char
		D0=D0+	2
		A=DAT0	A
		A=A+CON	A,2		* Skip '*' Char
		D0=A
		?C=0	B
		RTNYES
		D=C	B
		?ST=1	sUFL1
		GOYES	+
		LC(2)	21
		GOTO	Line->Fnt2
+		GOTO	Line->Font1	* Display the Line!
    ENDCODE
   ;
 ;



ASSEMBLE
_F48TREE
RPL
::
  inTree? ?SEMI
  dispMode@ #0=case	( Windows Style? )
  ::
    F48GotoTree		( Switch to Tree )
    dirOb? libOb? OR portMode? AND NOT?SEMI	( Reload! if in Port Mode! )
    FalseFalse dirOb! libOb!
    TRUEreload!
   ;

  TRUE F48Tree

ASSEMBLE
_F48Reload
RPL
  ::
    NOT?SEMI
    FalseFalse dirOb! libOb!
    TrueTrue reload! portMode!
    DUPTYPEBINT? case port!
    DUP CONTEXT! context!
    FalseTrue dirOb! portMode!
   ;
 ;



ASSEMBLE
_F48KeyUp
RPL
::
  F48KeyRepeat
  ELEVEN

ASSEMBLE
_F48UP
RPL
  ::
    inTree? case F48DirUp

    index@ min@
    #=case
    ::
      index@ #1= ?SEMI  ( already at TOP? )

      max@ #1- max!
      min@ #1-DUP min!
      DUP index!
      ONE
      TRUE

      statusMode@
      dispMode@
      FALSE		( 3API? )
      CODE
		STITLE	UP-KEY Display Refresh
		ST=1	Files		* Ensure Files!
		GOSUB	CpyScreenDwn
		LC(2)	6-1		* Loop counter
cpyInvbarLineUp D0=D0-	15
		D1=D1-	15

		?ST=0	Windows
		GOYES	+
		P=	15-1
		A=DAT0	WP
		A=-A-1	WP
		DAT1=A	WP
		P=	0
		D0=D0-	17+2
		D1=D1-	17+2
		GONC	prevLine

+		D0=D0-	1
		D1=D1-	1
		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		D0=D0-	16
		D1=D1-	16
		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		D0=D0-	2
		D1=D1-	2
prevLine	C=C-1	B
		GONC	cpyInvbarLineUp
		GOSBVL	=GETPTR
		GOLONG	File>Disp
*****************************************
* When scrolling:
* Refreshes the screen for next item
*****************************************
CpyScreenDwn	GOSUB	PopModes
		C=0	A
		LC(2)	30-1
		?ST=1	FullStatus
		GOYES	+
		LC(2)	36-1
+		B=C	A		* B.B= Lines to Copy
		D0=(5)	#8068D
		A=DAT0	A
		LC(3)	50*34-2
		A=A+C	A
		D0=A
		LC(3)	6*34
		A=A+C	A
		D1=A
		LC(2)	32
		?ST=0	Files
		GOYES	+
		?ST=0	Windows
		GOYES	UpSetup
		LC(2)	15
		GONC	UpSetup

+		?ST=0	Windows
		GOYES	UpSetup
		D0=D0-	16
		D1=D1-	16
		LC(2)	16

UpSetup		D=C	A		* D.A= Nibbs to Copy
		LC(2)	34
		C=C-D	A
		R0=C.F	A		* R0.A= Nibbs for prev Line
copyLineUp	C=D	A		* C.A= Nibbles to Copy
		GOSBVL	=MOVEUP
		C=R0.F	A
		AD0EX
		A=A-C	A
		D0=A
		AD1EX
		A=A-C	A
		D1=A
		B=B-1	A
		GONC	copyLineUp
		RTN
*****************************************
* Pops the statusMode & dispMode
* from the Stack.
*****************************************
PopModes	ST=0	Windows
		ST=0	FullStatus
		GOSBVL	=popflag
		GONC	+
		D1=D1+	10
		D=D+1	A
		D=D+1	A
		GOTO	SavRtn
+		GOSBVL	=POP2#
		?C#0	A
		GOYES	+
		ST=1	Windows
		GONC	++
+		?ST=0	Files
		GOYES	SavRtn
++		?A#0	A
		GOYES	SavRtn
		ST=1	FullStatus
SavRtn		GOVLNG	=SAVPTR
      ENDCODE
      F48Slider
     ;
    index@ #1-
    F48IndexDraw
   ;
  FALSE downEnter!
  inTree? case

ASSEMBLE
		CON(5)	=DOCODE
		REL(5)	->WaitEnd
WaitTime!	GOSBVL	=SAVPTR
		GOSBVL	=DisableIntr	* All Interrupts Off!
		GOSUB	ClrBusy		* Busy Annunciator Off!
LoadTime	D0=(5)	=TIMER2
		LC(5)	8192*50/100	* Loop 0.5 Seconds
		A=DAT0	A
		A=A-C	A
		B=A	A		* B[A]= Stop_Time
->Lup		LC(2)	18
		GOSUB	KeyPressed?
		GONC	+
*****************************************
KeyRight!	GOSUB	C=RStkGPEvalC	* Run DownDir Code!

RPL
::
  F48$Dir@
  F48Reload
  %0		( Dummy replace for { Item } )
  ELEVEN
  F48#EVAL	( Run F48DOWNDIR )
 ;
ASSEMBLE

C=RStkGPEvalC	GOSUB	ShowBusy	* Busy Annunciator On!
		C=RSTK
		GOSBVL	=AllowIntr	* Interruptions On!
		GOVLNG	=GETPTREVALC
*****************************************
+		LC(2)	11
		GOSUB	KeyPressed?
		GOC	KeyUp!
		LC(2)	17
		GOSUB	KeyPressed?
		GOC	KeyDwn!
		C=DAT0	A
		?C>B	A		* Loop Again?
		GOYES	->Lup
		GOSUB	C=RStkGPEvalC	* Update Right Side!
RPL
::
  F48$Dir@
  F48Reload
 ;
ASSEMBLE
*****************************************
KeyPressed?	A=C	A		* A[B]= Key
		GOVLNG	=ThisKeyDown?
ClrBusy		GOVLNG	=clrbusy
ShowBusy	GOVLNG	=showbusy
*****************************************
KeyUp!		A=PC
L1		LC(5)	(L1)-(_F48UP)
		A=A-C	A		* A[A]= F48UP Routine
		LC(5)	=ELEVEN
		GOTO	Up/DnEval
*****************************************
KeyDwn!		A=PC
L2		LC(5)	(_F48DOWN)-(L2)
		A=A+C	A		* A[A]= F48DOWN Routine
		LC(5)	=SEVENTEEN
Up/DnEval	RSTK=C			* Save Key
		GOSUB	ShowBusy	* Busy Annunciator On!
		GOSBVL	=GPPushA	* Push Routine!
		D=D-1	A
		D1=D1-	5
		C=RSTK			* Restore Key
		DAT1=C	A		* Push Key!
		A=PC
		A=A+CON	A,10
		PC=(A)			* Run Auto-Repeat Engine
		CON(5)	=DOCOL
		CON(5)	=OVER
		CON(5)	=EVAL
		CON(5)	=DOCODE
		REL(5)	->KeyEnd
		GOLONG	KeyLoop!
->KeyEnd	CON(5)	=DROP
		CON(5)	=COLA
		CON(5)	=DOCODE
		REL(5)	->WaitEnd
		GOSBVL	=SAVPTR
		GOSUB	ClrBusy		* Busy Annunciator Off!
		GOTO	LoadTime	* Loop Again!
*****************************************
->WaitEnd
RPL
 ;



ASSEMBLE
_F48MAXUP
RPL
::

ASSEMBLE
_F48MaxUpSetup
RPL
  ::
    ONEONE index! min!
    n@ maxFiles@ #MIN max!
    F48SafeSlider
   ;

ASSEMBLE
_F48Files/Dirs
RPL
  ::
    inTree? NOTcase F48FilesDraw
    F48DirsDraw
    F48$Dir@
    F48Reload
   ;
 ;



ASSEMBLE
_F48KeyDown
RPL
::
  F48KeyRepeat
  SEVENTEEN

ASSEMBLE
_F48DOWN
RPL
  ::
    inTree? case F48DirDown

    index@ max@
    #=case
    ::
      index@ n@ #= ?SEMI ( already at BOTTOM? )

      min@ #1+ min!
      max@ #1+DUP max!
      DUP index!
      maxFiles@
      TRUE

      statusMode@
      dispMode@
      FALSE		( 3API? )
      CODE
		STITLE	DOWN-KEY Display Refresh
		ST=1	Files		* Ensure Files!
		GOSUB	CpyScreenUp
		LC(2)	6-1		* Loop counter
cpyInvbarLineDn ?ST=0	Windows
		GOYES	+
		P=	15-1
		A=DAT0	WP
		A=-A-1	WP
		DAT1=A	WP
		P=	0
		D0=D0+	16
		D1=D1+	16
		GONC	nexLin

+		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
		D0=D0+	16
		D1=D1+	16
		A=DAT0	W
		A=-A-1	W
		DAT1=A	W
nexLin		D0=D0+	16+2
		D1=D1+	16+2
		C=C-1	B
		GONC	cpyInvbarLineDn
		GOSBVL	=GETPTR
		GOLONG	File>Disp
*****************************************
* When scrolling:
* Refreshes the screen for next item
*****************************************
CpyScreenUp	GOSUB	PopModes
		D0=(5)	#8068D
		A=DAT0	A
		C=0	A
		?ST=0	FullStatus
		GOYES	HoleWidth
		LC(2)	30-1
		B=C	A
		LC(3)	14*34
		GONC	AddSource
HoleWidth	LC(2)	36-1
		B=C	A
		LC(3)	8*34
AddSource	A=A+C	A
		D1=A
		LC(3)	6*34
		A=A+C	A
		D0=A

		LC(2)	32
		?ST=0	Files
		GOYES	+
		?ST=0	Windows
		GOYES	DownSetup
		D0=D0+	17
		D1=D1+	17
		LC(2)	15
		GONC	DownSetup

+		?ST=0	Windows
		GOYES	DownSetup
		LC(2)	16

DownSetup	D=C	A
		LC(2)	34
		C=C-D	A
		R0=C.F	A		* R0.A= Nibbs for next Line

copyLineDown	C=D	A		* Nibbles to copy
		GOSBVL	=MOVEDOWN
		C=R0.F	A
		AD0EX
		A=A+C	A
		D0=A			* ->nextLine
		AD1EX
		A=A+C	A
		D1=A			* ->nextLine
		B=B-1	A
		GONC	copyLineDown
		RTN
      ENDCODE
      F48Slider
     ;
    index@ #1+
    F48IndexDraw
   ;
  TRUE downEnter!
  inTree? case
CODE
		GOTO	WaitTime!
ENDCODE
 ;



ASSEMBLE
_F48MAXDOWN
RPL
::

ASSEMBLE
_F48MaxDnSetup
RPL
  ::
    n@ maxFiles@ #1+ OVER#> case index!

    DUPDUP index! max!
    maxFiles@ #1-- min!
    F48SafeSlider
   ;

  F48Files/Dirs
 ;



ASSEMBLE
_F48KeyEnter
RPL
::
  F48KeyRepeat
  TWENTYFIVE

ASSEMBLE
_F48ENTER
RPL
  ::
    inTree? ?SEMI
    n@ #0=?SEMI
    $vars@ index@
*****************************************
* Select/Un-Select #nth Object from $vars
* 2:  $vars
* 1:  #nth_ob	->
*****************************************
    CODE

max		EQU 2

		STITLE	File Check/Uncheck Engine
		GOSBVL	=POP#
		R0=A			* R0.A= #index
		GOSBVL	=PopASavptr
		R1=A			* R1.A= ->$vars
		D1=A
		D1=D1+	15		* ->#obs_Field
		C=DAT1	A
		R2=C			* R2.A= #obs
		D1=D1+	5		* D1 ->#Sel_Field
		A=DAT1	A		* A[A]= #Selected Obs
		LC(5)	999
		ST=0	max
		?A<C	A		* Max Selection not Reached?
		GOYES	+
		ST=1	max		* set max Flag!

* Get #index Object's Size

+		C=R0			* C.A= #index
		C=C+1	A
		GOSUBL	IntMult20	* C.A= (index#)*20
		A=R1
		A=A+C	A
		D0=A
		D0=D0+	5		* ->Size_Field
		C=DAT0	A		* C.A= Ob_Size

* Read Sel_Field to see if we
* check or uncheck index Obj

		D0=D0-	10		* D0 ->Sel_Field
		A=DAT0	A
		?A#0	X		* Selected Object?
		GOYES	uncheck		* yes, uncheck it!

		?ST=1	max		* if max Reached, quit!
		GOYES	pExit

* Increase #Sel_Field

		A=DAT1	A
		A=A+1	A		* Increase #sel files
		DAT1=A	A
		DAT0=A	X		* Select Index Obj!

* Update TotalSize_Field

		D1=D1+	5		* ->SelSize_Field
		A=DAT1	A		* A.A= Total
		A=A+C	A		* A.A= Total + Ob_Size
		DAT1=A	A		* new Total!
pExit		GOVLNG	=GETPTRLOOP
*****************************************
uncheck		B=A	A		* B.X= Save Selection#
		A=0	A
		DAT0=A	X		* Un-Select object

* Decrease #sel_Field

		A=DAT1	A
		A=A-1	A
		DAT1=A	A		* Update #Selected

* Update TotalSize_Field

		D1=D1+	5
		A=DAT1	A		* A.A= Total
		A=A-C	A		* A.A= Total - Ob_Size
		DAT1=A	A		* new Total!
		D1=D1+	10		* ->First_Ob

		C=R2			* C.A= #obs
		D=C	A		* Loop counter
decLup		D=D-1	A
		GOC	pExit
		C=DAT1	X
		?C<B	X
		GOYES	+
		C=C-1	X		* Update Sel_Field
		DAT1=C	X
+		D1=D1+	20
		GOTO	decLup
    ENDCODE
    F48StatusDraw	( Actualizar Estado )
*****************************************
    max@ #1+ min@
    DO
      INDEX@
      DUP min@ #-+1
      OVER index@ #=
*****************************************
* 3:   #nthel (1-n)
* 2:	 #pos (1-8)
* 1:  Invert? (true/false)  ->
*****************************************
      CODE
		ST=1	check		* Display the Check Only!
		GOLONG	Check>Disp
      ENDCODE
    LOOP
    %0		( Dummy Replace for { Item } )
    downEnter?
    ITE
    SEVEN	( F48DOWN )
    FIVE	( F48UP )
    F48#EVAL	( Run Internall Call! )
   ;
 ;



ASSEMBLE
_F48UPDIR
RPL
::
  inTree? ?SEMI

  context@ HOMEDIR?
  portMode? dirOb? libOb? ORNOT AND
  ORcase
  ::
    dispMode@ #0=case
ASSEMBLE
_F48GotoTree
RPL
    ::
      TRUE inTree!
      F48IndexPos FALSE F48FileDraw
      F48SwapLocals
      F48IndexPos TRUE F48DirDraw
      F48MenuDraw
     ;

    TrueTrue F48Tree NOTcase quit!

    TRUEreload!
    SWAPFALSE dirOb! portMode!
    DUPTYPEBINT? case port!
    DUP CONTEXT! context!
    FalseTrue dirOb! portMode!
   ;

  TRUEreload!
  context@ DUPZERO context!	( free-up the Ob )
  prevContext!
  libOb? dirOb? NOTAND
  FalseTrue updir! libOb!
  caseDROP
  port@
  portMode?

*****************************************
* Improved Version of GETUPDIR, Works
* on Directories inside any Port too!
* 3:  Context@		UpDIR@
* 2:     port@  ->	'Id'
* 1: portMode?	-> 	True / False
*****************************************
  CODE
		STITLE	Updir Engine

DirFound	EQU 3

F48GetUpDir	CLRST
		GOSBVL	=popflag
		GONC	+
		ST=1	PortMode
+		GOSBVL	=POP#
		R2=A			* R2.A= Port#
		GOSBVL	=PopASavptr
		R1=A			* R1.A= ->Directory

		D0=A
		A=DAT0	A
		LC(5)	=DOBINT
		?A#C	A		* Bint?
		GOYES	+
		D0=D0+	5		* Extract DIR embedded inside Bint
		C=DAT0	A
		R1=C			* R1.A= ->Directory

+		?ST=0	PortMode	* Not inside Port?
		GOYES	SafeUpdir

		A=R2			* A.A= Port#
		?A=0	A		* Port0?
		GOYES	SafeUpdir

		A=A-1	A
		?A=0	A		* Port1?
		GOYES	SafeUpdir
		ST=1	HighPort

SafeUpdir	GOSUB	UpdirEnd

* The Following Code is copied to
* the uart_buffer for safe Evaluation!

UpdirStart	?ST=0	HighPort
		GOYES	Updir!

		D1=(5)	=CARD1STAT
		C=DAT1	B
		?CBIT=0	3		* Card1 Not Present?
		GOYES	GetBank
		ST=1	Card1		* Card 1 Plugged!

		?CBIT=0	5		* 32K Card?
		GOYES	Uncover
		ST=1	Card1_128K	* Card 1 is 128K!

Uncover		LC(5)	#C0000		* Load Card1 Start Address
		UNCNFG			* Unconfigure it!

GetBank		A=R2			* A.A= Port#
		A=A-1	A
		A=A-1	A		* A.A= Bank# (Port# - 2)
		A=A+A	A		* A.A= (Bank#)*2
		LC(5)	#7F040
		C=C+A	A
		D0=C
		C=DAT0	B		* tells bank switcher bank# to read

* Finally the Updir Engine!

Updir!		D1=(5)	(=uart_buffer)+(UpdirEnd)-(UpdirStart)
		LC(5)	=DOIDNT
		DAT1=C	A
		D1=D1+	5

		A=R1			* A.A= ->Directory
		D0=A
		GOSBVL	=TRAVERSE-	* D0 ->Name
		C=0	A
		C=DAT0	B
		C=C+C	A
		C=C+1	A
		C=C+1	A
		GOSBVL	=MOVEDOWN	* Copy Name to Safe Area!

		A=R1
		D1=(5)	=USEROB
		C=DAT1	A
		?A#C	A		* Not HomeDir?
		GOYES	+
notFound	GOTO	CardConfig?
+		R0=C			* R0.A= ->HomeDir
		D0=A			* D0 ->Context@
		GOSBVL	=TRAVERSE-	* D0 ->Name
		D0=D0-	10
		A=DAT0	A
		LC(5)	=DOBAK
		?A=C	A		* Backup?
		GOYES	notFound
		D0=D0+	5
nxtObLup	C=DAT0	A
		?C=0	A		* Link=0?
		GOYES	getDir
		AD0EX
		A=A-C	A
		D0=A			* D0 ->nxtOb
		D0=D0-	5		* D0 ->link
		GOTO	nxtObLup
*****************************************
getDir		ST=1	DirFound
		D0=D0-	5		* ->Dir's LastRam-Word
		AD0EX

* Get Home's Last Object Offset

		C=R0			* Get ->Homedir
		D1=C
		D1=D1+	5
		C=DAT1	A
-		C=C-1	X
		GOC	+
		D1=D1+	13
		GONC	-
+		D1=D1+	3
		CD1EX
*****************************************
		?A#C	A		* Not Homedir?
		GOYES	+
		A=R0			* Get Homedir
		GONC	CardConfig?
+		A=A-CON	A,5+3		* A.A= ->UPDIR
*****************************************
* If we accessed a Covered Port and
* Card 1 is Plugged, then we have to
* Re-Configure Card 1 back at #C0000
*****************************************
CardConfig?	?ST=0	HighPort	* Not a High Port?
		RTNYES

		?ST=0	Card1		* Card 1 Not Plugged?
		RTNYES

		C=0	A
		P=	4
		LC(1)	#C		* C.A= #C0000 address
		?ST=1	Card1_128K	* Card 1 is 128K?
		GOYES	+
		LC(1)	#F		* 32K Card
+		CONFIG			* Give Card Size Using Complementation
		LC(1)	#C
		CONFIG			* Configure Card 1 back at #C0000
		P=	0
		RTN

* Here we copy the Updir Code to the
* uart_buffer for Safe Evaluation.

UpdirEnd	C=RSTK
		D0=C			* D0 ->Updir Code
		D1=(5)	=uart_buffer
		LC(5)	(UpdirEnd)-(UpdirStart)
		GOSBVL	=MOVEDOWN
		GOSBVL	=uart_buffer	* Eval Safe Code!

		?ST=1	DirFound	* Dir Found?
		GOYES	+
		GOSBVL	=GETPTR
		GONC	PushID

+		?ST=0	HighPort	* UnCovered Port?
		GOYES	PushPtr!
		R0=A
		GOSBVL	=PUSH#
		GONC	PushID
PushPtr!	GOSBVL	=GPPushA

PushID		D=D-1	A
		D1=D1-	5
		LC(5)	(=uart_buffer)+(UpdirEnd)-(UpdirStart)
		DAT1=C	A		* Push Safe Name
		?ST=1	DirFound
		GOYES	+
+		GOVLNG	=PushT/FLoop
  ENDCODE
  NOTcasedrop :: FALSE dirOb! ;
  DROPDUP context!
  portMode? caseDROP
  CONTEXT!
  F48DirCenter
 ;



ASSEMBLE
_F48DOWNDIR
RPL
::
  inTree? case
  ::
    FALSE inTree!
    F48IndexPos FALSE F48DirDraw
    F48SwapLocals
    F48IndexPos TRUE F48FileDraw
    F48MenuDraw
   ;

  n@ #0=?SEMI

  $vars@
  index@
  port@ #>1	( Covered Port? )
  portMode? AND
  CODE

Covered		EQU 1

		CLRST
		GOSBVL	=popflag
		GONC	+
		ST=1	Covered
+		GOSBVL	=POP#
		C=A	A		* C.A= #index
		C=C+1	A		* +1 to skip Data Fields
		GOSUBL	IntMult20
		RSTK=C			* Save (#index)*20
		GOSBVL	=PopASavptr
		C=RSTK
		C=C+A	A
		D0=C
		D0=D0-	2		* ->Index Name_Field
		C=DAT0	A
		RSTK=C			* Save ->Name
		D0=D0+	5		* ->Type_Field
		A=0	A
		A=DAT0	B		* A.A= Object Type
		D0=D0+	7		* ->Object_Field
		C=DAT0	A
		RSTK=C			* Save ->Ob
		GOSUB	Push#ASavptr	* Push Object Type as Bint
		C=RSTK
		A=C	A		* A.A= ->Ob
		?ST=1	Covered
		GOYES	+
		GOSBVL	=GPPushA	* Push Ob
		GOSUB	Savptr
		GONC	PushName
+		GOSUB	Push#ASavptr	* Push ->Ob as bint

PushName	C=RSTK
		D0=C			* D0 ->Name
		GOSBVL	=MakeID
		GOVLNG	=PUSHA		* Push it!

Push#ASavptr	R0=A
		GOSBVL	=PUSH#
Savptr		GOVLNG	=SAVPTR
  ENDCODE

  ROT

  NINETEEN
  #=casedrop	( Library? )
  ::
    ID>$ CHR \\ >T$
    ::
      context@ HOMEDIR?
      dirOb? libOb? ORNOT
      ORcase
      ::
	portMode? NOT?SEMI
	port@ #>$ CHR_: >T$
	SWAP&$
       ;

      $path@ SWAP&$
     ;

    $path!	( save new Title )
    context!
    TRUEreload!
    TRUE libOb!
   ;

  #0=		( Directory? )
  NOTcase2DROP
  DROPDUP context!
  TRUE dirOb!
  TRUEreload!
  portMode? caseDROP
  CONTEXT!
  F48DirCenter
 ;



ASSEMBLE
_F48PREVMENU
RPL
::
  page@ #1-
  DUP#0=IT :: DROP pageMax@ ;

  page!
  F48MenuDraw
 ;



ASSEMBLE
_F48NXTMENU
RPL
::
  page@ pageMax@ OVER#=
  ITE DROPONE #1+

  page!
  F48MenuDraw
 ;



ASSEMBLE
_F48EVAL
RPL
::
  F48$Index@
  DROPSWAPDROP DUP prevContext!
  TrueTrue updir! reload!
  COLA_EVAL
 ;



ASSEMBLE
_F48SWAPHEADER
RPL
::
  statusMode@
  DUP#0=ITE TWO DUP#1-
  SWAPDROPDUP statusMode!

  DUP#0=csedrp
  ::
    TRUE refresh!
    SEVEN maxFiles!

ASSEMBLE
_F48Shift8->7
RPL
    ::
      n@ maxFiles@ #> NOT?SEMI
      index@
      min@ DUP#1+ min!
      OVER #<>case DROP
      #1+ index!
     ;
    F48SliderCalc

    dispMode@ #0<> ?SEMI

    F48SwapLocals
    F48Shift8->7
    F48SliderCalc
    F48SwapLocals
   ;

  TWO #=case
  ::
    TRUE refresh!

ASSEMBLE
_F48Shift7->8
RPL
    ::
      n@ maxFiles@ #> NOT?SEMI
      min@
      #1=case
      :: max@ #1+ max! ;
      min@ #1- min!
     ;

    EIGHT maxFiles!
    F48SliderCalc

    dispMode@ #0<> ?SEMI

    F48SwapLocals
    SEVEN maxFiles!		( Re-Calculate! )
    F48Shift7->8
    EIGHT maxFiles!
    F48SliderCalc
    F48SwapLocals
   ;

  F48StatusDraw
 ;



ASSEMBLE
_F48CST1
RPL
::
  COLA_EVAL
 ;



ASSEMBLE
_F48CST2
RPL
::
  F48$Index@
  DROPSWAP ROT
  COLA_EVAL
 ;



ASSEMBLE
_F48CST3
RPL
::
  F48$Checks@
  toLEN_DO
    DUP INDEX@ NTHCOMPDROP
    ?ACCPTR>
    SWAPDUP INDEX@ #1+ NTHCOMPDROP
    DUPTYPEBINT?
    ITE UNCOERCE
	TOTEMPOB
    SWAP
    TWO
  +LOOP
  LENCOMP
  get1
  SWAP #2/ UNCOERCE SWAP
  COLA_EVAL
 ;



ASSEMBLE
_F48CST4
RPL
*****************************************
* 2: { Path }
* 1: << PRG >>	->
*****************************************
::
  F48$Checks@
  3NULLLAM{} BIND
  1GETLAM LENCOMP
  ZERO_DO
    3GETLAM		( path )
    1GETLAM ISTOP-INDEX #1- NTHCOMPDROP
    ?ACCPTR>
    1GETLAM ISTOP-INDEX NTHCOMPDROP
    DUPTYPEBINT?
    ITE UNCOERCE
	TOTEMPOB
    2GETEVAL
    TWO
  +LOOP
  ABND
 ;



ASSEMBLE
_F48CST5
RPL
::
  F48$Index@
  2DROP SWAP
  COLA_EVAL
 ;



ASSEMBLE
_F48CST6
RPL
::
  F48$Checks@
  toLEN_DO
    DUP INDEX@ #1+ NTHCOMPDROP
    DUPTYPEBINT?
    ITE UNCOERCE
	TOTEMPOB
    SWAP
    TWO
  +LOOP
  LENCOMP #2/
  get1
  SWAP UNCOERCE SWAP
  COLA_EVAL
 ;



ASSEMBLE
_F48CST7
RPL
::
  NULL$ TEN EXPAND
  $vars@
  index@
*****************************************
* Packs the Index Object's Name and Object
* addresses to a new $.
* 3: $New
* 2: $vars
* 1: #Index	->	$New
*****************************************
  CODE
		GOSBVL	=POP#
		C=A	A
		C=C+1	A
		GOSUBL	IntMult20	* (index#)*20
		RSTK=C
		GOSBVL	=PopASavptr
		C=DAT1	A
		D0=C			* ->$ (new)
		D0=D0+	10		* skip fields
		C=RSTK
		A=A+C	A
		D1=A
		D1=D1-	5		* ->Index Object ($vars)
		GOSUB	CpyName&Ob	* Copy Name & Ob addresses!
		GOVLNG	=GETPTRLOOP
  ENDCODE
  SWAP COLA_EVAL
 ;



ASSEMBLE
_F48CST8
RPL
::
  $vars@
*****************************************
* Packs all Object's Name and Object
* addresses to a new $.

* 1: $vars	->	$New
*****************************************
  CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D1=A
		D1=D1+	20		* ->#Selected_Field
		A=DAT1	A
		C=A	A
		C=C+C	A
		C=C+C	A
		C=C+A	A
		GOSBVL	=MAKE$		* Alloc #n*10 Nibbs= 2/3 of $vars
		A=DAT1	A
		D1=A			* D1 ->$vars
		D1=D1+	15
		C=DAT1	A		* C.A= #Objects
*****************************************
nxtObLp		C=C-1	A
		GOC	AddrQuit
		D1=D1+	20		* ->Sel_Field
		A=DAT1	X
		?A=0	X		* Not Selected?
		GOYES	nxtObLp
		GOSUB	CpyName&Ob
		GONC	nxtObLp
AddrQuit	GOVLNG	=GPOverWrR0Lp
*****************************************
CpyName&Ob	D1=D1+	3		* skip Sel field
		A=DAT1	A		* A.A= ->Name
		DAT0=A	A		* Write ->Name Addr
		D0=D0+	5
		D1=D1+	12		* ->Ob_Field
		A=DAT1	A		* A.A= ->Ob
		DAT0=A	A		* Write ->Ob Addr
		D0=D0+	5
		D1=D1-	15		* Restore D1 ->Object's_Fields
		RTNCC
  ENDCODE
  SWAP COLA_EVAL
 ;



ASSEMBLE
_F48LIST
RPL
::
  dispMode@ DUP #2=
  ITE DROPZERO #1+
  DUP dispMode!

  ZERO #=casedrop
  ::
    F48LoadTree
    TRUE refresh!
   ;

  TWO #=case
  ::
    FALSE inTree!
    NULL$ $dirs!
    F48FilesDraw
   ;

  inTree? case
  ::
    FALSE inTree!
    F48SwapLocals
    TRUE refresh!
   ;

  F48FilesDraw
 ;



ASSEMBLE
_F48EDIT
RPL
::
  F48$Index@		( Id Ob #Type )
  TRUEreload!
  ::

* Algebraic
    TWO #=casedrop
    ::
      ' ViewLevel1
      "EQW"
     ;

* Array
    TWENTYTWO #=casedrop
    ::
      ' ViewLevel1
      "MATRIX"
     ;

* System RPL / Assembly Language
    TWENTYFOUR OVER#= SWAP EIGHT #= ORcase
    ::
      # 1BC04
      "ED"
     ;

* General Purpose Editor
    ' EditLevel1
    "TED"
   ;

  palparse DROP
  DUPTYPEROMP? IT SWAP
  DROP
  DUPTYPEBINT? case DO#EXIT

  ROT 1LAMBIND		( Save ID! )
  EVAL 1GETABND		( Eval Editor -> Obj Id )
  DEPTH #>1 NOTcaseDROP
  ::
    portMode? NOT?SEMI
    WipeLastArgs!	( Wipe Last Arguments! )
    DUP port@
    PTR 21806		( Id, Port# -> Purge Port Object! )
   ;
  F48Store
 ;



ASSEMBLE
_F48COPY
RPL
::
  F48$Checks@
  FALSE		( COPY Mode! )
  F48Copy/Move
 ;



ASSEMBLE
_F48MOVE
RPL
::
  F48$Checks@
  TRUE		( MOVE Mode! )
  F48Copy/Move
 ;



ASSEMBLE
_F48RCL
RPL
::
  F48$Checks@
  toLEN_DO
    DUPINDEX@
    NTHCOMPDROP
    ?ACCPTR>		( Fetch Ob if Covered )
    ::
      dirOb? libOb? OR ?SEMI
      DNOTLIBcase BAK>OB
     ;
    SWAP
    TWO
  +LOOP
  DROP
 ;



ASSEMBLE
_F48PURGE
RPL
::
  portMode? dirOb? AND libOb? OR ?SEMI

  F48$Checks@

  TRUEreload!
  NULL$ $dirs!	( reload $dirs )
  FALSETRUE delMode! all!
  "Purging\1F"
  F48BarSetup

  portMode?
  NOTcase	( Dir Mode? )
  ::
    #1+_ONE_DO
      F48AskUser
      SWAPDROP
      ITE OBPURGE!
	  DROP
    F48BarDraw_LOOP
   ;

  port@
  #0=case	( Port 0? )
  ::
    #1+_ONE_DO
      F48AskUser		( Lib/Bak Lib#/Id )
      ITE
      ::
	SWAP			( Lib#/Id Lib/Bak )
	ObInUse? case2drop SETOBINUSE
	SWAP DUPTYPEBINT?	( Library? )
	ITE OFFSRRP		( Detach it )
	    DROP
	Port0_ObPurge
       ;
      2DROP
    F48BarDraw_LOOP
   ;

  port@
  F48PortWr?Err		( Port Writeable? )

  #1+_ONE_DO
    F48AskUser
    ITE
    ::
      DUPTYPEBINT?		( Library? )
      ITE ::
	    OFFSRRP		( Detach it )
	    REMRPLOOP		( Remove it from ROMPTAB )
	   ;
	  DROP

      port@
*****************************************
* Purges the Object referenced by ACCPTR
* 2: ACCPTR
* 1: Port#	->
*****************************************
      CODE

StkPtrs		EQU 0	Adjust Stack ACCPTR'S?

F48PrtObPurge	GOSBVL	=DisableIntr
		CLRST
		GOSBVL	=POP#
		R0=A			* R0.A= Port#
		GOSBVL	=PopASavptr
		D0=A			* ->ACCPTR
		D0=D0+	5
		A=DAT0	A
		R1=A			* R1.A= ->OB
		D0=D0+	5
		A=DAT0	A
		R2=A			* R2.A= ->Bank_Switcher
		GOSUB	ObPurgEnd

* The Following Code is copied to
* the uart_buffer for safe Evaluation!

ObPurgStart	A=R0
		A=A-1	A		* A.A= (Port#)-1
		?A=0	A		* Port 1?
		GOYES	OBPurge!
		ST=1	HighPort	* Access High Port!

* Check if Card 1 exists.

		D1=(5)	=CARD1STAT
		C=DAT1	B
		?CBIT=0	3		* Card1 Not Present?
		GOYES	pullBank
		ST=1	Card1		* Card 1 Plugged!

		?CBIT=0	5		* 32K Card?
		GOYES	+
		ST=1	Card1_128K	* Card 1 is 128K!

+		LC(5)	#C0000		* Card 1 start Address
		UNCNFG			* Unconfigure it!

pullBank	A=A-1	A		* A.A= Bank# (Port# - 2)
		A=A+A	A		* A.A= (Bank#)*2
		LC(5)	#7F040
		C=C+A	A
		D1=C
		C=DAT1	B		* tells bank switcher bank# to read

*****************************************
* Purges OBJECT inside Port > 0
*****************************************
OBPurge!	C=R1
		D=C	A		* Save ->Ob
		D1=C			* D1 ->Ob
		D0=C
		GOSBVL	=SKIPOB		* D0 ->ObEnd
		CD0EX
		B=C	A		* B.A= ->ObEnd
		C=C-D	A
		CR0EX			* R0.A= Ob Size

* Get Port_End address

		A=C	A		* A.A= Port#
		A=A+A	A
		A=A+A	A
		A=A+C	A		* A[A]:(PORT#)*5
		LC(5)	=PORT0EOS
		C=C+A	A
		D0=C
		A=DAT0	A		* A.A= PORTn EOS
		C=R0
		C=A-C	A		* C.A= new PORTn EOS
		DAT0=C	A		* Update it!

		C=A	A		* C.A= PORTn EOS
		A=B	A
		D0=A			* D1 ->ObEnd
		C=C-A	A		* C.A= Nibbs to Move
		?C=0	A		* Nothing to Move?
		GOYES	+
		ST=1	StkPtrs
		GOSBVL	=MOVEDOWN	* Move Obs Up!
		C=0	A
+		DAT1=C	A		* Port End Mark!

* If we accessed a Covered Port and
* Card 1 is Plugged, then we have to
* Re-Configure Card 1 back at #C0000

		?ST=0	HighPort	* Not a High Port?
		RTNYES

		?ST=0	Card1		* Card 1 Not Plugged?
		RTNYES

		C=0	A
		P=	4
		LC(1)	#C		* C.A= #C0000 address
		?ST=1	Card1_128K	* Card 1 is 128K?
		GOYES	+
		LC(1)	#F		* 32K Card
+		CONFIG			* Give Card Size Using Complementation
		LC(1)	#C
		CONFIG			* Configure Card 1 back at #C0000
		P=	0
		RTN

ObPurgEnd	C=RSTK
		D0=C
		D1=(5)	=uart_buffer
		C=0	A
		LC(2)	(ObPurgEnd)-(ObPurgStart)
		GOSBVL	=MOVEDOWN	* Copy!
		GOSBVL	=uart_buffer	* Eval Safe Code!

* Now we Adjust all Access Pointers
* on stack that were after the object
* we just Purged

		?ST=1	StkPtrs		* Adjust Stk's Access Pointers?
		GOYES	Adjust!
PgQuit		GOSBVL	=AllowIntr
		GOVLNG	=GETPTRLOOP

Adjust!		C=R1
		B=C	A		* B.A= ->Ob addr (Purged)
		C=R2
		D=C	A		* D.A= ->Bank_Switcher Addr
		GOSBVL	=D1=DSKTOP

AccAdjLp	C=DAT1	A
		D1=D1+	5		* ->nxt Stk Level
		?C=0	A		* No More Obs?
		GOYES	PgQuit

		D0=C			* D0 ->Object
		A=DAT0	A
		LC(5)	=DOACPTR
		?A#C	A		* Not an ACCPTR?
		GOYES	AccAdjLp

		D0=D0+	10
		C=DAT0	A		* C.A= Bank_Switcher addr
		?C#D	A		* Not in Same Port?
		GOYES	AccAdjLp

		D0=D0-	5
		A=DAT0	A		* A.A= Ob addr
		?B>A	A		* was Ob before Purged one?
		GOYES	AccAdjLp	* yep.

		C=R0			* C.A= Ob Size (Purged)
		A=A-C	A		* New Addr= Ob_Addr - (Purged_Ob Size)
		DAT0=A	A		* update Address!
		GOTO	AccAdjLp
      ENDCODE
     ;
    2DROP
  F48BarDraw_LOOP
 ;



ASSEMBLE
_F48RENAME
RPL
::
  TRUE refresh!
  port@
  portMode? case F48TreeLabel	( Label Port! )
  DROP

  inTree? ITE
  ::
    F48$Dir@
    DROPZERO
    OVER RAM-WORDNAME
    UNROT
   ;
  F48$Index@	( Id, Obj, #Type )

  DROPDUP
  HOMEDIR? OVER F48HiddenDir@ EQUAL ORcase DIRARGERR

  SWAP ID>$
  "Rename " OVER " to:" &$ &$SWAP
  F48Input NOTcaseDROP

ASSEMBLE
_F48ParseName
RPL
  ::
    BEGIN
    ::
      DUPLEN$ Blank$ OVER EQUALcase SETSTACKERR
      $>ID
      ::
	DUP
	portMode? NOTcase SAFE@_HERE
	port@ F48Portn_Ob@
       ;
      NOTcaseTRUE
      DROP ID>$ DUP
      " already Exists\ntry again:" &$SWAP
      F48Input NOTcase ABORT
      FALSE
     ;
    UNTIL
    TRUEreload!
   ;

*****************************************
* Renames the given object "In-Place"
*
* 2:	Object	->
* 1:	new_ID
*****************************************
  CODE
		GOSBVL	=SAVPTR
		D1=D1+	5		* ->Level2
		C=DAT1	A
		D0=C			* D0->Object to be Renamed
		R3=C			* R3[A]= Save Object!
		GOSBVL	=TRAVERSE-	* D0 ->Ob_Name
		A=0	A
		A=DAT0	B		* A[A]= Name_Length
		D1=D1-	5		* D1 ->Level1
		C=DAT1	A		* C[A]= ->newID
		RSTK=C			* Save it!
		D1=C			* D1 ->newID
		D1=D1+	5		* skip Prologue
		C=0	A
		C=DAT1	B		* C[A]= newID_Length
		?C=A	B		* Same Name Length?
		GOYES	Rename!
		?A#0	A		* Null Name?
		GOYES	+
		C=C+1	A		* Add Second Lenght Field
+		ST=1	5		* Expand!
		C=C-A	A		* NO Carry?
		GONC	++
		ST=0	5		* Shrink!
		C=-C	A		* Invert Chars
++		C=C+C	A		* C.A= Nibbles to Expand
		B=C	A
		AD0EX			* A[A]= ->Name
		C=R3
		D0=C			* D0= ->Object
		C=B	A		* Recall Nibbles to Expand!
		GOSBVL	=ECUSER
		A=B	A
		D0=A			* Restore ->Name
Rename!		C=RSTK
		D1=C
		D1=D1+	5
		C=DAT1	B
		D=C	B
RenameLp	A=DAT1	B
		DAT0=A	B
		D0=D0+	2
		D1=D1+	2
		C=C-1	B
		GONC	RenameLp
		?D=0	B
		GOYES	RenQuit
		C=D	B
		DAT0=C	B
RenQuit		GOVLNG	=GETPTRLOOP
  ENDCODE
  DROPNULL$ $dirs!
  inTree? caseDROP
  prevContext!
  TRUE updir!
 ;



ASSEMBLE
_F48NEW
RPL
::
  "Object"
  "Directory"
  TWO ZEROFALSE
  F48Choose NOT?SEMI

  TRUE refresh!
  #0=case
  ::
    # 7FF CRDIR#	( 1: RRP )
    "New Directory:"
    NULL$

ASSEMBLE
_F48Input
RPL
    ::
      #ZERO#ONE ONEONE
      <SkipKey >SkipKey
      NullMenuKey
      DUPDUP
      TogInsertKey
      SIX {}N
      ONEFALSE ZERO
      InputLine
     ;

    NOTcaseDROP
    F48ParseName

ASSEMBLE
_F48Store
RPL
**********************
* 2: Object
* 1: ID		->
**********************
    ::
      NULL$ $dirs!		( Rebuild $Dirs! )
      portMode? NOTcase		( Home? )
      ::
	SWAPOVER ?STO_HERE	( id ob id -> ob )
	@DROP prevContext!
	TRUE updir!
       ;
      DUPROT >BAK SWAP
      port@ DUP#0= case2drop Port0_Sto	( -> Port0? )
      ROTSWAP
      DUP PORTEND
      SWAP3PICK OSIZE #5+		( Id Bak AccPtr Port Size )
      SWAP
      F48RoomInPort?
      Portn_Sto!
     ;

   ;

  "Enter New Object:"
  NULL$
  ONEONE
  #TWO#TWO
  EditMenu
  ONEFALSE TWO
  InputLine NOT?SEMI

  "Enter Name:"
  NULL$
  F48Input NOT?SEMI
  F48ParseName
  F48Store
 ;



ASSEMBLE
_F48ORDER
RPL
::
  F48$Checks@
  TRUEreload!
  NULL$ $dirs!	( reload $dirs )
  "Ordering\1F"
  F48BarSetup
  #2* reversym #2/
  #1+_ONE_DO
    >LASTRAM-WOR
    DROP
  F48BarDraw_LOOP
  ZERO sortBy!		( No Sort! )
 ;



ASSEMBLE
_F48ZIP
RPL
::
  F48$Index@		( id obj #type )
  OVER
  F48HiddenDir@
  EQUALcase DIRARGERR	( HiddenDir? Error! )

  # 1BC02
  "BZ" palparse DROPTRUE refresh!
  DUP DUPTYPEROMP? ITE ROMPTR@ @
  NOTcasedrop DO#EXIT
  TYPECOL? NOTcasedrop DO#EXIT
  UNROTDROP		( Id Obj BZ #Type )

* Auto-Unzip Program?
  TWENTYFOUR OVER#= IT
  ::
    3PICK ONE NTHELCOMP NOT?SEMI
    DUPTYPECSTR? NOTcaseDROP
    DUPONE TWO SUB$ "BZ"
    EQUALNOTcase DROP
    4ROLLDROP UNROTDROP
    THIRTY
   ;

* Zip File -> Unzip
  THIRTY #=case
  ::
    statusMode@ #0=ITE FOURTEEN EIGHT
    FIFTYSIX OVER#- BLANKIT
    FORTYTWO TWENTYSEVEN
    "Extract?" $>BIGGROB XYGROBDISP
    PTR 17F15		( Display YES, NO labels )
    PTR 17FB1		( YES, NO Key Handler )
    case 3DROP		( Cancel Operation! )
    NOTcase 3DROP
    EVAL OVER STO
    @DROP prevContext!	( ob -> )
    TrueTrue updir! reload!
    NULL$ $dirs!	( reload $dirs )
   ;

* Any Object -> Zip
  CLEARVDISP DispStsBound
  DUPUNROT EVAL
  TWENTYSEVEN TWENTYSEVEN
  "Auto-Extract?" $>BIGGROB XYGROBDISP
  PTR 17F15		( Display YES, NO labels )
  PTR 17FB1		( YES, NO Key Handler )
  case 3DROP		( Cancel Operation! )
  ITE
  ::
    SWAP' EVAL THREE ::N
   ;
  SWAPDROP

  OVER STO		( id ob id -> id )
  @DROP prevContext!
  TrueTrue updir! reload!
  NULL$ $dirs!	( reload $dirs )
 ;



ASSEMBLE
_F48LINK
RPL
::

ASSEMBLE
_F48GetIO
RPL
  :: ( Recall Sender & Receiver... )
    { xSEND xRECV }
    # 1BC03		( Invalid 'F48IO' )
    ' ID F48IO @ NOTcaseDROP
    DUPTYPELIST? NOTcasedrop ERROROUT
    DUPLENCOMP #2= NOTcasedrop ERROROUT
    UNROT2DROP
   ;

  INCOMPDROP SWAP
  "Receive "
  "Send    "
  TWO
  #1+_ONE_DO
    ROT DO>STR EIGHT 1_#1-SUB$ CHR_LeftPar >H$ CHR_RightPar >T$
    &$SWAP
  LOOP
  TWO
  ZEROFALSE
  F48Choose NOT?SEMI

  #1=case	* Receive Files...
ASSEMBLE
_F48RECV
RPL
  ::
    F48GetIO
    TRUEreload!
    TWO NTHCOMPDROP 2PUTLAM
    BEGIN
      2GETEVAL
      ATTO?
    UNTIL
   ;

  ( Send Files... )
ASSEMBLE
_F48SEND
RPL
  ::
    F48$Checks@
    F48GetIO
    TRUEreload!
    ONE NTHCOMPDROP 2PUTLAM

    toLEN_DO
    DUPINDEX@ #1+ NTHCOMPDROP	( Get Name )
    ::
      portMode? NOTcase 2GETEVAL
      DUPTYPEBINT? IT :: #>$ CHR_L >H$ $>ID ID>LAM ;
      OVERINDEX@ NTHCOMPDROP	( Get Obj )
      2GETLAM			( Get Sender )
      SWAP3PICK			( list,lam,sender,ob,lam)
      ONE DOBIND		( Save OB in LAM )
      EVAL			( Send Object... )
      ABND
     ;
    TWO
    +LOOP
    DROP
   ;
 ;



ASSEMBLE
_F48CST
RPL
::
  F48{}Menu
  {}menu@ OVER
  EQIT :: DROP' ID F48.CST XEQRCL ;

  DUPTYPELIST? NOTcasedrop INVFUNCERR
  DUPLENCOMP SIX #/ SWAP #0=?SKIP #1+
  pageMax!
  {}menu!
  ONE page!
  F48MenuDraw
 ;



ASSEMBLE
_F48PAGEUP
RPL
::

ASSEMBLE
_F48PageUpSetup
RPL
  ::
    min@ #1- maxFiles@ #MIN
    min@ OVER#- min!
    max@ OVER#- max!
    index@ SWAP#- index!
    F48SafeSlider
   ;

  F48Files/Dirs
 ;



ASSEMBLE
_F48PAGEDOWN
RPL
::

ASSEMBLE
_F48PageDnSetup
RPL
  ::
    n@ max@ #- maxFiles@ #MIN
    min@ OVER#+ min!
    max@ OVER#+ max!
    index@ #+ index!
    F48SafeSlider
   ;

  F48Files/Dirs
 ;



ASSEMBLE
_F48SwapLocals
RPL
*****************************************
* Swaps the Local Vars to use the Tree
* Browser.
*****************************************
CODE
LAMTbar		EQU 30
LAMbar		EQU 8

		GOSBVL	=SAVPTR
		D0=(5)	=TEMPENV
		A=DAT0	A
		C=0	A
		LC(2)	(LAMbar)*10+5
		C=C+A	A
		D0=C			* ->LAMbar
		LC(5)	(LAMTbar)*10+5
		C=C+A	A
		D1=C			* ->LAMTbar
		P=	16-6
SwapLup		A=DAT0	A		* <-----+
		C=DAT1	A		*	
		DAT1=A	A		*	
		DAT0=C	A		*	
		D0=D0+	10		*	
		D1=D1+	10		*	
		P=P+1			*	
		GONC	SwapLup		* ------+
		GOVLNG	=GETPTRLOOP
ENDCODE



ASSEMBLE
_F48IndexPos
RPL
::
  index@
  DUP min@ #-+1
 ;



ASSEMBLE
FilerMsg	CON(5)	=DOLNKARRY	* Linked Array
		REL(5)	->MsgEnd	* Size Field
		CON(5)	=DOCSTR		* String Type
		CON(5)	1		* 1 Dimension
		CON(5)	6		* 6 Messages

* Now we have Offsets to the Messages:

		REL(5)	->m1
		REL(5)	->m2
		REL(5)	->m3
		REL(5)	->m4
		REL(5)	->m5
		REL(5)	->m6

* Finally the Messages themeselves:

->m1		REL(5)	->m2
		NIBASC	\Library UFL not Found\
->m2		REL(5)	->m3
		NIBASC	\BZ Program not Found\
->m3		REL(5)	->m4
		NIBASC	\Invalid 'F48IO'\
->m4		REL(5)	->m5
		NIBASC	\Library JAZZ not Found\
->m5		REL(5)	->m6
		NIBASC	\Card is Write-Protected\
->m6		REL(5)	->MsgEnd
		NIBASC	\Put Filer in Port0/1\
->MsgEnd



FilerCfg
RPL
::
  444 ONSRRP?TOSRRP
*****************************************
* Find the Appropriate A3 Library and
* Execute its Config Code, to fix the
* Link Table's Offsets.
*****************************************
  CODE
		GOSBVL	=SAVPTR
		C=0	A
		LC(2)	163
		A=C	A
		GOSBVL	=D0->LIB#
		GONC	+
Cfg_Quit	GOVLNG	=GETPTRLOOP
+		D1=C
		D1=D1+	8
		C=DAT1	A
		?A#C	X
		GOYES	Cfg_Quit
		D1=D1+	3
		C=DAT1	13
		D1=D1-	16
		A=DAT1	13
		?A<C	A
		GOYES	+
		ACEX	W
+		D0=C
		D0=D0+	23
		B=A	A		* Save A[A]
		A=DAT0	B
		?A#0	B		* Appropiate A3 Library?
		GOYES	Cfg_Quit	* No, Quit!
		A=B	A		* Restore A[A]
		DAT1=C	13		* Swap Libraries!
		D1=D1+	16
		DAT1=A	13
		D0=D0-	5		* ->Config Offset
		A=DAT0	A
		CD0EX
		C=C+A	A		* ->Config Code
		GOVLNG	=GETPTREVALC
  ENDCODE
 ;

ASSEMBLE
		CON(4)	0		* Library CRC
->LibEnd
RPL
